<?php
/**
 + Created by	:	JoomBah Team
 * Company		:	ISDS Sdn Bhd
 + Contact		:	www.joombah.com , support@joombah.com
 * Created on	:	August 2010
 * Author		:	Faisel
 * Tested by	: 	Zaki
 + Project		: 	Job site
 * File Name	:	controllers/jbjobs.php
 * License		:	GNU General Public License version 3, or later
 ^ 
 * Description	: 	Entry point for the component (jbjobs)
 ^ 
 * History		:	
 * */
 defined('_JEXEC') or die('Restricted access');
	
require_once(JPATH_SITE.DS.'administrator'.DS.'components'.DS.'com_jbjobs'.DS.'models'.DS.'jbjobs.php');
include_once(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jbjobs'.DS.'helper'.DS.'helper.php');
JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jbjobs'.DS.'tables');
$document = JFactory::getDocument();
$document->addStyleSheet ( JURI::base().'components/com_jbjobs/assets/css/style.css' );
/**
 * Jbjobs Model
 *
 * @package    Joomla.Components
 * @subpackage 	Jbjobs
 */
class JBJobsControllerJbjobs extends JController {

	/**
	 * Parameters in config.xml.
	 *
	 * @var	object
	 * @access	protected
	 */
	private $_params = null;
	
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	function __construct(){
		parent::__construct();
		
		// Register Extra tasks
		$this->registerTask('add', 'edit');
		
		// Set reference to parameters
		$this->_params = &JComponentHelper::getParams( 'com_jbjobs' );
	}

	public function publish(){
		$ctype = JRequest::getVar('ctype', 0);
		$msg = JText::_('JBJOBS_PUBLISHED_SUCCESSFULLY');
		if( $ctype == 'customfield' ){
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showcustomfield';
			$this->jbPubUnpub(1, '#__jbjobs_custom_field', $link, $msg);
		}
		elseif($ctype == 'plan'){
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showplan';
			$this->jbPubUnpub(1, '#__jbjobs_plan', $link, $msg);
		}
		elseif($ctype == 'planjs'){
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showplanjs';
			$this->jbPubUnpub(1, '#__jbjobs_plan_js', $link, $msg);
		}
		elseif( $ctype == 'fieldorder' ){
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=fieldorder';
			$this->jbPubUnpub(1, '#__jbjobs_fieldorder', $link, $msg);
		}
		elseif( $ctype == 'paymode' ){
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showpaymode';
			$this->jbPubUnpub(1, '#__jbjobs_payment_mode', $link, $msg);
		}
		elseif( $ctype == 'country' ){
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showcountry';
			$this->jbPubUnpub(1, '#__jbjobs_country', $link, $msg);
		}
		elseif( $ctype == 'state' ){
			$country_id = JRequest::getVar('country_id', 0, 'post', 'int');
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showstate&country_id='.$country_id;
			$this->jbPubUnpub(1, '#__jbjobs_state', $link, $msg);
		}
		elseif( $ctype == 'city' ){
			$state_name = JRequest::getVar('stat_name', '', 'post', 'string');
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showcity&state_name='.$state_name;
			$this->jbPubUnpub(1, '#__jbjobs_city', $link, $msg);
		}
		elseif( $ctype == 'cron' ){
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showcron';
			$this->jbPubUnpub(1, '#__jbjobs_crontask', $link, $msg);
		}
		elseif($ctype == 'major'){
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showmajor';
			$this->jbPubUnpub(1, '#__jbjobs_major', $link, $msg);
		}
		elseif($ctype == 'deglevel'){
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showdeglevel';
			$this->jbPubUnpub(1, '#__jbjobs_degree_level', $link, $msg);
		}
		elseif($ctype == 'saltype'){
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showsaltype';
			$this->jbPubUnpub(1, '#__jbjobs_type_salary', $link, $msg);
		}
		elseif($ctype == 'jobexp'){
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showjobexp';
			$this->jbPubUnpub(1, '#__jbjobs_job_exp', $link, $msg);
		}
		elseif($ctype == 'postype'){
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showpostype';
			$this->jbPubUnpub(1, '#__jbjobs_pos_type', $link, $msg);
		}
		elseif($ctype == 'jobspec'){
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showjobspec';
			$this->jbPubUnpub(1, '#__jbjobs_job_spec', $link, $msg);
		}
		elseif($ctype == 'jobcateg'){
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showjobcateg';
			$this->jbPubUnpub(1, '#__jbjobs_job_categ', $link, $msg);
		}
		elseif($ctype == 'indcomp'){
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showindcomp';
			$this->jbPubUnpub(1, '#__jbjobs_industry', $link, $msg);
		}
	}

	public function unpublish(){
		$ctype = JRequest::getVar('ctype', 0);
		$msg = JText::_('JBJOBS_UNPUBLISHED_SUCCESSFULLY');
		if($ctype == 'customfield'){
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showcustomfield';
			$this->jbPubUnpub(0, '#__jbjobs_custom_field', $link, $msg);
		}
		elseif($ctype == 'plan'){
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showplan';
			$this->jbPubUnpub(0, '#__jbjobs_plan', $link, $msg);
		}
		elseif($ctype == 'planjs'){
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showplanjs';
			$this->jbPubUnpub(0, '#__jbjobs_plan_js', $link, $msg);
		}
		elseif($ctype == 'fieldorder'){
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=fieldorder';
			$this->jbPubUnpub(0, '#__jbjobs_fieldorder', $link, $msg);
		}
		elseif($ctype == 'paymode'){
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showpaymode';
			$this->jbPubUnpub(0, '#__jbjobs_payment_mode', $link, $msg);
		}
		elseif($ctype == 'country'){
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showcountry';
			$this->jbPubUnpub(0, '#__jbjobs_country', $link, $msg);
		}
		elseif($ctype == 'state'){
			$country_id = JRequest::getVar('country_id', 0, 'post', 'int');
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showstate&country_id='.$country_id;
			$this->jbPubUnpub(0, '#__jbjobs_state', $link, $msg);
		}
		elseif($ctype == 'city'){
			$state_name = JRequest::getVar('stat_name', '', 'post', 'string');
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showcity&state_name='.$state_name;
			$this->jbPubUnpub(0, '#__jbjobs_city', $link, $msg);
		}
		elseif( $ctype == 'cron' ){
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showcron';
			$this->jbPubUnpub(0, '#__jbjobs_crontask', $link, $msg);
		}
		elseif( $ctype == 'major' ){
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showmajor';
			$this->jbPubUnpub(0, '#__jbjobs_major', $link, $msg);
		}
		elseif($ctype == 'deglevel'){
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showdeglevel';
			$this->jbPubUnpub(0, '#__jbjobs_degree_level', $link, $msg);
		}
		elseif($ctype == 'saltype'){
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showsaltype';
			$this->jbPubUnpub(0, '#__jbjobs_type_salary', $link, $msg);
		}
		elseif($ctype == 'jobexp'){
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showjobexp';
			$this->jbPubUnpub(0, '#__jbjobs_job_exp', $link, $msg);
		}
		elseif($ctype == 'postype'){
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showpostype';
			$this->jbPubUnpub(0, '#__jbjobs_pos_type', $link, $msg);
		}
		elseif($ctype == 'jobspec'){
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showjobspec';
			$this->jbPubUnpub(0, '#__jbjobs_job_spec', $link, $msg);
		}
		elseif($ctype == 'jobcateg'){
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showjobcateg';
			$this->jbPubUnpub(0, '#__jbjobs_job_categ', $link, $msg);
		}
		elseif($ctype == 'indcomp'){
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showindcomp';
			$this->jbPubUnpub(0, '#__jbjobs_industry', $link, $msg);
		}
	}
	
	public function required(){
		$ctype = JRequest::getVar('ctype', 0);
		$msg = JText::_('JBJOBS_FIELD_SET_REQUIRED');
		if( $ctype == 'fieldorder' ){
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=fieldorder';
			$this->jbReqUnrequired(1, '#__jbjobs_fieldorder', $link, $msg);
		}
		elseif( $ctype == 'customfield' ){
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showcustomfield';
			$this->jbReqUnrequired(1, '#__jbjobs_custom_field', $link, $msg);
		}
	}

	public function unrequired(){
		$ctype = JRequest::getVar('ctype', 0);
		$msg = JText::_('JBJOBS_FIELD_SET_UNREQUIRED');
		if( $ctype == 'fieldorder' ){
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=fieldorder';
			$this->jbReqUnrequired(0, '#__jbjobs_fieldorder', $link, $msg);
		}
		if( $ctype == 'customfield' ){
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showcustomfield';
			$this->jbReqUnrequired(0, '#__jbjobs_custom_field', $link, $msg);
		}
	}

	public function orderup(){
		$app =& JFactory::getApplication();
		
		$cid = JRequest::getVar( 'cid', array(0), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		$ctype = JRequest::getVar('ctype', 0);
		$fieldfor = JRequest::getVar('fieldfor', 0, 'post', 'int');
		
		if( $ctype == 'customfield' ){
			$row =& JTable::getInstance('custom', 'Table');
			$link = 'index.php?option=com_jbjobs&view=adminconfig&layout=showcustomfield';
		}
		elseif( $ctype == 'plan' ){
			$row =& JTable::getInstance('plan', 'Table');
			$link = 'index.php?option=com_jbjobs&view=adminconfig&layout=showplan';
		}
		elseif($ctype == 'planjs'){
			$row =& JTable::getInstance('planjs', 'Table');
			$link = 'index.php?option=com_jbjobs&view=adminconfig&layout=showplanjs';
		}
		elseif( $ctype == 'fieldorder' ){
			$row =& JTable::getInstance('fieldorder', 'Table');
			$link = 'index.php?option=com_jbjobs&view=adminconfig&layout=fieldorder';
		}
		elseif( $ctype == 'paymode' ){
			$row =& JTable::getInstance('paymode', 'Table');
			$link = 'index.php?option=com_jbjobs&view=adminconfig&layout=showpaymode';
		}
		elseif( $ctype == 'major' ){
			$row =& JTable::getInstance('major', 'Table');
			$link = 'index.php?option=com_jbjobs&view=adminconfig&layout=showmajor';
		}
		elseif($ctype == 'deglevel'){
			$row =& JTable::getInstance('degreelevel', 'Table');
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showdeglevel';
		}
		elseif($ctype == 'saltype'){
			$row =& JTable::getInstance('typesalary', 'Table');
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showsaltype';
		}
		elseif($ctype == 'jobexp'){
			$row =& JTable::getInstance('jobexp', 'Table');
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showjobexp';
		}
		elseif($ctype == 'postype'){
			$row =& JTable::getInstance('postype', 'Table');
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showpostype';
		}
		elseif($ctype == 'jobspec'){
			$row =& JTable::getInstance('jobspec', 'Table');
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showjobspec';
		}
		elseif($ctype == 'jobcateg'){
			$row =& JTable::getInstance('jobcateg', 'Table');
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showjobcateg';
		}
		elseif($ctype == 'indcomp'){
			$row =& JTable::getInstance('industry', 'Table');
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showindcomp';
		}
		
		$row->load($cid[0]);
		if($ctype == 'fieldorder' || $ctype == 'customfield'){
				$row->move( -1, 'field_for='.$fieldfor.' AND parent = '.(int) $row->parent );
		}
		elseif($ctype == 'paymode'){
				$row->move( -1, 'parent = '.(int) $row->parent );
		}
		else {
			$row->move(-1);
		}
		$app->redirect($link);
	}

	public function orderdown(){
		$app =& JFactory::getApplication();
		
		$cid = JRequest::getVar( 'cid', array(0), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		$ctype = JRequest::getVar('ctype', 0);
		$fieldfor = JRequest::getVar('fieldfor', 0, 'post', 'int');
		
		if( $ctype == 'customfield' ){
			$row =& JTable::getInstance('custom', 'Table');
			$link = 'index.php?option=com_jbjobs&view=adminconfig&layout=showcustomfield';
		}
		elseif( $ctype == 'plan' ){
			$row =& JTable::getInstance('plan','Table');
			$link = 'index.php?option=com_jbjobs&view=adminconfig&layout=showplan';
		}
		elseif($ctype == 'planjs'){
			$row =& JTable::getInstance('planjs','Table');
			$link = 'index.php?option=com_jbjobs&view=adminconfig&layout=showplanjs';
		}
		elseif( $ctype == 'fieldorder' ){
			$row =& JTable::getInstance('fieldorder','Table');
			$link = 'index.php?option=com_jbjobs&view=adminconfig&layout=fieldorder';
		}
		elseif( $ctype == 'paymode' ){
			$row =& JTable::getInstance('paymode', 'Table');
			$link = 'index.php?option=com_jbjobs&view=adminconfig&layout=showpaymode';
		}
		elseif($ctype == 'major'){
			$row =& JTable::getInstance('major', 'Table');
			$link = 'index.php?option=com_jbjobs&view=adminconfig&layout=showmajor';
		}
		elseif($ctype == 'deglevel'){
			$row =& JTable::getInstance('degreelevel', 'Table');
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showdeglevel';
		}
		elseif($ctype == 'saltype'){
			$row =& JTable::getInstance('typesalary', 'Table');
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showsaltype';
		}
		elseif($ctype == 'jobexp'){
			$row =& JTable::getInstance('jobexp', 'Table');
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showjobexp';
		}
		elseif($ctype == 'postype'){
			$row =& JTable::getInstance('postype', 'Table');
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showpostype';
		}
		elseif($ctype == 'jobspec'){
			$row =& JTable::getInstance('jobspec', 'Table');
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showjobspec';
		}
		elseif($ctype == 'jobcateg'){
			$row =& JTable::getInstance('jobcateg', 'Table');
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showjobcateg';
		}
		elseif($ctype == 'indcomp'){
			$row =& JTable::getInstance('industry', 'Table');
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showindcomp';
		}
	
		$row->load($cid[0]);
		if($ctype == 'fieldorder' || $ctype == 'customfield'){
			$row->move( 1, 'field_for='.$fieldfor.' AND parent = '.(int)$row->parent);
		}
		elseif($ctype == 'paymode'){
			$row->move( 1, 'parent = '.(int)$row->parent);
		}
		else {
			$row->move(1);
		}
		$app->redirect($link);
	}

	public function saveorder(){
		$app =& JFactory::getApplication();

		$cid = JRequest::getVar( 'cid', array(0), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		$ctype = JRequest::getVar('ctype', '', 'post', 'string');
		$fieldfor = JRequest::getVar('fieldfor', 0, 'post', 'int');
		
		if($ctype == 'customfield'){
			$row =& JTable::getInstance('custom', 'Table');
			$link = 'index.php?option=com_jbjobs&view=adminconfig&layout=showcustomfield';
		}
		elseif($ctype == 'plan'){
			$row =& JTable::getInstance('plan', 'Table');
			$link = 'index.php?option=com_jbjobs&view=adminconfig&layout=showplan';
		}
		elseif($ctype == 'planjs'){
			$row =& JTable::getInstance('planjs', 'Table');
			$link = 'index.php?option=com_jbjobs&view=adminconfig&layout=showplanjs';
		}
		elseif($ctype == 'fieldorder'){
			$row =& JTable::getInstance('fieldorder', 'Table');
			$link = 'index.php?option=com_jbjobs&view=adminconfig&layout=fieldorder';
		}
		elseif($ctype == 'paymode'){
			$row =& JTable::getInstance('paymode', 'Table');
			$link = 'index.php?option=com_jbjobs&view=adminconfig&layout=showpaymode';
		}
		elseif( $ctype == 'major' ){
			$row =& JTable::getInstance('major', 'Table');
			$link = 'index.php?option=com_jbjobs&view=adminconfig&layout=showmajor';
		}
		elseif($ctype == 'deglevel'){
			$row =& JTable::getInstance('degreelevel', 'Table');
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showdeglevel';
		}
		elseif($ctype == 'saltype'){
			$row =& JTable::getInstance('typesalary', 'Table');
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showsaltype';
		}
		elseif($ctype == 'jobexp'){
			$row =& JTable::getInstance('jobexp', 'Table');
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showjobexp';
		}
		elseif($ctype == 'postype'){
			$row =& JTable::getInstance('postype', 'Table');
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showpostype';
		}
		elseif($ctype == 'jobspec'){
			$row =& JTable::getInstance('jobspec', 'Table');
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showjobspec';
		}
		elseif($ctype == 'jobcateg'){
			$row =& JTable::getInstance('jobcateg', 'Table');
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showjobcateg';
		}
		elseif($ctype == 'indcomp'){
			$row =& JTable::getInstance('industry', 'Table');
			$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showindcomp';
		}
	
		$total		= count($cid);
		$groupings	= array();
		$order		= JRequest::getVar( 'order', array(0), 'post', 'array' );
		JArrayHelper::toInteger($order, array(0));
	
		// update ordering values
		for( $i=0; $i < $total; $i++ ){
			$row->load((int)$cid[$i]);
			// track parents
			$groupings[] = $row->parent;
			if ($row->ordering != $order[$i]) {
				$row->ordering = $order[$i];
				if (!$row->store()) {
					JError::raiseError(500, $db->getErrorMsg() );
				}
			}
		}
		
		if($ctype == 'customfield' || $ctype == 'paymode'){
			// execute updateOrder for each parent group
			$groupings = array_unique($groupings);
			foreach ($groupings as $group){
				$row->reorder('parent = '.(int)$group.' AND published >=0');
			}
		}
		elseif($ctype == 'fieldorder'){
			// execute updateOrder for each parent group
			$groupings = array_unique($groupings);print_r($groupings);
			foreach ($groupings as $group){
				$row->reorder('field_for='.$fieldfor.' AND parent = '.(int)$group.' AND published >=0');
			}
		}
		else {
			$row->reorder();
		}
		
		$msg = JText::_('JBJOBS_NEW_ORDERING_SAVED');
		$app->redirect( $link, $msg );
	}
/**
  ================================================================================================================
	SECTION : Billing History - approve, remove
  ================================================================================================================
*/	
	function approveBilling(){
		
		$app =& JFactory::getApplication();
		$db		=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
		
		$cid 	=& JRequest::getVar('cid', array(0), 'post', 'array');
		JArrayHelper::toInteger($cid, array(0));
		
		if (count($cid)) {
			$count_ketemu = 0;
			for($i = 0; $i < count($cid); $i++){
				$curr_bid = $cid[$i];
				$row	=& JTable::getInstance('billing', 'Table');
				$row->load($curr_bid);
				
				//checking first
				if($row->id_trans == 0){
					$desc_credit = JText::sprintf('JBJOBS_CREDIT_PURCHASE_MANY_CREDITS', $row->credit);
					$trans = $this->updateTransaction($row->user_id, $desc_credit, $row->credit, 1);
					
					$date_approve   = date('Y-m-d H:i:s', time() + ($app->getCfg('offset') * 60 * 60));
							
					//update billing approval
					$row->approval_date = $date_approve;
					$row->approval = 'y';
					$row->id_trans = $trans->id;
					
					// pre-save checks
					if (!$row->check()){
						JError::raiseError(500, $row->getError());
					}	
					// save the changes
					if (!$row->store()){
						JError::raiseError(500, $row->getError());
					}
								
					$row->checkin();	
				}
				$this->sendCreditApprovedEmail($row->id, $row->user_id);
			}
		}
		
		$msg	= JText::_('JBJOBS_CREDIT_PURCHASE_APPROVED');
		$link	= 'index.php?option=com_jbjobs&view=adminjob&layout=showbilling';
		$app->redirect($link, $msg);
	}
	
	function removeBilling(){
		$app =& JFactory::getApplication();
		JArrayHelper::toInteger($cid);
	
		$db =& JFactory::getDBO();
		
		$cid 	=& JRequest::getVar('cid', array(0), 'post', 'array');
		JArrayHelper::toInteger($cid, array(0));
		
		if(count($cid)){
			for($i = 0; $i < count($cid); $i++){
				$db->setQuery("DELETE FROM #__jbjobs_billing WHERE id=".$cid[$i]);
				if (!$db->query()){
					JError::raiseError($db->getErrorNum(), $db->getErrorMsg());
				}
			}
		}
		$msg	= JText::_('JBJOBS_CREDIT_PURCHASE_DELETED');
		$link	= 'index.php?option=com_jbjobs&view=adminjob&layout=showbilling';
		$app->redirect($link, $msg);
	}
/**
  ================================================================================================================
	SECTION : Subscription - new, approve, remove, save, cancel
  ================================================================================================================
*/	
	function newSubscr(){
		JRequest :: setVar('view', 'adminjob');
		JRequest :: setVar('hidemainmenu', 1);
		JRequest :: setVar('layout', 'editsubscr');
		$this->display();
	}
	
	function approveSubscr(){
		
		$app =& JFactory::getApplication();
		$db		=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
		
		$cid 	=& JRequest::getVar('cid', array(0), 'post', 'array');
		JArrayHelper::toInteger($cid, array(0));
		
		if(count($cid)){
			$count_ketemu = 0;
			for($i = 0; $i < count($cid); $i++){
				$curr_bid = $cid[$i];
				$row	=& JTable::getInstance('plansubscr', 'Table');
				$row->load($curr_bid);
				
				if($row->user_type == 'e')
	 				$planTblName = '#__jbjobs_plan';
	 			elseif($row->user_type == 'j')
	 				$planTblName = '#__jbjobs_plan_js';
				
	 			//get the plan details
				$query = "SELECT * FROM $planTblName WHERE id = ".$row->subscription_id;
				$db->setQuery($query);
				$plan = $db->loadObject();
				
				//checking first
				if($row->trans_id == 0){
					$date_approve   = date( 'Y-m-d H:i:s', time() + ( $app->getCfg('offset') * 60 * 60 ) );
					
					$desc_credit = JText::_('JBJOBS_SUBSCR_BUY').' - '.$plan->name;
					$trans = $this->updateTransaction($row->user_id, $desc_credit, $row->credit, 1);
					
					//update subscription approval
					$date_expires = date("Y-m-d H:i:s", strtotime("+$plan->days $plan->days_type") + ($app->getCfg('offset') * 60 * 60));
					$row->date_approval = $date_approve;
					$row->date_expire = $date_expires;
					$row->approved = 1;
					$row->gateway_id = time();
					$row->trans_id = $trans->id;
					
					// pre-save checks
					if(!$row->check()){
						JError::raiseError(500, $row->getError());
					}	
					// save the changes
					if(!$row->store()){
						JError::raiseError(500, $row->getError());
					}
					$row->checkin();	
				}
				$this->sendSubscrApprovedEmail($row->id, $row->user_id);
			}
		}
		$msg = JText::_('JBJOBS_SUBSCRIPTION_APPROVED');
		$link = 'index.php?option=com_jbjobs&view=adminjob&layout=showsubscr';
		$app->redirect($link, $msg);
	}
	
	function removeSubscr(){
		$app =& JFactory::getApplication();
		$db =& JFactory::getDBO();
		$cid 	=& JRequest::getVar('cid', array(0), 'post', 'array');
		JArrayHelper::toInteger($cid, array(0));
		
		if(count($cid)){
			for($i = 0; $i < count($cid); $i++){
				$db->setQuery("DELETE FROM #__jbjobs_plan_subscr WHERE id=".$cid[$i]);
				if (!$db->query()){
					JError::raiseError($db->getErrorNum(), $db->getErrorMsg());
				}
			}
		}
		$msg  = JText::_('JBJOBS_SUBSCRIPTION_DELETED');
		$link = 'index.php?option=com_jbjobs&view=adminjob&layout=showsubscr';
		$app->redirect($link, $msg);
	} 

	function showSubscr(){
		JRequest :: setVar('view', 'adminjob');
		JRequest :: setVar('layout', 'showsubscr');
		$this->display();
	}

	function saveSubscr(){
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		// Initialize variables
		$app =& JFactory::getApplication();
		$db		=& JFactory::getDBO();
		$row	=& JTable::getInstance('plansubscr', 'Table');
		
		$config =& JTable::getInstance('config', 'Table');
		$config->load(1);
		$invoiceFormatPlan = $config->invoiceFormatPlan;	
		
		$post   = JRequest::get('post');
		$id = $post['id'];
		$user_type = JRequest::getVar('user_type', 'e', 'post', 'string');
		if($user_type == 'e')
			$tbl_name = '#__jbjobs_plan';
		elseif($user_type == 'j')
			$tbl_name = '#__jbjobs_plan_js';
		
		if($id == 0)
			$isNew = true;
	
		if (!$row->bind($post)) {
			JError::raiseError(500, $row->getError());
		}
		// pre-save checks
		if (!$row->check()) {
			JError::raiseError(500, $row->getError());
		}
		if($isNew){
			//calculate the price
			$sql = 'SELECT id, days, days_type, price, discount, credit, name FROM '.$tbl_name.' WHERE id ='.$row->subscription_id;
		    $db->setQuery($sql);
		    $plan = $db->loadObject();
			
			if($plan->discount){
		    	$sql = 'SELECT COUNT(*) AS total FROM #__jbjobs_plan_subscr WHERE subscription_id ='.$row->subscription_id.' AND user_id='.$row->user_id;
		    	$db->setQuery($sql);
		    	$total = $db->loadResult();
		    	if($total > 0){
		    		$plan->price = $plan->price - (($plan->price / 100) * $plan->discount);
		    	}
		    }
			$date_buy = date('Y-m-d H:i:s', time() + ($app->getCfg('offset') * 60 * 60));
			$row->price = $plan->price;
			$row->credit = $plan->credit;
			$row->date_buy = $date_buy;
			$row->tax_percent = $config->taxpercent;
			
			if (!$row->store()) {
				JError::raiseError(500, $row->getError() );
			}
			//update the invoice no
			$year = date("Y");
			$time = time();
			//replace the tags
			$tags = array("[ID]", "[USERID]", "[YYYY]", "[TIME]");
			$tagsValues = array("$row->id", "$row->user_id", "$year", "$time");
			$invoiceNo = str_replace($tags, $tagsValues, $invoiceFormatPlan);
			$row->invoiceNo = $invoiceNo;
		}
		// save the changes
		if (!$row->store()) {
			JError::raiseError(500, $row->getError() );
		}
		$row->checkin();
		
		//approve the subscription if new or approve manully by admin.
		if($post['approved']){
			if($isNew || $row->trans_id == 0){
				JRequest :: setVar('cid', $row->id);
				$this->approveSubscr();
			}
		}
	
		$msg	= JText::_('JBJOBS_SUBSCRIPTION_SAVED');
		$link	= 'index.php?option=com_jbjobs&view=adminjob&layout=showsubscr';
		$app->redirect($link, $msg);
	}
	
	function cancelSubscr($cancel){
		$app =& JFactory::getApplication();
		$msg = '';
		$link = 'index.php?option=com_jbjobs&view=adminjob&layout=showsubscr';
		$app->redirect($link, $msg);
	} 
/**
  ================================================================================================================
	SECTION : Job Alert - send, save
	================================================================================================================
*/	
	function sendJobAlert(){
		$app =& JFactory::getApplication();
		$cronHelper = JBjobs::get('helper.cron');
		$abdul = $cronHelper->cron();
		
		$emails_count	= JRequest::getVar('emails_count', 0, '', 'int');
		$msg	= JText::sprintf('JBJOBS_JOB_ALERTS_SENT_TO_MANY_USERS', $emails_count);
		$link	= JRoute::_('index.php?option=com_jbjobs&view=adminjob&layout=showjobalert', false);
		$app->redirect($link, $msg);
	}
	
	function removeJobalert(){
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
	
		// Initialize variables
		$app =& JFactory::getApplication();
		$db =& JFactory::getDBO();
		JArrayHelper::toInteger($cid);
	
		$cid 	=& JRequest::getVar('cid', array(0), 'post', 'array');
		JArrayHelper::toInteger($cid, array(0));
		
		if (count($cid)){
			for($i=0; $i<count($cid); $i++){
				$db->setQuery("DELETE FROM #__jbjobs_job_alert WHERE id=".$cid[$i]);
				if (!$db->query()){
					JError::raiseError($db->getErrorNum(), $db->getErrorMsg());
				}
			}
		}
		$msg	= JText::_('JBJOBS_JOB_ALERTS_DELETED');
		$link	= 'index.php?option=com_jbjobs&view=adminjob&layout=showjobalert';
		$app->redirect($link, $msg);
	}
	
	function saveJobalert(){
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		// Initialize variables
		$app =& JFactory::getApplication();
		$db		=& JFactory::getDBO();
		$row	=& JTable::getInstance('jobalert', 'Table');
		$post   = JRequest::get('post');
		$id_js 	= (!empty($post['id_js'])) ? $post['id_js'] : JRequest::getVar('id_js', '', '', 'string');
		
		if(count($id_js) > 0 && !(count($id_js) == 1 && empty($id_js[0]))){
			$job_spec = implode(',', $id_js );
		}
		elseif($id_js[0] == 0){
			$job_spec = 0;
		}
		
		$row->id_job_spec = $job_spec;
	
		if(!$row->bind($post)){
			JError::raiseError(500, $row->getError());
		}
		// pre-save checks
		if(!$row->check()){
			JError::raiseError(500, $row->getError());
		}
		// save the changes
		if(!$row->store()){
			JError::raiseError(500, $row->getError());
		}
		$row->checkin();
	
		$msg	= JText::_('JBJOBS_JOB_ALERTS_SAVED');
		$link	= 'index.php?option=com_jbjobs&view=adminjob&layout=showjobalert';
		$app->redirect($link, $msg);
	}
	
	function cancelJobalert(){
		$app =& JFactory::getApplication();
		$msg = '';
		$link	= 'index.php?option=com_jbjobs&view=adminjob&layout=showjobalert';
		$app->redirect($link,$msg);		
	}
/**
  ================================================================================================================
	SECTION : Job - new, remove, save, cancel
	================================================================================================================
*/	
	function newjob(){
		JRequest :: setVar('view', 'adminjob');
		JRequest :: setVar('hidemainmenu', 1);
		JRequest :: setVar('layout', 'editjob');
		$this->display();
	}
	
	function removeJob(){
	
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
	
		// Initialize variables
		$app =& JFactory::getApplication();
		$db =& JFactory::getDBO();
		JArrayHelper::toInteger($cid);
	
		$cid 	=& JRequest::getVar('cid', array(0), 'post', 'array');
		JArrayHelper::toInteger($cid, array(0));
		
		if(count($cid)){
			for($i=0;$i<count($cid);$i++){
				$db->setQuery("DELETE FROM #__jbjobs_job WHERE id=".$cid[$i]);
				if (!$db->query()){
					JError::raiseError($db->getErrorNum(), $db->getErrorMsg());
				}
			}
		}
		$msg	= JText::_('JBJOBS_JOBS_DELETED');
		$link	= 'index.php?option=com_jbjobs&view=adminjob&layout=joblist';
		$app->redirect($link, $msg);
	}
	
	function saveJob(){
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		// Initialize variables
		$app   =& JFactory::getApplication();
		$db	   =& JFactory::getDBO();
		$row   =& JTable::getInstance('job', 'Table');
		$post  = JRequest::get( 'post' );
		$post['short_desc'] = JRequest::getVar('short_desc', '', 'post', 'string', JREQUEST_ALLOWRAW);
		$post['long_desc'] = JRequest::getVar('long_desc', '', 'post', 'string', JREQUEST_ALLOWRAW);
	
		if(!$row->bind($post)){
			JError::raiseError(500, $row->getError());
		}
		// pre-save checks
		if(!$row->check()){
			JError::raiseError(500, $row->getError());
		}
		// save the changes
		if(!$row->store()){
			JError::raiseError(500, $row->getError());
		}
		$row->checkin();
	
		$this->insertCustomField('job', $row->id, $post);
	
		$msg	= JText::_('JBJOBS_JOBS_SAVED');
		$link	= 'index.php?option=com_jbjobs&view=adminjob&layout=joblist';
		$app->redirect($link, $msg);
	}
	
	function cancelJob($cancel){
		$app =& JFactory::getApplication();
		$msg = '';
		$link = 'index.php?option=com_jbjobs&view=adminjob&layout=joblist';
		$app->redirect($link,$msg);		
	}
/**
  ================================================================================================================
	SECTION : Employer - new, remove, save, cancel
	================================================================================================================
*/
	function newemployer(){
		JRequest :: setVar('view', 'adminjob');
		JRequest :: setVar('hidemainmenu', 1);
		JRequest :: setVar('layout', 'editemployer');
		$this->display();
	}
	
	function removeEmployer(){
	
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
	
		// Initialize variables
		$app =& JFactory::getApplication();
		$db  =& JFactory::getDBO();
		$cid =& JRequest::getVar('cid', array(0), 'post', 'array');
		JArrayHelper::toInteger($cid);	
		
		if(count($cid)){
			for($i=0; $i<count($cid); $i++){
				$curr_bid =$cid[$i];
				$db->setQuery("DELETE FROM #__jbjobs_employer WHERE id = $curr_bid");
				if (!$db->query()){
					JError::raiseError($db->getErrorNum(), $db->getErrorMsg());
				}
			}
		}
		$msg  = JText::_('JBJOBS_EMPLOYERS_DELETED');
		$link = 'index.php?option=com_jbjobs&view=adminjob&layout=showemployer';
		$app->redirect($link, $msg);
	}
	
	function saveEmployer(){
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		// Initialize variables
		$app 		 =& JFactory::getApplication();
		$db			 =& JFactory::getDBO();
		$model 		 = $this->getModel();
		$row		 =& JTable::getInstance('employer', 'Table');
		$post  		 = JRequest::get( 'post' );
		$id			 = (!empty($post['id'])) ? (int)$post['id'] : 0;
		$credit 	 = (!empty($post['credit'])) ? (int)$post['credit'] : null;
		$desc_credit = (!empty($post['desc_credit'])) ? $post['desc_credit'] : null;
		$type_credit = (!empty($post['type_credit'])) ? $post['type_credit'] : null;
		$user_id 	 = (!empty($post['username'])) ? (int) $post['username'] : 0;
		
		if($id > 0){	//existing employer
			$row->load($id);
			$user_id = $row->user_id;
		}
		else {	// new employer
			$row->user_id = $user_id;
		}
		
		if(!$row->bind($post)){
			JError::raiseError(500, $row->getError());
		}
		// pre-save checks
		if(!$row->check()){
			JError::raiseError(500, $row->getError());
		}
		// if new item, last in appropriate group
		if(!$row->id){
			$where = "id=".(int)$row->id;		
		}
		// save the changes
		if(!$row->store()){
			JError::raiseError(500, $row->getError());
		}
		$row->checkin();
		
		if(!empty($credit)){
			//update the transaction table
			if($type_credit == 'p'){
				$this->updateTransaction($user_id, $desc_credit, $credit, 1);
				$msg_credit = JText::sprintf('JBJOBS_USER_CREDITED_WITH_MANY_CREDITS', $credit);
				$app->enqueueMessage($msg_credit);
			}
			elseif($type_credit == 'm'){
				$this->updateTransaction($user_id, $desc_credit, $credit, -1);
				$msg_credit = JText::sprintf('JBJOBS_USER_DEBITED_WITH_MANY_CREDITS', $credit);
				$app->enqueueMessage($msg_credit);
			}
		}
		
		$this->insertCustomField('employer', $row->user_id, $post);
		
		$name = $post['firstname'];
		$name .= (!empty($post['lastname'])) ? ' ' . $post['lastname'] : '';
		$query = "UPDATE #__users SET name='$name' WHERE id=".$db->quote($user_id);
		$db->setQuery($query);
		$db->query();
	
		$msg	= JText::_('JBJOBS_EMPLOYERS_SAVED');
		$link	= 'index.php?option=com_jbjobs&view=adminjob&layout=showemployer';
		$app->redirect($link, $msg);
	}

	function cancelEmployer($cancel){
		$app =& JFactory::getApplication();
		$msg = '';
		$link = 'index.php?option=com_jbjobs&view=adminjob&layout=showemployer';
		$app->redirect($link,$msg);
	}
/**
  ================================================================================================================
	SECTION : Jobseeker - new, remove, save, cancel
	================================================================================================================
*/
	function newjobseeker(){
		JRequest :: setVar('view', 'adminjob');
		JRequest :: setVar('hidemainmenu', 1);
		JRequest :: setVar('layout', 'editjobseeker');
		$this->display();
	}
	
	function removeJobSeeker(){
	
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
	
		// Initialize variables
		$app =& JFactory::getApplication();
		$db  =& JFactory::getDBO();
		$cid =& JRequest::getVar('cid', array(0), 'post', 'array');
		JArrayHelper::toInteger($cid);
	
		if (count($cid)){
			for($i=0; $i<count($cid); $i++){
				$curr_bid =$cid[$i];
				
				$db->setQuery("DELETE FROM #__jbjobs_jobseeker WHERE id = $curr_bid");
				if (!$db->query()) {
					JError::raiseError($db->getErrorNum(), $db->getErrorMsg());
				}
			}
		}
		$msg	= JText::_('JBJOBS_JOBSEEKER_DELETED');
		$link	= 'index.php?option=com_jbjobs&view=adminjob&layout=showjobseeker';
		$app->redirect($link, $msg);
	}

	function saveJobSeeker(){
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		// Initialize variables
		$app 	=& JFactory::getApplication();
		$db		=& JFactory::getDBO();
		$model 	= $this->getModel();
		$row	=& JTable::getInstance('jobSeeker', 'Table');
		$post   = JRequest::get( 'post' );
		$id 	= (!empty($post['id'])) ? (int) $post['id'] : 0;	
		$user_id = (!empty($post['username'])) ? (int) $post['username'] : 0;
		$credit = JRequest::getVar('credit', 0, 'post', 'float');
		$desc_credit = JRequest::getVar('desc_credit', '', 'post', 'string');
		$type_credit = JRequest::getVar('type_credit', '', 'post', 'string');
		
		if($id > 0){	//existing jobseeker
			$row->load($id);
			$user_id = $row->user_id;
		}
		else {	//new jobseeker
			$row->user_id = $user_id;
		}
		
		if(!$row->bind($post)){
			JError::raiseError(500, $row->getError());
		}
		// pre-save checks
		if(!$row->check()){
			JError::raiseError(500, $row->getError());
		}
		// save the changes
		if(!$row->store()){
			JError::raiseError(500, $row->getError());
		}
		$row->checkin();
	
		//save to experience Table
		$exp			=& JTable::getInstance('experience', 'Table');
		$prev_employer 	= $post['prev_employer'];
		$designation 	= $post['designation'];
		$from 			= $post['from_date'];
		$to 			= $post['to_date'];
		$expid 			= $post['expid'];
		$job_profile 	= $post['job_profile'];
		$exp->id 			= $expid;
		$exp->user_id 		= $user_id;
		$exp->prev_employer = $prev_employer;
		$exp->designation 	= $designation;
		$exp->from_date 	= $from;
		$exp->to_date 		= $to;
		$exp->job_profile 	= $job_profile;
		// pre-save checks
		if(!$exp->check()){
			JError::raiseError(500, $exp->getError());
		}
		// save the changes
		if(!$exp->store()){
			JError::raiseError(500, $exp->getError());
		}
		$exp->checkin();
		
		if(!empty($credit)){
			//update the transaction table
			if($type_credit == 'p'){
				$this->updateTransaction($user_id, $desc_credit, $credit, 1);
				$msg_credit = JText::sprintf('JBJOBS_USER_CREDITED_WITH_MANY_CREDITS', $credit);
				$app->enqueueMessage($msg_credit);
			}
			elseif($type_credit == 'm'){
				$this->updateTransaction($user_id, $desc_credit, $credit, -1);
				$msg_credit = JText::sprintf('JBJOBS_USER_DEBITED_WITH_MANY_CREDITS', $credit);
				$app->enqueueMessage($msg_credit);
			}
		}
		
		$this->insertCustomField('jobseeker', $row->user_id, $post);
	
		$name = $post['first_name'];
		$name .= (!empty($post['last_name'])) ? ' ' . $post['last_name'] : '';
		$query = "UPDATE #__users SET name='$name' WHERE id=".$user_id;
		$db->setQuery($query);
		$db->query();
	
		$msg	= JText::_('JBJOBS_JOBSEEKERS_SAVED');
		$link	= 'index.php?option=com_jbjobs&view=adminjob&layout=showjobseeker';
		$app->redirect($link, $msg);
	}
	
	function cancelJobSeeker($cancel){
		$app =& JFactory::getApplication();
		$msg = '';
		$link	= 'index.php?option=com_jbjobs&view=adminjob&layout=showjobseeker';
		$app->redirect($link, $msg);
	}
	
	//3.Save Resume
	function saveResume(){
		// Check for request forgeries
		JRequest::checkToken() or jexit('Invalid Token');
		
		$app =& JFactory::getApplication();
		$user	=& JFactory::getUser();
		$model = $this->getModel();
		$db		=& JFactory::getDBO();
		
		// Initialize variables
		$row	=& JTable::getInstance('resume', 'Table');
		$post   = JRequest::get('post');
		$id 	= JRequest::getInt('id', 0, 'post');
		$jseekerid 	= JRequest::getInt('jseekerid', 0, 'post');
		$type_resume = (!empty($post['type'][0])) ?  $post['type'][0] : 'c';	
		$resume      = JRequest::getVar('resume', '', 'post', 'string', JREQUEST_ALLOWRAW);	
		$is_active 	 = (!empty($post['is_active'])) ?  $post['is_active'] : 'n';
		
		if($id > 0){
			$row->load($id);
		}
		
		//If the current resume is set active, set others as inactive
		if($is_active == 'y'){
			$query = "UPDATE #__jbjobs_resume SET is_active='n' WHERE jseeker_id=".$db->quote($row->jseeker_id);	
			$db->setQuery($query);
			$db->query();
		}
		
		if(!$row->bind($post)) {
			JError::raiseError(500, $row->getError());
		}
		//$row->jseeker_id  = $user->id;
		$row->resume  	  = $resume;
		$row->type  	  = $type_resume;
		
		//UPLOAD FILE
		jimport('joomla.filesystem.file');
		$file = $_FILES['file_resume'];	
		$config =& JTable::getInstance('config', 'Table');
		$config->load(1);
		$type = $config->get('cvfiletype');
		//$type ='bmp,csv,doc,gif,ico,jpg,jpeg,odg,odp,ods,odt,pdf,png,ppt,swf,txt,xcf,xls,BMP,CSV,DOC,GIF,ICO,JPG,JPEG,ODG,ODP,ODS,ODT,PDF,PNG,PPT,SWF,TXT,XCF,XLS';
		$allowed = explode(',', $type);
		
		if($file['size'] > 0){
			if($file['error'] != 0){
				$this->jbJobsMsgAlert(JText::_('JBJOBS_UPLOAD_FILE_ERROR'));
				exit ();
			}
			if($file['size'] == 0){
				$file = null;
			}
			
			$format = $file['type'];
			if(!preg_match('/(.*)\.(zip|docx)/',$file['name'])){
				if(!in_array($format, $allowed)){	
					$this->jbJobsMsgAlert(JText::_('JBJOBS_YOUR_FILE_IS_IGNORED'));
					exit ();
					$file = null;
				}
			}
			$old_doc = $row->file_resume;		
			if ($file != null){
				if(!file_exists(JPATH_SITE.DS.'images'.DS.'jbjobs'.DS.'pf')){
					if(mkdir(JPATH_SITE.DS.'images'.DS.'jbjobs'.DS.'pf')){
						JPath::setPermissions(JPATH_SITE.DS.'images'.DS.'jbjobs'.DS.'pf', '0777');
						if(file_exists(JPATH_SITE.DS.'images'.DS.'index.html')){
							copy(JPATH_SITE.DS.'images'.DS.'index.html', JPATH_SITE.DS.'images'.DS.'jbjobs/pf/index.html');
						}
					}
				}
				$doc = explode(".",$file['name']);					
				$new_doc = "p_".$row->jseeker_id."_".strtotime("now").".".$doc[count($doc)-1];
				$dest = JPATH_SITE.DS.'images'.DS.'jbjobs'.DS.'pf'.DS.$new_doc;
				$soure = $file['tmp_name'];
				// Move uploaded file
				$uploaded = JFile::upload($soure,$dest);
				if($old_doc !="" || !empty($old_doc))
				{
					$old_doc_file = explode("/",$old_doc);				
					$delete = JPATH_SITE.DS.'images'.DS.'jbjobs'.DS.'pf'.DS.$old_doc_file[count($old_doc_file)-1];
					unlink($delete);
				}
				$row->file_resume = JURI::root().'images/jbjobs/pf/'.$new_doc;
			}
		}
		if($file['size'] > 0 && $type_resume =='f'){
			$row->type ='f';
			$row->resume ='';
		}
		elseif($file['size'] == 0 && $type_resume =='f'){
			$row->type ='f';
			$row->resume ='';
		}
		else {
			$row->type ='c';
			$old_doc = $row->file_resume;
			if($old_doc !="" || !empty($old_doc)){
				$old_doc_file = explode("/",$old_doc);				
				$delete =JPATH_SITE.DS.'images'.DS.'jbjobs'.DS.'pf'.DS.$old_doc_file[count($old_doc_file)-1];
				unlink($delete);
			}
			$row->file_resume = '';
			$row->resume = $resume;
		}
		// pre-save checks
		if (!$row->check()){
			JError::raiseError(500, $row->getError());
		}
		// save the changes
		if (!$row->store()){
			JError::raiseError(500, $row->getError());
		}
		$row->checkin();
		$link	= JRoute::_('index.php?option=com_jbjobs&view=adminjob&layout=editjobseeker&cid[]='.$jseekerid, false);
		$msg = JText::_('JBJOBS_RESUME_SAVED_SUCCESS');
		$app->redirect($link, $msg);
	}
	
	//4.Remove Resume
	function removeResume(){
		$id = JRequest::getVar('id', 0, 'get', 'int');
		$jseekerid 	= JRequest::getInt('jseekerid', 0, 'get');
		
		$row =& JTable::getInstance('resume', 'Table');
		$row->delete($id);
		
		$link = JRoute::_('index.php?option=com_jbjobs&view=adminjob&layout=editjobseeker&cid[]='.$jseekerid, false);
		$msg = JText::_('JBJOBS_RESUME_DEL_SUCCESS');
		$this->setRedirect($link, $msg);
	}

/**
  ================================================================================================================
	SECTION : Configuration:Config - save, cancel
	================================================================================================================
*/	
	function saveConfig(){
		$app =& JFactory::getApplication();
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		// Initialize variables
		$db		=& JFactory::getDBO();
		$row	=& JTable::getInstance('config', 'Table');
		$post   = JRequest::get( 'post' );
		$post['myinvoicedetails'] = JRequest::getVar('myinvoicedetails', '', 'post', 'string', JREQUEST_ALLOWRAW);
		$post['welcome_jobseeker'] = JRequest::getVar('welcome_jobseeker', '', 'post', 'string', JREQUEST_ALLOWRAW);
		$post['welcome_employer'] = JRequest::getVar('welcome_employer', '', 'post', 'string', JREQUEST_ALLOWRAW);
		
		if(!$row->bind($post)){
			JError::raiseError(500, $row->getError());
		}
		// pre-save checks
		if(!$row->check()){
			JError::raiseError(500, $row->getError());
		}
		// if new item,  last in appropriate group
		if(!$row->id){
			$where = "id=".(int)$row->id;		
		}
		// save the changes
		if(!$row->store()){
			JError::raiseError(500, $row->getError());
		}
		$row->checkin();
		
		$msg	= JText::_('JBJOBS_COMPONENT_SETTINGS_SAVED');
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=config';
		$app->redirect($link, $msg);
	}
	
	function cancelConfig($cancel){
		$app =& JFactory::getApplication();
		$msg ='';
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showconfig';
		$app->redirect( $link, $msg );
	}
/**
  ================================================================================================================
	SECTION : Configuration:Plan - new, remove, save, cancel, publish, show
	================================================================================================================
*/	
	function newPlan(){
		JRequest :: setVar('view', 'adminconfig');
		JRequest :: setVar('hidemainmenu', 1);
		JRequest :: setVar('layout', 'editplan');
		$this->display();
	}
	
	function removePlan(){
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
	
		// Initialize variables
		$app =& JFactory::getApplication();
		$db =& JFactory::getDBO();
		$cid 	=& JRequest::getVar('cid', array(0), 'post', 'array');
		JArrayHelper::toInteger($cid, array(0));
		JArrayHelper::toInteger($cid);
		$ketemu = 0;
		$add_msg = '';
		$find_2 = 0;
		
		if (count($cid)){
			$count_ketemu =0;
			for($i=0; $i < count($cid); $i++){
				$curr_bid = $cid[$i];
				
				$query ="SELECT COUNT(*) FROM  #__jbjobs_plan_subscr ".
			 			 "WHERE subscription_id = $curr_bid AND user_type='e'";
				$db->setQuery($query);	
				$find_1 = $db->loadResult();
				
				if($curr_bid == 1){
					$find_2 = 1;	//plan_id = 1 is the default one and cannot be deleted.
					$add_msg = JText::_('JBJOBS_PLAN_ID1_DEFAULT_CANNOT_BE_DELETED').'\n';
				}	
				if($find_1 > 0 || $find_2 > 0){
					$ketemu = 1;
				}						
				if($find_1 == 0 && $find_2 == 0){
					$db->setQuery("DELETE FROM #__jbjobs_plan WHERE id = $curr_bid");
					if (!$db->query()) {
						JError::raiseError($db->getErrorNum(), $db->getErrorMsg());
					}
				}
				if($ketemu > 0){
					$count_ketemu++;
				}
			}
			if($count_ketemu > 0){
				echo "<script> 
						alert('".$add_msg.JText::sprintf('JBJOBS_CANNOT_DELETE_DATA_DUE_TO_TABLE_LINKING', JText::_('JBJOBS_PLAN'))."'); 
						window.history.go(-1);
					  </script>\n";
				exit;
			}		
		}
		$msg	= JText::_('JBJOBS_PLANS_DELETED');
		$link	= 'index.php?option=com_=jbjobs&view=adminconfig&layout=showplan';
		$app->redirect($link, $msg);
	}
	
	function savePlan(){
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		// Initialize variables
		$app =& JFactory::getApplication();
		$db		=& JFactory::getDBO();
		$row	=& JTable::getInstance('plan', 'Table');
		$post   = JRequest::get( 'post' );
		$post['description'] = JRequest::getVar('description', '', 'post', 'string', JREQUEST_ALLOWRAW);
		$post['finish_msg'] = JRequest::getVar('finish_msg', '', 'post', 'string', JREQUEST_ALLOWRAW);
		
		if(!$row->bind($post)){
			JError::raiseError(500, $row->getError());
		}
		// pre-save checks
		if(!$row->check()){
			JError::raiseError(500, $row->getError());
		}
		// if new item,  last in appropriate group
		if(!$row->id){
			$where = "id=".(int)$row->id;		
		}
		// save the changes
		if(!$row->store()){
			JError::raiseError(500, $row->getError());
		}
		$row->checkin();
		
		$msg	= JText::_('JBJOBS_PLANS_SAVED');
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showplan';
		$app->redirect($link, $msg);
	}
	
	function cancelPlan($cancel){
		$app =& JFactory::getApplication();
		$msg ='';
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showplan';	
		$app->redirect( $link,$msg );
	}

 	function showPlan(){
		JRequest :: setVar('view', 'adminconfig');
		JRequest :: setVar('layout', 'showplan');
		$this->display();
	}
/**
  ================================================================================================================
	SECTION : Configuration:Jobseeker Plan - new, remove, save, cancel, show
	================================================================================================================
*/	
	function newPlanJS(){
		JRequest :: setVar('view', 'adminconfig');
		JRequest :: setVar('hidemainmenu', 1);
		JRequest :: setVar('layout', 'editplanjs');
		$this->display();
	}
	
	function removePlanJS(){
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
	
		// Initialize variables
		$app =& JFactory::getApplication();
		$db =& JFactory::getDBO();
		$cid 	=& JRequest::getVar('cid', array(0), 'post', 'array');
		JArrayHelper::toInteger($cid, array(0));
		JArrayHelper::toInteger($cid);
		$ketemu = 0;
		$add_msg = '';
		$find_2 = 0;
		
		if (count($cid)){
			$count_ketemu =0;
			for($i=0; $i < count($cid); $i++){
				$curr_bid = $cid[$i];
				
				$query ="SELECT COUNT(*) FROM  #__jbjobs_plan_subscr ".
			 			 "WHERE subscription_id = $curr_bid AND user_type='j'";
				$db->setQuery($query);	
				$find_1 = $db->loadResult();
				
				if($curr_bid == 1){
					$find_2 = 1;	//plan_id = 1 is the default one and cannot be deleted.
					$add_msg = JText::_('JBJOBS_PLAN_ID1_DEFAULT_CANNOT_BE_DELETED').'\n';
				}	
				if($find_1 > 0 || $find_2 > 0){
					$ketemu = 1;
				}						

				if($find_1 == 0 && $find_2 == 0){
					$db->setQuery("DELETE FROM #__jbjobs_plan_js WHERE id = $curr_bid");
					if (!$db->query()) {
						JError::raiseError($db->getErrorNum(), $db->getErrorMsg());
					}
				}
				if($ketemu > 0){
					$count_ketemu++;
				}
			}
			if($count_ketemu > 0){
				echo "<script> 
						alert('".$add_msg.JText::sprintf('JBJOBS_CANNOT_DELETE_DATA_DUE_TO_TABLE_LINKING', JText::_('JBJOBS_PLAN'))."');
						window.history.go(-1);
					  </script>\n";
				exit;
			}		
		}
		$msg	= JText::_('JBJOBS_PLANS_DELETED');
		$link	= 'index.php?option=com_=jbjobs&view=adminconfig&layout=showplanjs';
		$app->redirect($link, $msg);
	}
	
	function savePlanJS(){
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		// Initialize variables
		$app =& JFactory::getApplication();
		$db		=& JFactory::getDBO();
		$row	=& JTable::getInstance('planjs', 'Table');
		$post   = JRequest::get('post');
		$post['description'] = JRequest::getVar('description', '', 'post', 'string', JREQUEST_ALLOWRAW);
		$post['finish_msg'] = JRequest::getVar('finish_msg', '', 'post', 'string', JREQUEST_ALLOWRAW);
		
		if(!$row->bind($post)){
			JError::raiseError(500, $row->getError());
		}
		// pre-save checks
		if(!$row->check()){
			JError::raiseError(500, $row->getError());
		}
		// if new item,  last in appropriate group
		if(!$row->id){
			$where = "id=".(int)$row->id;		
		}
		// save the changes
		if(!$row->store()){
			JError::raiseError(500, $row->getError());
		}
		$row->checkin();
		
		$msg	= JText::_('JBJOBS_PLANS_SAVED');
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showplanjs';
		$app->redirect($link, $msg);
	}
	
	function cancelPlanJS($cancel){
		$app =& JFactory::getApplication();
		$msg = '';
		$link = 'index.php?option=com_jbjobs&view=adminconfig&layout=showplanjs';	
		$app->redirect($link, $msg);
	}
 
 	function showPlanJS(){
		JRequest :: setVar('view', 'adminconfig');
		JRequest :: setVar('layout', 'showplanjs');
		$this->display();
	}
/**
  ================================================================================================================
	SECTION : Configuration:Payment Modes - save, cancel
  ================================================================================================================
*/	
	function savePaymode(){
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		// Initialize variables
		$db		=& JFactory::getDBO();
		$post   = JRequest::get('post');
		
		foreach ($post as $key=>$value){
			$query = 'UPDATE #__jbjobs_payment_mode SET savedvalue='.$db->quote($value).' WHERE fieldname='.$db->quote($key);
			$db->setQuery($query);
			if(!$db->query()){
				JError::raiseError($db->getErrorNum(), $db->getErrorMsg());
			}
         }
		$msg	= JText::_('JBJOBS_PAYMENT_SETTINGS_SAVED');
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showpaymode';
		$this->setRedirect($link, $msg);
	}
	
	function cancelPaymode(){
		$app =& JFactory::getApplication();
		$msg ='';
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showpaymode';	
		$this->setRedirect($link, $msg);
	}
	
 /**
  ================================================================================================================
	SECTION : Configuration:Country - new, remove, save, cancel
	================================================================================================================
*/	
	function newcountry(){
		JRequest :: setVar('view', 'adminconfig');
		JRequest :: setVar('hidemainmenu', 1);
		JRequest :: setVar('layout', 'editcountry');
		$this->display();
	}
	
	function removeCountry(){
	
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
	
		// Initialize variables
		$app =& JFactory::getApplication();
		$db  =& JFactory::getDBO();
		$cid =& JRequest::getVar('cid', array(0), 'post', 'array');
		JArrayHelper::toInteger($cid, array(0));
		$delCount = 0;
	
		if(count($cid)){
			$count_ketemu = 0;
			for($i=0; $i<count($cid); $i++){
				$curr_bid =$cid[$i];
				
				$query ="SELECT COUNT(*) FROM #__jbjobs_job WHERE id_country=$curr_bid";
				$db->setQuery($query);	
				$find_1 = $db->loadResult();	

				$query ="SELECT COUNT(*) FROM #__jbjobs_billing WHERE id_country=$curr_bid";
				$db->setQuery($query);	
				$find_2 = $db->loadResult();	

				$query ="SELECT COUNT(*) FROM #__jbjobs_jobseekeer WHERE id_country=$curr_bid";
				$db->setQuery($query);	
				$find_3 = $db->loadResult();	

				$query ="SELECT COUNT(*) FROM #__jbjobs_employer WHERE id_country=$curr_bid";
				$db->setQuery($query);	
				$find_4 = $db->loadResult();

				if($find_1 > 0 || $find_2 > 0 || $find_3 > 0 || $find_4 > 0){
					$ketemu = 1;
				}						
				if($find_1 == 0 && $find_2 == 0 && $find_3 == 0 && $find_4 == 0){
					$db->setQuery("DELETE FROM #__jbjobs_country WHERE id = $curr_bid");
					$delCount++;
					if(!$db->query()){
						JError::raiseError($db->getErrorNum(), $db->getErrorMsg());
					}
				}
				if($ketemu > 0){
					$count_ketemu++;
				}
			}
			if($count_ketemu > 0){
				$app->enqueueMessage(JText::sprintf('JBJOBS_CANNOT_DELETE_DATA_DUE_TO_TABLE_LINKING', JText::_('JBJOBS_COUNTRY')), 'error');
			}		
		}
		$msg	= $delCount.' '.JText::_('JBJOBS_COUNTRY_DELETED');
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showcountry';
		$app->redirect($link, $msg);
	}
	
	function saveCountry(){
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		// Initialize variables
		$app =& JFactory::getApplication();
		$db		=& JFactory::getDBO();
		$row	=& JTable::getInstance('country', 'Table');
		$post   = JRequest::get( 'post' );
		
		if(!$row->bind($post)){
			JError::raiseError(500, $row->getError());
		}
		// pre-save checks
		if(!$row->check()){
			JError::raiseError(500, $row->getError());
		}
		// if new item,  last in appropriate group
		if(!$row->id){
			$where = "id=".(int)$row->id;		
		}
		// save the changes
		if(!$row->store()){
			JError::raiseError(500, $row->getError());
		}
		$row->checkin();
		
		$msg  = JText::_('JBJOBS_COUNTRY_SAVED');
		$link = 'index.php?option=com_jbjobs&view=adminconfig&layout=showcountry';
		$app->redirect($link, $msg);
	}
	
	function cancelCountry($cancel){
		$app =& JFactory::getApplication();
		$msg = '';
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showcountry';	
		$app->redirect($link,$msg);
	}
 
 	function showCountry(){
		JRequest :: setVar('view', 'adminconfig');
		JRequest :: setVar('layout', 'showcountry');
		$this->display();
	}
 /**
  ================================================================================================================
	SECTION : Configuration:State - new, remove, save, cancel
	================================================================================================================
*/	
	function newState(){
		JRequest :: setVar('view', 'adminconfig');
		JRequest :: setVar('hidemainmenu', 1);
		JRequest :: setVar('layout', 'editstate');
		$this->display();
	}
		
	function removeState(){
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		// Initialize variables
		$app =& JFactory::getApplication();
		$db  =& JFactory::getDBO();
		$cid =& JRequest::getVar('cid', array(0), 'post', 'array');
		JArrayHelper::toInteger($cid, array(0));
		
		//get the country id for routing after deletion.
		$query = "SELECT country_id FROM #__jbjobs_state  WHERE id=".$cid[0];
		$db->setQuery($query);
		$country_id = $db->loadResult();
		
		if(count($cid)){
			for($i=0; $i < count($cid); $i++){
				$curr_bid = $cid[$i];
				$db->setQuery("DELETE FROM #__jbjobs_state WHERE id = $curr_bid");
				if(!$db->query()){
					JError::raiseError($db->getErrorNum(), $db->getErrorMsg());
				}
			}
		}
		$msg  = JText::_('JBJOBS_STATES_DELETED');
		$link = 'index.php?option=com_jbjobs&view=adminconfig&layout=showstate&country_id='.$country_id;
		$app->redirect($link, $msg);
	}
	
	function savestate(){
		$app =& JFactory::getApplication();
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		// Initialize variables
		$db		=& JFactory::getDBO();
		$row	=& JTable::getInstance('state', 'Table');
		$post   = JRequest::get('post');
		$state_name = $post['state'];
		
		if(!$row->bind($post)){
			JError::raiseError(500, $row->getError());
		}
		// pre-save checks
		if(!$row->check()){
			JError::raiseError(500, $row->getError());
		}
		// if new item,  last in appropriate group
		if(!$row->id){
			$where = "id=".(int)$row->id;		
		}
		// save the changes
		if(!$row->store()){
			JError::raiseError(500, $row->getError());
		}
		$row->checkin();
		
		//update the state name in the city table
		$query = "UPDATE #__jbjobs_city SET state_name=".$db->quote($state_name). " WHERE state_id=".$db->quote($post['id']);
		$db->setQuery($query);
		$save = $db->query();
		
		$msg  = JText::_('JBJOBS_STATES_SAVED');
		$link = 'index.php?option=com_jbjobs&view=adminconfig&layout=showstate&country_id='.$row->country_id;
		$app->redirect($link, $msg);
	}
	
	function cancelState($cancel){
		$app =& JFactory::getApplication();
		$country_id = JRequest::getVar('cont_id', '', 'post', 'string');
		$msg ='';
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showstate&country_id='.$country_id;	
		$app->redirect($link, $msg);
	}
	
	function showState(){
		JRequest :: setVar('view', 'adminconfig');
		JRequest :: setVar('layout', 'showstate');
		$this->display();
	} 
 /**
  ================================================================================================================
	SECTION : Configuration:City - new, remove, save, cancel
	================================================================================================================
*/	
	function newCity(){
		JRequest :: setVar('view', 'adminconfig');
		JRequest :: setVar('hidemainmenu', 1);
		JRequest :: setVar('layout', 'editcity');
		$this->display();
	}
		
	function removeCity(){
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		// Initialize variables
		$app =& JFactory::getApplication();
		$db =& JFactory::getDBO();
		$cid 	=& JRequest::getVar('cid', array(0), 'post', 'array');
		JArrayHelper::toInteger($cid, array(0));
		$post   = JRequest::get('post');
		$state_name = $post['stat_name'];
		
		if(count($cid)){
			for($i=0; $i < count($cid); $i++){
				$curr_bid = $cid[$i];
				$db->setQuery("DELETE FROM #__jbjobs_city WHERE id = $curr_bid");
				if (!$db->query()){
					JError::raiseError($db->getErrorNum(), $db->getErrorMsg());
				}
			}
		}
		$msg  = JText::_('JBJOBS_CITIES_DELETED');
		$link = 'index.php?option=com_jbjobs&view=adminconfig&layout=showcity&state_name='.$state_name;
		$app->redirect($link, $msg);
	}
	
	function saveCity(){
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		// Initialize variables
		$app =& JFactory::getApplication();
		$db		=& JFactory::getDBO();
		$row	=& JTable::getInstance('city', 'Table');
		$post   = JRequest::get('post');
		$state_name = $post['state'];
		
		if(empty($post['state_id'])){
			$query = "SELECT id FROM #__jbjobs_state WHERE state=".$db->Quote($state_name);
			$db->setQuery($query);
			$state_id = $db->loadResult();
			$post['state_id'] = $state_id;
		}
		
		if(!$row->bind($post)){
			JError::raiseError(500, $row->getError());
		}
		$row->state_name = $post['state'];
		// pre-save checks
		if(!$row->check()){
			JError::raiseError(500, $row->getError());
		}
		// if new item,  last in appropriate group
		if(!$row->id){
			$where = "id=".(int)$row->id;		
		}
		// save the changes
		if(!$row->store()){
			JError::raiseError(500, $row->getError());
		}
		$row->checkin();
		
		$msg  = JText::_('JBJOBS_CITIES_SAVED');
		$link = 'index.php?option=com_jbjobs&view=adminconfig&layout=showcity&state_name='.$state_name;
		$app->redirect($link, $msg);
	}
	
	function cancelCity($cancel){
		$app =& JFactory::getApplication();
		$post   = JRequest::get('post');
		$state_name = $post['state_name'];
		$msg = '';
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showcity&state_name='.$state_name;
		$app->redirect($link, $msg);
	}

/**
  ================================================================================================================
	SECTION : Configuration:Email Templates - save
  ================================================================================================================
*/
	function saveEmailTemplate(){
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		// Initialize variables
		$app =& JFactory::getApplication();
		$db		=& JFactory::getDBO();
		$row	=& JTable::getInstance('emailtemp', 'Table');
		$post   = JRequest::get('post');
		$post['body'] = JRequest::getVar('body', '', 'post', 'string', JREQUEST_ALLOWRAW);
		
		if(!$row->bind($post)){
			JError::raiseError(500, $row->getError());
		}
		// pre-save checks
		if(!$row->check()){
			JError::raiseError(500, $row->getError());
		}
		// if new item,  last in appropriate group
		if(!$row->id){
			$where = "id=".(int)$row->id;		
		}
		// save the changes
		if(!$row->store()){
			JError::raiseError(500, $row->getError());
		}
		$row->checkin();
		
		$msg	= JText::_('JBJOBS_EMAIL_TEMPLATE_SAVED');
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=emailtemplate';
		$this->setRedirect($link, $msg);
	}
/**
  ================================================================================================================
	SECTION : Configuration:Major - new, remove, save, cancel
	================================================================================================================
*/	
	function newmajor(){
				JRequest :: setVar('view', 'adminconfig');
				JRequest :: setVar('hidemainmenu', 1);
				JRequest :: setVar('layout', 'editmajor');
				$this->display();
	}
	
	function removeMajor(){
		$app =& JFactory::getApplication();
	
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
	
		// Initialize variables
		$db =& JFactory::getDBO();
		$cid 	=& JRequest::getVar('cid', array(0), 'post', 'array');
		JArrayHelper::toInteger($cid);
		$delCount = 0;
	
		if(count($cid)){
			$count_ketemu = 0;
			for($i=0; $i<count($cid); $i++){
				$curr_bid = $cid[$i];
				
				$query = "SELECT COUNT(*) FROM #__jbjobs_jobseeker WHERE id_major=$curr_bid";
				$db->setQuery($query);	
				$find_1 = $db->loadResult();	
				
				$query = "SELECT COUNT(*) FROM #__jbjobs_job WHERE id_major=$curr_bid";
				$db->setQuery($query);	
				$find_2 = $db->loadResult();
				
				if($find_1 > 0 || $find_2 > 0){
					$ketemu = 1;
				}			
				if($find_1 == 0  && $find_2 == 0){
					$db->setQuery("DELETE FROM #__jbjobs_major WHERE id = $curr_bid");
					$delCount++;
					if(!$db->query()){
						JError::raiseError($db->getErrorNum(), $db->getErrorMsg());
					}
				}
				if($ketemu > 0){
					$count_ketemu++;
				}
			}
			if($count_ketemu > 0){
				$app->enqueueMessage(JText::sprintf('JBJOBS_CANNOT_DELETE_DATA_DUE_TO_TABLE_LINKING', JText::_('JBJOBS_MAJOR')), 'error');
			}		
		}
		$msg	= $delCount.' '.JText::_('JBJOBS_MAJOR_DELETED');
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showmajor';
		$app->redirect($link, $msg);
	}
	
	function saveMajor(){
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		// Initialize variables
		$app =& JFactory::getApplication();
		$db	 =& JFactory::getDBO();
		$row =& JTable::getInstance('major', 'Table');
		$post = JRequest::get('post');
		
		if(!$row->bind($post)){
			JError::raiseError(500, $row->getError());
		}
		// pre-save checks
		if(!$row->check()){
			JError::raiseError(500, $row->getError());
		}
		// if new item,  last in appropriate group
		if(!$row->id){
			$where = "id=".(int)$row->id;		
		}
		// save the changes
		if(!$row->store()){
			JError::raiseError(500, $row->getError());
		}
		$row->checkin();
		
		$msg	= JText::_('JBJOBS_MAJOR_SAVED');
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showmajor';
		$app->redirect($link, $msg);
	}
	
	function cancelMajor($cancel){
		$app =& JFactory::getApplication();
		$msg ='';
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showmajor';	
		$app->redirect( $link,$msg );
			
	}
/**
  ================================================================================================================
	SECTION : Configuration:Degree Level - new, remove, save, cancel
	================================================================================================================
*/	
	function newDegLevel(){
		JRequest :: setVar('view', 'adminconfig');
		JRequest :: setVar('hidemainmenu', 1);
		JRequest :: setVar('layout', 'editdeglevel');
		$this->display();
	}
	
	function removeDegLevel(){
	
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
	
		// Initialize variables
		$app =& JFactory::getApplication();
		$db =& JFactory::getDBO();
		$cid 	=& JRequest::getVar('cid', array(0), 'post', 'array');
		JArrayHelper::toInteger($cid);
		$delCount = 0;
	
		if(count($cid)){
			$count_ketemu =0;
			for($i=0;$i<count($cid);$i++){
				$curr_bid =$cid[$i];
				
				$query ="SELECT COUNT(*) FROM #__jbjobs_job WHERE id_degree_level=$curr_bid";
				$db->setQuery($query);	
				$find_1 = $db->loadResult();	
				
				$query ="SELECT COUNT(*) FROM #__jbjobs_jobseeker WHERE id_degree_level=$curr_bid";
				$db->setQuery($query);	
				$find_2 = $db->loadResult();	
					
				if($find_1 > 0 || $find_2 > 0 ){
					$ketemu = 1;
				}								
				if($find_1 == 0  && $find_2 == 0){
					$db->setQuery("DELETE FROM #__jbjobs_degree_level WHERE id = $curr_bid");
					$delCount++;
					if(!$db->query()){
						JError::raiseError($db->getErrorNum(), $db->getErrorMsg());
					}
				}
				if($ketemu > 0){
					$count_ketemu++;
				}
			}
			if($count_ketemu > 0){				
				$app->enqueueMessage(JText::sprintf('JBJOBS_CANNOT_DELETE_DATA_DUE_TO_TABLE_LINKING', JText::_('JBJOBS_DEG_LEVEL')), 'error');
			}		
		}
		$msg	= $delCount.' '.JText::_('JBJOBS_DEG_LEVELS_DELETED');
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showdeglevel';
		$app->redirect($link, $msg);
	}
	
	function saveDegLevel(){
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		// Initialize variables
		$app =& JFactory::getApplication();
		$db		=& JFactory::getDBO();
		$row	=& JTable::getInstance('degreeLevel', 'Table');
		$post   = JRequest::get( 'post' );
		
		if(!$row->bind($post)){
			JError::raiseError(500, $row->getError());
		}
		// pre-save checks
		if(!$row->check()){
			JError::raiseError(500, $row->getError());
		}
		// if new item,  last in appropriate group
		if(!$row->id){
			$where = "id=".(int)$row->id;		
		}
		// save the changes
		if(!$row->store()){
			JError::raiseError(500, $row->getError());
		}
		$row->checkin();
		
		$msg	= JText::_('JBJOBS_DEG_LEVELS_SAVED');
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showdeglevel';
		$app->redirect($link, $msg);
	}
	
	function cancelDegLevel($cancel){
		$app =& JFactory::getApplication();
		$msg = '';
		$link = 'index.php?option=com_jbjobs&view=adminconfig&layout=showdeglevel';
		$app->redirect($link,$msg);
	}

/**
  ================================================================================================================
	SECTION : Configuration:University - new, remove, save, cancel
	================================================================================================================
*/	
	function newUniversity(){
		JRequest :: setVar('view', 'adminconfig');
		JRequest :: setVar('hidemainmenu', 1);
		JRequest :: setVar('layout', 'edituniversity');
		$this->display();
	}
	
	function removeUniversity(){
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		// Initialize variables
		$app =& JFactory::getApplication();
		$db =& JFactory::getDBO();
		$cid =& JRequest::getVar('cid', array(0), 'post', 'array');
		JArrayHelper::toInteger($cid);
		$delCount = 0;
		
		if(count($cid)){
			$count_ketemu =0;
			for($i=0; $i<count($cid); $i++){
				$curr_bid =$cid[$i];
				
				$db->setQuery("DELETE FROM #__jbjobs_university WHERE id = $curr_bid");
				$delCount++;
				if(!$db->query()){
					JError::raiseError($db->getErrorNum(), $db->getErrorMsg());
				}
			}
		}
		$msg	= $delCount.' '.JText::_('JBJOBS_UNIVERSITY_DELETED');
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showuniversity';
		$app->redirect($link, $msg);
	}
	
	function saveUniversity(){
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		// Initialize variables
		$app =& JFactory::getApplication();
		$db		=& JFactory::getDBO();
		$row	=& JTable::getInstance('university', 'Table');
		$post   = JRequest::get( 'post' );
		
		if(!$row->bind($post)){
			JError::raiseError(500, $row->getError());
		}
		// pre-save checks
		if(!$row->check()){
			JError::raiseError(500, $row->getError());
		}
		// if new item,  last in appropriate group
		if(!$row->id){
			$where = "id=".(int)$row->id;		
		}
		// save the changes
		if(!$row->store()){
			JError::raiseError(500, $row->getError());
		}
		$row->checkin();
		
		$msg	= JText::_('JBJOBS_UNIVERSITY_SAVED');
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showuniversity';
		$app->redirect($link, $msg);
	}
	
	function cancelUniversity($cancel){
		$app =& JFactory::getApplication();
		$msg = '';
		$link = 'index.php?option=com_jbjobs&view=adminconfig&layout=showuniversity';
		$app->redirect($link, $msg);
	}
/**
  ================================================================================================================
	SECTION : Configuration:Salary Type - new, remove, save, cancel
	================================================================================================================
*/		
	function newSalType(){
		JRequest :: setVar('view', 'adminconfig');
		JRequest :: setVar('hidemainmenu', 1);
		JRequest :: setVar('layout', 'editsaltype');
		$this->display();
	}
	
	function removeSalType(){
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
	
		// Initialize variables
		$app =& JFactory::getApplication();
		$db =& JFactory::getDBO();
		$cid 	=& JRequest::getVar('cid', array(0), 'post', 'array');
		JArrayHelper::toInteger($cid);
		$delCount = 0;
	
		if (count($cid)) {
			$count_ketemu =0;
			for($i=0; $i<count($cid); $i++){
				$curr_bid =$cid[$i];
				
				$query ="SELECT COUNT(*) FROM  #__jbjobs_job WHERE id_salary_type=".$curr_bid;
				$db->setQuery($query);	
				$find_1 = $db->loadResult();	
				
				$query ="select COUNT(*) FROM  #__jbjobs_jobseeker where id_type_salary=".$curr_bid;
				$db->setQuery($query);	
				$find_2 = $db->loadResult();	
					
				if($find_1 > 0 || $find_2 > 0 ){
					$ketemu = 1;
				}									
				if($find_1 == 0  && $find_2 == 0){
					$db->setQuery("DELETE FROM #__jbjobs_type_salary WHERE id=$curr_bid");
					$delCount++;
					if (!$db->query()) {
						JError::raiseError($db->getErrorNum(), $db->getErrorMsg());
					}
				}
				if($ketemu >0){
					$count_ketemu++;
				}
			}
			if($count_ketemu >0){				
				$app->enqueueMessage(JText::sprintf('JBJOBS_CANNOT_DELETE_DATA_DUE_TO_TABLE_LINKING', JText::_('JBJOBS_SAL_TYPE')), 'error');
			}		
		}
	
		$msg	= $delCount.' '.JText::_('JBJOBS_SAL_TYPE_DELETED');
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showsaltype';
		$app->redirect($link, $msg);
	}
	
	function saveSalType($option){
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		// Initialize variables
		$app =& JFactory::getApplication();
		$db		=& JFactory::getDBO();
		$row	=& JTable::getInstance('typeSalary', 'Table');
		$post   = JRequest::get( 'post' );
		
		if(!$row->bind($post)){
			JError::raiseError(500, $row->getError());
		}
		// pre-save checks
		if(!$row->check()){
			JError::raiseError(500, $row->getError());
		}
		// if new item,  last in appropriate group
		if(!$row->id){
			$where = "id=".(int)$row->id;		
		}
		// save the changes
		if(!$row->store()){
			JError::raiseError(500, $row->getError());
		}
		$row->checkin();
		
		$msg	= JText::_('JBJOBS_SAL_TYPE_SAVED');
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showsaltype';
		$app->redirect($link, $msg);
	}
	
	function cancelSalType($cancel){
		$app =& JFactory::getApplication();
		$msg = '';
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showsaltype';
		$app->redirect($link, $msg);
	}
/**
  ================================================================================================================
	SECTION : Configuration:Job Experience - new, remove, save, cancel
	================================================================================================================
*/		
	function newJobExp(){
		JRequest :: setVar('view', 'adminconfig');
		JRequest :: setVar('hidemainmenu', 1);
		JRequest :: setVar('layout', 'editjobexp');
		$this->display();
	}
	
	function removeJobExp(){
	
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
	
		// Initialize variables
		$app =& JFactory::getApplication();
		$db =& JFactory::getDBO();
		$cid 	=& JRequest::getVar('cid', array(0), 'post', 'array');
		JArrayHelper::toInteger($cid);
		$delCount = 0;
	
		if(count($cid)){
			$count_ketemu =0;
			for($i=0;$i<count($cid);$i++){
				$curr_bid =$cid[$i];
				
				$query ="SELECT COUNT(*) FROM #__jbjobs_job WHERE id_job_exp=$curr_bid";
				$db->setQuery($query);	
				$find_1 = $db->loadResult();	
				
				$query ="SELECT COUNT(*) FROM #__jbjobs_jobseeker WHERE id_job_exp=$curr_bid";
				$db->setQuery($query);	
				$find_2 = $db->loadResult();	
				
				if($find_1 > 0 || $find_2 > 0 ){
					$ketemu = 1;
				}									
				if($find_1 == 0 && $find_2 == 0){
					$db->setQuery("DELETE FROM #__jbjobs_job_exp WHERE id = $curr_bid");
					$delCount++;
					if (!$db->query()) {
						JError::raiseError($db->getErrorNum(), $db->getErrorMsg());
					}
				}
				if($ketemu > 0){
					$count_ketemu++;
				}
			}
			if($count_ketemu > 0){				
				$app->enqueueMessage(JText::sprintf('JBJOBS_CANNOT_DELETE_DATA_DUE_TO_TABLE_LINKING', JText::_('JBJOBS_EXP_LEVEL')), 'error');
			}		
		}
		$msg	= $delCount.' '.JText::_('JBJOBS_EXP_LEVEL_DELETED');
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showjobexp';
		$app->redirect($link, $msg);
	}
	
	function saveJobExp(){
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		// Initialize variables
		$app =& JFactory::getApplication();
		$db		=& JFactory::getDBO();
		$row	=& JTable::getInstance('jobExp', 'Table');
		$post   = JRequest::get( 'post' );
		
		if(!$row->bind($post)){
			JError::raiseError(500, $row->getError());
		}
		// pre-save checks
		if(!$row->check()){
			JError::raiseError(500, $row->getError());
		}
		// if new item,  last in appropriate group
		if(!$row->id){
			$where = "id=".(int)$row->id;		
		}
		// save the changes
		if(!$row->store()){
			JError::raiseError(500, $row->getError());
		}
		$row->checkin();
		
		$msg	= JText::_('JBJOBS_EXP_LEVEL_SAVED');
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showjobexp';
		$app->redirect($link, $msg);
	}

	function cancelJobExp($cancel){
		$app =& JFactory::getApplication();
		$msg = '';
		$link = 'index.php?option=com_jbjobs&view=adminconfig&layout=showjobexp';
		$app->redirect($link, $msg);
	}
/**
  ================================================================================================================
	SECTION : Configuration:Company Type - new, remove, save, cancel
	================================================================================================================
*/		
	function newCompType(){
		JRequest :: setVar('view', 'adminconfig');
		JRequest :: setVar('hidemainmenu', 1);
		JRequest :: setVar('layout', 'editcomptype');
		$this->display();
	}
	
	function removeCompType(){
	
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
	
		// Initialize variables
		$app =& JFactory::getApplication();
		$db =& JFactory::getDBO();
		$cid =& JRequest::getVar('cid', array(0), 'post', 'array');
		JArrayHelper::toInteger($cid);
		$delCount = 0;
	
		if(count($cid)){
			$count_ketemu =0;
			for($i=0; $i<count($cid); $i++){
				$curr_bid =$cid[$i];
				
				$query ="SELECT COUNT(*) FROM #__jbjobs_employer WHERE id_comp_type=$curr_bid";
				$db->setQuery($query);	
				$find_1 = $db->loadResult();	
				
				if($find_1 > 0){
					$ketemu = 1;
				}		
				if($find_1 == 0){
					$db->setQuery("DELETE FROM #__jbjobs_comp_type WHERE id = $curr_bid");
					$delCount++;
					if (!$db->query()) {
						JError::raiseError($db->getErrorNum(), $db->getErrorMsg());
					}
				}
				if($ketemu > 0){
					$count_ketemu++;
				}
			}
			if($count_ketemu > 0){				
				$app->enqueueMessage(JText::sprintf('JBJOBS_CANNOT_DELETE_DATA_DUE_TO_TABLE_LINKING', JText::_('JBJOBS_COMP_TYPE')), 'error');
			}		
		}
		$msg	= $delCount.' '.JText::_('JBJOBS_COMP_TYPE_DELETED');
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showcomptype';
		$app->redirect($link, $msg);
	}

	function saveCompType(){
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		// Initialize variables
		$app =& JFactory::getApplication();
		$db		=& JFactory::getDBO();
		$row	=& JTable::getInstance('compType', 'Table');
		$post   = JRequest::get('post');
		
		if(!$row->bind($post)){
			JError::raiseError(500, $row->getError());
		}
		// pre-save checks
		if(!$row->check()){
			JError::raiseError(500, $row->getError());
		}
		// if new item,  last in appropriate group
		if(!$row->id){
			$where = "id=".(int)$row->id;		
		}
		// save the changes
		if(!$row->store()){
			JError::raiseError(500, $row->getError());
		}
		$row->checkin();
		
		$msg	= JText::_('JBJOBS_COMP_TYPE_SAVED');
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showcomptype';
		$app->redirect($link, $msg);
	}
	
	function cancelCompType($cancel){
		$app =& JFactory::getApplication();
		$msg = '';
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showcomptype';
		$app->redirect($link, $msg);
	}
/**
  ================================================================================================================
	SECTION : Configuration:Salutation - new, remove, save, cancel
	================================================================================================================
*/	
	function newSalutation(){
		JRequest :: setVar('view', 'adminconfig');
		JRequest :: setVar('hidemainmenu', 1);
		JRequest :: setVar('layout', 'editsalutation');
		$this->display();
	}
	
	function removeSalutation(){
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
	
		// Initialize variables
		$app =& JFactory::getApplication();
		$db =& JFactory::getDBO();
		$cid 	=& JRequest::getVar('cid', array(0), 'post', 'array');
		JArrayHelper::toInteger($cid);
		$delCount = 0;
	
		if(count($cid)){
			$count_ketemu =0;
			for($i=0;$i<count($cid);$i++){
				$curr_bid =$cid[$i];
				
				$query = "SELECT COUNT(*) FROM #__jbjobs_employer WHERE id_salutation=$curr_bid";
				$db->setQuery($query);	
				$find_1 = $db->loadResult();	
				
				if($find_1 > 0){
					$ketemu = 1;
				}									
				if($find_1 == 0){
					$db->setQuery("DELETE FROM #__jbjobs_salutation WHERE id = $curr_bid");
					$delCount++;
					if (!$db->query()) {
						JError::raiseError($db->getErrorNum(), $db->getErrorMsg());
					}
				}
				if($ketemu > 0){
					$count_ketemu++;
				}
			}
			if($count_ketemu > 0){				
				$app->enqueueMessage(JText::sprintf('JBJOBS_CANNOT_DELETE_DATA_DUE_TO_TABLE_LINKING', JText::_('JBJOBS_SALUTATION')), 'error');
			}		
		}
		$msg	= $delCount.' '.JText::_('JBJOBS_SALUTATION_DELETED');
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showsalutation';
		$app->redirect($link, $msg);
	}

	function saveSalutation(){
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		// Initialize variables
		$app =& JFactory::getApplication();
		$db		=& JFactory::getDBO();
		$row	=& JTable::getInstance('salutation', 'Table');
		$post   = JRequest::get( 'post' );
		
		if(!$row->bind($post)){
			JError::raiseError(500, $row->getError());
		}
		// pre-save checks
		if(!$row->check()){
			JError::raiseError(500, $row->getError());
		}
		// if new item,  last in appropriate group
		if(!$row->id){
			$where = "id=".(int)$row->id;		
		}
		// save the changes
		if(!$row->store()){
			JError::raiseError(500, $row->getError());
		}
		$row->checkin();
		
		$msg	= JText::_('JBJOBS_SALUTATION_SAVED');
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showsalutation';
		$app->redirect($link, $msg);
	}

	function cancelSalutation($cancel){
		$app =& JFactory::getApplication();
		$msg = '';
		$link = 'index.php?option=com_jbjobs&view=adminconfig&layout=showsalutation';
		$app->redirect($link, $msg);
	}
/**
  ================================================================================================================
	SECTION : Configuration:Position Type - new, remove, save, cancel
	================================================================================================================
*/		
	function newPosType(){
		JRequest :: setVar('view', 'adminconfig');
		JRequest :: setVar('hidemainmenu', 1);
		JRequest :: setVar('layout', 'editpostype');
		$this->display();
	}
	
	function removePosType(){
	
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
	
		// Initialize variables
		$app =& JFactory::getApplication();
		$db  =& JFactory::getDBO();
		$cid =& JRequest::getVar('cid', array(0), 'post', 'array');
		JArrayHelper::toInteger($cid);
		$delCount = 0;
	
		if(count($cid)){
			$count_ketemu = 0;
			for($i=0;$i<count($cid);$i++){
				$curr_bid =$cid[$i];
				
				$query = "SELECT COUNT(*) FROM #__jbjobs_jobseeker WHERE id_pos_type=$curr_bid";
				$db->setQuery($query);	
				$find_1 = $db->loadResult();	
				
				if($find_1 > 0){
					$ketemu =1;
				}		
				if($find_1 == 0){
					$db->setQuery("DELETE FROM #__jbjobs_pos_type WHERE id = $curr_bid");
					$delCount++;
					if (!$db->query()) {
						JError::raiseError($db->getErrorNum(), $db->getErrorMsg());
					}
				}
				if($ketemu > 0){
					$count_ketemu++;
				}
			}
			if($count_ketemu > 0){				
				$app->enqueueMessage(JText::sprintf('JBJOBS_CANNOT_DELETE_DATA_DUE_TO_TABLE_LINKING', JText::_('JBJOBS_POS_TYPE')), 'error');
			}		
		}
		$msg	= $delCount.' '.JText::_('JBJOBS_POS_TYPE_DELETED');
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showpostype';
		$app->redirect($link, $msg);
	}

	function savePosType(){
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		// Initialize variables
		$app =& JFactory::getApplication();
		$db		=& JFactory::getDBO();
		$row	=& JTable::getInstance('posType', 'Table');
		$post   = JRequest::get( 'post' );
		
		if(!$row->bind($post)){
			JError::raiseError(500, $row->getError());
		}
		// pre-save checks
		if(!$row->check()){
			JError::raiseError(500, $row->getError());
		}
		// if new item,  last in appropriate group
		if(!$row->id){
			$where = "id=".(int)$row->id;		
		}
		// save the changes
		if(!$row->store()){
			JError::raiseError(500, $row->getError());
		}
		$row->checkin();
		
		$msg	= JText::_('JBJOBS_POS_TYPE_SAVED');
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showpostype';
		$app->redirect($link, $msg);
	}
	
	function cancelPosType($cancel){
		$app =& JFactory::getApplication();
		$msg = '';
		$link = 'index.php?option=com_jbjobs&view=adminconfig&layout=showpostype';	
		$app->redirect($link, $msg);
	}
/**
  ================================================================================================================
	SECTION : Configuration:Job Specialization - new, remove, save, cancel, show
	================================================================================================================
*/	
	function newJobSpec(){
		JRequest :: setVar('view', 'adminconfig');
		JRequest :: setVar('hidemainmenu', 1);
		JRequest :: setVar('layout', 'editjobspec');
		$this->display();
	}
	
	function removeJobSpec(){
	
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
	
		// Initialize variables
		$app =& JFactory::getApplication();
		$db =& JFactory::getDBO();
		$cid 	=& JRequest::getVar('cid', array(0), 'post', 'array');
		JArrayHelper::toInteger($cid);
		$delCount = 0;
	
		if(count($cid)){
			$count_ketemu = 0;
			for($i=0; $i<count($cid); $i++){
				$curr_bid =$cid[$i];
					
				$query ="SELECT COUNT(*) FROM #__jbjobs_job WHERE id_job_spec=$curr_bid";
				$db->setQuery($query);	
				$find_1 = $db->loadResult();	
				
				$query ="SELECT COUNT(*) FROM #__jbjobs_jobseeker WHERE id_job_spec=$curr_bid";
				$db->setQuery($query);	
				$find_2 = $db->loadResult();	
				
				if($find_1 > 0 || $find_2 > 0){
					$ketemu =1;
				}
				if($find_1 == 0 && $find_2 == 0){
					
					$db->setQuery("DELETE FROM #__jbjobs_job_spec WHERE id = $curr_bid");
					$delCount++;
					if (!$db->query()) {
						JError::raiseError($db->getErrorNum(), $db->getErrorMsg());
					}
				}
				if($ketemu > 0){
					$count_ketemu++;
				}
			}
			if($count_ketemu > 0){				
				$app->enqueueMessage(JText::sprintf('JBJOBS_CANNOT_DELETE_DATA_DUE_TO_TABLE_LINKING', JText::_('JBJOBS_JOB_SPEC')), 'error');
			}		
		}
		$msg	= $delCount.' '.JText::_('JBJOBS_JOB_SPEC_DELETED');
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showjobspec';
		$app->redirect($link, $msg);
	}
	
	function saveJobSpec(){
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		// Initialize variables
		$app =& JFactory::getApplication();
		$db		=& JFactory::getDBO();
		$row	=& JTable::getInstance('jobSpec', 'Table');
		$post   = JRequest::get('post');
		
		if(!$row->bind($post)){
			JError::raiseError(500, $row->getError());
		}
		// pre-save checks
		if(!$row->check()){
			JError::raiseError(500, $row->getError());
		}
		// if new item,  last in appropriate group
		if(!$row->id){
			$where = "id=".(int)$row->id;		
		}
		// save the changes
		if(!$row->store()){
			JError::raiseError(500, $row->getError());
		}
		$row->checkin();
		
		$msg	= JText::_('JBJOBS_JOB_SPEC_SAVED');
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showjobspec';
		$app->redirect($link, $msg);
	}
	
	function cancelJobSpec($cancel){
		$app =& JFactory::getApplication();
		$msg = '';
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showjobspec';
		$app->redirect($link, $msg);
}

	function showJobSpec(){
		JRequest :: setVar('view', 'adminconfig');
		JRequest :: setVar('layout', 'showjobspec');
		$this->display();
	}
/**
  ================================================================================================================
	SECTION : Configuration:Job Category - new, remove, save, cancel, show
	================================================================================================================
*/
	function newJobCateg(){
		JRequest :: setVar('view', 'adminconfig');
		JRequest :: setVar('hidemainmenu', 1);
		JRequest :: setVar('layout', 'editjobcateg');
		$this->display();
	}
	
	function removeJobCateg(){
	
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
	
		// Initialize variables
		$app =& JFactory::getApplication();
		$db  =& JFactory::getDBO();
		$cid =& JRequest::getVar('cid', array(0), 'post', 'array');
		JArrayHelper::toInteger($cid);
		$delCount = 0;
	
		if(count($cid)){
			$count_ketemu =0;
			for($i=0; $i<count($cid); $i++){
				$curr_bid =$cid[$i];
				
				$query ="select COUNT(*) FROM  #__jbjobs_job_spec where id_category=$curr_bid";
				$db->setQuery($query);	
				$find_1 = $db->loadResult();
					
				if($find_1 > 0){
					$ketemu = 1;
				}
				if($find_1 == 0){
					$db->setQuery("DELETE FROM #__jbjobs_job_categ WHERE id = $curr_bid");
					$delCount++;
					if(!$db->query()){
						JError::raiseError($db->getErrorNum(), $db->getErrorMsg());
					}
				}
				if($ketemu > 0){
					$count_ketemu++;
				}
			}
			if($count_ketemu > 0){				
				$app->enqueueMessage(JText::sprintf('JBJOBS_CANNOT_DELETE_DATA_DUE_TO_TABLE_LINKING', JText::_('JBJOBS_JOB_CATEG')), 'error');
			}		
		}
		$msg	= $delCount.' '.JText::_('JBJOBS_JOB_CATEG_DELETED');
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showjobcateg';
		$app->redirect($link, $msg);
	}

	function saveJobCateg(){
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		// Initialize variables
		$app =& JFactory::getApplication();
		$db		=& JFactory::getDBO();
		$row	=& JTable::getInstance('jobCateg', 'Table');
		$post   = JRequest::get( 'post' );
		
		if(!$row->bind($post)){
			JError::raiseError(500, $row->getError());
		}
		// pre-save checks
		if(!$row->check()){
			JError::raiseError(500, $row->getError());
		}
		// if new item,  last in appropriate group
		if(!$row->id){
			$where = "id=".(int)$row->id;		
		}
		// save the changes
		if(!$row->store()){
			JError::raiseError(500, $row->getError());
		}
		$row->checkin();
		
		$msg	= JText::_('JBJOBS_JOB_CATEG_SAVED');
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showjobcateg';
		$app->redirect($link, $msg);
	}
	
	function cancelJobCateg($cancel){
		$app =& JFactory::getApplication();
		$msg = '';
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showjobcateg';
		$app->redirect($link, $msg);
	}
	
	function showJobCateg(){
		JRequest :: setVar('view', 'adminconfig');
		JRequest :: setVar('layout', 'showjobcateg');
		$this->display();
	}
/**
  ================================================================================================================
	SECTION : Configuration:Industry - new, remove, save, cancel
	================================================================================================================
*/	
	function newIndComp(){
		JRequest :: setVar('view', 'adminconfig');
		JRequest :: setVar('hidemainmenu', 1);
		JRequest :: setVar('layout', 'editindcomp');
		$this->display();
	}
	
	function removeIndComp(){
	
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
	
		// Initialize variables
		$app =& JFactory::getApplication();
		$db =& JFactory::getDBO();
		$cid 	=& JRequest::getVar('cid', array(0), 'post', 'array');
		JArrayHelper::toInteger($cid);
		$delCount = 0;
	
		if(count($cid)){
			$count_ketemu = 0;
			for($i=0; $i<count($cid); $i++){
				$curr_bid = $cid[$i];
				
				$query = "SELECT COUNT(*) FROM  #__jbjobs_employer WHERE id_industry=$curr_bid";
				$db->setQuery($query);	
				$find_1 = $db->loadResult();	
				
				$query = "SELECT COUNT(*) FROM  #__jbjobs_jobseeker WHERE id_industry1 = $curr_bid OR id_industry2 =  $curr_bid";
				$db->setQuery($query);	
				$find_2 = $db->loadResult();	
				
				if($find_1 > 0 || $find_2 > 0){
					$ketemu = 1;
				}			
				if($find_1 == 0 && $find_2 == 0){
					$db->setQuery("DELETE FROM #__jbjobs_industry WHERE id = $curr_bid");
					$delCount++;
					if(!$db->query()){
						JError::raiseError($db->getErrorNum(), $db->getErrorMsg());
					}
				}
				if($ketemu > 0){
					$count_ketemu++;
				}
			}
			if($count_ketemu > 0){				
				$app->enqueueMessage(JText::sprintf('JBJOBS_CANNOT_DELETE_DATA_DUE_TO_TABLE_LINKING', JText::_('JBJOBS_INDUSTRY')), 'error');
			}		
		}
		$msg	= $delCount.' '.JText::_('JBJOBS_INDUSTRY_DELETED');
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showindcomp';
		$app->redirect($link, $msg);
	}

	function saveIndComp(){
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		// Initialize variables
		$app =& JFactory::getApplication();
		$db	 =& JFactory::getDBO();
		$row =& JTable::getInstance('industry', 'Table');
		$post = JRequest::get('post');
		
		if(!$row->bind($post)){
			JError::raiseError(500, $row->getError());
		}
		// pre-save checks
		if(!$row->check()){
			JError::raiseError(500, $row->getError());
		}
		// if new item,  last in appropriate group
		if(!$row->id){
			$where = "id=".(int)$row->id;		
		}
		// save the changes
		if(!$row->store()){
			JError::raiseError(500, $row->getError());
		}
		$row->checkin();
		
		$msg	= JText::_('JBJOBS_INDUSTRY_SAVED');
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showindcomp';
		$app->redirect($link, $msg);
	}
	
	function cancelIndComp($cancel){
		$app =& JFactory::getApplication();
		$msg = '';
		$link = 'index.php?option=com_jbjobs&view=adminconfig&layout=showindcomp';
		$app->redirect($link, $msg);
	}
/**
  ================================================================================================================
	SECTION : Custom Fields - new, remove, save, cancel, publish
	================================================================================================================
*/
	function newCustomField(){
		JRequest :: setVar('view', 'adminconfig');
		JRequest :: setVar('hidemainmenu', 1);
		JRequest :: setVar('layout', 'editcustomfield');
		$this->display();
	}
	
	function showCustomField(){
		JRequest :: setVar('view', 'adminconfig');
		JRequest :: setVar('hidemainmenu', 1);
		JRequest :: setVar('layout', 'showcustomfield');
		$this->display();
	}
	
	function newCustomGroup(){
		JRequest :: setVar('view', 'adminconfig');
		JRequest :: setVar('hidemainmenu', 1);
		JRequest :: setVar('layout', 'editcustomfield');
		JRequest :: setVar('type', 'group');
		$this->display();
	}
	
	function removeCustomField(){
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
	
		// Initialize variables
		$app =& JFactory::getApplication();
		$db  =& JFactory::getDBO();
		$cid = JRequest::getVar('cid', array(), 'post', 'array');
		JArrayHelper::toInteger( $cid );
		
		$cids = implode(',', $cid);
		$query = 'DELETE FROM #__jbjobs_custom_field WHERE id IN ('.$cids.')';
		$db->setQuery($query);
		$db->query();
		
		$msg	= JText::_('JBJOBS_CUSTOM_FIELD_DELETED');
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showcustomfield';
		$app->redirect($link, $msg);
	}
	
	function saveCustomField(){
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		// Initialize variables
		$app =& JFactory::getApplication();
		$db =& JFactory::getDBO();
		$row =& JTable::getInstance('custom', 'Table');
		$post = JRequest::get( 'post' );
		$required = (!empty($post['required']))? $post['required'] : 0;
		$published = (!empty($post['published']))? $post['published'] : 0;
		$parent = ($post['type'] == 'group')? 0 : $post['parent'];
		
		$row->required = $required;
		$row->published = $published;
		$row->parent = $parent;
		
		if(!$row->bind($post)){
			JError::raiseError(500, $row->getError());
		}
		// pre-save checks
		if(!$row->check()){
			JError::raiseError(500, $row->getError());
		}
		// save the changes
		if(!$row->store()){
			JError::raiseError(500, $row->getError());
		}
		$row->checkin();
		
		$msg	= JText::_('JBJOBS_CUSTOM_FIELD_SAVED');
		$link	= 'index.php?option=com_jbjobs&view=adminconfig&layout=showcustomfield';
		$app->redirect($link, $msg);
	}
	
	function cancelCustomField($cancel){
		$app =& JFactory::getApplication();
		$msg = '';
		$link = 'index.php?option=com_jbjobs&view=adminconfig&layout=showcustomfield';
		$app->redirect($link, $msg);
	}

/**
  ================================================================================================================
	SECTION : Misc
	1.InsertCustom Field
	2.Save Parameter
	3.Send subscription appoved email to user
	4.Send credit purchase appoved email to user
	5.Publish / Unpublish row data
	6.Require / Unrequire fields
	7.Load Address Data
	================================================================================================================
*/	
	function insertCustomField($type, $id, $post){
		$db = & JFactory::getDBO();
		
		$query = "SELECT * FROM #__jbjobs_custom_field WHERE field_for='$type' AND published='1'";
		$db->setQuery($query);
		$custom = $db->loadObjectList();
		
		if(count($custom)){
			foreach($custom as $ct){
				if(isset($post['custom_field_'.$ct->id])){
					if($type == 'job'){
						$query = "SELECT COUNT(*) FROM #__jbjobs_custom_field_value WHERE fieldid='$ct->id' AND jobid='$id'";
					}
					else {
						$query = "SELECT COUNT(*) FROM #__jbjobs_custom_field_value WHERE fieldid='$ct->id' AND userid='$id'";
					}
					$db->setQuery($query);
					$fvalue = 'value';
					$value = $post['custom_field_'.$ct->id];
					switch($ct->field_type){
						case 'textarea':
							$fvalue = 'valuetext';
							break;
						case 'checkbox':
						case 'multiple select':
							$value = (is_array($value)) ? implode(";", $value) : $value;
							break;
					}
					if($db->loadResult()){
						if($type == 'job'){
							$query = "UPDATE #__jbjobs_custom_field_value SET $fvalue='$value' WHERE fieldid='$ct->id' AND jobid='$id'";
						}
						else {
							$query = "UPDATE #__jbjobs_custom_field_value SET $fvalue='$value' WHERE fieldid='$ct->id' AND userid='$id'";
						}
					}
					else {
						if($type == 'job'){
							$query = "INSERT INTO #__jbjobs_custom_field_value (fieldid, jobid, $fvalue) VALUES ('$ct->id', '$id', '$value')";
						}
						else {
							$query = "INSERT INTO #__jbjobs_custom_field_value (fieldid, userid, $fvalue) VALUES ('$ct->id', '$id', '$value')";
						}
					}
					$db->setQuery($query);
					$db->query();
				}
			}
		}
	}

	function sendSubscrApprovedEmail($subscrid, $userid){
		$app =& JFactory::getApplication();
		$db =& JFactory::getDBO();
		$model = $this->getModel();
		$row	=& JTable::getInstance('plansubscr', 'Table');
		$row->load($subscrid);
		
		if($row->user_type == 'e')
 			$planTblName = '#__jbjobs_plan';
 		elseif($row->user_type == 'j')
 			$planTblName = '#__jbjobs_plan_js';
 		
 		$query = "SELECT * FROM $planTblName WHERE id = ".$row->subscription_id;
		$db->setQuery($query);
		$plan = $db->loadObject();
	
		$data =& JFactory::getUser($userid);
		$name = $data->name;
		$mailto = $data->email;
		$username = $data->username;

		$sitename = $app->getCfg('sitename');
		$fromname = $app->getCfg('fromname');
		$mailfrom = $app->getCfg('mailfrom');
		$siteURL = JURI::root();
		
		// check if Global Config `mailfrom` and `fromname` values exist
		if ( ! $mailfrom  || ! $fromname ) {
			// use email address and name of first superadmin for use in email sent to user
			$query = "SELECT name, email"
			. "\n FROM #__users"
			. "\n WHERE LOWER( usertype ) = 'superadministrator'"
			. "\n OR LOWER( usertype ) = 'super administrator'"
			;
			$db->setQuery($query);
			$rows = $db->loadResult();
			
			$fromname 	= $rows->name;
			$mailfrom 	= $rows->email;
		}
	
		$subscrid = $row->id;
		$planname = $plan->name;
		
		$tags = array("[NAME]", "[PLANNAME]", "[SITENAME]", "[SITEURL]");
		$tagsValues = array("$name", "$planname", "$sitename", "$siteURL");
		
		//get the email template
		$template = $model->getTemplate('subscr-approved-admin');
		
		//get subject
		$subject = $template->subject;
		$subject = str_replace($tags, $tagsValues, $subject);
		$subject = html_entity_decode($subject, ENT_QUOTES);
		
		//get message body
		$message = $template->body;
		$message = str_replace($tags, $tagsValues, $message);
		$message = html_entity_decode($message, ENT_QUOTES);
		
		// Send email to user
		JUtility::sendMail($mailfrom, $fromname, $mailto, $subject, $message, 1);
	}
	
	function sendCreditApprovedEmail($invoiceid, $userid){
		$app =& JFactory::getApplication();
		$db =& JFactory::getDBO();
		$model = $this->getModel();
		$row	=& JTable::getInstance('billing', 'Table');
		$row->load($invoiceid);
		
		$data 	=& JFactory::getUser($userid);
		$name = $data->name;
		$mailto = $data->email;
		$username = $data->username;

		$sitename = $app->getCfg('sitename');
		$fromname = $app->getCfg('fromname');
		$mailfrom = $app->getCfg('mailfrom');
		$siteURL = JURI::root();
		
		// check if Global Config `mailfrom` and `fromname` values exist
		if ( ! $mailfrom  || ! $fromname ) {
			// use email address and name of first superadmin for use in email sent to user
			$query = "SELECT name, email"
			. "\n FROM #__users"
			. "\n WHERE LOWER( usertype ) = 'superadministrator'"
			. "\n OR LOWER( usertype ) = 'super administrator'"
			;
			$db->setQuery($query);
			$rows = $db->loadResult();
			
			$fromname 	= $rows->name;
			$mailfrom 	= $rows->email;
		}
	
		$subscrid = $row->id;
		$planname = $plan->name;
		
		$tags = array("[NAME]", "[CREDITS]", "[INVOICENO]", "[SITENAME]", "[SITEURL]");
		$tagsValues = array("$name", "$row->credit", "$row->id", "$sitename", "$siteURL");
		
		//get the email template
		$template = $model->getTemplate('credit-approved-admin');
		
		//get subject
		$subject = $template->subject;
		$subject = str_replace($tags, $tagsValues, $subject);
		$subject = html_entity_decode($subject, ENT_QUOTES);
		
		//get message body
		$message = $template->body;
		$message = str_replace($tags, $tagsValues, $message);
		$message = html_entity_decode($message, ENT_QUOTES);
	
		// Send email to user
		JUtility::sendMail($mailfrom, $fromname, $mailto, $subject, $message, 1);
	}
	
	//5.Publish row data
	function jbPubUnpub($publish, $tbl, $link, $msg){
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
	
		// Initialize variables
		$app =& JFactory::getApplication();
		$db =& JFactory::getDBO();
		$user =& JFactory::getUser();
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		$task = JRequest::getCmd('task');
		$n = count($cid);
	
		JArrayHelper::toInteger($cid);
		$cids = implode(',', $cid);
		$query = 'UPDATE '.$tbl.' SET published = '.(int)$publish.' WHERE id IN ('.$cids.')';
		$db->setQuery($query);
	
		if (!$db->query()) {
			return JError::raiseWarning(500, $db->getError());
		}
		$app->redirect($link, $msg);
	}
	
	//6.Require / Unrequire fields
	function jbReqUnrequired($required, $tbl, $link, $msg){
		$app =& JFactory::getApplication();
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
	
		// Initialize variables
		$db =& JFactory::getDBO();
		$user =& JFactory::getUser();
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		$task = JRequest::getCmd( 'task' );
	
		JArrayHelper::toInteger($cid);
		$cids = implode(',', $cid);
		$query = 'UPDATE '.$tbl.' SET required = '.(int)$required.' WHERE id IN ('.$cids.')';
		$db->setQuery($query);
	
		if(!$db->query()){
			return JError::raiseWarning(500, $db->getError());
		}
		$app->redirect($link, $msg);
	}
	
	//7.Load Address Data
	function loadaddressdata(){
		$model = & $this->getModel();
		$return_value = $model->loadAddressData();
		$link = 'index.php?option=com_jbjobs&view=adminconfig&layout=showcountry&er=2';
		if($return_value == 1)	{
			$msg = JText::_('JBJOBS_ADDRESS_DATA_SAVED');
			$link = 'index.php?option=com_jbjobs&view=adminconfig&layout=showcountry';
		}
		elseif($return_value == 2){ // file mismatch
			$msg = JText::_('JBJOBS_ONLY_SQL_ALLOWED');
		}
		else {
			$msg = JText::_('JBJOBS_ADDRESS_DATA_NOT_SAVED');
		}
		$this->setRedirect($link, $msg);
	}
	
	//4.Load address data
	function listempaddressdata(){ 
		$app =& JFactory::getApplication();
		$model = $this->getModel();
		$db 	  =& JFactory::getDBO();
		
		$val 	 = JRequest::getVar('val', '', 'post', 'string');
		$nxtname = JRequest::getVar('nxtname', '', 'post', 'string');
		$pos = strpos($nxtname, "bill"); $nxtnxtname='city';
		if($nxtname == 'bill_state' || $nxtname == 'bill_district')
		 $nxtnxtname='bill_city';
		
		if($nxtname == 'state' || $nxtname == 'district' || $nxtname == 'bill_state' || $nxtname == 'bill_district'){
			$query  = "SELECT id, state FROM #__jbjobs_state WHERE country_id='$val' AND published=1 ORDER BY state";
			$db->setQuery($query);
			$result = $db->loadObjectList();		
			
			if (empty($result))	{
				$return_value = "<input type='text' class='inputbox' id='$nxtname' name='$nxtname' size='35' maxlength='100'/>";
			}
			else {
				$return_value = "<select id='$nxtname' name='$nxtname' class='inputbox' onChange=\"loadaddress(this.value, '$nxtnxtname')\">\n";
				$return_value .= "<option value=''>". '- '.JText::_('JBJOBS_SELECT_STATE').' - ' ."</option>\n";
				
				foreach($result as $row){
					$return_value .= "<option value=\"$row->state\" >$row->state</option> \n" ;
				}
				$return_value .= "</select>\n";
			}
		}
		elseif($nxtname == 'city' || $nxtname == 'bill_city'){
			$query  = "SELECT id, city FROM #__jbjobs_city WHERE state_name='$val' AND published=1 ORDER BY city";
			$db->setQuery($query);
			$result = $db->loadObjectList();		
			
			if (empty($result))	{
				$return_value = "<input type='text' class='inputbox' id='$nxtname' name='$nxtname' size='35' maxlength='100'/>";
			}
			else {
				$return_value = "<select id='$nxtname' name='$nxtname' class='inputbox'>\n";
				$return_value .= "<option value=''>". '- '.JText::_('JBJOBS_SELECT_CITY').' - ' ."</option>\n";
				
				foreach($result as $row){
					$return_value .= "<option value=\"$row->city\" >$row->city</option> \n" ;
				}
				$return_value .= "</select>\n";
			}
		}
		
		echo $return_value;
		exit;
	  }
	  
	//3.Upload Photo
	function uploadPicture(){
		//UPLOAD FILE
		$file = $_FILES['photo'];
		$userid = JRequest::getVar('userid', '', 'post', 'int');
		$response = array();
		
		$lang =& JFactory::getLanguage();
	 	$lang->load('com_jbjobs', JPATH_SITE);
		
		$config =& JTable::getInstance('config', 'Table');
		$config->load(1);
		//$allowed = array('image/pjpeg', 'image/jpeg', 'image/jpg', 'image/png', 'image/x-png', 'image/gif', 'image/ico', 'image/x-icon');
		$type = $config->get('imgfiletype');
		$allowed = explode(',', $type);
		$pwidth  = $config->get('imgwidth');
		$pheight = $config->get('imgheight');
		$maxsize = $config->get('imgmaxsize');
		if($file['size'] > 0 &&  ($file['size'] / 1024  < $maxsize)){
			if(!file_exists(JPATH_SITE.DS.'images'.DS.'jbjobs')){
				if(mkdir(JPATH_SITE.DS.'images'.DS.'jbjobs')){
					JPath::setPermissions(JPATH_SITE.DS.'images'.DS.'jbjobs', '0777');
					if(file_exists(JPATH_SITE.DS.'images'.DS.'index.html')){
						copy(JPATH_SITE.DS.'images'.DS.'index.html', JPATH_SITE.DS.'images'.DS.'jbjobs/index.html');
					}
				}
			}
			if($file['error'] != 0){
				echo JText::_('JBJOBS_FILE_PHOTO_ERROR');
				exit;
			}
			if($file['size'] == 0){
				$file = null;
			}
			if(!in_array($file['type'], $allowed)){
				$file = null;
				$response['result'] = 'NO';
				$response['msg'] = JText::_('JBJOBS_FILE_TYPE_NOT_ALLOWED');
				echo json_encode($response); exit;
			}
			if ($file != null){
				$dest = JPATH_SITE.DS.'images'.DS.'jbjobs'.DS.$userid.'.jpg';
				if(file_exists($dest)){
					$del = unlink($dest);
				}
				$soure = $file['tmp_name'];
				jimport('joomla.filesystem.file');
				$uploaded = JFile::upload($soure,$dest);
				$fileAtr = getimagesize($dest);
				$widthOri = $fileAtr[0];
				$heightOri = $fileAtr[1];
				$type = $fileAtr['mime'];
				$img = false;
				switch ($type){
					case 'image/jpeg':
					case 'image/jpg':
					case 'image/pjpeg':
					$img = imagecreatefromjpeg($dest);					 
					break;
					case 'image/ico':
					$img = imagecreatefromico($dest);
					break;
					case 'image/x-png':
					case 'image/png':
					$img = imagecreatefrompng($dest);
					break;
					case 'image/gif':
					$img = imagecreatefromgif($dest);
					break;
				}
				if(!$img){
					return false;
				}
				$curr = @getimagesize($dest);
				$perc_w = $pwidth / $widthOri;
				$perc_h = $pheight / $heightOri;
				if(($widthOri<$pwidth) && ($heightOri<$height)){
					return;
				}
				if($perc_h > $perc_w){
					$pwidth = $pwidth;
					$pheight = round($heightOri * $perc_w);
				}
				else {
					$pheight = $pheight;
					$pwidth = round($widthOri * $perc_h);
				}
				$nwimg = imagecreatetruecolor($pwidth, $pheight);
				imagecopyresampled($nwimg, $img, 0, 0, 0, 0, $pwidth, $pheight, $widthOri, $heightOri);
				imagejpeg($nwimg, $dest, 100);
				imagedestroy($nwimg);
				imagedestroy($img);
				
				$response['result'] = 'OK';
				$response['image'] = JURI::root().'images/jbjobs/'.$userid.'.jpg?'.time();
				$response['msg'] = JText::_('JBJOBS_PICTURE_UPLOADED_SUCCESSFULLY');
				echo json_encode($response); exit;
			}
		}
		else {
			if($file['size'] / 1024  > $maxsize){
				$response['result'] = 'NO';
				$response['msg'] = JText::sprintf('JBJOBS_PICTURE_EXCEEDS_LIMIT', $maxsize);
				echo json_encode($response); exit;
			}
		}
	}
	
	function removePicture(){
		$userid = JRequest::getVar('userid', 0, 'post', 'int');
		$dest = JPATH_SITE.DS.'images'.DS.'jbjobs'.DS.$userid.'.jpg';
		
		$response = array();
		$lang =& JFactory::getLanguage();
	 	$lang->load('com_jbjobs', JPATH_SITE);
		
		if(file_exists($dest)){
			$del = unlink($dest);
			$response['result'] = 'OK';
			$response['msg'] = JText::_('JBJOBS_PICTURE_REMOVED_SUCCESSFULLY');
			echo json_encode($response); exit;
		}
		else {
			$response['result'] = 'NO';
			$response['msg'] = JText::_('JBJOBS_FILE_NOT_EXISTS');
			echo json_encode($response); exit;
		}
	}
	
	/**
	 * Update the transaction of the users to the transaction table (#__jbjobs_transaction)
	 * @param int $userid
	 * @param string $transDtl
	 * @param int $credit
	 * @param int $plusMinus
	 */
	function updateTransaction($userid, $transDtl, $credit, $plusMinus){
		$app =& JFactory::getApplication();
		$now  = date('Y-m-d H:i:s', time() + ($app->getCfg('offset') * 60 * 60));	
		//Insert the transaction into the transaction table incase credit per job is greater than zero		
		if($credit > 0){
			$row_trans	=& JTable::getInstance('transaction', 'Table');
			$row_trans->date_trans  = $now;
			$row_trans->transaction = $transDtl;
			$row_trans->user_id  = $userid;
			
			if($plusMinus == 1)
				$row_trans->credit_plus = $credit; 
			elseif($plusMinus == -1)
				$row_trans->credit_minus = $credit; 
			
			// pre-save checks
			if(!$row_trans->check()){
				JError::raiseError(500, $row_trans->getError());
			}	
			if(!$row_trans->store()){
					JError::raiseError(500, $row_trans->getError());
			}											
			$row_trans->checkin();
			return $row_trans;
		}
	}
	
	function display(){
		$document = & JFactory :: getDocument();
		$viewName = JRequest :: getVar('view', 'adminjob'); 
		$layoutName = JRequest :: getVar('layout', 'dashboard');
		$viewType = $document->getType();
		$model = $this->getModel('jbjobs', 'JBJobsModel'); 
		$view = & $this->getView($viewName, $viewType);
		if (!JError :: isError($model)){
			$view->setModel($model, true);
		}
		$view->setLayout($layoutName);
		$view->display();
	}
	
}