<?php
/**
 + Created by	:	JoomBah Team
 * Company		:	ISDS Sdn Bhd
 + Contact		:	www.joombah.com , support@joombah.com
 * Created on	:	06 May 2011
 * Author		:	Faisel
 * Tested by	: 	-
 + Project		: 	Job site
 * File Name	:	helper/feeds.php
 * License		:	GNU General Public License version 3, or later
 ^ 
 * Description	: 	Feeds Helper file (jbjobs)
 ^ 
 * History		:	
 * */
defined('_JEXEC') or die('Restricted access');
require_once(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jbjobs'.DS.'helper'.DS.'helper.php');
jimport('joomla.filesystem.file');
class JBFeeds {
	
	function add($feed, $params = '', $points = 1){
		$db =& JFactory::getDBO();
		
		$db->insertObject('#__jbjobs_feed', $feed);
		
	}
	
	function getRawFeeds($userid = 0, $limit = 50){
		$db =& JFactory::getDBO();
		$user =& JFactory::getUser();
		$where = '';$onActor = '';
		$queryStringsAnd = $queryStringsOr = array();
		
		if(!empty($userid))
			$queryStringsOr[] = "f.target=$userid";
		
		if(!empty($userid)){
			$queryStringsOr[] = "f.actor=$userid";
			$onActor = " AND (f.actor=$userid)";
		}
			
		if(!empty($userid)){
			//get the list of acitivity id in hidden feed table
			$subQuery	= 'SELECT fh.activity_id FROM #__jbjobs_feed_hide as fh WHERE fh.user_id = '. $db->Quote($userid);
			$db->setQuery($subQuery);
			$subResult	= $db->loadResultArray();
			$subString	= implode(',', $subResult);
		
			if( ! empty($subString))
				$queryStringsAnd[] = "f.id NOT IN ($subString) ";
	    }
	    
		if(true){
			// Add friends limits, but admin should be able to see all
			// @todo: should use global admin code check instead
			if($user->id == 0){
				// for guest, it is enough to just test access <= 0
				$queryStringsAnd[] = "(f.access <= 0)";
				
			}
			elseif( !( $user->usertype == 'Super Administrator'
					|| $user->usertype == 'Administrator'
					|| $user->usertype == 'Manager' )){
				$queryStringsOr[] = "((f.access = 0) {$onActor})";	//guest
				$queryStringsOr[] = "( (f.access = 10) AND ({$user->id} != 0)  {$onActor})";	//site members
				$queryStringsOr[] = "( (f.access = 20) AND (f.actor = {$user->id}) {$onActor})";	//only me
				$queryStringsAnd[] = "f.access != 30";	//no body
			} 
		}
	    
		$orWhere = (count($queryStringsOr) ? '  ('.implode(') OR (', $queryStringsOr ).')' : 'true' );	
		$andWhere = (count($queryStringsAnd) ? '  ('.implode(') AND (', $queryStringsAnd ).')' : 'true' );	
	    
		$query = "SELECT f.*,(TO_DAYS(NOW()) - TO_DAYS(f.created)) as daydiff FROM #__jbjobs_feed f".
				" WHERE ( ".$orWhere." ) AND ".$andWhere.
	  		 	" ORDER BY f.created DESC".
			 	" LIMIT ".$limit;//echo $query;
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		return $rows;
	}
	
	function getFeedsData($userid = 0, $limit = 50){
		$lang =& JFactory::getLanguage();
	 	$lang->load('com_jbjobs', JPATH_SITE);
		$rows = $this->getRawFeeds($userid, $limit);
		$htmlData = array();
		
		foreach ($rows as $row){
			$act = new stdClass();
			
			$act->id = $row->id;
			
			//get the title
			$actorLink = $this->actorLink($row->actor);
			$targetLink = $this->targetLink($row->target);
			$jobLink = $this->jobLink($row->id_job);
			$compName = $this->compName($row->actor);
			
			$tags = array("{actor}", "{target}", "{jobid}", "{companyname}");
			$tagsValues = array($actorLink, $targetLink, $jobLink, $compName);
			$title = str_replace($tags, $tagsValues, $row->title);
			
			$act->title = $title;
			
			//get the content
			$act->content = $row->content;
			
			//get the logo
			$act->logo = JBjobs::getLogo($row->actor, 'class=avatar width=36');
			
			//get the days diff
			$day = $row->daydiff;
					
			if($day == 0){
				$act->daysago = JText::_('TODAY');
			}
			else if($day == 1){
				$act->daysago = JText::_('JBJOBS_YESTERDAY');
			}
			else if($day < 7){
				$act->daysago = JText::sprintf('JBJOBS_DAYS_AGO', $day);
			}
			else if(($day >= 7) && ($day < 30)){
				$dayinterval = 7;						
				$act->daysago = (intval($day/$dayinterval) == 1 ? JText::_('JBJOBS_WEEK_AGO') : JText::sprintf('JBJOBS_WEEKS_AGO', intval($day/$dayinterval)));
			}	
			else if(($day >= 30)){
				$dayinterval = 30;
				$act->daysago = (intval($day/$dayinterval) == 1 ? JText::_('JBJOBS_MONTH_AGO') : JText::sprintf('JBJOBS_MONTHS_AGO', intval($day/$dayinterval)));
			}
			
			$act->isMine = JBjobs::isMine($userid, $row->actor);
			
			$htmlData[] = $act;
		}
		return $htmlData;
	}
	
	function actorLink($id){
		$linkName	= ($id == 0)? false : true;
		$user		=& JFactory::getUser($id);
		$jbhelper = new JBjobs();
		
		//get privacy settings
		$privacy = $jbhelper->getPrivacySettings($id);
		$showName = $privacy['show_name'];
		if($showName == 'y')
			$name = $user->name;
		else {
			if($privacy['usertype'] == 'j')
				$name = JText::_('JBJOBS_JOBSEEKER');
			else
				$name = JText::_('JBJOBS_EMPLOYER');
		}
		
		// Wrap the name with link to his/her profile
		$html = $name;
		
		if($linkName){
			$userURL = $jbhelper->userProfileLink($user->id);
			$html = JHTML::_('link', $userURL, $name, array('class'=>'jobcriteria'));
		}
		return $html;
	}
	
	function targetLink($id){
		$linkName	= ($id == 0)? false : true;
		$user		= JFactory::getUser($id);
		$name = $user->name;
		$jbhelper = new JBjobs();
		
		//get privacy settings
		$privacy = $jbhelper->getPrivacySettings($id);
		$showName = $privacy['show_name'];
		if($showName == 'y')
			$name = $user->name;
		else {
			if($privacy['usertype'] == 'j')
				$name = JText::_('JBJOBS_JOBSEEKER');
			else
				$name = JText::_('JBJOBS_EMPLOYER');
		}
		
		// Wrap the name with link to his/her profile
		$html = $name;
		
		if($linkName){
			$userURL = $jbhelper->userProfileLink($user->id);
			$html = JHTML::_('link', $userURL, $name, array('class'=>'jobcriteria'));
		}
		return $html;
	}
	
	function jobLink($id){
		
		$job =& JTable::getInstance('job', 'Table');
		$job->load($id);
		
		$jobURL = JRoute::_('index.php?option=com_jbjobs&view=guest&layout=detailjob&id='.$id);
		$html = JHTML::_('link', $jobURL, $job->job_title, array('class'=>'jobcriteria'));
		return $html;
	}
	
	function compName($userid){
		
		$db =& JFactory::getDBO();
		$query = "SELECT comp_name FROM #__jbjobs_employer WHERE user_id=$userid";
		$db->setQuery($query);
		$comp_name = $db->loadResult();
		$jbhelper = new JBjobs();
		$showCompName = 'n';
		
		//get privacy settings
		$privacy = $jbhelper->getPrivacySettings($userid);
		
		if(isset($privacy['show_comp_name']))
			$showCompName = $privacy['show_comp_name'];
		
		if($showCompName == 'y')
			$comp_name = $comp_name;
		else
			$comp_name = JText::_('JBJOBS_COMPANY_NAME_CONFIDENT');
		
		$compURL = $jbhelper->userProfileLink($userid);
		$html = JHTML::_('link', $compURL, $comp_name, array('class'=>'jobcriteria'));
		return $html;
	}
	
}