CREATE TABLE IF NOT EXISTS #__jbjobs_billing (
  `id` int(11) NOT NULL auto_increment,
  `user_id` int(11) NOT NULL DEFAULT 0 ,
  `credit` int(11) NOT NULL DEFAULT 0 ,
  `date_buy` datetime NOT NULL DEFAULT '0000-00-00 00:00:00' ,
  `amount` float ,
  `tax_percent` FLOAT DEFAULT 0 NOT NULL,
  `approval` char(1) NOT NULL DEFAULT 'n' ,
  `approval_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00' ,
  `mode_pay` char(1) NOT NULL DEFAULT 'm' ,
  `gateway` VARCHAR(20) DEFAULT '' NOT NULL,
  `address` varchar(255) ,
  `address_cont` varchar(255) ,
  `city` varchar(100) ,
  `state` varchar(100) ,
  `zip` varchar(50) ,
  `id_country` int(11) ,
  `phone` varchar(50) ,
  `id_trans` int(11) NOT NULL DEFAULT 0 ,
  `invoiceNo` VARCHAR(100),
  PRIMARY KEY (`id`)
);

CREATE TABLE IF NOT EXISTS #__jbjobs_city (
   `id` INT NOT NULL AUTO_INCREMENT,
   `city` VARCHAR(35) NOT NULL,
   `state_name` VARCHAR(35) NOT NULL,
   `country_id` INT(20) NOT NULL,
   `state_id` INT NOT NULL,
   `published` TINYINT(1) DEFAULT '1' NOT NULL,
   PRIMARY KEY (`id`)
);

CREATE TABLE IF NOT EXISTS #__jbjobs_comp_type (
  `id` int(11) NOT NULL auto_increment,
  `comp_type` varchar(50) NOT NULL DEFAULT '' ,
  PRIMARY KEY (`id`)
);

CREATE TABLE IF NOT EXISTS #__jbjobs_config (
	`id` int(11) NOT NULL auto_increment,
	`welcome_title` varchar(50) NOT NULL default 'Welcome to JoomBah!',
	`freemode` tinyint(1) NOT NULL default '0',
	`limittimeforfreemode` int(11) NOT NULL default '7',
	`currencysymbol` varchar(5) NOT NULL default '$',
	`currencycode` varchar(5) NOT NULL default 'BND',
	`showjbcredit` tinyint(1) NOT NULL default '1',
	`termarticleid` int(11) NOT NULL default '1',
	`enablerss` tinyint(1) NOT NULL default '1',
	`rsslimit` int(11) NOT NULL default '10',
	`enableempreg` tinyint(1) NOT NULL default '1',
	`enablejsreg` tinyint(1) NOT NULL default '1',
	`showcaptcha` tinyint(1) NOT NULL default '1',
	`showbookmark` tinyint(1) NOT NULL default '1',
	`creditmin` int(11) NOT NULL default '1',
	`taxname` varchar(20) NOT NULL default 'VAT',
	`taxpercent` float NOT NULL default '10',
	`myinvoicedetails` text NOT NULL,
	`cvfiletype` varchar(1000) NOT NULL,
	`cvfiletext` varchar(50) NOT NULL,
	`imgfiletype` varchar(1000) NOT NULL,
	`imgwidth` int(5) NOT NULL default '100',
	`imgheight` int(5) NOT NULL default '200',
	`imgmaxsize` int(5) NOT NULL default '200',
	`userprofile` tinyint(1) NOT NULL default '0',
	`indeedenable` tinyint(1) NOT NULL default '1',
	`indeedpubid` varchar(50) NOT NULL,
	`indeedkey` varchar(30) NOT NULL default 'php,java',
	`indeedlocate` varchar(30) NOT NULL default 'singapore',
	`indeedcountry` varchar(10) NOT NULL default 'sg',
	`enablemooupg` tinyint(1) NOT NULL default '1',
	`dateformat` varchar(30) NOT NULL default 'yyyy-mm-dd',
	`theme` varchar(20) NOT NULL default 'stylejb.css',
	`enableJobalert` tinyint(1) NOT NULL default '1',
	`jobsperEmail` int(5) NOT NULL default '5',
	`emailperBatch` int(5) NOT NULL default '50',
	`pausebwBatch` int(5) NOT NULL default '1',
	`emailTry` int(5) NOT NULL default '3',
	`enableCron` tinyint(1) NOT NULL default '1',
	`enablecronEmail` tinyint(1) NOT NULL default '0',
	`cronEmail` varchar(30) default NULL,
	`enablecronLog` tinyint(1) NOT NULL default '0',
	`welcome_jobseeker` text,
	`welcome_employer` text,
	`pm_enable` tinyint(1) NOT NULL default '1',
	`pm_sendNotify` tinyint(1) NOT NULL default '1',
	`pm_suggestion` int(1) NOT NULL default '0',
	`invoiceFormatPlan` varchar(100) default 'MSP/[YYYY]/[ID]',
	`invoiceFormatCredit` varchar(100) default 'CRP/[YYYY]/[ID]',
	`freemode_js` tinyint(1) NOT NULL default '1',
	`anonymous_jobapply` tinyint(1) NOT NULL default '0',
	`googleApiKey` VARCHAR(100),
	`googleWidth` INT(3) DEFAULT '500' NOT NULL,
	`googleHeight` INT(3) DEFAULT '400' NOT NULL,
	`defaultCountry` INT DEFAULT '1' NOT NULL,
	`allowGuest_jobdetail` TINYINT(1) DEFAULT '1' NOT NULL,
	`allowGuest_compdetail` TINYINT(1) DEFAULT '1' NOT NULL,
	PRIMARY KEY (`id`)
);  

CREATE TABLE IF NOT EXISTS #__jbjobs_country (
  `id` int(11) NOT NULL auto_increment,
  `country` varchar(50) NOT NULL DEFAULT '',
  `published` TINYINT(1) DEFAULT '1' NOT NULL,
  PRIMARY KEY (`id`)
);

CREATE TABLE IF NOT EXISTS #__jbjobs_coverletter (
  `id` INT NOT NULL AUTO_INCREMENT,
  `jseeker_id` INT DEFAULT '0' NOT NULL,
  `title` VARCHAR(50) NOT NULL,
  `description` text NOT NULL,
  `is_active` TINYINT(1) DEFAULT '1' NOT NULL,
  PRIMARY KEY (`id`)
);

CREATE TABLE IF NOT EXISTS #__jbjobs_crontask (
    `id` INT(10) NOT NULL AUTO_INCREMENT,
    `task` VARCHAR(255) NOT NULL,
    `type` INT(1) DEFAULT '0' NOT NULL,
    `published` TINYINT(1) DEFAULT '0' NOT NULL,
    `file` VARCHAR(255) NOT NULL,
    `ran_at` DATETIME,
    `ok` TINYINT DEFAULT '0' NOT NULL,
    `log_text` longtext NOT NULL,
    `unix_mhdmd` VARCHAR(255) NOT NULL,
    `last_run` INT(1) DEFAULT '0' NOT NULL,
    PRIMARY KEY (`id`)
);

CREATE TABLE IF NOT EXISTS `#__jbjobs_custom_field` (
   `id` int(11) NOT NULL AUTO_INCREMENT,
   `field_for` enum('employer','jobseeker','job') NOT NULL,
   `field_title` VARCHAR(255) NOT NULL,
   `field_type` enum('textbox','textarea','radio','checkbox','select','multiple select','URL','Email','Date') NOT NULL,
   `values` VARCHAR(255) NOT NULL,
   `class` VARCHAR(255) NOT NULL,
   `show_type` enum('left-to-right','top-to-bottom') NOT NULL,
   `parent` INT DEFAULT '0' NOT NULL,
   `lang_code` VARCHAR(20) DEFAULT 'JBJOBS_' NOT NULL,
   `tips` VARCHAR(100),
   `ordering` INT NOT NULL,
   `required` TINYINT(1) DEFAULT '0' NOT NULL,
   `published` TINYINT(1) NOT NULL,
   `registration` TINYINT(1) DEFAULT '1' NOT NULL,
   `gdesc` VARCHAR(500),
   PRIMARY KEY (`id`)
);

CREATE TABLE IF NOT EXISTS `#__jbjobs_custom_field_value` (
   `id` int(11) NOT NULL AUTO_INCREMENT,
   `fieldid` INT NOT NULL,
   `userid` INT DEFAULT '0' NOT NULL,
   `jobid` INT DEFAULT '0' NOT NULL,
   `value` VARCHAR(255) NOT NULL,
   `valuetext` text NOT NULL,
   PRIMARY KEY (`id`)
);

CREATE TABLE IF NOT EXISTS #__jbjobs_degree_level (
  `id` int(11) NOT NULL auto_increment,
  `degree_level` varchar(75) NOT NULL DEFAULT '' ,
  `ordering` INT DEFAULT '0' NOT NULL,
  `published` TINYINT(1) DEFAULT '1' NOT NULL,
  PRIMARY KEY (`id`)
);

CREATE TABLE IF NOT EXISTS #__jbjobs_emailtemplate (
    `id` INT NOT NULL AUTO_INCREMENT,
    `templatefor` VARCHAR(50),
    `title` VARCHAR(50),
    `subject` VARCHAR(255),
    `body` text,
    PRIMARY KEY (`id`)
);

CREATE TABLE IF NOT EXISTS #__jbjobs_employer (
	`id` int(11) NOT NULL auto_increment,
	`user_id` int(11) NOT NULL DEFAULT 0 ,
	`firstname` varchar(100) NOT NULL DEFAULT '' ,
	`lastname` varchar(100) NOT NULL DEFAULT '' ,
	`id_salutation` int(11) NOT NULL DEFAULT 0 ,
	`other_title` varchar(100) NOT NULL DEFAULT '' ,
	`comp_name` varchar(100) NOT NULL DEFAULT '' ,
	`primary_phone` varchar(50) NOT NULL DEFAULT '' ,
	`fax_number` varchar(50) NOT NULL DEFAULT '' ,
	`street_addr` varchar(100) NOT NULL DEFAULT '' ,
	`id_country` int(11) NOT NULL DEFAULT 0 ,
	`state` varchar(50) NOT NULL DEFAULT '' ,
	`city` varchar(50) NOT NULL DEFAULT '' ,
	`zip` varchar(30) NOT NULL DEFAULT '' ,
	`id_comp_type` int(11) NOT NULL DEFAULT 0 ,
	`id_industry` int(11) ,
	`show_name` char(1) NOT NULL DEFAULT 'y' ,
	`show_location` char(1) NOT NULL DEFAULT 'y' ,
	`show_phone` char(1) NOT NULL DEFAULT 'y' ,
	`show_email` char(1) NOT NULL DEFAULT 'y' ,
	`show_addr` char(1) NOT NULL DEFAULT 'y' ,
	`show_fax` char(1) NOT NULL DEFAULT 'y' ,
	`bill_addr` varchar(255) ,
	`bill_addr_cont` varchar(255) ,
	`bill_id_country` int(11) ,
	`bill_state` varchar(50) ,
	`bill_city` varchar(100) ,
	`bill_zip` varchar(25) ,
	`bill_phone` varchar(50) ,
	`status` INT(1) DEFAULT '1' NOT NULL,
	`comp_overview` text,
	`comp_history` text,
	`comp_benefits` text,
	`show_post` INT(3) DEFAULT '20' NOT NULL,
	`show_comp_name` CHAR(1) DEFAULT 'y' NOT NULL,
	PRIMARY KEY (`id`),
	UNIQUE KEY user_index (`user_id`)
);

CREATE TABLE IF NOT EXISTS #__jbjobs_experience (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` INT DEFAULT 0 NOT NULL,
  `prev_employer` VARCHAR(255) NOT NULL,
  `designation` VARCHAR(255) NOT NULL,
  `from_date` DATE DEFAULT '0000-00-00' NOT NULL,
  `to_date` DATE DEFAULT '0000-00-00' NOT NULL,
  `job_profile` VARCHAR(255) NOT NULL,
  PRIMARY KEY (`id`)
);

CREATE TABLE IF NOT EXISTS #__jbjobs_feed (
	`id` INT NOT NULL AUTO_INCREMENT,
	`actor` INT DEFAULT '0' NOT NULL,
	`target` INT DEFAULT '0' NOT NULL,
	`id_job` INT DEFAULT '0' NOT NULL,
	`title` text,
	`content` text NOT NULL,
	`created` DATETIME DEFAULT '0000-00-00 00:00:00' NOT NULL,
	`access` TINYINT(3) NOT NULL,
	`params` text NOT NULL,
	`points` INT(4) DEFAULT '1' NOT NULL,
	`archived` TINYINT(3) NOT NULL,
	`status` INT(1) DEFAULT '0' NOT NULL,
	PRIMARY KEY (`id`),
	INDEX `actor` (`actor`),
	INDEX `target` (`target`),
	INDEX `created` (`created`),
	INDEX `archived` (`archived`)
);

CREATE TABLE IF NOT EXISTS #__jbjobs_feed_hide (
	`id` INT NOT NULL AUTO_INCREMENT,
	`activity_id` INT NOT NULL,
	`user_id` INT NOT NULL,
	PRIMARY KEY (`id`),
	INDEX `user_id` (`user_id`)
);

CREATE TABLE IF NOT EXISTS #__jbjobs_fieldorder (
   `id` INT NOT NULL AUTO_INCREMENT,
   `field` VARCHAR(50) NOT NULL,
   `fieldtitle` VARCHAR(50),
   `ordering` INT,
   `section` VARCHAR(20),
   `field_for` TINYINT(2),
   `published` TINYINT(1),
   `sys` TINYINT(1) NOT NULL,
   `cannotunpublish` TINYINT(1) NOT NULL,
   `required` TINYINT(1) DEFAULT '0' NOT NULL,
   `parent` INT DEFAULT '0' NOT NULL,
   `lang_code` VARCHAR(20) DEFAULT 'JBJOBS_' NOT NULL,
   `tips` VARCHAR(250),
   `level` int(11) NOT NULL default '0',
    PRIMARY KEY (`id`)
);
   
CREATE TABLE IF NOT EXISTS #__jbjobs_industry (
  `id` int(11) NOT NULL auto_increment,
  `industry` varchar(100) ,
  `ordering` INT DEFAULT '0' NOT NULL,
  `published` TINYINT(1) DEFAULT '1' NOT NULL,
  PRIMARY KEY (`id`)
);

CREATE TABLE IF NOT EXISTS #__jbjobs_job (
	`id` int(11) NOT NULL auto_increment,
	`job_title` varchar(100) NOT NULL DEFAULT '' ,
	`employer_id` int(11) ,
	`id_degree_level` int(11) NOT NULL DEFAULT 0,
	`id_pos_type` int(11) NOT NULL DEFAULT 0 ,
	`id_salary_type` int(11) NOT NULL DEFAULT 0 ,
	`id_job_exp` int(11) NOT NULL DEFAULT 0 ,
	`id_job_spec` int(11) NOT NULL DEFAULT 0 ,
	`salary` float ,
	`currency_salary` char(10) ,
	`id_country` int(11) NOT NULL DEFAULT 0 ,
	`state` varchar(100) NOT NULL DEFAULT '' ,
	`city` varchar(100) NOT NULL DEFAULT '' ,
	`short_desc` tinytext ,
	`long_desc` mediumtext ,
	`publish_date` datetime DEFAULT '0000-00-00 00:00:00' ,
	`expire_date` datetime DEFAULT '0000-00-00 00:00:00' ,
	`is_active` char(1) NOT NULL DEFAULT 'y' ,
	`is_featured` TINYINT(1) DEFAULT '0' NOT NULL,
	`hits` INT DEFAULT '0' NOT NULL,
	`glng` VARCHAR(15),
	`glat` VARCHAR(15),
	`gzoom` VARCHAR(2),
	`address_geocode` VARCHAR(250),
	`hotjob_expire` DATETIME DEFAULT '0000-00-00 00:00:00',
	`manage_applicant` TINYINT(1) DEFAULT '0' NOT NULL,
	`ext_apply_url` VARCHAR(200),
	PRIMARY KEY (`id`)
);

CREATE TABLE IF NOT EXISTS #__jbjobs_job_alert (
    `id` bigint NOT NULL AUTO_INCREMENT,
    `userid` bigint NOT NULL,
    `alert_title` VARCHAR(32) NOT NULL,
    `id_job_spec` VARCHAR(32) NOT NULL,
    `keyword` VARCHAR(50) NOT NULL,
    `frequency` CHAR(1) DEFAULT 'w' NOT NULL,
    `subscribed` TINYINT(1) DEFAULT '1' NOT NULL,
    `phrase` VARCHAR(10) DEFAULT 'any' NOT NULL,
    PRIMARY KEY (`id`)
);

CREATE TABLE IF NOT EXISTS #__jbjobs_job_categ (
  `id` int(11) NOT NULL auto_increment,
  `category` varchar(80) ,
  `ordering` INT DEFAULT '0' NOT NULL,
  `published` TINYINT(1) DEFAULT '1' NOT NULL,
  PRIMARY KEY (`id`)
);

CREATE TABLE IF NOT EXISTS #__jbjobs_job_exp (
  `id` int(11) NOT NULL auto_increment,
  `exp_name` varchar(50) NOT NULL DEFAULT '' ,
  `ordering` INT DEFAULT '0' NOT NULL,
  `published` TINYINT(1) DEFAULT '1' NOT NULL, 
  PRIMARY KEY (`id`)
);

CREATE TABLE IF NOT EXISTS #__jbjobs_job_spec (
  `id` int(11) NOT NULL auto_increment,
  `specialization` varchar(255) NOT NULL DEFAULT '' ,
  `id_category` int(11) NOT NULL DEFAULT 0 ,
  `ordering` INT DEFAULT '0' NOT NULL,
  `published` TINYINT(1) DEFAULT '1' NOT NULL,
  PRIMARY KEY (`id`)
);

CREATE TABLE IF NOT EXISTS #__jbjobs_jobalert_send (
    `id` INT NOT NULL AUTO_INCREMENT,
    `alertid` INT NOT NULL,
    `userid` INT NOT NULL,
    `jobid` VARCHAR(50) NOT NULL,
    `lastAlertSent` DATETIME DEFAULT '0000-00-00 00:00:00' NOT NULL,
    `queued` TINYINT(1) DEFAULT '1' NOT NULL,
    `try` INT(3) DEFAULT '3' NOT NULL,
    PRIMARY KEY (`id`)
);

CREATE TABLE IF NOT EXISTS #__jbjobs_jobseeker (
	`id` int(11) NOT NULL auto_increment,
	`user_id` int(11) NOT NULL DEFAULT 0 ,
	`first_name` varchar(255) NOT NULL DEFAULT '' ,
	`last_name` varchar(255) NOT NULL DEFAULT '' ,
	`street_addr` VARCHAR(100) NOT NULL,
	`city` VARCHAR(20) NOT NULL,
	`district` VARCHAR(70) NOT NULL,
	`zip` VARCHAR(10) NOT NULL,
	`id_country` INT DEFAULT 0 NOT NULL,
	`contactno` VARCHAR(30) NOT NULL,
	`id_degree_level` int(11) NOT NULL DEFAULT 0 ,
	`id_major` int(11) NOT NULL DEFAULT 0 ,
	`ug_graduated` YEAR NOT NULL,
	`ug_university` VARCHAR(50) NOT NULL,
	`pg_id_degree_level` INT DEFAULT 0 NOT NULL,
	`pg_major` VARCHAR(50) NOT NULL,
	`pg_graduated` YEAR NOT NULL,
	`pg_university` VARCHAR(50) NOT NULL,
	`current_employer` VARCHAR(50) NOT NULL,
	`current_position` varchar(255) NOT NULL DEFAULT '' ,
	`id_job_spec` INT DEFAULT 0 NOT NULL,
	`id_job_exp` int(11) NOT NULL DEFAULT 0 ,
	`skill_summary` text NOT NULL,
	`id_industry1` int(11) NOT NULL DEFAULT 0 ,
	`id_industry2` int(11) NOT NULL DEFAULT 0 ,
	`id_pos_type` int(11) NOT NULL DEFAULT 0 ,
	`min_salary` float NOT NULL DEFAULT 0 ,
	`currency_salary` char(10) ,
	`id_type_salary` int(11) NOT NULL DEFAULT 0 ,
	`personal_birthday` DATE DEFAULT '0000-00-00' NOT NULL,
	`personal_gender` VARCHAR(7) NOT NULL,
	`personal_status` VARCHAR(10) NOT NULL,
	`personal_nationality` VARCHAR(10) NOT NULL,
	`id_job_agency` INT DEFAULT 0 NOT NULL,
	`bill_addr` varchar(255) default NULL,
	`bill_addr_cont` varchar(255) default NULL,
	`bill_id_country` int(11) default NULL,
	`bill_state` varchar(50) default NULL,
	`bill_city` varchar(100) default NULL,
	`bill_zip` varchar(25) default NULL,
	`bill_phone` varchar(50) default NULL,
	`show_name` CHAR(1) DEFAULT 'y' NOT NULL,
	`show_addr` CHAR(1) DEFAULT 'y' NOT NULL,
	`show_location` CHAR(1) DEFAULT 'y' NOT NULL,
	`show_phone` CHAR(1) DEFAULT 'y' NOT NULL,
	`show_zip` CHAR(1) DEFAULT 'y' NOT NULL,
	`show_email` CHAR(1) DEFAULT 'y' NOT NULL,
	`show_post` INT(3) DEFAULT '20' NOT NULL,
	PRIMARY KEY (`id`),
	UNIQUE KEY seeker_idx (`user_id`)
);

CREATE TABLE IF NOT EXISTS #__jbjobs_major (
  `id` int(11) NOT NULL auto_increment,
  `major` varchar(75) NOT NULL DEFAULT '' ,
  `ordering` INT DEFAULT '0' NOT NULL,
  `published` TINYINT(1) DEFAULT '1' NOT NULL,
  PRIMARY KEY (`id`)
);

CREATE TABLE IF NOT EXISTS #__jbjobs_payment_mode (
   `id` bigint NOT NULL AUTO_INCREMENT,
   `fieldname` VARCHAR(100) NOT NULL,
   `fieldgroup` VARCHAR(100) NOT NULL,
   `fieldtype` INT NOT NULL COMMENT '0=Text, 1=Boolean, 2=Selection List',
   `fieldtext` VARCHAR(100) NOT NULL,
   `savedvalue` VARCHAR(600) NOT NULL,
   `displayside` TINYINT DEFAULT '0' NOT NULL COMMENT 'Stores the column in which the config values will be displayed (E.g. 0=Left, 1=Right)',
   `fieldwidth` bigint DEFAULT '100' NOT NULL COMMENT 'Field width in pixels',
   `published` TINYINT(1) DEFAULT '1' NOT NULL,
   `ordering` INT DEFAULT '0' NOT NULL,
   `parent` INT DEFAULT '0' NOT NULL,
   `tips` VARCHAR(200),
   `shortcode` VARCHAR(5) NOT NULL,
   `gwcode` VARCHAR(20),
   `optionvalues` VARCHAR(200),
   PRIMARY KEY (`id`)
);

CREATE TABLE IF NOT EXISTS #__jbjobs_plan (
  `id` INT(11) NOT NULL AUTO_INCREMENT,
  `name` VARCHAR(155) NOT NULL,
  `days` INT(10) DEFAULT '0' NOT NULL,
  `days_type` SET('days','weeks','months','years') DEFAULT 'days' NOT NULL,
  `price` FLOAT DEFAULT '0' NOT NULL,
  `discount` FLOAT DEFAULT '0' NOT NULL,
  `published` TINYINT(1) DEFAULT '1' NOT NULL,
  `invisible` TINYINT(1) DEFAULT '0' NOT NULL,
  `ordering` TINYINT(3) DEFAULT '0' NOT NULL,
  `time_limit` INT(10) DEFAULT '0' NOT NULL,
  `one_time` TINYINT(1) DEFAULT '0' NOT NULL,
  `alert_admin` TINYINT(1) DEFAULT '1' NOT NULL,
  `adwords` mediumtext NOT NULL, 
  `credit` INT DEFAULT '0' NOT NULL,
  `creditperjob` FLOAT DEFAULT '1' NOT NULL,
  `creditperfeatured` FLOAT DEFAULT '1' NOT NULL,
  `creditprice` FLOAT DEFAULT '5' NOT NULL,
  `creditpercv` FLOAT DEFAULT '1' NOT NULL,
  `jobexpire` INT DEFAULT '30' NOT NULL,
  `graceperiod` INT DEFAULT '0' NOT NULL,
  `creditexpire` TINYINT(1) DEFAULT '1' NOT NULL,
  `description` text NOT NULL,
  `finish_msg` text NOT NULL,
  `creditperhotjob` FLOAT DEFAULT '2' NOT NULL,
  `hotjobexpire` INT DEFAULT '5' NOT NULL,
  PRIMARY KEY (`id`)
);

CREATE TABLE IF NOT EXISTS #__jbjobs_plan_js (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(155) NOT NULL,
  `days` int(10) NOT NULL default '0',
  `days_type` set('days','weeks','months','years') NOT NULL default 'days',
  `graceperiod` int(11) NOT NULL default '0',
  `price` float NOT NULL default '0',
  `discount` float NOT NULL default '0',
  `description` text NOT NULL,
  `finish_msg` text NOT NULL,
  `time_limit` int(10) NOT NULL default '0',
  `one_time` tinyint(1) NOT NULL default '0',
  `published` tinyint(1) NOT NULL default '1',
  `invisible` tinyint(1) NOT NULL default '0',
  `ordering` tinyint(3) NOT NULL default '0',
  `alert_admin` tinyint(1) NOT NULL default '1',
  `adwords` mediumtext NOT NULL,
  `credit` int(11) NOT NULL default '0',
  `creditprice` float NOT NULL default '5',
  `creditexpire` tinyint(1) NOT NULL default '1',
  `credit_applyjob` float NOT NULL default '1',
  `credit_featuredapplyjob` float NOT NULL default '2',
  `credit_featuredresume` float NOT NULL default '3',
  `resume_no` int(11) NOT NULL default '3',
  `coverletter_no` int(11) NOT NULL default '3',
  `featuredresume` tinyint(1) NOT NULL default '1',
  `videoresume` tinyint(1) NOT NULL default '0',
  `featuredres_expireday` int(11) NOT NULL default '30',
  `jobalert` tinyint(1) NOT NULL default '0',
  `recruitersview` tinyint(1) NOT NULL default '0',
  `jobalert_no` int(11) NOT NULL default '1',
  PRIMARY KEY  (`id`)
);

CREATE TABLE IF NOT EXISTS #__jbjobs_plan_subscr (
  `id` INT(11) NOT NULL AUTO_INCREMENT,
  `user_id` INT(10) DEFAULT '0' NOT NULL,
  `subscription_id` INT(10) DEFAULT '0' NOT NULL,
  `approved` INT(1) DEFAULT '0' NOT NULL,
  `price` FLOAT DEFAULT '0' NOT NULL,
  `tax_percent` FLOAT DEFAULT '0' NOT NULL,
  `access_count` INT(10) DEFAULT '0' NOT NULL,
  `access_limit` INT(10) DEFAULT '0' NOT NULL,
  `gateway` VARCHAR(45) DEFAULT 'undefined' NOT NULL,
  `gateway_id` VARCHAR(200) NOT NULL,
  `trans_id` INT DEFAULT '0' NOT NULL,
  `credit` INT DEFAULT '0' NOT NULL,
  `date_buy` DATETIME DEFAULT '0000-00-00 00:00:00' NOT NULL,
  `date_approval` DATETIME DEFAULT '0000-00-00 00:00:00' NOT NULL,
  `date_expire` DATETIME DEFAULT '0000-00-00 00:00:00' NOT NULL,
  `invoiceNo` VARCHAR(100),
  `user_type` CHAR(1) DEFAULT 'e' NOT NULL,
  PRIMARY KEY (`id`)
);

CREATE TABLE IF NOT EXISTS #__jbjobs_pos_type (
  `id` int(11) NOT NULL auto_increment,
  `pos_type` varchar(50) NOT NULL DEFAULT '' ,
  `ordering` INT DEFAULT '0' NOT NULL,
  `published` TINYINT(1) DEFAULT '1' NOT NULL,
  PRIMARY KEY (`id`)
);

CREATE TABLE IF NOT EXISTS #__jbjobs_resume (
  `id` int(11) NOT NULL auto_increment,
  `jseeker_id` int(11) NOT NULL DEFAULT 0 ,
  `name_resume` varchar(50) NOT NULL DEFAULT '' ,
  `description` varchar(255) NOT NULL DEFAULT '' ,
  `type` char(1) NOT NULL DEFAULT 'c' ,
  `file_resume` varchar(255) NOT NULL DEFAULT '' ,
  `resume` text NOT NULL DEFAULT '' ,
  `is_active` char(1) ,
  `featured` tinyint(1) NOT NULL default '0',
  `featured_expire` datetime default '0000-00-00 00:00:00',
  `video_link` varchar(100) default NULL,
  `video_url` varchar(50) default NULL,
  PRIMARY KEY (`id`)
);

CREATE TABLE IF NOT EXISTS #__jbjobs_resume_view (
  `id` INT NOT NULL AUTO_INCREMENT,
  `last_viewed` DATETIME DEFAULT '0000-00-00 00:00:00' NOT NULL,
  `jseeker_id` INT DEFAULT '0' NOT NULL,
  `employer_id` INT DEFAULT '0' NOT NULL,
  `hits` INT DEFAULT '0' NOT NULL,
  `search_hits` INT DEFAULT '0' NOT NULL,
  PRIMARY KEY (`id`)
);

CREATE TABLE IF NOT EXISTS #__jbjobs_salutation (
  `id` int(11) NOT NULL auto_increment,
  `salutation` char(10) ,
  PRIMARY KEY (`id`)
);

CREATE TABLE IF NOT EXISTS #__jbjobs_save_job (
	`id` int(11) NOT NULL auto_increment,
	`id_job` int(11) NOT NULL DEFAULT 0 ,
	`jseeker_id` int(11) NOT NULL DEFAULT 0 ,
	`is_apply` char(1) NOT NULL DEFAULT 'n' ,
	`is_view` char(1) NOT NULL DEFAULT 'y' ,
	`contact_name` varchar(100) default NULL,
	`contact_email` varchar(50) default NULL,
	`contact_no` varchar(50) default NULL,
	`cover_letter` VARCHAR(512),
	`resume_title` VARCHAR(50),
	`resume_link` VARCHAR(100),
	PRIMARY KEY (`id`)
);

CREATE TABLE IF NOT EXISTS #__jbjobs_state (
   `id` INT NOT NULL AUTO_INCREMENT,
   `state` CHAR(35) NOT NULL,
   `country_id` INT NOT NULL,
   `published` TINYINT(1) DEFAULT '1' NOT NULL,
   PRIMARY KEY (`id`)
);

CREATE TABLE IF NOT EXISTS #__jbjobs_transaction (
  `id` int(11) NOT NULL auto_increment,
  `date_trans` datetime NOT NULL DEFAULT '0000-00-00 00:00:00' ,
  `transaction` varchar(255) NOT NULL DEFAULT '' ,
  `credit_plus` FLOAT NOT NULL DEFAULT 0 ,
  `credit_minus` FLOAT NOT NULL DEFAULT 0 ,
  `user_id` int(11) NOT NULL DEFAULT 0 ,
  PRIMARY KEY (`id`)
);

CREATE TABLE IF NOT EXISTS #__jbjobs_type_salary (
  `id` int(11) NOT NULL auto_increment,
  `type_salary` varchar(50) NOT NULL DEFAULT '' ,
  `ordering` INT DEFAULT '0' NOT NULL,
  `published` TINYINT(1) DEFAULT '1' NOT NULL,
  PRIMARY KEY (`id`)
);

CREATE TABLE IF NOT EXISTS #__jbjobs_university (
  `id` int(11) NOT NULL auto_increment,
  `university` VARCHAR(255) NOT NULL,
  PRIMARY KEY (`id`)
);

CREATE TABLE IF NOT EXISTS `#__jb_messaging` (
  `n` int(11) NOT NULL auto_increment,
  `idFrom` int(11) NOT NULL,
  `idTo` int(11) NOT NULL,
  `subject` varchar(100) NOT NULL,
  `message` text NOT NULL,
  `seen` bool NOT NULL,
  `date` datetime NOT NULL,
  PRIMARY KEY  (`n`)
);