<?php
/**
 + Created by	:	JoomBah Team
 * Company		:	ISDS Sdn Bhd
 + Contact		:	www.joombah.com , support@joombah.com
 * Created on	:	August 2010
 * Author 		:	Faisel
 + Project		: 	Job site
 * File Name	:	models/jbjobs.php
 * License		:	GNU General Public License version 3, or later
 ^ 
 * Description	: 	Entry point for the component (jbjobs)
 ^ 
 * History		:	NONE
 * */
 defined('_JEXEC') or die('Restricted access');
	
jimport('joomla.application.component.model');
jimport('joomla.html.html');

$option = JRequest :: getVar('option', 'com_jbjobs');

class JBJobsModelJbjobs extends JModel {
	function __construct(){
		parent :: __construct();
		$user	=& JFactory::getUser();
	}
/**
  ================================================================================================================
	SECTION : Admin
	1.Dashboard
	2.Jobs List- show, edit, publish
	3.Billing - show
	4.Employer - show, edit
	5.Jobseeker - show, edit
	6.Subscription - show, edit
	7.Custom User - show, edit
	8.Custom Job - show, edit
	================================================================================================================
*/	
	//1.Jobs List - show
	function getDashboard(){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO();
		
		$query = "SELECT COUNT(*) FROM #__users";
		$db->setQuery($query);
		$users = $db->loadResult();
		
		$query = "SELECT COUNT(*) FROM #__jbjobs_jobseeker";
		$db->setQuery($query);
		$jobseekers = $db->loadResult();
		
		$query = "SELECT COUNT(*) FROM #__jbjobs_employer";
		$db->setQuery($query);
		$employers = $db->loadResult();
		
		$query = "SELECT COUNT(*) FROM #__jbjobs_job";
		$db->setQuery( $query );
		$jobs = $db->loadResult();
		
		$return[0] = $users;
		$return[1] = $jobseekers;
		$return[2] = $employers;
		$return[3] = $jobs;
		return $return;
	}
	
	//2.Jobs List - show
	function getJobList(){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO();
		$post   = JRequest::get('post');
 
        $filter_order      = $app->getUserStateFromRequest( 'com_jbjobs_filter_order_jl', 'filter_order', 'a.job_title', 'cmd' );
        $filter_order_Dir  = $app->getUserStateFromRequest( 'com_jbjobs_filter_order_Dir_jl', 'filter_order_Dir', 'asc', 'word' );
		$filter_job_status = $app->getUserStateFromRequest( 'com_jbjobs_filter_job_status', 'filter_job_status', 0, 'string' );
		$search			   = $app->getUserStateFromRequest( 'com_jbjobs_job_search',	'search', '', 'string' );
		if (strpos($search, '"') !== false) {
			$search = str_replace(array('=', '<'), '', $search);
		}
		$search = JString::strtolower($search);
		
        $this->setState('filter_order', $filter_order);
        $this->setState('filter_order_Dir', $filter_order_Dir);
		$orderby = $this->_buildContentOrderBy();
		$lists['order_Dir']  = $this->getState( 'filter_order_Dir' );
        $lists['order']      = $this->getState( 'filter_order' );
		$lists['job_status'] = $this->getSelectJobStatus('filter_job_status', $filter_job_status, 0, 'onchange="document.adminForm.submit( );"');
		$lists['search'] = $search;
		
		$filter = '';
		$where = array();
		
		if (isset( $search ) && $search != '') {
			$searchEscaped = $db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
			$where[] = 'a.job_title LIKE '.$searchEscaped.' OR e.comp_name LIKE '.$searchEscaped;
		}
		
		$now = date('Y-m-d');//, time() + ( $app->getCfg('offset') * 60 * 60 ) );
		
		if($filter_job_status == 1)
			$where[] = "a.is_active='y' and a.publish_date <= '".$now."' and a.expire_date >= '".$now."' and a.expire_date <> '0000-00-00 00:00:00'";
		elseif($filter_job_status == 2)
			$where[] = "a.expire_date <= '".$now."' and a.expire_date <> '0000-00-00 00:00:00'";
		elseif($filter_job_status == 3)
			$where[] = "a.publish_date = '0000-00-00 00:00:00'";
		
		$where = (count( $where) ? ' WHERE (' . implode( ') AND (', $where ) . ')' : '' );	
		
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', $filter_job_status, 'int');
		
		$query = "SELECT COUNT(*) FROM #__jbjobs_job a".
				 $where.
				 $orderby;
		
		$db->setQuery($query);
		$total = $db->loadResult();
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination( $total, $limitstart, $limit );
	
		$query = "SELECT a.*,b.specialization,e.comp_name,(SELECT COUNT(*) FROM #__jbjobs_save_job s WHERE s.id_job=a.id and s.is_apply='y') AS appcount FROM #__jbjobs_job a".
				 " LEFT JOIN #__jbjobs_job_spec b ON a.id_job_spec = b.id".
				 " LEFT JOIN #__jbjobs_employer e ON e.user_id = a.employer_id".
				 $where.
				 $orderby;
		
		$db->setQuery( $query, $pageNav->limitstart, $pageNav->limit );
		$rows = $db->loadObjectList();
		
		$return[0] = $rows;
		$return[1] = $pageNav;
		$return[2] = $lists;
		return $return;
	}
	
	//2.Jobs List - edit
	function getEditJob(){
		$db		=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
	
		$cid 	= JRequest::getVar('cid', array(0), '', 'array');
		$option = JRequest::getCmd('option');
	
		JArrayHelper::toInteger($cid, array(0));
		
		//if it is new job, cid = 0
		($cid[0] == 0)?	$isNew = true : $isNew = false;
	
		$row =& JTable::getInstance('job','Table'); 
		// load the row from the db table
		$disabled ='';
		
		if(!$isNew){
			$row->load($cid[0]);	
		}
			
		//make selection user
		$query = "SELECT a.id AS value, username, name FROM #__users a
				  INNER JOIN #__jbjobs_employer b ON a.id = b.user_id
				  ORDER BY username";
		$db->setQuery($query);
		$users = $db->loadObjectList();
		
		$types[] = JHTML::_('select.option',  '', '- '. JText::_('JBJOBS_USERNAME_USERID_NAME') .' -' );
		foreach($users as $item){
			$types[] = JHTML::_('select.option', $item->value, sprintf("%s [%d] (%s)", $item->username, $item->value, $item->name));
		}
		
		$lists 	= JHTML::_('select.genericlist', $types, 'employer_id', 'class="inputbox required" size="1" '.$disabled.'', 'value', 'text', $row->employer_id ? $row->employer_id :'0' );
		
		$query = "SELECT * FROM #__jbjobs_custom_field WHERE published='1' and field_for='job' ORDER BY ordering";
		$db->setQuery($query);
		$custom = $db->loadObjectList();
		
		$fields = $this->getFieldsOrdering(3);
		$parents = $fields[0];
		$children = $fields[1];
		
		$query = "SELECT b.*,a.*,b.id AS jobseeker_id, d.name,r.hits,c.job_title FROM #__jbjobs_save_job a".
				" LEFT JOIN #__jbjobs_jobseeker b ON a.jseeker_id = b.user_id".
				" LEFT JOIN #__jbjobs_job c on c.id = a.id_job".
				" LEFT JOIN #__users d ON a.jseeker_id = d.id".
				" LEFT JOIN #__jbjobs_resume_view r on r.jseeker_id=a.jseeker_id AND r.employer_id=$row->employer_id".
				" WHERE a.id_job=$cid[0] AND a.is_apply='y'";
		$db->setQuery($query);
		$apps = $db->loadObjectList();	
		
		$return[0] = $row; 
		$return[1] = $lists;
		$return[2] = $custom;
		$return[3] = $parents;
		$return[4] = $children;
		$return[5] = $apps;
		
		return $return;
	}

	//2.Publish Job
	function getPublishJob(){

		$db		=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
	
		$cid 	= JRequest::getVar('cid', array(0), '', 'array');
		$option = JRequest::getCmd('option');
		$post   = JRequest::get( 'post' );
		$employer_id = (!empty($post['employer_id'])) ? $post['employer_id'] : 0;
		$id 		 = (!empty($post['id'])) ? $post['id'] : 0;
		
		JArrayHelper::toInteger($cid, array(0));
	
		$row =& JTable::getInstance('job', 'Table');
		$row->load($id);
		
		return $row;
	}
	
	//3.Billing - show
	function getShowBilling(){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO();
		
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', 0, 'int');
		$gateways 	= $app->getUserStateFromRequest( 'com_jbjobs.cgateways', 'cgateways', '', 'string' );	
		$status 	= $app->getUserStateFromRequest( 'com_jbjobs.cstatus', 'cstatus', 'a', 'string' );	
		$inv_num 	= $app->getUserStateFromRequest( 'com_jbjobs.cinv_num', 'cinv_num', '', 'string' );
		$user_id 	= $app->getUserStateFromRequest( 'com_jbjobs.cuser_id', 'cuser_id', '', 'string' );
		$credit_id 	= $app->getUserStateFromRequest( 'com_jbjobs.ccredit_id', 'ccredit_id', '', 'string' );
	    
		$lists['cinv_num'] = $inv_num;
		$lists['cuser_id'] = $user_id;
		$lists['ccredit_id'] = $credit_id;
		$lists['cgateways'] = $this->getSelectPaymode('cgateways', $gateways, 'onchange="document.adminForm.submit( );"');
		$lists['cstatus'] = $this->getSelectCreditStatus('cstatus', $status, 'onchange="document.adminForm.submit( );"');
		
		$where = array();
		if($inv_num != '' ) $where[] = 'a.invoiceNo ='.$db->Quote($inv_num);
	    if($user_id > 0 ) $where[] = 'a.user_id ='.$user_id;
	    if($credit_id > 0 ) $where[] = 'a.id ='.$credit_id;
	    if($gateways != '' ) $where[] = 'a.gateway ='.$db->Quote($gateways); 
	    if($status != 'a') $where[] = 'a.approval  = '.$db->Quote($status); 
	    
	    $where = (count( $where) ? ' WHERE (' . implode( ') AND (', $where ) . ')' : '' );
		
		$query = "SELECT COUNT(*) FROM #__jbjobs_billing a".
				 " LEFT JOIN #__jbjobs_employer b ON a.user_id = b.user_id".
				 " LEFT JOIN #__jbjobs_salutation c  ON b.id_salutation = c.id".$where.
				 " ORDER BY a.date_buy desc";
		$db->setQuery($query);
		$total = $db->loadResult();
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination( $total, $limitstart, $limit );
	
		$query = "SELECT a.*,u.name FROM #__jbjobs_billing a".
				 " LEFT JOIN #__users u ON a.user_id = u.id".
				 " ORDER BY a.date_buy desc";
		$db->setQuery($query, $pageNav->limitstart, $pageNav->limit);
		$rows = $db->loadObjectList();
		
		$return[0] = $rows;
		$return[1] = $pageNav;
		$return[2] = $lists;
		
		return $return;
	}
	
	//4.Employer - show
	function getShowEmployer(){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO();
		$post   = JRequest::get( 'post' );
		
		$filter_order     = $app->getUserStateFromRequest( 'com_jbjobs_filter_order_emp', 'filter_order', 'a.firstname', 'cmd' );
        $filter_order_Dir = $app->getUserStateFromRequest( 'com_jbjobs_filter_order_Dir_emp', 'filter_order_Dir', 'asc', 'word' );
		$search			  = $app->getUserStateFromRequest( 'com_jbjobs_employer_search',	'search', '', 'string' );
		if (strpos($search, '"') !== false) {
			$search = str_replace(array('=', '<'), '', $search);
		}
		$search = JString::strtolower($search);
		
        $this->setState('filter_order', $filter_order);
        $this->setState('filter_order_Dir', $filter_order_Dir);
		$orderby = $this->_buildContentOrderBy();
		$lists['order_Dir'] =  $this->getState( 'filter_order_Dir' );
        $lists['order']     =  $this->getState( 'filter_order' );
		$lists['search'] 	= $search;
		
		$where = array();
		
		if (isset( $search ) && $search != '') {
			$searchEscaped = $db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
			$where[] = 'a.firstname LIKE '.$searchEscaped.' OR a.lastname LIKE '.$searchEscaped.'OR a.comp_name LIKE '.$searchEscaped;
		}
		$where = (count( $where) ? ' WHERE (' . implode( ') AND (', $where ) . ')' : '' );	
		
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', 0, 'int');
		
		$query = "SELECT COUNT(*) FROM #__jbjobs_employer a".
				 " LEFT JOIN #__users b ON a.user_id = b.id".
				 " LEFT JOIN #__jbjobs_country c ON a.id_country = c.id".
				 " LEFT JOIN #__jbjobs_comp_type d ON a.id_comp_type = d.id".
				 " LEFT JOIN #__jbjobs_salutation e ON a.id_salutation = e.id".
				 $where.
				 $orderby;
		
		$db->setQuery( $query );
		$total = $db->loadResult();
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination( $total, $limitstart, $limit );
		
		$query = "SELECT a.*,b.id as user_id,e.salutation,c.country FROM #__jbjobs_employer a".
				 " LEFT JOIN #__users b ON a.user_id = b.id".
				 " LEFT JOIN #__jbjobs_country c ON a.id_country = c.id".
				 " LEFT JOIN #__jbjobs_comp_type d ON a.id_comp_type = d.id".
				 " LEFT JOIN #__jbjobs_salutation e ON a.id_salutation = e.id".
				 $where.
				 $orderby;
		
		$db->setQuery( $query, $pageNav->limitstart, $pageNav->limit );
		$rows = $db->loadObjectList();
		$rows2 = $db->loadObjectList();
		
		$rows = null;
		
		if(count($rows2)){
			$i = 0;
			foreach($rows2 as $row){
				$rows[$i] = new stdClass();
				$plus = 0;
				$minus = 0;
				$total_credit = 0;
				$query = "select sum(credit_plus) from #__jbjobs_transaction where user_id = ".$row->user_id;
				$db->setQuery( $query );
				$plus = $db->loadResult();
				
				$query = "select sum(credit_minus) from #__jbjobs_transaction where user_id = ".$row->user_id;
				$db->setQuery( $query );
				$minus = $db->loadResult();
				
				$total_credit = $plus - $minus;
				
				$rows[$i] = $row;
				$rows[$i]->total_credit = $total_credit;
				$i++;
			}
		}
		$return[0] = $rows;
		$return[1] = $pageNav;
		$return[2] = $lists;
		
		return $return;
	}
	
	//4.Employer - edit
	function getEditEmployer(){
		$db		=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
		$row =& JTable::getInstance('employer', 'Table');
		$cid 	= JRequest::getVar('cid', array(0), '', 'array');
		JArrayHelper::toInteger($cid, array(0));
		
		//if it is new, cid[0] = 0
		($cid[0] == 0)?	$isNew = true : $isNew = false;
	
		if(!$isNew)
			$row->load($cid[0]);
		
	    $disabled ='';
		
		//make selection user
	    if($isNew){		//for new jobseekers, get the list of user not in jobseeker and in employer table
			$query = "SELECT id AS value, username, name FROM #__users 
				  WHERE id NOT IN (SELECT user_id FROM #__jbjobs_jobseeker) AND
				  id NOT IN (SELECT user_id FROM #__jbjobs_employer) 
				  ORDER BY username";
	    }
		else {
			$query = "SELECT id AS value, username, name FROM #__users ORDER BY username";
		}
		$db->setQuery($query);
		$users = $db->loadObjectList();
		
		$types[] = JHTML::_('select.option',  '', '- '.JText::_('JBJOBS_USERNAME_USERID_NAME').' -' );
		foreach( $users as $item ){
			$types[] = JHTML::_('select.option', $item->value, sprintf("%s [%d] (%s)", $item->username, $item->value, $item->name));
		}
		
		if(!$isNew)
			$disabled ='disabled';
		
		$lists 	= JHTML::_('select.genericlist', $types, 'username', 'class="inputbox required" size="1" '.$disabled.'', 'value', 'text', $row->user_id ? $row->user_id :'0' );

		$plus = 0;
		$minus = 0;
		$total_credit = 0;
		$query = "select sum(credit_plus) from #__jbjobs_transaction where user_id = ".$row->user_id;
		$db->setQuery( $query );
		$plus = $db->loadResult();
			
		$query = "select sum(credit_minus) from #__jbjobs_transaction where user_id = ".$row->user_id;
		$db->setQuery( $query );
		$minus = $db->loadResult();
			
		$row->total_credit = $plus - $minus;

	    $query = "SELECT * FROM #__jbjobs_custom_field WHERE field_for='employer' AND published='1' ORDER BY ordering";
	  	$db->setQuery($query);
	  	$custom = $db->loadObjectList();
	  	
	  	$fields = $this->getFieldsOrdering(1);
		$parents = $fields[0];
		$children = $fields[1];
		
		//get the transaction list of the jobseeker
		$query = "SELECT * FROM #__jbjobs_transaction ".
				 " WHERE user_id =".$db->quote($row->user_id)." ORDER BY date_trans DESC";
		$db->setQuery($query);
		$trans = $db->loadObjectList();
		
		$return[0] = $row;
		$return[1] = $lists;
		$return[2] = $custom;
		$return[3] = $parents;
		$return[4] = $children;
		$return[5] = $trans;
		
		return $return;
	}
	
	//5.Jobseeker - show
	function getShowJobSeeker(){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO();
		$post   = JRequest::get( 'post' );
		
		$filter_order     = $app->getUserStateFromRequest(  'com_jbjobs_filter_order_js', 'filter_order', 'a.first_name', 'cmd' );
        $filter_order_Dir = $app->getUserStateFromRequest( 'com_jbjobs_filter_order_Dir_js', 'filter_order_Dir', 'asc', 'word' );
        $search			  = $app->getUserStateFromRequest( 'com_jbjobs_jobseeker_search', 'search', '', 'string' );
		if (strpos($search, '"') !== false) {
			$search = str_replace(array('=', '<'), '', $search);
		}
		$search = JString::strtolower($search);
		
		$this->setState('filter_order', $filter_order);
        $this->setState('filter_order_Dir', $filter_order_Dir);
		$orderby = $this->_buildContentOrderBy();
		$lists['order_Dir'] =  $this->getState( 'filter_order_Dir' );
        $lists['order']     =  $this->getState( 'filter_order' );
		$lists['search'] = $search;
		
		$where = array();
		
		if (isset( $search ) && $search != '') {
			$searchEscaped = $db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
			$where[] = 'a.first_name LIKE '.$searchEscaped.' OR a.last_name LIKE '.$searchEscaped;
		}
		$where = (count( $where) ? ' WHERE (' . implode( ') AND (', $where ) . ')' : '' );
		
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', 0, 'int');
		
		$query = "SELECT COUNT(*) FROM #__jbjobs_jobseeker a".
				 " LEFT JOIN #__users b ON a.user_id = b.id".
				 " LEFT JOIN #__jbjobs_major c ON a.id_major = c.id".
				 " LEFT JOIN #__jbjobs_degree_level d ON a.id_degree_level = d.id".
				 $where.
				 $orderby;
		
		$db->setQuery( $query );
		$total = $db->loadResult();
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination( $total, $limitstart, $limit );
		
		$query = "SELECT a.*,b.name,b.id as user_id,c.major,d.degree_level FROM #__jbjobs_jobseeker a".
				 " LEFT JOIN #__users b ON a.user_id = b.id".
				 " LEFT JOIN #__jbjobs_major c ON a.id_major = c.id".
				 " LEFT JOIN #__jbjobs_degree_level d ON a.id_degree_level = d.id".
				 $where.
				 $orderby;
		
		$db->setQuery( $query, $pageNav->limitstart, $pageNav->limit );
		$rows = $db->loadObjectList();
		
		$return[0] = $rows;
		$return[1] = $pageNav;
		$return[2] = $lists;
		
		return $return;
	}
	
	//5.Jobseeker - edit
	function getEditJobSeeker(){
		$db		=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
		$cid 	= JRequest::getVar('cid', array(0), '', 'array');
		JArrayHelper::toInteger($cid, array(0));
		$row =& JTable::getInstance('jobseeker', 'Table');
		
		($cid[0] == 0)?	$isNew = true : $isNew = false;		//if it is new, cid[0] = 0
		if(!$isNew)
			$row->load($cid[0]);
		
	    $disabled = '';
		
	    //make selection user
	    if($isNew){		//for new jobseekers, get the list of user not in jobseeker and in employer table
			$query = "SELECT id AS value, username, name FROM #__users 
				  WHERE id NOT IN (SELECT user_id FROM #__jbjobs_jobseeker) AND
				  id NOT IN (SELECT user_id FROM #__jbjobs_employer) 
				  ORDER BY username";
	    }
		else {
			$query = "SELECT id AS value, username, name FROM #__users ORDER BY username";
		}
		$db->setQuery($query);
		$users = $db->loadObjectList();
		
		$types[] = JHTML::_('select.option',  '', '- '.JText::_('JBJOBS_USERNAME_USERID_NAME').' -' );
		foreach($users as $item){
			$types[] = JHTML::_('select.option', $item->value, sprintf("%s [%d] (%s)", $item->username, $item->value, $item->name) );
		}
		
		if(!$isNew)
			$disabled = 'disabled';
		
		$lists 	= JHTML::_('select.genericlist', $types, 'username', 'class="inputbox" size="1" '.$disabled.'', 'value', 'text', $row->user_id ? $row->user_id : '0' );

		$query = "SELECT * FROM #__jbjobs_custom_field WHERE field_for='jobseeker' AND published='1' ORDER BY ordering";
	  	$db->setQuery($query);
	  	$custom = $db->loadObjectList();
		
		$exp =& JTable::getInstance('experience', 'Table'); 
		if(true){
			$query = "SELECT id FROM #__jbjobs_experience WHERE user_id =".$row->user_id;
			$db->setQuery($query);
			$id_exp = $db->loadResult();
			$exp->load($id_exp);
		}
		$fields = $this->getFieldsOrdering(2);
		$parents = $fields[0];
		$children = $fields[1];
		
		global $tree;
		$query = "SELECT * FROM #__jbjobs_fieldorder
				  where field_for=2 AND parent=0
				  ORDER BY ordering";
		$db->setQuery($query);
		$pars = $db->loadObjectList();
		
		// subcategories view as tree
	   	$tree = array();
	   	
	   	foreach ($pars as $v) {
	       	$ident = '';
	       	$tree[] = $v;
			$this->tree($v->id, $ident, $tree);
		}
	    
		//get the transaction list of the jobseeker
		$query = "SELECT * FROM #__jbjobs_transaction ".
				 " WHERE user_id =".$db->quote($row->user_id)." ORDER BY date_trans DESC";
		$db->setQuery($query);
		$trans = $db->loadObjectList();
		
		//get resume of jobseeker
		$query = "SELECT * FROM #__jbjobs_resume WHERE jseeker_id = ".$db->quote($row->user_id);
		$db->setQuery($query);
		$resumes = $db->loadObjectList();
		
		$return[0] = $row;
		$return[1] = $lists;
		$return[2] = $custom;
		$return[3] = $exp;
		$return[4] = $parents;
		$return[5] = $children;
		$return[6] = $tree;
		$return[7] = $trans;
		$return[8] = $resumes;
		return $return;
	}
	
	//4.Edit Resume
	function getEditResume(){
		$db	=& JFactory::getDBO();
		$id = JRequest::getVar('id', 0, 'get', 'int');
		
		$row =& JTable::getInstance('resume', 'Table');
		$row->load($id);
		
		return $row;
	}

	//6.Subscription - show
	function getShowSubscr(){
	
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO();
	    
	    $limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', 0, 'int');
		
		$filter_order     = $app->getUserStateFromRequest(  'com_jbjobs_filter_order_subscr', 'filter_order', 'u.id', 'cmd');
        $filter_order_Dir = $app->getUserStateFromRequest( 'com_jbjobs_filter_order_Dir_subscr', 'filter_order_Dir', 'desc', 'word');
		$subscr_status = $app->getUserStateFromRequest( 'com_jbjobs_filter_subscr_status', 'subscr_status', 0, 'string');	
		$subscr_plan = $app->getUserStateFromRequest( 'com_jbjobs_filter_subscr_plan', 'subscr_plan', 0, 'string');	
		$user_type = $app->getUserStateFromRequest( 'com_jbjobs_filter_user_type', 'user_type', 'e', 'string');	
		$inv_num = $app->getUserStateFromRequest( 'com_jbjobs_sinv_num', 'sinv_num', '', 'string');
		$user_id = $app->getUserStateFromRequest( 'com_jbjobs_subscr_userid', 'suser_id', '', 'string');
		$subscr_id = $app->getUserStateFromRequest( 'com_jbjobs_subscr_subscrid', 'ssubscr_id', '', 'string');
	    
		$this->setState('filter_order', $filter_order);
        $this->setState('filter_order_Dir', $filter_order_Dir);
		$orderby = $this->_buildContentOrderBy();
		$lists['order_Dir'] =  $this->getState( 'filter_order_Dir' );
        $lists['order']     =  $this->getState( 'filter_order' );
		$lists['sinv_num'] = $inv_num;
		$lists['suser_id'] = $user_id;
		$lists['ssubscr_id'] = $subscr_id;
		$lists['subscr_status'] = $this->getSelectSubscrStatus('subscr_status', $subscr_status, 0, 'onchange="document.adminForm.submit();"');
		$lists['subscr_plan'] = $this->getSelectPlan('subscr_plan', $subscr_plan, 0, $user_type, 'onchange="document.adminForm.submit();"');
		$lists['user_type'] = $this->getSelectUserType('user_type', $user_type, 'e', 'onchange="document.adminForm.submit();"');
			
		$where = array();
		if($inv_num != '' ) $where[] = 'u.invoiceNo ='.$db->Quote($inv_num);
	    if($user_id > 0 ) $where[] = 'u.user_id ='.$user_id;
	    if($subscr_id > 0 ) $where[] = 'u.id ='.$subscr_id;
	    if($subscr_status == 1) $where[] = 'u.approved = 1'; 
	    if($subscr_status == 2) $where[] = 'u.approved = 0';
	    if($subscr_status == 3) $where[] = '(TO_DAYS(u.date_expire) - TO_DAYS(NOW()))<0';
	    if($subscr_status == 4) $where[] = 'u.approved = 2';
		if($subscr_plan > 0) $where[] = 'u.subscription_id ='.$subscr_plan;
		if($user_type != '') $where[] = 'u.user_type ='.$db->Quote($user_type);
		$where = (count( $where) ? ' WHERE (' . implode( ') AND (', $where ) . ')' : '' );	
		
		if($user_type == 'e') $join = 'LEFT JOIN #__jbjobs_plan AS s ON s.id = u.subscription_id';
		elseif($user_type == 'j') $join = 'LEFT JOIN #__jbjobs_plan_js AS s ON s.id = u.subscription_id';
		
		$sql = "SELECT count(*) FROM #__jbjobs_plan_subscr AS u 
	 			$join
	 			LEFT JOIN #__users AS n ON n.id = u.user_id". 
	    		$where.
				$orderby;
		$db->setQuery($sql);
		$total = $db->loadResult();
	    
	    jimport('joomla.html.pagination');
		$pageNav = new JPagination( $total, $limitstart, $limit );
		
		 $sql = "SELECT u.*, n.name AS uname, n.email, n.id AS uid, s.name, 
	           	(TO_DAYS(u.date_expire) - TO_DAYS(NOW())) as days, s.id AS sid 
	      		FROM #__jbjobs_plan_subscr AS u 
	 			$join
	 			LEFT JOIN #__users AS n ON n.id = u.user_id". 
	    		$where.
				$orderby;
	    $db->setQuery( $sql, $pageNav->limitstart, $pageNav->limit );
	    $rows = $db->loadObjectList();
			
		$return[0] = $rows;
		$return[1] = $pageNav;
		$return[2] = $lists;
		
		return $return;
	}

	//6.Subscription - edit
	function getEditSubscr(){
		$app =& JFactory::getApplication();
		$db		=& JFactory::getDBO();
    	$cid 	= JRequest::getVar('cid', array(0), '', 'array');
		JArrayHelper::toInteger($cid, array(0));
		
		//if it is new, cid[0] = 0
		($cid[0] == 0)?	$isNew = true : $isNew = false;
		
		$row =& JTable::getInstance('plansubscr', 'Table');
		
		if(!$isNew)
			$row->load($cid[0]);
		
		$disabled = '';
		if(!$isNew)
			$disabled = 'disabled';
		
		$filter_user_type = $app->getUserStateFromRequest('com_jbjobs.filter_user_type', 'user_type', 'e', 'string');
		$def_user_type = !empty($row->user_type) ? $row->user_type : $filter_user_type;
		$lists['user_type'] = $this->getSelectUserType('user_type', $def_user_type, $disabled, 'onchange="document.adminForm.submit();"');
		
		if($def_user_type == 'e'){
			$tblPlanName = '#__jbjobs_plan';
			$tblProfName = '#__jbjobs_employer';
		}
		elseif($def_user_type == 'j'){
			$tblPlanName = '#__jbjobs_plan_js';
			$tblProfName = '#__jbjobs_jobseeker';
		}
		
	    //make selection user
		$query = "SELECT u.id as value, u.username, u.name FROM $tblProfName e
				  LEFT JOIN #__users u ON e.user_id = u.id";
		$db->setQuery($query);
		$user_rows = $db->loadObjectList();
		
		$types[] = JHTML::_('select.option', '0', '- '.JText::_('JBJOBS_USERNAME_USERID_NAME').' -' );
		foreach($user_rows as $item){
			$types[] = JHTML::_('select.option', $item->value, sprintf("[%d] %s (%s)", $item->value, $item->username, $item->name));
		}
		$users 	= JHTML::_('select.genericlist', $types, 'user_id', 'class="inputbox" size="1" '.$disabled.'', 'value', 'text', $row->user_id ? $row->user_id : '0' );

		//make plans selection list
		$query = "SELECT * FROM $tblPlanName p WHERE p.published = 1 ORDER BY p.id ASC";    
  		$db->setQuery( $query );
		$plan_rows = $db->loadObjectList();
		
		$types = '';
		$types[] = JHTML::_('select.option', '0', '- '.JText::_('JBJOBS_SELECT_PLAN').' -' );
		foreach($plan_rows as $item){
			$types[] = JHTML::_('select.option', $item->id, sprintf("[%d] %s", $item->id, $item->name));
		}
		$plans 	= JHTML::_('select.genericlist', $types, 'subscription_id', 'class="inputbox" size="1" '.$disabled.'', 'value', 'text', $row->subscription_id ? $row->subscription_id : '0');
	
		$return[0] = $row;
		$return[1] = $users;
		$return[2] = $plans;
		$return[3] = $lists;
		return $return;
	}
	
	//2.Jobs List - show
	function getShowJobalert(){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO();
		$post   = JRequest::get('post');
 
        $filter_order      = $app->getUserStateFromRequest( 'com_jbjobs_filter_order_ja', 'filter_order', 'a.job_title', 'cmd' );
        $filter_order_Dir  = $app->getUserStateFromRequest( 'com_jbjobs_filter_order_Dir_ja', 'filter_order_Dir', 'asc', 'word' );
		$filter_job_status = $app->getUserStateFromRequest( 'com_jbjobs_filter_job_status', 'filter_job_status', 0, 'string' );
		$search			   = $app->getUserStateFromRequest( 'com_jbjobs_job_search',	'search', '', 'string' );
		if (strpos($search, '"') !== false) {
			$search = str_replace(array('=', '<'), '', $search);
		}
		$search = JString::strtolower($search);
		
        $this->setState('filter_order', $filter_order);
        $this->setState('filter_order_Dir', $filter_order_Dir);
		$orderby = $this->_buildContentOrderBy();
		$lists['order_Dir']  = $this->getState( 'filter_order_Dir' );
        $lists['order']      = $this->getState( 'filter_order' );
		$lists['job_status'] = $this->getSelectJobStatus('filter_job_status', $filter_job_status, 0, 'onchange="document.adminForm.submit( );"');
		$lists['search'] = $search;
		
		$filter = '';
		$where = array();
		
		if (isset( $search ) && $search != '') {
			$searchEscaped = $db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
			$where[] = 'a.job_title LIKE '.$searchEscaped.' OR e.comp_name LIKE '.$searchEscaped;
		}
		
		$now = date('Y-m-d');//, time() + ( $app->getCfg('offset') * 60 * 60 ) );
		
		if($filter_job_status == 1)
			$where[] = "a.is_active='y' and a.publish_date <= '".$now."' and a.expire_date >= '".$now."' and a.expire_date <> '0000-00-00 00:00:00'";
		elseif($filter_job_status == 2)
			$where[] = "a.expire_date <= '".$now."' and a.expire_date <> '0000-00-00 00:00:00'";
		elseif($filter_job_status == 3)
			$where[] = "a.publish_date = '0000-00-00 00:00:00'";
		
		$where = (count( $where) ? ' WHERE (' . implode( ') AND (', $where ) . ')' : '' );	
		
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', $filter_job_status, 'int');
		
		$query = "SELECT count(*) FROM #__jbjobs_job_alert a".
				// " LEFT JOIN #__jbjobs_job_spec b ON a .id_job_spec = b.id".
				 " LEFT JOIN #__jbjobs_jobseeker j ON j.user_id = a.userid";//.
		$db->setQuery($query);
		$total = $db->loadResult();
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination( $total, $limitstart, $limit );
	
		$query = "SELECT a.*,j.first_name FROM #__jbjobs_job_alert a".
				// " LEFT JOIN #__jbjobs_job_spec b ON a .id_job_spec = b.id".
				 " LEFT JOIN #__jbjobs_jobseeker j ON j.user_id = a.userid order by a.id";//.
				/* $where.
				 $orderby;*///echo $query;
		
		$db->setQuery($query, $pageNav->limitstart, $pageNav->limit);
		$rows = $db->loadObjectList();
		
		$return[0] = $rows;
		$return[1] = $pageNav;
		$return[2] = $lists;
		return $return;
	}
	
	//Job Alert - Edit
	function getEditJobalert(){
		$app =& JFactory::getApplication();
		$user =& JFactory::getUser();
		$db	  =& JFactory::getDBO();
		$cid 	= JRequest::getVar('cid', array(0), '', 'array');
		JArrayHelper::toInteger($cid, array(0));
		
		$row =& JTable::getInstance('jobalert', 'Table'); 
		$row->load($cid[0]);
		
		$spec_ids = $row->id_job_spec;
		$query = "SELECT js.* FROM #__jbjobs_job_spec js WHERE js.id IN(".$spec_ids.")";
		$db->setQuery($query);
		$specs = $db->loadObjectList();
	
		$return[0] = $row;
	 	$return[1] = $specs;
	  	return $return;
	}
	
	//jobAlert
	function showRecommendedJob(){
		$app =& JFactory::getApplication();
		$user	=& JFactory::getUser();
		$db		=& JFactory::getDBO();
		$cid 	= JRequest::getVar('cid', array(0), '', 'array');
		JArrayHelper::toInteger($cid, array(0));
		
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', 0, 'int');
		
		$query = "SELECT ja.* from #__jbjobs_job_alert ja WHERE ja.id=".$cid[0];
		$db->setQuery($query);
		$alert = $db->loadObject();
		
		$keyword = $alert->keyword;
		
		// slashes cause errors, <> get stripped anyway later on. # causes problems.
		$badchars = array('#','>','<','\\'); 
		$searchword = trim(str_replace($badchars, '', $keyword));

		//stript the space before and after comma(,)
		$spaceStripped = preg_replace("/\s*,\s*/", ",", $searchword);
		
		$result = array();
		$result = explode(',', $spaceStripped);

		$phrase = $alert->phrase;
		switch ($phrase) {
			case 'exact':
				$text		= $db->Quote( '%'.$db->getEscaped( $result, true ).'%', false );
				$wheres2 	= array();
				$wheres2[] 	= 'a.job_title LIKE '.$text;
				$wheres2[] 	= 'a.state LIKE '.$text;
				$wheres2[] 	= 'a.city LIKE '.$text;
				$wheres2[] 	= 'b.country LIKE '.$text;
				$wheres2[] 	= 'c.comp_name LIKE '.$text;
				$wheres2[] 	= 'cv.value LIKE '.$text;
				$wheres2[] 	= 'cv.valuetext LIKE '.$text;
				$wheres2[] 	= 'a.short_desc LIKE '.$text;
				$wheres2[] 	= 'a.long_desc LIKE '.$text;
				$queryStrings[] = '(' . implode( ') OR (', $wheres2 ) . ')';
				break;
	
			case 'all':
			case 'any':
			default:
				$wheres = array();
				foreach ($result as $word) {
					$word		= $db->Quote( '%'.$db->getEscaped( $word, true ).'%', false );
					$wheres2 	= array();
					$wheres2[] 	= 'a.job_title LIKE '.$word;
					$wheres2[] 	= 'a.state LIKE '.$word;
					$wheres2[] 	= 'a.city LIKE '.$word;
					$wheres2[] 	= 'b.country LIKE '.$word;
					$wheres2[] 	= 'c.comp_name LIKE '.$word;
					$wheres2[] 	= 'cv.value LIKE '.$word;
					$wheres2[] 	= 'cv.valuetext LIKE '.$word;
					$wheres2[] 	= 'a.short_desc LIKE '.$word;
					$wheres2[] 	= 'a.long_desc LIKE '.$word;
					$wheres[] 	= implode( ' OR ', $wheres2 );
				}
				$queryStrings[] = '(' . implode( ($phrase == 'all' ? ') AND (' : ') OR ('), $wheres ) . ')';
				break;
		}
			
		$id_job_spec = $alert->id_job_spec;
		if($id_job_spec > 0){
			$queryStrings[] = "a.id_job_spec IN (".$id_job_spec.")";
		}
		
		$where =  implode (' AND ', $queryStrings);
		$now = date('Y-m-d H:i:s', time() + ($app->getCfg('offset') * 60 * 60));
		$where .= " AND a.is_active='y' AND a.expire_date > '".$now."' AND a.expire_date <> '0000-00-00 00:00:00' ";
		
		$total = 0;
		$query = "SELECT DISTINCT a.*,country,comp_name,comp_type,b.id countryid FROM #__jbjobs_job a".
		      	 " LEFT JOIN #__jbjobs_country b ON a.id_country = b.id".
			 	 " LEFT JOIN #__jbjobs_employer c ON a.employer_id = c.user_id".
		 		 " LEFT JOIN #__jbjobs_custom_field_value cv ON cv.jobid=a.id".
				 " LEFT JOIN #__jbjobs_comp_type d ON c.id_comp_type = d.id". 
				 " WHERE ".$where.
				 " ORDER BY a.is_featured DESC, a.publish_date DESC, a.id DESC";
		$db->setQuery($query);
		$db->query();
		$total = $db->getNumRows();
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination( $total, $limitstart, $limit );
	
		$db->setQuery( $query, $pageNav->limitstart, $pageNav->limit );
		$rows = $db->loadObjectList();	
		
		//get the jobids sent
		$query = "SELECT * from #__jbjobs_jobalert_send where alertid=$cid[0]";
		$db->setQuery($query);
		$alerts = $db->loadObjectList();
		
		$return[0] = $rows;
		$return[1] = $pageNav;
		//$return[2] = $sentJobIds;
		$return[2] = $alerts;
		return $return;
	}
	
	//7.Custom Field - show
	function getShowCustomField(){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO();
		$post   = JRequest::get( 'post' );
	
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', 0, 'int');
		$filter_field_type = $app->getUserStateFromRequest( 'com_jbjobs.filter_cust_field_type', 'filter_field_type', 1, 'int' );
		
		$where = '';
		if($filter_field_type > 0)
			$where = " WHERE field_for=$filter_field_type";
		
		$lists['field_type'] = $this->getSelectFieldtype('filter_field_type', $filter_field_type, 0, 'onchange="document.adminForm.submit( );"');

		$query = "SELECT COUNT(*) FROM #__jbjobs_custom_field $where";
		$db->setQuery($query);
		$total = $db->loadResult();
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination( $total, $limitstart, $limit );
		
		$query = "SELECT * FROM #__jbjobs_custom_field
				  $where
				  ORDER BY ordering";
		$db->setQuery($query/*, $pageNav->limitstart, $pageNav->limit*/);
		$rows = $db->loadObjectList();
		
		$parents = $children = array();
		foreach($rows as $ct){
			if($ct->parent == 0)
				$parents[] = $ct;
			else
				$children[] = $ct;
		}
		$ordered = '';
		
		if(count($parents)){
			foreach($parents as $pt){
				$ordered[] = $pt;
				foreach($children as $ct){
					if($ct->parent == $pt->id){
						$ordered[]= $ct;
					}
				}
			}
			$rows = $ordered;
		}
		
		$return[0] = $rows;
		$return[1] = $pageNav;
		$return[2] = $lists;
		$return[3] = $filter_field_type;
		
		return $return;
	}

	//7.Custom Field - edit
	function getEditCustomField(){
		$app =& JFactory::getApplication();
		$db		=& JFactory::getDBO();
		$cid 	= JRequest::getVar('cid', array(0), '', 'array');
		JArrayHelper::toInteger($cid, array(0));
	
		$row =& JTable::getInstance('custom','Table');
		$row->load($cid[0]);
		
		$filter_field_type = $app->getUserStateFromRequest( 'com_jbjobs.filter_cust_field_type', 'field_for', 1, 'int' );
		$lists['field_type'] = $this->getSelectFieldtype('field_for', $filter_field_type, 0, 'onchange="document.adminForm.submit( );"');
		if($filter_field_type > 0)
			$where = "  field_for=$filter_field_type";
		
		//make selection custom group
		$query = 'SELECT id AS value, field_title AS text FROM #__jbjobs_custom_field WHERE parent=0 AND'. $where.' ORDER BY ordering';
		$db->setQuery($query);
		$users = $db->loadObjectList();
		
		$types = array();
		foreach($users as $item){
			$types[] = JHTML::_('select.option', $item->value, JText::_($item->text));
		}		
		$groups = JHTML::_('select.genericlist', $types, 'parent', 'class="inputbox" size="8"', 'value', 'text', $row->parent);
		
		$return[0] = $row;
		$return[1] = $groups;
		$return[2] = $lists;
		return $return;
	}
	
	
	//3.Cron - show
	function getShowCron(){
		$db	= & JFactory::getDBO();
		
		$query = "SELECT COUNT(*) FROM #__jbjobs_crontask c";
		$db->setQuery($query);
		$total = $db->loadResult();
		
		$query = "SELECT c.* FROM #__jbjobs_crontask c";
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		
		$return[0] = $rows;
		return $return;
	}
	
	//Email Templates
	function getEmailTemplate(){
		$db = & JFactory :: getDBO();
		$tempFor = JRequest::getVar('tempfor', 'subscr-pending', 'get', 'string');
		
		$query = "SELECT * FROM #__jbjobs_emailtemplate WHERE templatefor = ".$db->Quote($tempFor);
		$db->setQuery($query);
		$template = $db->loadObject();
		
		return $template;
	}
	
	function & getTemplate($tempfor){
		$db = & JFactory :: getDBO();
		
		$query = "SELECT * FROM #__jbjobs_emailtemplate WHERE templatefor = ".$db->Quote($tempfor);
		$db->setQuery($query);
		$template = $db->loadObject();
		return $template;
	}
	
	//7a.Pay Modes - show
	function getShowPaymode(){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO();
		$post   = JRequest::get( 'post' );
	
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', 0, 'int');
		$filter_field_type = $app->getUserStateFromRequest( 'com_jbjobs.filter_cust_field_type', 'filter_field_type', 1, 'int' );
		
		$where = '';
		if($filter_field_type > 0)
			$where = " WHERE field_for=$filter_field_type";
		
		$lists['field_type'] = $this->getSelectFieldtype('filter_field_type', $filter_field_type, 0, 'onchange="document.adminForm.submit( );"');

		$query = "SELECT COUNT(*) FROM #__jbjobs_payment_mode WHERE parent=0";
		$db->setQuery($query);
		$total = $db->loadResult();
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination( $total, $limitstart, $limit );
		
		$query = "SELECT * FROM #__jbjobs_payment_mode
				  WHERE parent=0
				  ORDER BY ordering";//echo $query;
		$db->setQuery($query, $pageNav->limitstart, $pageNav->limit);
		$rows = $db->loadObjectList();
		
		$return[0] = $rows;
		$return[1] = $pageNav;
		$return[2] = $lists;
		$return[3] = $filter_field_type;
		
		return $return;
	}

	//7a.Pay Modes - edit
	function getEditPaymode(){
		$db		=& JFactory::getDBO();
		$cid 	= JRequest::getVar('cid', array(0), '', 'array');
		JArrayHelper::toInteger($cid, array(0));
		
		$row =& JTable::getInstance('paymode', 'Table');
		$row->load($cid[0]);
	
		$query = 'SELECT * FROM #__jbjobs_payment_mode
				  WHERE parent='.$cid[0];
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		
		$payname = $row->fieldtext;
		
		$return[0] = $rows;
		$return[1] = $payname;
		return $return;
	}
	
	
/**
  ================================================================================================================
	SECTION : Configuration
	1.Component Settings - edit
	2.Plans - show, edit
	3.Country - show, edit
	4.Major - show, edit
	5.Degree Level - show, edit
	6.University - show, edit
	7.Salary Type - show, edit
	8.Job Experience - show, edit
	9.Company Type - show, edit
	10.Salutation - show, edit
	11.Position Type - show, edit
	12.Job Specialization - show, edit
	13.Job Category - show, edit
	14.Industry - show, edit
	15.Front Page Text - show, edit
	================================================================================================================
*/	
	//1.Country - show
	function getConfig(){
		
		$row =& JTable::getInstance('config','Table');
		$row->load(1);
		
		$return[0] = $row;
		return $return;
	}
	
	//2.Membership Plans - show
	function getShowMemberPlan(){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO();
    
	   	$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', 0, 'int');
		
	    $query = "SELECT COUNT(*) FROM #__jbjobs_plan";
	    $db->setQuery($query);
	    $total = $db->loadResult();
	    
	    jimport('joomla.html.pagination');
		$pageNav = new JPagination( $total, $limitstart, $limit );
	
	    $query = "SELECT p.*, COUNT(s.id) as subscr FROM #__jbjobs_plan p 
				  LEFT JOIN #__jbjobs_plan_subscr AS s ON s.subscription_id = p.id AND s.user_type='e'
				  GROUP BY p.id 
				  ORDER BY p.ordering ASC";
	    $db->setQuery( $query, $pageNav->limitstart, $pageNav->limit );
	    $rows = $db->loadObjectList();
	 
		$return[0] = $rows;
		$return[1] = $pageNav;
		
		return $return;
	}
	
	//2.Membership Plans - edit
	function getEditMemberPlan(){
	
		$cid 	= JRequest::getVar('cid', array(0), '', 'array');
		
		//if it is new job, cid = 0
		($cid[0] == 0)?	$isNew = true : $isNew = false;
		
		JArrayHelper::toInteger($cid, array(0));
	
		$row =& JTable::getInstance('plan','Table');
		// load the row from the db table
		
		if(!$isNew)
			$row->load($cid[0]);
		
		return $row;
	}
	
	//2a.Membership Plans for Jobseekers - show
	function getShowMemberPlanJS(){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO();
    
	   	$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', 0, 'int');
		
	    $query = "SELECT COUNT(*) FROM #__jbjobs_plan_js";
	    $db->setQuery($query);
	    $total = $db->loadResult();
	    
	    jimport('joomla.html.pagination');
		$pageNav = new JPagination( $total, $limitstart, $limit );
	
	    $query = "SELECT p.*, COUNT(s.id) AS subscr FROM #__jbjobs_plan_js p 
				  LEFT JOIN #__jbjobs_plan_subscr AS s ON s.subscription_id = p.id AND s.user_type='j'
				  GROUP BY p.id 
				  ORDER BY p.ordering ASC";
	    $db->setQuery( $query, $pageNav->limitstart, $pageNav->limit );
	    $rows = $db->loadObjectList();
	 
		$return[0] = $rows;
		$return[1] = $pageNav;
		
		return $return;
	}
	
	//2.Membership Plans for Jobseeker- edit
	function getEditMemberPlanJS(){
	
		$cid 	= JRequest::getVar('cid', array(0), '', 'array');
		
		//if it is new job, cid = 0
		($cid[0] == 0)?	$isNew = true : $isNew = false;
		
		JArrayHelper::toInteger($cid, array(0));
	
		$row =& JTable::getInstance('planjs', 'Table');
		// load the row from the db table
		
		if(!$isNew)
			$row->load($cid[0]);
		
		return $row;
	}
	
	//3.Country - show
	function getShowCountry(){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO();
		
		$post   = JRequest::get( 'post' );
		
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', 0, 'int');
		$search		= $app->getUserStateFromRequest('country_search',	'search', '', 'string' );
		$filter_order      = $app->getUserStateFromRequest('com_jbjobs_filter_order_cl', 'filter_order', 'c.country', 'cmd' );
        $filter_order_Dir  = $app->getUserStateFromRequest('com_jbjobs_filter_order_Dir_cl', 'filter_order_Dir', 'asc', 'word' );
	
		if (strpos($search, '"') !== false) {
			$search = str_replace(array('=', '<'), '', $search);
		}
		$search = JString::strtolower($search);
		
		$this->setState('filter_order', $filter_order);
        $this->setState('filter_order_Dir', $filter_order_Dir);
		$orderby = $this->_buildContentOrderBy();
		$lists['order_Dir']  = $this->getState( 'filter_order_Dir' );
        $lists['order']      = $this->getState( 'filter_order' );
		$lists['search'] = $search;
		
		$filter = '';
		$where = array();
		
		if (isset( $search ) && $search != '') {
			$searchEscaped = $db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
			$where[] = 'c.country LIKE '.$searchEscaped;
		}
		$where = (count( $where) ? ' WHERE (' . implode( ') AND (', $where ) . ')' : '' );
		
		$query = "SELECT COUNT(*) FROM #__jbjobs_country c".
				  $where;
		$db->setQuery($query);
		$total = $db->loadResult();
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination( $total, $limitstart, $limit );
		
		$query = "SELECT c.* FROM #__jbjobs_country c". 
				  $where.
				  $orderby;
		$db->setQuery($query, $pageNav->limitstart, $pageNav->limit);
		$rows = $db->loadObjectList();
		
		$return[0] = $rows;
		$return[1] = $pageNav;
		$return[2] = $lists;
		return $return;
	}
	
	//3.Country - edit
	function getEditCountry(){
		$db		=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
	
		$cid 	= JRequest::getVar('cid', array(0), '', 'array');
		$option = JRequest::getCmd('option');
	
		JArrayHelper::toInteger($cid, array(0));
	
		$row =& JTable::getInstance('country','Table');
		// load the row from the db table
		
		if(true)
			$row->load($cid[0]);
		
		return $row;
	}
	
	//3b.State - show
	function getShowState(){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO();
		
		$post   = JRequest::get( 'post' );
		$country_id = JRequest::getVar('country_id', 0, '', 'int');
		
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', 0, 'int');
		
		$query = "SELECT COUNT(*) FROM #__jbjobs_state s
				  WHERE s.country_id=".$country_id;
		$db->setQuery($query);
		$total = $db->loadResult();
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination( $total, $limitstart, $limit );
		
		$query = "SELECT s.* FROM #__jbjobs_state s
				  WHERE s.country_id=".$country_id." ORDER BY state";
		$db->setQuery($query, $pageNav->limitstart, $pageNav->limit);
		$rows = $db->loadObjectList();
		
		$return[0] = $rows;
		$return[1] = $pageNav;
		return $return;
	}
	
	//3b.State - edit
	function getEditState(){
		$db		=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
	
		$cid 	= JRequest::getVar('cid', array(0), '', 'array');
		$option = JRequest::getCmd('option');
	
		JArrayHelper::toInteger($cid, array(0));
	
		$row =& JTable::getInstance('state','Table');
		// load the row from the db table
		
		if(true)
			$row->load($cid[0]);
		
		return $row;
	}

	//3c.City - show
	function getShowCity(){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO();
		
		$post   = JRequest::get( 'post' );
		$state_name = JRequest::getVar('state_name', '', '', 'string');
		
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', 0, 'int');
		
		$query = "SELECT COUNT(*) FROM #__jbjobs_city c
				  WHERE c.state_name=".$db->quote($state_name);
		$db->setQuery($query);
		$total = $db->loadResult();
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination( $total, $limitstart, $limit );
		
		$query = "SELECT c.* FROM #__jbjobs_city c
				  WHERE c.state_name=".$db->quote($state_name).
				 "ORDER BY c.city";
		$db->setQuery($query, $pageNav->limitstart, $pageNav->limit);
		$rows = $db->loadObjectList();
		
		$return[0] = $rows;
		$return[1] = $pageNav;
		return $return;
	}
	
	//3b.City - edit
	function getEditCity(){
		$db		=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
	
		$cid 	= JRequest::getVar('cid', array(0), '', 'array');
		$option = JRequest::getCmd('option');
	
		JArrayHelper::toInteger($cid, array(0));
	
		$row =& JTable::getInstance('city','Table');
		// load the row from the db table
		
		if(true)
			$row->load($cid[0]);
		
		return $row;
	}
	
	//4.Major - show
	function getShowMajor(){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO();
		$post   = JRequest::get('post');
	
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', 0, 'int');
	
		$query = "SELECT COUNT(*) FROM #__jbjobs_major a";
		$db->setQuery($query);
		$total = $db->loadResult();
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination( $total, $limitstart, $limit );
	
		$query = "SELECT a.* FROM #__jbjobs_major a ORDER BY a.ordering";
		$db->setQuery($query, $pageNav->limitstart, $pageNav->limit);
		$rows = $db->loadObjectList();
	
		$return[0] = $rows;
		$return[1] = $pageNav;
		
		return $return;
	}
	
	//4.Major - edit
	function getEditMajor(){
		$db		=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
	
		$cid 	= JRequest::getVar('cid', array(0), '', 'array');
		$option = JRequest::getCmd('option');
	
		JArrayHelper::toInteger($cid, array(0));
	
		$row =& JTable::getInstance('major','Table');
		// load the row from the db table
		
		if(true)
			$row->load($cid[0]);
	
		return $row;
	}

	//5.Degree Level - show
	function getShowDegLevel(){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO();
		$post   = JRequest::get( 'post' );
		
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', 0, 'int');
		
		$query = "SELECT COUNT(*) FROM #__jbjobs_degree_level a";
		$db->setQuery($query);
		$total = $db->loadResult();
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination($total, $limitstart, $limit);
	
		$query = "SELECT a.* FROM #__jbjobs_degree_level a ORDER BY ordering";
		$db->setQuery($query, $pageNav->limitstart, $pageNav->limit);
		$rows = $db->loadObjectList();
		
		$return[0] = $rows;
		$return[1] = $pageNav;
		return $return;
	}
	
	//5.Degree Level - edit
	function getEditDegLevel(){
		$db		=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
	
		$cid 	= JRequest::getVar('cid', array(0), '', 'array');
		$option = JRequest::getCmd('option');
	
		JArrayHelper::toInteger($cid, array(0));
		
		//if it is new job, cid = 0
		($cid[0] == 0)?	$isNew = true : $isNew = false;
	
		$row =& JTable::getInstance('degreeLevel','Table');
		// load the row from the db tabler
		
		if(!$isNew)
			$row->load($cid[0]);
		
		return $row;
	}
	
	//6.University - show
	function getShowUniversity(){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO();
		
		
		$post   = JRequest::get( 'post' );
		
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', 0, 'int');
		
		$query = "SELECT COUNT(*)".	          
				 " FROM #__jbjobs_university a";
		
		$db->setQuery( $query );
		$total = $db->loadResult();
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination( $total, $limitstart, $limit );
	
		$query = "SELECT a.*  ".
				 " FROM #__jbjobs_university a";
		
		$db->setQuery( $query, $pageNav->limitstart, $pageNav->limit );
		$rows = $db->loadObjectList();
		
		$return[0] = $rows;
		$return[1] = $pageNav;
		
		return $return;
	}
	
	//6.University - edit
	function getEditUniversity(){
		$db		=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
	
		$cid 	= JRequest::getVar('cid', array(0), '', 'array');
	
		JArrayHelper::toInteger($cid, array(0));
		
		//if it is new job, cid = 0
		($cid[0] == 0)?	$isNew = true : $isNew = false;
	
		$row =& JTable::getInstance('university','Table');
		// load the row from the db tabler
		
		if(!$isNew)
			$row->load($cid[0]);
		
		return $row;
	}
	
	//7.Salary Type - show
	function getShowSalType(){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO();
		$post   = JRequest::get( 'post' );
		
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', 0, 'int');
		
		$query = "SELECT COUNT(*) FROM #__jbjobs_type_salary a";
		$db->setQuery($query);
		$total = $db->loadResult();
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination($total, $limitstart, $limit);
	
		$query = "SELECT a.* FROM #__jbjobs_type_salary a ORDER BY a.ordering";
		$db->setQuery($query, $pageNav->limitstart, $pageNav->limit);
		$rows = $db->loadObjectList();
		
		$return[0] = $rows;
		$return[1] = $pageNav;
		return $return;
	}
	
	//7.Salary Type - edit
	function getEditSalType(){
		$db		=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
	
		$cid 	= JRequest::getVar('cid', array(0), '', 'array');
		$option = JRequest::getCmd('option');
	
		JArrayHelper::toInteger($cid, array(0));
		($cid[0] == 0)?	$isNew = true : $isNew = false; //if it is new job, cid = 0
	
		$row =& JTable::getInstance('typeSalary','Table');
		// load the row from the db tabler
		
		if(!$isNew)
			$row->load($cid[0]);
		
		return $row;
	}
	
	//8.Job Experience - show
	function getShowJobExp(){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO();
		$post   = JRequest::get( 'post' );
		
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', 0, 'int');
		
		$query = "SELECT COUNT(*) FROM #__jbjobs_job_exp a";
		$db->setQuery($query);
		$total = $db->loadResult();
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination($total, $limitstart, $limit);
	
		$query = "SELECT a.* FROM #__jbjobs_job_exp a ORDER BY a.ordering";
		$db->setQuery($query, $pageNav->limitstart, $pageNav->limit);
		$rows = $db->loadObjectList();
		
		$return[0] = $rows;
		$return[1] = $pageNav;
		return $return;
	}
	
	//8.Job Experience - edit
	function getEditJobExp(){
		$db		=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
	
		$cid 	= JRequest::getVar('cid', array(0), '', 'array');
		$option = JRequest::getCmd('option');
	
		JArrayHelper::toInteger($cid, array(0));
		($cid[0] == 0)?	$isNew = true : $isNew = false; //if it is new job, cid = 0
	
		$row =& JTable::getInstance('jobExp','Table');
		// load the row from the db tabler
		
		if(!$isNew)
		 $row->load($cid[0]);
		
		return $row;
	}
	
	//9.Company Type - show
	function getShowCompType(){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO();
		
		
		$post   = JRequest::get( 'post' );
		
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', 0, 'int');
		
		
		$query = "SELECT COUNT(*)".	          
				 " FROM #__jbjobs_comp_type a";
		
		
		$db->setQuery( $query );
		$total = $db->loadResult();
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination( $total, $limitstart, $limit );
	
		
		$query = "SELECT a.*  ".
				 " FROM #__jbjobs_comp_type a";
		
		
		$db->setQuery( $query, $pageNav->limitstart, $pageNav->limit );
		$rows = $db->loadObjectList();
		
		$return[0] = $rows;
		$return[1] = $pageNav;
		
		return $return;
	}
	
	//9.Company Type - edit
	function getEditCompType(){
		$db		=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
	
		$cid 	= JRequest::getVar('cid', array(0), '', 'array');
		$option = JRequest::getCmd('option');
	
		JArrayHelper::toInteger($cid, array(0));
		($cid[0] == 0)?	$isNew = true : $isNew = false; //if it is new job, cid = 0
	
		$row =& JTable::getInstance('compType','Table');
		// load the row from the db tabler
		
		if(!$isNew)
		$row->load($cid[0]);
		
		return $row;
	}
	
	//10.Salutation - show
	function getShowSalutation(){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO();
		
		$post   = JRequest::get( 'post' );
		
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', 0, 'int');
		
		
		$query = "SELECT COUNT(*)".	          
				 " FROM #__jbjobs_salutation a";
		
		
		$db->setQuery( $query );
		$total = $db->loadResult();
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination( $total, $limitstart, $limit );
	
		
		$query = "SELECT a.*  ".
				 " FROM #__jbjobs_salutation a";
		
		
		$db->setQuery( $query, $pageNav->limitstart, $pageNav->limit );
		$rows = $db->loadObjectList();
		
		$return[0] = $rows;
		$return[1] = $pageNav;
		
		return $return;
	}
	
	//10.Salutation - edit
	function getEditSalutation(){
		$db		=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
	
		$cid 	= JRequest::getVar('cid', array(0), '', 'array');
		$option = JRequest::getCmd('option');
	
		JArrayHelper::toInteger($cid, array(0));
		($cid[0] == 0)?	$isNew = true : $isNew = false; //if it is new job, cid = 0
	
		$row =& JTable::getInstance('salutation','Table');
		// load the row from the db tabler
		
		if(!$isNew)
			$row->load($cid[0]);
		
		return $row;		
	}
	
	//11.Position Type - show
	function getShowPosType(){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO();
		$post   = JRequest::get( 'post' );
		
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', 0, 'int');
		
		$query = "SELECT COUNT(*) FROM #__jbjobs_pos_type a";
		$db->setQuery($query);
		$total = $db->loadResult();
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination( $total, $limitstart, $limit );
	
		$query = "SELECT a.* FROM #__jbjobs_pos_type a ORDER BY a.ordering";
		$db->setQuery($query, $pageNav->limitstart, $pageNav->limit);
		$rows = $db->loadObjectList();
		
		$return[0] = $rows;
		$return[1] = $pageNav;
		return $return;
	}

	//11.Position Type - edit
	function getEditPosType(){
		$db		=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
	
		$cid 	= JRequest::getVar('cid', array(0), '', 'array');
		$option = JRequest::getCmd('option');
	
		JArrayHelper::toInteger($cid, array(0));
		($cid[0] == 0)?	$isNew = true : $isNew = false; //if it is new job, cid = 0
	
		$row =& JTable::getInstance('posType','Table');
		// load the row from the db tabler
		
		if(!$isNew)
			$row->load($cid[0]);
		
		return $row;
	}
	
	//12.Job Specialization - show
	function getShowJobSpec(){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO();
		$post   = JRequest::get( 'post' );
		
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', 0, 'int');
		
		$query = "SELECT COUNT(*) FROM #__jbjobs_job_spec a".
				 " LEFT JOIN #__jbjobs_job_categ b ON a.id_category =b.id";
		$db->setQuery($query);
		$total = $db->loadResult();
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination( $total, $limitstart, $limit );
		
		$query = "SELECT a.*,category FROM #__jbjobs_job_spec a".
				 " LEFT JOIN #__jbjobs_job_categ b ON a.id_category =b.id".
				 " ORDER BY a.ordering";
		
		$db->setQuery( $query, $pageNav->limitstart, $pageNav->limit );
		$rows = $db->loadObjectList();
		
		$return[0] = $rows;
		$return[1] = $pageNav;
		
		return $return;
	}
	
	//12.Job Specialization - edit
	function getEditJobSpec(){
		$db		=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
	
		$cid 	= JRequest::getVar('cid', array(0), '', 'array');
		$option = JRequest::getCmd('option');
	
		JArrayHelper::toInteger($cid, array(0));
		($cid[0] == 0)?	$isNew = true : $isNew = false; //if it is new job, cid = 0
	
		$row =& JTable::getInstance('jobSpec','Table');
		// load the row from the db tabler
		
		if(!$isNew)
			$row->load($cid[0]);
		
		return $row;
	}
	
	//13.Job Category - show
	function getShowJobCateg(){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO();
		$post   = JRequest::get('post');
	
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', 0, 'int');
	
		$query = "SELECT COUNT(*) FROM #__jbjobs_job_categ a";
		$db->setQuery($query);
		$total = $db->loadResult();
	
		jimport('joomla.html.pagination');
		$pageNav = new JPagination($total, $limitstart, $limit);
	
		$query = "SELECT a.* FROM #__jbjobs_job_categ a ORDER BY a.ordering";
		$db->setQuery($query, $pageNav->limitstart, $pageNav->limit);
		$rows = $db->loadObjectList();
	
		$return[0] = $rows;
		$return[1] = $pageNav;
		return $return;
	}
	
	//13.Job Category - edit
	function getEditJobCateg(){
		$db		=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
	
		$cid 	= JRequest::getVar('cid', array(0), '', 'array');
		$option = JRequest::getCmd('option');
	
		JArrayHelper::toInteger($cid, array(0));
		($cid[0] == 0)?	$isNew = true : $isNew = false; //if it is new job, cid = 0
	
		$row =& JTable::getInstance('jobCateg','Table');
		// load the row from the db tabler
		
		if(!$isNew)
			$row->load($cid[0]);
		
		return $row;
	}
	
	//14.Industry - show
	function getShowIndComp(){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO();
		$post   = JRequest::get('post');
		
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', 0, 'int');
		
		$query = "SELECT COUNT(*) FROM #__jbjobs_industry a";
		$db->setQuery($query);
		$total = $db->loadResult();
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination($total, $limitstart, $limit);
		
		$query = "SELECT a.* FROM #__jbjobs_industry a ORDER BY ordering";
		$db->setQuery($query, $pageNav->limitstart, $pageNav->limit);
		$rows = $db->loadObjectList();
		
		$return[0] = $rows;
		$return[1] = $pageNav;
		return $return;
	}
	
	//14.Industry - edit
	function getEditIndComp(){
		$db		=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
	
		$cid 	= JRequest::getVar('cid', array(0), '', 'array');
		$option = JRequest::getCmd('option');
	
		JArrayHelper::toInteger($cid, array(0));
		($cid[0] == 0)?	$isNew = true : $isNew = false; //if it is new job, cid = 0
	
		$row =& JTable::getInstance('industry','Table');
		// load the row from the db tabler
		
		if(!$isNew)
			$row->load($cid[0]);
		
		return $row;
	}
	
	//16. Field ordering
	function getFieldOrder(){
		$app =& JFactory::getApplication();
		$db =& JFactory::getDBO();
		
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', 0, 'int');
		$filter_order      = $app->getUserStateFromRequest( 'com_jbjobs.filter_order_fo', 'filter_order', 'f.ordering', 'cmd' );
        $filter_order_Dir  = $app->getUserStateFromRequest('com_jbjobs.filter_order_Dir_fo', 'filter_order_Dir', 'asc', 'word' );
		$filter_field_type = $app->getUserStateFromRequest( 'com_jbjobs.filter_field_type', 'filter_field_type', 1, 'int' );
		
		$where = '';
		if($filter_field_type > 0)
			$where = " WHERE field_for=$filter_field_type";
		
		$this->setState('filter_order', $filter_order);
		$this->setState('filter_order_Dir', $filter_order_Dir);
		//$orderby = $this->_buildContentOrderBy();
		$lists['field_type'] = $this->getSelectFieldtype('filter_field_type', $filter_field_type, 0, 'onchange="document.adminForm.submit( );"');
		$lists['order_Dir'] =  $this->getState( 'filter_order_Dir' );
        $lists['order']     =  $this->getState( 'filter_order' );
		
		// ensure $filter_order has a good value
		if (!in_array($filter_order, array('f.field', 'f.published', 'f.ordering', 'f.id'))) {
			$filter_order = 'f.ordering';
		}

		// just in case filter_order get's messed up
		if ($filter_order) {
			$orderby = ' ORDER BY '.$filter_order .' '. $filter_order_Dir .', f.parent, f.ordering';
		} else {
			$orderby = ' ORDER BY f.parent, f.ordering';
		}
		
		/*$query = 'SELECT count(*) FROM (
				  SELECT t1.* , t2.ordering AS level2, t1.ordering AS level1 
				  FROM #__jbjobs_fieldorder as t1 
				  LEFT JOIN #__jbjobs_fieldorder as t2 on t1.parent = t2.id 
				  ) as depth_table'.
				  $where;*/
		$query = "SELECT count(*) FROM #__jbjobs_fieldorder".
				  $where;
		$db->setQuery($query);
		$total = $db->loadResult();
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination( $total, $limitstart, $limit );

		/*$query = "SELECT *, CONCAT_WS('_', level2, level1) as level FROM (
				  SELECT t1.* , t2.ordering AS level2, t1.ordering AS level1 
				  FROM #__jbjobs_fieldorder as t1 
				  LEFT JOIN #__jbjobs_fieldorder as t2 on t1.parent = t2.id 
				  ) as depth_table 
				  $where
				  ORDER BY level";//echo $query;
		$db->setQuery($query, $pageNav->limitstart, $pageNav->limit);
		$rows = $db->loadObjectList();
		*/
		$query = "SELECT * FROM #__jbjobs_fieldorder
				  $where
				  ORDER BY ordering";//echo $query;
		$db->setQuery($query/*, $pageNav->limitstart, $pageNav->limit*/);
		$rows = $db->loadObjectList();
		
		$parents = $children = '';
		foreach($rows as $ct){
			if($ct->parent == 0)
				$parents[] = $ct;
			else
				$children[] = $ct;
		}
		$ordered = '';
		
		foreach($parents as $pt){
			$ordered[] = $pt;
			foreach($children as $ct){
				if($ct->parent == $pt->id){
					$ordered[]= $ct;
				}
			}
		}
		$rows = $ordered;
		
		global $tree;
		$query = "SELECT * FROM #__jbjobs_fieldorder
				  $where AND parent=0
				  ORDER BY ordering";
		$db->setQuery($query/*, $pageNav->limitstart, $pageNav->limit*/);
		$pars = $db->loadObjectList();
		
		// subcategories view as tree
	   	$tree = array();
	   	
	   	foreach ($pars as $v) {
	       	$ident = '';
	       	$tree[] = $v;
			$this->tree($v->id, $ident, $tree);
		}
	    
	    //$tree = array_slice($tree, $pageNav->limitstart, $pageNav->limit);
	    $tree = $tree;
		
		$return[0] = $rows;
		$return[1] = $pageNav;
		$return[2] = $filter_field_type;
		$return[3] = $lists;
		$return[4] = $tree;
		return $return;
	}
	
	// list subcats as tree
	function tree($parent, $ident, $tree) {
	    global $tree;
	    $database = &JFactory::getDBO();
	
	   $database->setQuery("SELECT * FROM #__jbjobs_fieldorder WHERE parent =".$parent." ORDER BY ordering");
	    $rows = $database->loadObjectList();
	    if ($database->getErrorNum()) {
	        echo $database->stderr();
	        return false;
	    }
	    foreach ($rows as $v) {
	    $v->fieldtitle = $ident.".&nbsp;&nbsp;<sup>L</sup>&nbsp;".$v->fieldtitle;
	    $v->fieldtitle = str_replace('.&nbsp;&nbsp;<sup>L</sup>&nbsp;','.&nbsp;&nbsp;&nbsp;&nbsp;',$v->fieldtitle);
	    $x = strrpos($v->fieldtitle,'.&nbsp;&nbsp;&nbsp;&nbsp;');
	    $v->fieldtitle = substr_replace($v->fieldtitle, '.&nbsp;&nbsp;<sup>L</sup>&nbsp;', $x,7);
	    $tree[] = $v;
	    
	    $this->tree($v->id, $ident.".&nbsp;&nbsp;<sup>L</sup>&nbsp;", $tree);
	    }
	}
	
/**
  ================================================================================================================
	SECTION : Misc
	1.isEmployer
	2.showCustom
	3.Custom Field Javascript
	4.PM Settings
	5.buildcontentorderby
	6.getFieldsOrdering
	================================================================================================================
*/		
	//1.isEmployer	
	function isEmployer($userid){
		$db =& JFactory::getDBO();
		$query = "SELECT COUNT(*) FROM #__jbjobs_employer where user_id =".$db->quote( $userid );
		$db->setQuery( $query );
		$total = $db->loadResult();
		if($total == 1){
			return 1;
		}else{
			return 0;
		}
	}
	
	//5.Is JobSeeker?	
	function isJobSeeker($userid){
		$db 	=& JFactory::getDBO();
		$query 	= "SELECT COUNT(*) FROM #__jbjobs_jobseeker where user_id =".$db->quote( $userid );
		$db->setQuery( $query );
		$total 	= $db->loadResult();
		if($total == 1)
			return 1;
		else
			return 0;
	}
	
	//2.showCustom
	function showCustom($custom=null, $id = null, $type = 'user'){
	if(!empty($custom)){
			$row = null;
			if(!empty($id)){
				$db =& JFactory::getDBO();
				if($type == 'job'){
					$query = "SELECT * FROM #__jbjobs_custom_field_value WHERE jobid='$id'";
				}
				else {
					$query = "SELECT * FROM #__jbjobs_custom_field_value WHERE userid='$id'";
				}

				$db->setQuery($query);
				$c = $db->loadObjectList();
				if(count($c)){
					foreach($c as $v){
						$row[$v->fieldid] = $v;
					}
				}
			}
			$parents = array();$children = array();
			//isolate parent and childr
			foreach($custom as $ct){
					if($ct->parent == 0)
						$parents[] = $ct;
					else
						$children[] = $ct;
				}
			
			if(count($parents)){
			?>
			<br />
			<?php foreach($parents as $pt){ ?>
				
				<fieldset class="adminform">
					<legend><?php echo JText::_( $pt->field_title ); ?></legend>
			
					<table class="admintable">
					<?php foreach($children as $ct){?>
						<?php if($ct->parent == $pt->id){ ?>
						<tr>
							<td class="key" valign="top">
								<?php 
									$labelsuffix = '';
									if($ct->field_type == 'checkbox') $labelsuffix = '[]'; //added to validate checkbox
								?>
								<label for="custom_field_<?php echo $ct->id.$labelsuffix; ?>"><?php echo JText::_( $ct->field_title ); ?><span class="redfont"><?php echo ($ct->required)? '*' : ''; ?></span>:</label>
							</td>
							<td>
								<?php
								$val = (!empty($row[$ct->id]->value)) ? $row[$ct->id]->value : null;
								$req = '';
								if($ct->required){
									if($ct->field_type == 'radio') $req = 'validate-radio';
									elseif($ct->field_type == 'checkbox') $req = 'validate-checkbox';
									elseif($ct->field_type == 'multiple select') $req = 'validate-dropdown';
									else $req = 'required';
								}
								switch($ct->field_type){
								case 'textbox':
									?>
									<input class="<?php echo $ct->class.' '.$req; ?>" type="text" name="custom_field_<?php echo $ct->id; ?>" id="custom_field_<?php echo $ct->id; ?>" size="60" value="<?php echo $val; ?>" />
									<?php
								break;
								case 'textarea':
									$val = (!empty($row[$ct->id]->valuetext)) ? $row[$ct->id]->valuetext : null;
									?>
									<textarea class="<?php echo $ct->class.' '.$req; ?>" name="custom_field_<?php echo $ct->id; ?>" id="custom_field_<?php echo $ct->id; ?>"><?php echo $val; ?></textarea>
									<?php
								break;
								case 'radio':
									if(!empty($ct->values)){
										$values = explode(";", $ct->values);
										$put = array();
										if($ct->show_type == 'left-to-right'){
											foreach($values as $value){
												if($value){
													$put[] = JHTML::_('select.option',  $value, JText::_( $value ));
												}
											}
											echo JHTML::_('select.radiolist',  $put, 'custom_field_'.$ct->id, 'class="'.$ct->class.' '.$req.'"', 'value', 'text', $val );
										}
										else {
											foreach($values as $value){
												if($value){
													$checked = ($val == $value) ? ' checked': '';
												?>
													<input class="<?php echo $ct->class.' '.$req; ?>" type="radio" name="custom_field_<?php echo $ct->id; ?>" value="<?php echo $value; ?>"<?php echo $checked; ?>> <?php echo $value; ?><br />
												<?php
												}
											}
										}
									}
								break;
								case 'checkbox':
									if(!empty($ct->values)){
										$values = explode(";", $ct->values);
										$put = array();
										if($ct->show_type == 'left-to-right'){
											$x = 0;
											foreach($values as $value){
												if($value){
													$checked = (in_array($value, explode(";",$val))) ? ' checked': '';
													?>
													<input id="c<?php echo $ct->id;?>b<?php echo $x; ?>" class="<?php echo $ct->class.' '.$req; ?>" type="checkbox" name="custom_field_<?php echo $ct->id; ?>[]" value="<?php echo $value; ?>"<?php echo $checked; ?>> <?php echo $value; ?>&nbsp;
													<?php
													$x++;
												}
											}
										}
										else {
											$x = 0;
											foreach($values as $value){
												if($value){
													$checked = (in_array($value, explode(";",$val))) ? ' checked': '';
													?>
													<input id="c<?php echo $ct->id;?>b<?php echo $x; ?>" class="<?php echo $ct->class.' '.$req; ?>" type="checkbox" name="custom_field_<?php echo $ct->id; ?>[]" value="<?php echo $value; ?>"<?php echo $checked; ?>> <?php echo $value; ?><br />
													<?php
													$x++;
												}
											}
										}
									}
								break;
								case 'select':
									if(!empty($ct->values)){
										$values = explode(";", $ct->values);
										$put = array();
										foreach($values as $value){
											if($value){
												$put[] = JHTML::_('select.option',  $value, JText::_( $value ), 'value', 'text');
											}
										}
										
										echo JHTML::_('select.genericlist',  $put, 'custom_field_'.$ct->id, 'class="'.$ct->class.' '.$req.'" size="1"', 'value', 'text', $val );
									}
								break;
								case 'multiple select':
									if(!empty($ct->values)){
										$values = explode(";", $ct->values);
										$put = array();
										$val =  explode(";", $val);
										foreach($values as $value){
											if($value){
												$put[] = JHTML::_('select.option',  $value, JText::_( $value ), 'value', 'text');
											}
										}
										$size = (count($put) < 5) ? count($put) : 5;
										echo JHTML::_('select.genericlist',  $put, 'custom_field_'.$ct->id.'[]', 'class="'.$ct->class.' '.$req.'" size="'.$size.'" multiple', 'value', 'text', $val );
										echo '&nbsp;';
										echo JText::_('JBJOBS_HOLD_CTRL_FOR_MULTIPLE_SELECT');
									}
								break;
								case 'URL':
									?>
									<input class="<?php echo $ct->class.' '.$req; ?>" type="text" name="custom_field_<?php echo $ct->id; ?>" id="custom_field_<?php echo $ct->id; ?>" size="45" value="<?php echo $val; ?>" /> <?php echo JText::_('JBJOBS_INCLUDE_HTTP'); ?>
									<?php
								break;
								case 'Email':
									?>
									<input class="<?php echo $ct->class.' '.$req; ?>" type="text" name="custom_field_<?php echo $ct->id; ?>" id="custom_field_<?php echo $ct->id; ?>" size="45" value="<?php echo $val; ?>" />
									<?php
								break;
								case 'Date':
									?>
									<?php echo JHTML::_('calendar', $val, 'custom_field_'.$ct->id, 'custom_field_'.$ct->id, '%Y-%m-%d', array('class'=>$ct->class.' '.$req)); ?>
									<?php
								break;
							}																																																																																																									
								?>
							</td>
						</tr>
						<?php } ?>
					<?php } ?>
					</table>
				</fieldset>
				
			<?php } ?>
			
			<?php
			}
		}
	}
	
	//2.showPaymodeFields
	function showPaymodeFields($paymodeFields){
		
		foreach ($paymodeFields as $pf){ ?>
			<tr>
				<td class="key"><label for="name"><?php echo stripslashes($pf->fieldtext); ?>: </label></td>
				<td>
					<?php
					$database =& JFactory::getDBO();
					switch($pf->fieldtype){
						case 0: //Text
							echo "<input type='text' maxlength='100' name='" . $pf->fieldname . "' id='" . $pf->fieldname . "' value='" . $pf->savedvalue . "' style='width: " . $pf->fieldwidth . "px'>";
						break;
						
						case 1: //Boolean
							echo JHTML::_('select.booleanlist', $pf->fieldname, 'class="inputbox"', $pf->savedvalue );
						break;
						
						default:
						break;
					}
		
					?>
				</td>
				<td><?php echo $pf->tips; ?></td>
			</tr>
	<?php
		}
	}
	
	//5.buildcontentorderby
	function _buildContentOrderBy(){
        $app =& JFactory::getApplication();
 
        $orderby = '';
        $filter_order     = $this->getState('filter_order');
        $filter_order_Dir = $this->getState('filter_order_Dir');

        /* Error handling is never a bad thing*/
        if(!empty($filter_order) && !empty($filter_order_Dir) ){
                $orderby = ' ORDER BY '.$filter_order.' '.$filter_order_Dir;
        }

        return $orderby;
	}

	//6.getFieldsOrdering
	function getFieldsOrdering($fieldfor){
		$db = &$this->getDBO();
		$query =  "SELECT * FROM #__jbjobs_fieldorder
				   WHERE published = 1 AND level=1 AND field_for=".$fieldfor.
				 " ORDER BY ordering";
		$db->setQuery($query);
		$parents = $db->loadObjectList();
		
		$query =  "SELECT * FROM #__jbjobs_fieldorder
				   WHERE published = 1 AND level=2 AND field_for=".$fieldfor.
				 " ORDER BY ordering";
		$db->setQuery($query);
		$children = $db->loadObjectList();
		
		$return[0] = $parents;
		$return[1] = $children;
		return $return;
	}
	
	function loadAddressData(){
		$db =& JFactory::getDBO();
		$data = JRequest :: get('post');
		
		$sitepath = JPATH_SITE;
		$returncode = 1;
		if ($data['actiontype'] == 1){ // first time
			if($_FILES['loadaddressdata']['size'] > 0){
				$file_name = $_FILES['loadaddressdata']['name']; // file name
				$file_tmp = $_FILES['loadaddressdata']['tmp_name']; // actual location
				$file_size = $_FILES['loadaddressdata']['size']; // file size
				$file_type = $_FILES['loadaddressdata']['type']; // mime type of file determined by php
				$file_error = $_FILES['loadaddressdata']['error']; // any error!. get reason here
				
				$info = pathinfo($file_name);
				$ext = $info['extension'];
				
				if( !empty($file_tmp)){
					if ($ext != "sql")
						return 2; //file type mismatch
				}

				$path = $sitepath.DS.'components'.DS.'com_jbjobs'.DS.'data';
				if (!file_exists($path)){ // creating data directory
					mkdir($path, 0755);
				}

				$path = $sitepath.DS.'components'.DS.'com_jbjobs'.DS.'data'.DS.'temp';
				if (!file_exists($path)){ // creating temp directory
					mkdir($path, 0755);
				}
				$comp_filename = $path.'/' . $file_name;
				move_uploaded_file($file_tmp, $path.'/'.$file_name);
				
				$myFile = $comp_filename;
				
				$fh = fopen($myFile, 'r');
				$theData = fread($fh, filesize($myFile));
				fclose($fh);
				
				if($returncode == 1){		
					$db->setQuery($theData);
					if ($result = $db->queryBatch())
						return 1;
				}
							
				return $returncode;
			}
		}
	}
/**
  ================================================================================================================
	SECTION : Additional Functions
	1.YesNo - boolean
	2.YesNo
	3.getSelectCountry
	4.getSelectJobCateory
	5.getSelectJobSpec
	6.getSelectUserProfile
	7.getSelectJobStatus
	8.getSelectSubscrStatus
	9.getSelectPositionType
	10.getSelectExpLevel
	11.getSelectDegreeLevel
	12.getSelectTypeSalary
	13.getSalutation
	14.getSelectCompType
	15.getSelectIndustry
	16.getSelectPersonalStatus
	17.getSelectJobAgency
	18.getSelectMajor
	19.getSelectPlan
	20.getSelectFieldtype
	21.maleFemale
	================================================================================================================
*/
	//get the total available credit of the employer
	function getTotalCredit($userid){
		$db	=& JFactory::getDBO();
		$total_credit = 0;
		$query = "SELECT (SUM(credit_plus)-SUM(credit_minus)) FROM #__jbjobs_transaction WHERE user_id=".$db->quote($userid);
		$db->setQuery($query);
		$total_credit = $db->loadResult();
		$total_credit = number_format($total_credit, 2, '.', '' ); 
		return $total_credit;
	}
	
	//1.YesNo - boolean
	function YesNoBool( $name, $value = 1 ){
		$yesno = JHTML::_('select.booleanlist', $name, 'class="inputbox"', $value );
		return $yesno;
	}
	
	//2.YesNo
	function YesNo( $name, $value = 'y'){
		$put[] = JHTML::_('select.option',  'n', JText::_('NO'));
		$put[] = JHTML::_('select.option',  'y', JText::_('YES'));
		$yesno = JHTML::_('select.radiolist',  $put, $name, '', 'value', 'text', $value );
		return $yesno;
	}	
	
	//4.getSelectCountry
	function getSelectCountry($var, $default, $disabled, $event){
		$db	= & JFactory::getDBO(); 
	
		$option = '';
		if($disabled == 1) 
			$option = 'disabled';
		
		//make selection country
		$query = 'SELECT id AS value, country AS text FROM #__jbjobs_country WHERE published=1 ORDER BY country';		
		$db->setQuery($query);
		$countries = $db->loadObjectList();
		
		$types[] = JHTML::_('select.option', '', '- '.JText::_('JBJOBS_SELECT_COUNTRY').' -');
		foreach($countries as $item){
			$types[] = JHTML::_('select.option', $item->value, JText::_($item->text));
		}		
		$lists 	= JHTML::_('select.genericlist', $types, $var, 'class="inputbox" size="1" '.$option.' '.$event.'', 'value', 'text', $default);
		return $lists;
	}	
	
	//4.getSelectState
	function getSelectState($var, $default, $event, $countryid){
		$db	= & JFactory::getDBO(); 
	
		if($default == '') 
			$default = '0'; 
		
		//make selection state
		$query = 'SELECT state AS value, state AS text FROM #__jbjobs_state WHERE country_id='.$countryid.' ORDER BY state';		
		$db->setQuery($query);
		$states = $db->loadObjectList();
		
		$types[] = JHTML::_('select.option',  '', '- '. JText::_('JBJOBS_SELECT_STATE') .' -');
		if(!empty($states)){
			foreach($states as $item){
				$types[] = JHTML::_('select.option', $item->value, JText::_($item->text));
			}
		}
		$lists = '';
		if (isset($types[1])) if ($types[1] != '')
			$lists 	= JHTML::_('select.genericlist', $types, $var, 'class="inputbox" size="1" '.$event.'', 'value', 'text', $default );
		return $lists;
	}	
	
	//4.getSelectCity
	function getSelectCity($var, $default, $event, $statename){
		$db	= & JFactory::getDBO(); 
	
		if($default == '') 
			$default = '0'; 
		
		//make selection state
		$query = 'SELECT city AS value, city AS text FROM #__jbjobs_city WHERE state_name='.$db->quote($statename).' ORDER BY city';		
		$db->setQuery($query);
		$cities = $db->loadObjectList();
		
		$types[] = JHTML::_('select.option',  '', '- '. JText::_('JBJOBS_SELECT_CITY') .' -');
		foreach($cities as $item){
			$types[] = JHTML::_('select.option', $item->value, JText::_($item->text));
		}
		$lists = '';
		if (isset($types[1])) if ($types[1] != '')
			$lists 	= JHTML::_('select.genericlist', $types, $var, 'class="inputbox" size="1" '.$event.'', 'value', 'text', $default );
		return $lists;
	}	
	
	//4.getSelectJobCateory
	function getSelectJobCategory($var,$default,$disabled){
		$db	= & JFactory::getDBO(); 
		
		$option = '';
		if($disabled == 1) 
			$option = 'disabled';
		
		//make selection job category
		$query = 'SELECT id AS value, category AS text FROM #__jbjobs_job_categ WHERE published=1 ORDER BY ordering';
		$db->setQuery($query);
		$users = $db->loadObjectList();
		
		$types[] = JHTML::_('select.option', '0', '- '.JText::_('JBJOBS_SELECT_JOB_CATEG').' -');
		foreach( $users as $item ){
			$types[] = JHTML::_('select.option', $item->value, JText::_($item->text));
		}		
		
		$lists 	= JHTML::_('select.genericlist', $types, $var, 'class="inputbox" size="1" '.$option.'', 'value', 'text', $default);
		return $lists;
	}
	
	//5.getSelectJobSpec
	function getSelectJobSpec($var, $default, $disabled){
		$db	= & JFactory::getDBO(); 
		
		$option = '';
		if($disabled == 1) 
			$option = 'disabled';
		
		//make selection Job Specialization
		$query = 'SELECT id AS value, specialization AS text FROM #__jbjobs_job_spec WHERE published=1 ORDER BY ordering';
		$db->setQuery($query);
		$users = $db->loadObjectList();
		
		$types[] = JHTML::_('select.option', '', '- '.JText::_('JBJOBS_SELECT_JOB_SPEC').' -');
		foreach($users as $item){
			$types[] = JHTML::_('select.option', $item->value, JText::_($item->text));
		}		
		
		$lists 	= JHTML::_('select.genericlist', $types, $var, 'class="inputbox" size="1" '.$option.'', 'value', 'text', $default);
		return $lists;
	}
	
	//6.getSelectUserProfile
	function getSelectUserProfile($var, $default, $disabled){
		$option = '';
		if($disabled == 1) 
			$option = 'disabled';
		
		$types[] = JHTML::_('select.option',  '0', JText::_('JBJOBS_JOOMBAH_JOBS_DEFAULT'));
		$types[] = JHTML::_('select.option',  '1', JText::_('JBJOBS_COMMUNITY_BUILDER'));
		$types[] = JHTML::_('select.option',  '2', JText::_('JBJOBS_JOMSOCIAL'));
		
		$lists 	= JHTML::_('select.genericlist',   $types, $var, 'class="inputbox" size="1" '.$option.'', 'value', 'text', $default);
		
		return $lists;
	}
	
	//7.getSelectJobStatus
	function getSelectJobStatus($var, $default, $disabled, $event){
		$option ='';
		if($disabled == 1) 
			$option = 'disabled';
		
		$types[] = JHTML::_('select.option', '0', JText::_('JBJOBS_SELECT_JOB_STATUS'));
		$types[] = JHTML::_('select.option', '1', JText::_('JBJOBS_ACTIVE'));
		$types[] = JHTML::_('select.option', '2', JText::_('JBJOBS_EXPIRED'));
		$types[] = JHTML::_('select.option', '3', JText::_('JBJOBS_UNPUBLISHED'));
		
		$lists 	 = JHTML::_('select.genericlist',   $types, $var, "class=\"inputbox\" size=\"1\" $option $event", 'value', 'text', $default );
		
		return $lists;
	}
	
	//8.getSelectSubscrStatus
	function getSelectSubscrStatus($var, $default, $disabled, $event){
		$option ='';
		if($disabled == 1) 
			$option = 'disabled';
		
		$types[] = JHTML::_('select.option', '0', JText::_('JBJOBS_SELECT_SUBSCR_STATUS'));
		$types[] = JHTML::_('select.option', '1', JText::_('JBJOBS_APPROVED'));
		$types[] = JHTML::_('select.option', '2', JText::_('JBJOBS_UNAPPROVED'));
		$types[] = JHTML::_('select.option', '3', JText::_('JBJOBS_EXPIRED'));
		$types[] = JHTML::_('select.option', '4', JText::_('JBJOBS_CANCELLED'));
		
		$lists 	 = JHTML::_('select.genericlist', $types, $var, "class=\"inputbox\" size=\"1\" $option $event", 'value', 'text', $default );
		
		return $lists;
	}
	
	//9.getSelectPositionType
	function getSelectPositionType($var, $default, $disabled){
		$db	= & JFactory::getDBO(); 
		
		$option = '';
		if($disabled == 1) 
			$option = 'disabled';
		
		//make selection position type
		$query = 'SELECT id AS value, pos_type AS text FROM #__jbjobs_pos_type WHERE published=1 ORDER BY ordering';
		$db->setQuery($query);
		$users = $db->loadObjectList();
		
		$types[] = JHTML::_('select.option', '', '- '.JText::_('JBJOBS_SELECT_POS_TYPE').' -');
		foreach($users as $item){
			$types[] = JHTML::_('select.option', $item->value, JText::_($item->text));
		}		
		
		$lists 	= JHTML::_('select.genericlist', $types, $var, 'class="inputbox" size="1" '.$option.'', 'value', 'text', $default);
		return $lists;
	}

	//10.getSelectExpLevel
	function getSelectExpLevel($var, $default, $disabled){
		$db	= & JFactory::getDBO(); 
		
		$option = '';
		if($disabled == 1) 
			$option = 'disabled';
		
		//make selection experience level
		$query = 'SELECT id AS value, exp_name AS text FROM #__jbjobs_job_exp WHERE published=1 ORDER BY ordering';
		$db->setQuery($query);
		$users = $db->loadObjectList();
		
		$types[] = JHTML::_('select.option', '', '- '. JText::_('JBJOBS_SELECT_EXP_LEVEL').' -' );
		foreach( $users as $item ){
			$types[] = JHTML::_('select.option', $item->value, JText::_($item->text));
		}		
		
		$lists 	= JHTML::_('select.genericlist', $types, $var, 'class="inputbox" size="1" '.$option.'', 'value', 'text', $default );
		return $lists;
	}

	//11.getSelectDegreeLevel
	function getSelectDegreeLevel($var, $default, $disabled){
		$db	= & JFactory::getDBO(); 
		
		$option ='';
		if($disabled == 1) 
			$option = 'disabled';
		
		//make selection degreelevel
		$query = 'SELECT id AS value, degree_level AS text FROM #__jbjobs_degree_level WHERE published=1 ORDER BY ordering';
		$db->setQuery($query);
		$users = $db->loadObjectList();
		
		$types[] = JHTML::_('select.option',  '', '- '.JText::_('JBJOBS_SELECT_DEG_LEVEL').' -');
		foreach( $users as $item ){
			$types[] = JHTML::_('select.option', $item->value, JText::_($item->text));
		}		
		
		$lists 	= JHTML::_('select.genericlist', $types, $var, 'class="inputbox" size="1" '.$option.'', 'value', 'text', $default);
		return $lists;
	}

	//12.getSelectTypeSalary
	function getSelectTypeSalary($var, $default, $disabled){
		$db	= & JFactory::getDBO(); 
		
		$option = '';
		if($disabled == 1) 
			$option = 'disabled';
		
		//make selection salary type
		$query = 'SELECT id AS value, type_salary AS text FROM #__jbjobs_type_salary WHERE published=1 ORDER BY ordering';
		$db->setQuery( $query );
		$users = $db->loadObjectList();
		
		$types[] = JHTML::_('select.option',  '', '- '.JText::_('JBJOBS_SELECT_SAL_TYPE').' -');
		foreach($users as $item){
			$types[] = JHTML::_('select.option', $item->value, JText::_($item->text));
		}		
		
		$lists 	= JHTML::_('select.genericlist', $types, $var, 'class="inputbox" size="1" '.$option.'', 'value', 'text', $default);
		return $lists;
	}
	
	//13.getSalutation
	function getSalutation($var, $default, $disabled){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO(); 
		
		$option = '';
		if($disabled == 1) 
			$option = 'disabled';
		
		//make selection salutation
		$query = 'SELECT id AS value, salutation AS text FROM #__jbjobs_salutation ORDER BY salutation';
		$db->setQuery( $query );
		$users = $db->loadObjectList();
		
		$types[] 		= JHTML::_('select.option', '', '- '.JText::_('JBJOBS_SELECT_SALUTATION').' -');
		foreach( $users as $item ){
			$types[] = JHTML::_('select.option', $item->value, JText::_($item->text));
		}		
		
		$lists 	= JHTML::_('select.genericlist', $types, $var, 'class="inputbox" size="1" '.$option.'', 'value', 'text', $default );
		return $lists;
	}
	
	//14.getSelectCompType
	function getSelectCompType($var, $default, $disabled){
		$db	= & JFactory::getDBO(); 
		
		$option = '';
		if($disabled == 1) 
			$option = 'disabled';
		 
		//make selection country
		$query = 'SELECT id AS value, comp_type AS text FROM #__jbjobs_comp_type ORDER BY comp_type';
		$db->setQuery( $query );
		$users = $db->loadObjectList();
		
		$types[] 		= JHTML::_('select.option',  '', '- '.JText::_('JBJOBS_SELECT_COMP_TYPE').' -');
		foreach( $users as $item ){
			$types[] = JHTML::_('select.option', $item->value, JText::_($item->text));
		}		
		
		$lists 	= JHTML::_('select.genericlist', $types, $var, 'class="inputbox" size="1" '.$option.'', 'value', 'text', $default);
		return $lists;
	}
	
	//15.getSelectIndustry
	function getSelectIndustry($var, $default, $disabled){
		$db	= & JFactory::getDBO(); 
		
		$option = '';
		if($disabled == 1) 
			$option = 'disabled';
		
		//make selection industry
		$query = 'SELECT id AS value, industry AS text FROM #__jbjobs_industry WHERE published=1 ORDER BY ordering';
		$db->setQuery($query);
		$users = $db->loadObjectList();
		
		$types[] = JHTML::_('select.option',  '', '- '.JText::_('JBJOBS_SELECT_INDUSTRY').' -');
		foreach($users as $item){
			$types[] = JHTML::_('select.option', $item->value, JText::_($item->text));
		}		
		
		$lists = JHTML::_('select.genericlist', $types, $var, 'class="inputbox" size="1" '.$option.'', 'value', 'text', $default);
		return $lists;
	}
	
	//16.getSelectPersonalStatus
	function getSelectPersonalStatus($var, $title, $default, $disabled){
		$option ='';
		
		if($disabled ==1) 
			$option = 'disabled';
		
		if($default == '') 
			$default = '0'; 
		
		//make selection personal status
		$types[] = JHTML::_('select.option', '', '- '.$title.' -');
		$types[] = JHTML::_('select.option',  'Single', JText::_('JBJOBS_SINGLE'));
		$types[] = JHTML::_('select.option',  'Married', JText::_('JBJOBS_MARRIED'));
		$types[] = JHTML::_('select.option',  'Widowed', JText::_('JBJOBS_WIDOWED'));
		$types[] = JHTML::_('select.option',  'Divorced', JText::_('JBJOBS_DIVORCED'));
		$types[] = JHTML::_('select.option',  'Separated', JText::_('JBJOBS_SEPARATED'));
		$types[] = JHTML::_('select.option',  'Other', JText::_('JBJOBS_OTHER'));
		
		$lists 	 = JHTML::_('select.genericlist',   $types, $var, 'class="inputbox" size="1" '.$option.'', 'value', 'text', $default );
		return $lists;
	}
	
	//17.getSelectJobAgency
	function getSelectJobAgency($var, $title, $default, $disabled){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO(); 
	
		$option = '';
		if($disabled == 1) 
			$option = 'disabled';
		
		//make selection job agency
		$query = 'SELECT user_id AS value, comp_name AS text FROM #__jbjobs_employer WHERE id_comp_type=2 ORDER BY comp_name';		
		$db->setQuery( $query );
		$jobagencies = $db->loadObjectList();
		
		$types[] = JHTML::_('select.option',  '', '- '.$title.' -');
		$types[] = JHTML::_('select.option',  '-1', JText::_('JBJOBS_NONE'));
		foreach( $jobagencies as $item ){
			$types[] = JHTML::_('select.option', $item->value, JText::_($item->text));
		}		
		$tip = JText::_('JBJOBS_TT_CHOOSE_YOUR_REFERER');
		$lists 	= JHTML::_('select.genericlist', $types, $var, 'class="inputbox" size="1" '.$option.'', 'value', 'text', $default);
		return $lists;

	}

	//18.getSelectMajor
	function getSelectMajor($var, $default, $disabled){
		$db	= & JFactory::getDBO(); 
		
		$option ='';
		if($disabled == 1) 
			$option = 'disabled';
		
		//make selection major
		$query = 'SELECT id AS value, major AS text FROM #__jbjobs_major WHERE published=1 ORDER BY ordering';
		$db->setQuery( $query );
		$users = $db->loadObjectList();
		
		$types[] = JHTML::_('select.option', '', '- '. JText::_('JBJOBS_SELECT_MAJOR') .' -');
		foreach( $users as $item ){
			$types[] = JHTML::_('select.option', $item->value, JText::_($item->text));
		}		
		
		$lists 	= JHTML::_('select.genericlist', $types, $var, 'class="inputbox" size="1" '.$option.'', 'value', 'text', $default );
		return $lists;
	}
	
	//19.getSelectPlan
	function getSelectPlan($var, $default, $disabled, $user_type, $event){
		$db	= & JFactory::getDBO(); 
		
		if($user_type == 'e'){
			$tblPlanName = '#__jbjobs_plan';
		}
		elseif($user_type == 'j'){
			$tblPlanName = '#__jbjobs_plan_js';
		}
		
		$option = '';
		if($disabled == 1) 
			$option = 'disabled';
		
		//make selection plans
		$query = "SELECT id as value, name as text FROM $tblPlanName p WHERE p.published = 1 ORDER BY p.id";    
  		$db->setQuery($query);
		$plans = $db->loadObjectList();
		
		$types[] = JHTML::_('select.option', '0', '- '.JText::_('JBJOBS_SELECT_PLAN').' -');
		foreach($plans as $item){
			$types[] = JHTML::_('select.option', $item->value, $item->text);
		}		
		
		$lists 	= JHTML::_('select.genericlist', $types, $var, 'class="inputbox" size="1" '.$option.' '.$event.'', 'value', 'text', $default);
		return $lists;
	}
	
	//20.getSelectFieldtype
	function getSelectFieldtype($var, $default, $disabled, $event){
		$option = '';
		if($disabled == 1) 
			$option = 'disabled';
		
		$types[] = JHTML::_('select.option', '1', JText::_('JBJOBS_EMPLOYER'));
		$types[] = JHTML::_('select.option', '2', JText::_('JBJOBS_JOBSEEKER'));
		$types[] = JHTML::_('select.option', '3', JText::_('JBJOBS_JOB'));
		
		$lists 	 = JHTML::_('select.genericlist', $types, $var, "class=\"inputbox\" size=\"1\" $option $event", 'value', 'text', $default);
		return $lists;
	}
	
	//20.getSelectUserType
	function getSelectUserType($var, $default, $disabled, $event){
		$option ='';
		if($disabled == 1 || $disabled == 'disabled') 
			$option = 'disabled';
			
		$types[] = JHTML::_('select.option', 'e', JText::_('JBJOBS_EMPLOYER'));
		$types[] = JHTML::_('select.option', 'j', JText::_('JBJOBS_JOBSEEKER'));
		
		$lists 	 = JHTML::_('select.genericlist', $types, $var, "class='inputbox' size='1' $option $event", 'value', 'text', $default );
		return $lists;
	}
	
	function getSelectTheme($var, $default){
		$types[] = JHTML::_('select.option', 'styleJB.css', JText::_('JBJOBS_JOOMBAH_DEFAULT'));
		$types[] = JHTML::_('select.option', 'styleFB.css', JText::_('JBJOBS_FACEBOOK_BLUE'));
		$types[] = JHTML::_('select.option', 'styleJS.css', JText::_('JBJOBS_JOMSOCIAL_GREEN'));
		$types[] = JHTML::_('select.option', 'styleBO.css', JText::_('JBJOBS_BLACK_ORANGE'));
		$types[] = JHTML::_('select.option', 'styleOR.css', JText::_('JBJOBS_ORANGE'));
		$types[] = JHTML::_('select.option', 'styleGR.css', JText::_('JBJOBS_GREY'));
		$types[] = JHTML::_('select.option', 'styleCS1.css', JText::_('JBJOBS_CUSTOM1'));
		$types[] = JHTML::_('select.option', 'styleCS2.css', JText::_('JBJOBS_CUSTOM2'));
		
		$lists 	 = JHTML::_('select.genericlist', $types, $var, 'class="inputbox" size="1"', 'value', 'text', $default);
		
		return $lists;
	}
	
	//13.getSelectPaymode
	function getSelectPaymode($var, $default, $event){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO(); 
		
		//make selection gateways
		$query = 'SELECT gwcode AS value, fieldtext AS text FROM #__jbjobs_payment_mode 
				  WHERE parent=0 AND published=1
				  ORDER BY ordering';
		$db->setQuery($query);
		$gateways = $db->loadObjectList();
		
		$types[] = JHTML::_('select.option',  '', '- '.JText::_('JBJOBS_ALL_GATEWAYS').' -');
		foreach($gateways as $item){
			$types[] = JHTML::_('select.option', $item->value, JText::_($item->text));
		}		
		$lists 	= JHTML::_('select.genericlist', $types, $var, 'class="inputbox" size="1" '.$event.'', 'value', 'text', $default);
		return $lists;
	}
	
	//8.getSelectCreditStatus
	function getSelectCreditStatus($var, $default, $event){
		$types[] = JHTML::_('select.option', 'a', '- '.JText::_('JBJOBS_ALL_STATUS').' -');
		$types[] = JHTML::_('select.option', 'y', JText::_('JBJOBS_APPROVED'));
		$types[] = JHTML::_('select.option', 'n', JText::_('JBJOBS_UNAPPROVED'));
		
		$lists 	 = JHTML::_('select.genericlist', $types, $var, "class='inputbox' size='1' $event", 'value', 'text', $default );
		
		return $lists;
	}
	
	function getselectDateFormat($var, $default){
		$types[] = JHTML::_('select.option', '%d-%m-%Y', JText::_('dd-mm-yyyy'));
		$types[] = JHTML::_('select.option', '%m-%d-%Y', JText::_('mm-dd-yyyy'));
		$types[] = JHTML::_('select.option', '%Y-%m-%d', JText::_('yyyy-mm-dd'));
		
		$lists 	 = JHTML::_('select.genericlist', $types, $var, 'class="inputbox" size="1"', 'value', 'text', $default);
		
		return $lists;
	}
	
	//getJobalertFrequency
	function getJobalertFrequency( $name, $value = 'w'){
		$put[] = JHTML::_('select.option',  'd', JText::_('JBJOBS_DAILY'));
		$put[] = JHTML::_('select.option',  'w', JText::_('JBJOBS_WEEKLY'));
		$put[] = JHTML::_('select.option',  'm', JText::_('JBJOBS_MONTHLY'));
		$frequency = JHTML::_('select.radiolist', $put, $name, '', 'value', 'text', $value);
		return $frequency;
	}
	
	//16.getMultipleJobSpec
	function getMultipleJobSpec($var, $title, $default, $event){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO(); 
		
		//make selection salutation
		$query = 'select id as value, specialization as text from #__jbjobs_job_spec ORDER BY specialization';
		$db->setQuery( $query );
		$users = $db->loadObjectList();
		
		$types[] = JHTML::_('select.option', '0', '- '.$title.' -');
		foreach($users as $item){
			$types[] = JHTML::_('select.option', $item->value, JText::_($item->text));
		}		
		
		$lists 	= JHTML::_('select.genericlist', $types, $var, 'class="inputbox" size="10" multiple '.$event.'', 'value', 'text', $default);
		return $lists;
	}
	
	//21.maleFemale
	function maleFemale( $name, $value = 'M'){
		$put[] = JHTML::_('select.option',  'M', JText::_('JBJOBS_MALE'));
		$put[] = JHTML::_('select.option',  'F', JText::_('JBJOBS_FEMALE'));
		$malefemale = JHTML::_('select.radiolist', $put, $name, '', 'value', 'text', $value );
		return $malefemale;
	}
	
	//3.postingPrivacy
	function postingPrivacy($name, $value = 0){
		$put[] = JHTML::_('select.option',  0, JText::_('JBJOBS_PUBLIC'));
		$put[] = JHTML::_('select.option',  10, JText::_('JBJOBS_SITE_MEMBERS'));
		$put[] = JHTML::_('select.option',  20, JText::_('JBJOBS_ONLY_ME'));
		$put[] = JHTML::_('select.option',  30, JText::_('JBJOBS_NOBODY'));
		$postingPrivacy = JHTML::_('select.radiolist', $put, $name, '', 'value', 'text', $value);
		return $postingPrivacy;
	}
	
	//7.getSelectJobStatus
	function getSelectDuration($var, $default, $disabled, $event){
		$option = '';
		if($disabled == 1) 
			$option = 'disabled';
		
		$types[] = JHTML::_('select.option', 'days', JText::_('JBJOBS_DAYS'));
		$types[] = JHTML::_('select.option', 'weeks', JText::_('JBJOBS_WEEKS'));
		$types[] = JHTML::_('select.option', 'months', JText::_('JBJOBS_MONTHS'));
		$types[] = JHTML::_('select.option', 'years', JText::_('JBJOBS_YEARS'));
		
		$lists = JHTML::_('select.genericlist', $types, $var, "class=\"inputbox\" size=\"1\" $option $event", 'value', 'text', $default);
		return $lists;
	}
	
	//14.getSelectManageApplicant 
	function getSelectManageApplicant($var, $default, $disabled){
		
		//make selection personal status
		$types[] = JHTML::_('select.option',  0, JText::_('JBJOBS_JOB_BOARD_ACCOUNT'));
		$types[] = JHTML::_('select.option',  1, JText::_('JBJOBS_EXTERNAL_WEBSITE'));
		
		$tip = JText::_('JBJOBS_TT_MANAGE_APPLICANTS');
		$lists 	= JHTML::_('select.genericlist', $types, $var, "class='inputbox jbtooltip' size='1' title='$tip'", 'value', 'text', $default );
		return $lists;
	}
	
	//14.getSelectVideo 
	function getSelectVideo($var, $title, $default){
		
		$types[] = JHTML::_('select.option',  '', '- '. JText::_(''.$title.'') .' -');
		$types[] = JHTML::_('select.option',  'youtube', JText::_('Youtube'));
		$types[] = JHTML::_('select.option',  'googlevideo', JText::_('Google Video'));
		
		$lists 	= JHTML::_('select.genericlist', $types, $var, 'class="inputbox" size="1" ', 'value', 'text', $default );
		return $lists;
	}
}	
?>
