<?php
/**
 + Created by	:	JoomBah Team
 * Company		:	ISDS Sdn Bhd
 + Contact		:	www.joombah.com , support@joombah.com
 * Created on	:	August 2010
 * Author 		:	Faisel
 * Tested by	: 	Zaki
 + Project		: 	Job site
 * File Name	:	plg_forceprofileupdate.php
 ^ 
 * Description	: 	Entry point for the plugin (jbjobs)
 ^ 
 * History		:	NONE
 * */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.plugin.plugin');

class plgSystemForceProfileUpdate extends JPlugin {
	function plgSystemForceProfileUpdate(&$subject, $config){
		parent::__construct($subject, $config);
	}

	function onAfterRoute(){
		$app =& JFactory::getApplication();

        // Don't do anything if this is the administrator backend or debugging is on
        if($app->isAdmin() || JDEBUG) {
        	return;
        }

		$user = &JFactory::getUser();

		$option = JRequest::getVar('option');
		$view 	= JRequest::getVar('view');
		$task 	= JRequest::getVar('task');
		$layout = JRequest::getVar('layout');
		
		//check whether the user is jobseeker or employer and set the view and layout accordingly
		$is_employer = $this->isEmployer($user->id);
		$is_jobseeker = $this->isJobSeeker($user->id);
		
		$editProfileOption 	 = "com_jbjobs";
				
		if($is_jobseeker){
			$editProfileView	 = "jobseeker";
			$editProfileLayout 	 = "regjobseeker";
			$editProfileSaveTask = "savejobseeker";
		}
		elseif($is_employer){
			$editProfileView	 = "employer";
			$editProfileLayout 	 = "regemployer";
			$editProfileSaveTask = "saveemployer";
		}
		
		// execute the below script if the user is either an employer or a jobseeker. If his is just a registered member, do not execute.
		if(($is_employer || $is_jobseeker) && $user->lastvisitDate == "0000-00-00 00:00:00"){
			//ignore this for loading address data and university search suggestion.
			if ($task == "listempaddressdata" or $task == "searchsuggest" or $task == "uploadpicture" or $task == "removePicture") { 
			//do nothing
			}
			else {
				// The user is not a guest and their lastvisitDate is zeros
				if($option == $editProfileOption && $task == $editProfileSaveTask){
					// The user is saving their profile
	
					// Set the last visit date to a real value so we won't continue forcing them to update their profile
					$user->setLastVisit();
					$date = JFactory::getDate();
					$user->lastvisitDate = $date->toMySQL();
				}
				else if(!($option == $editProfileOption && $view == $editProfileView && $layout == $editProfileLayout)){
					// The user is not on the edit profile form
	
					// Update lastvisitDate back to zero
					$dbo = &JFactory::getDBO();
					$query = "UPDATE #__users ".
						"SET lastvisitDate = ".$dbo->quote("0000-00-00 00:00:00")." ".
						"WHERE id = ".$dbo->quote($user->id);
					$dbo->setQuery($query);
					$dbo->query();
		
					// Redirect to edit profile
					$app->redirect(
						JRoute::_("index.php?option=".$editProfileOption."&view=".$editProfileView."&layout=".$editProfileLayout, false),
						$this->params->get("message", "You must update your profile before continuing to use the site.")
					);
				}
			}
		}
	}
	
	//isEmployer	
	function isEmployer($userid){
		$db =& JFactory::getDBO();
		$query = "SELECT COUNT(*) FROM #__jbjobs_employer where user_id =".$db->quote($userid);
		$db->setQuery( $query );
		$total = $db->loadResult();
		if($total == 1)
			return 1;
		else
			return 0;
	}

	//isJobSeeker	
	function isJobSeeker($userid){
		$db =& JFactory::getDBO();
		$query = "SELECT COUNT(*) FROM #__jbjobs_jobseeker where user_id =".$db->quote($userid);
		$db->setQuery( $query );
		$total = $db->loadResult();
		if($total == 1)
			return 1;
		else
			return 0;
	}
	
}
