<?php
/**
 + Created by	:	JoomBah Team
 * Company		:	ISDS Sdn Bhd
 + Contact		:	www.joombah.com , support@joombah.com
 * Created on	:	August 2010
 * Author 		:	Faisel
 * Tested by	: 	Zaki
 + Project		: 	Job site
 * File Name	:	controllers/jbjobs.php
 * License		:	GNU General Public License version 3, or later
 ^ 
 * Description	: 	Entry point for the component (jbjobs)
 ^ 
 * History		:	
 * */
defined('_JEXEC') or die('Restricted access');
jimport('joomla.application.component.controller');

JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jbjobs'.DS.'tables');
include_once(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jbjobs'.DS.'helper'.DS.'helper.php');
require_once(JPATH_SITE.DS.'components'.DS.'com_jbjobs'.DS.'models'.DS.'jbjobs.php');

$config =& JTable::getInstance('config','Table');
$config->load(1);

if(!defined('JBJOBS_FREE_MODE')){
	define('JBJOBS_FREE_MODE', $config->get('freemode'));
}
if(!defined('JBJOBS_FREE_MODE_JS')){
	define('JBJOBS_FREE_MODE_JS', $config->get('freemode_js'));
}

class JBJobsControllerJbjobs extends JController {
	
	function __construct(){
		$user	=& JFactory::getUser();
		if ($user->guest){
			// redirect user if not login
			$link = 'index.php?option=com_user';
			$this->setRedirect($link);
		}
		parent :: __construct();
	}
	
/**	
==================================================================================================================	
	SECTION : Registration & Login
	1.Check Username & Email (ajax)
	2.Search suggestion for University
	3.Dashboard Decide
	4.Load address data
==================================================================================================================
*/
	
	function lightjs() {
		header('Content-type: text/javascript');
		require_once(JPATH_SITE.DS.'components'.DS.'com_jbjobs'.DS.'js'.DS.'light.js');
		die();
	}
	
	//cron job
	function cron(){
		$app =& JFactory::getApplication();
		$db =& JFactory::getDBO();
		$now  = date('Y-m-d H:i:s', time() + ($app->getCfg('offset') * 60 * 60));	
		$freq = JRequest::getVar('freq', '', 'get', 'string');
		
		if(!empty($freq)){
			$query = "SELECT id FROM #__jbjobs_job_alert WHERE subscribed=1 AND frequency=".$db->quote($freq)." ORDER BY id";
			$db->setQuery($query);//echo $query;
			$jobids = $db->loadResultArray();
			if(count($jobids)){
				JRequest::setVar('cid', $jobids);
				$cronHelper = JBjobs::get('helper.cron');
				$cronHelper->cron();
			}
			//else echo 'nothing found';
		}
		else {
			//echo 'freq not found';
		}
	}
/**	
==================================================================================================================	
	SECTION : AJAX Requests
	1.checkUser - Check Username & Email (ajax)
	2.processFeed - Hide feed/activity
	3.searchSuggest - Search suggestion for University
	4.listempaddressdata - Load address data
	5.Dashboard Decide
==================================================================================================================
*/	
	//1.Check Username & Email (ajax)
	function checkUser(){
		$db 	  =& JFactory::getDBO();
		$inputstr = JRequest::getVar('inputstr', '', 'post', 'string');
		$name 	  = JRequest::getVar('name', '', 'post', 'string');
		
		if($name == 'username'){
			$sql = "SELECT COUNT(*) FROM #__users WHERE username='$inputstr'";
			$msg = 'JBJOBS_USERNAME_EXISTS';
		}
		elseif($name == 'email'){
			$sql = "SELECT COUNT(*) FROM #__users WHERE email='$inputstr'";
			$msg = 'JBJOBS_EMAIL_EXISTS';
		}
		
		$db->setQuery($sql);
		if($db->loadResult()){
			echo JText::sprintf($msg, $inputstr);
		}
		else {
			echo 'OK';
		}
		exit;
	}
	
	//2.Hide/remove feeds
	function processFeed(){
		$db 	  =& JFactory::getDBO();
		$userid = JRequest::getVar('userid', '', 'post', 'int');
		$activityid = JRequest::getVar('activityid', '', 'post', 'int');
		$type = JRequest::getVar('type', '', 'post', 'string');
		
		if($type == 'remove')
			$query	= 'DELETE FROM #__jbjobs_feed WHERE id='.$activityid;
		elseif($type == 'hide')
			$query = "INSERT INTO #__jbjobs_feed_hide(`activity_id`,`user_id`) VALUES('$activityid', '$userid')";
		
		$db->setQuery($query);
		$db->query();
		
		echo 'OK';
		exit;
	}
	
	//3.Search suggestion for University
	function searchSuggest(){
		$db 		=& JFactory::getDBO();
		$inputstr = JRequest::getVar('inputstr', '', 'post', 'string');
		$type 	  = JRequest::getVar('type', '', 'post', 'string');
		
		$sql = "SELECT university FROM #__jbjobs_university WHERE university like '%".$inputstr."%' LIMIT 5";
		$db->setQuery($sql);
		$rows = $db->loadObjectList();
		if(count($rows) > 0){
			for($i = 0; $i < count($rows); $i++){
			$row = $rows[$i];
			echo "<li onClick=\"fill('$row->university','$type');\">$row->university</li>";
			}
		}
		else {
			echo '<span class="whitefont">'.JText::_('JBJOBS_NOSUGGESTIONS').'</span>';
		}
		 exit;
	}

	//4.Load address data
	function listempaddressdata(){ 
		$app =& JFactory::getApplication();
		$model = $this->getModel();
		$db 	  =& JFactory::getDBO();
		
		$val 	 = JRequest::getVar('val', '', 'post', 'string');
		$nxtname = JRequest::getVar('nxtname', '', 'post', 'string');
		$pos = strpos($nxtname, "bill"); $nxtnxtname='city';
		if($nxtname == 'bill_state' || $nxtname == 'bill_district')
		 $nxtnxtname='bill_city';
		
		if($nxtname == 'state' || $nxtname == 'district' || $nxtname == 'bill_state' || $nxtname == 'bill_district'){
			$query  = "SELECT id, state FROM #__jbjobs_state WHERE country_id='$val' AND published=1 ORDER BY state";
			$db->setQuery($query);
			$result = $db->loadObjectList();		
			
			if (empty($result))	{
				$return_value = "<input type='text' class='inputbox' id='$nxtname' name='$nxtname' size='35' maxlength='100'/>";
			}
			else {
				$return_value = "<select id='$nxtname' name='$nxtname' class='inputbox' onChange=\"loadaddress(this.value, '$nxtnxtname')\">\n";
				$return_value .= "<option value=''>". '- '.JText::_('JBJOBS_SELECT_STATE').' - ' ."</option>\n";
				
				foreach($result as $row){
					$return_value .= "<option value=\"$row->state\" >$row->state</option> \n" ;
				}
				$return_value .= "</select>\n";
			}
		}
		elseif($nxtname == 'city' || $nxtname == 'bill_city'){
			$query  = "SELECT id, city FROM #__jbjobs_city WHERE state_name='$val' AND published=1 ORDER BY city";
			$db->setQuery($query);
			$result = $db->loadObjectList();		
			
			if (empty($result))	{
				$return_value = "<input type='text' class='inputbox' id='$nxtname' name='$nxtname' size='35' maxlength='100'/>";
			}
			else {
				$return_value = "<select id='$nxtname' name='$nxtname' class='inputbox'>\n";
				$return_value .= "<option value=''>". '- '.JText::_('JBJOBS_SELECT_CITY').' - ' ."</option>\n";
				
				foreach($result as $row){
					$return_value .= "<option value=\"$row->city\" >$row->city</option> \n" ;
				}
				$return_value .= "</select>\n";
			}
		}
		
		echo $return_value;
		exit;
	  }
	  
	//5.Dashboard Decide
	function decideDashboard(){
		$user	=& JFactory::getUser();
		$model = $this->getModel();
		
		// set Itemid id for links from menu
		$menu = &JSite::getMenu();
	
		if($model->isJobSeeker($user->id)){
			$items	= $menu->getItems('link', 'index.php?option=com_jbjobs&view=jobseeker&layout=dashboard');
			if(isset($items[0])) {
				$Itemid = $items[0]->id;
			}
			elseif(JRequest::getInt('Itemid') > 0){ //use Itemid from requesting page only if there is no existing menu
				$Itemid = JRequest::getInt('Itemid');
			}
			$link = JRoute::_('index.php?option=com_jbjobs&view=jobseeker&layout=dashboard&Itemid='.$Itemid, false);
			$this->setRedirect($link);
			return false;
		}
		elseif($model->isEmployer(($user->id))){
			$items	= $menu->getItems('link', 'index.php?option=com_jbjobs&view=employer&layout=dashboard');
			if(isset($items[0])) {
				$Itemid = $items[0]->id;
			}
			elseif(JRequest::getInt('Itemid') > 0){ //use Itemid from requesting page only if there is no existing menu
				$Itemid = JRequest::getInt('Itemid');
			}
			$link = JRoute::_('index.php?option=com_jbjobs&view=employer&layout=dashboard&Itemid='.$Itemid, false);
			$this->setRedirect($link);
			return false;
		}
		else {
			$link = JRoute::_('index.php?option=com_jbjobs&view=guest&layout=showfront');	
			$this->setRedirect($link);
			return false;
		}
	}
/**	
==================================================================================================================	
	SECTION : Jobseeker
	1.Save new Jobseeker
	2.Save Jobseeker Profile
	3.Save Resume
	4.Remove Resume
	5.Save Cover Letter
	6.Remove Cover Letter
	7.Apply and Save job by Jobseeker
	8.Delete Saved Job
	9.Delete All Saved Job
==================================================================================================================
*/
	//1.Save new Jobseeker
	function saveJobSeekerNew(){
		$app =& JFactory::getApplication();
		$user	=& JFactory::getUser();
		
		// Check for request forgeries
		JRequest::checkToken() or jexit('Invalid Token');
		
		// Initialize variables
		$db		=& JFactory::getDBO();
		$row	=& JTable::getInstance('jobSeeker', 'Table');
		$post   = JRequest::get('post');
		
		$post['name'] = (!empty($post['first_name'])) ? $post['first_name'] : null;
		$post['name'] .= (!empty($post['name']) && !empty($post['last_name'])) ? ' ' . $post['last_name'] : null;
	
		////////////////////////////////////////
		// Get required system objects
		$usern 		=  clone(JFactory::getUser());
		$pathway 	=& $app->getPathway();
		$config 	=& JFactory::getConfig();
		$authorize 	=& JFactory::getACL();
		$document 	=& JFactory::getDocument();
		
		// If user registration is not allowed, show 403 not authorized.
		$usersConfig = &JComponentHelper::getParams('com_users');
		if ($usersConfig->get('allowUserRegistration') == '0') {
			JError::raiseError( 403, JText::_('JBJOBS_ACCESS_FORBIDDEN'));
			return;
		}
		
		// Initialize new usertype setting
		$newUsertype = $usersConfig->get('new_usertype');
		if (!$newUsertype) {
			$newUsertype = 'Registered';
		}
		
		// Bind the post array to the user object
		if (!$usern->bind( $post, 'usertype')) {
			JError::raiseError( 500, $usern->getError());
		}
		
		// Set some initial user values
		$usern->set('id', 0);
		$usern->set('usertype', $newUsertype);
		$usern->set('gid', $authorize->get_group_id('', $newUsertype, 'ARO'));
		$date =& JFactory::getDate();
		$usern->set('registerDate', $date->toMySQL());
		
		$lang =& JFactory::getLanguage();
	 	$lang->load('com_user', JPATH_SITE);
	
		// If user activation is turned on, we need to set the activation information
		$useractivation = $usersConfig->get('useractivation');
		if ($useractivation == '1'){
			jimport('joomla.user.helper');
			$usern->set('activation', JUtility::getHash( JUserHelper::genRandomPassword()) );
			$usern->set('block', '1');
		}
	
		// If there was an error with registration, set the message and display form
		if ( !$usern->save() ){
			$msg = JText::_( $usern->getError());
			$link = JRoute::_('index.php?option=com_jbjobs&view=jobseeker&layout=regjobseekernew');	
			$this->setRedirect($link, $msg);
			return false;
		}
		
		$userid = $usern->id;
		
		$row->user_id = $userid;
		
		if (!$row->bind( $post )) {
			JError::raiseError(500, $row->getError() );
		}
		// pre-save checks
		if (!$row->check()) {
			JError::raiseError(500, $row->getError() );
		}
		// save the changes
		if (!$row->store()) {
			JError::raiseError(500, $row->getError() );
		}	
		$row->checkin();
		
		$this->insertCustomField('jobseeker', $row->user_id, $post);	
	
		// Send registration confirmation mail
		$password = JRequest::getString('password', '', 'post', JREQUEST_ALLOWRAW);
		$password = preg_replace('/[\x00-\x1F\x7F]/', '', $password); //Disallow control chars in the email
		$this->JBJobSendMail($usern, $password);
		
		if($useractivation){
			$msg = JText::_('JBJOBS_ACCOUNT_HAS_BEEN_CREATED_NEED_ACTIVATION');
		}
		else {
			$msg = JText::_('JBJOBS_ACCOUNT_HAS_BEEN_CREATED_PLEASE_LOGIN');
		}
		if(!JBJOBS_FREE_MODE_JS){
			//add jobseeker to the subscription Table
			$this->addSubscription($userid);
			$subscrid = JRequest::getVar('returnrowid', 0, 'post', 'int');	//this returnid is the subscr id from plan_subscr table
			$session =& JFactory::getSession();
			$session->set('id', $subscrid, 'upgsubscr');
			
			if($post['gateway'] == '.banktransfer'){
				//send alert to admin and user
				$this->alertAdminSubscr($subscrid, $userid);
				$this->alertUserSubscr($subscrid, $userid);
			}
			
			$link = JRoute::_('index.php?option=com_jbjobs&view=membership&layout=check_out');
		}
		else {
			$link = JRoute::_('index.php?option=com_jbjobs&view=guest&layout=joblist');
		}
		$this->setRedirect($link, $msg);
	}
	
	//2.Save Jobseeker Profile
	function saveJobSeeker(){
		// Check for request forgeries
		JRequest::checkToken() or jexit('Invalid Token');
		
		// Initialize variables
		$user	=& JFactory::getUser();
		$Itemid = JRequest::getInt('Itemid');
		$db		=& JFactory::getDBO();
		$row	=& JTable::getInstance('jobSeeker', 'Table');
		$post   = JRequest::get('post');
		$row->user_id = $user->id;
		
		if (!$row->bind($post)){
			JError::raiseError(500, $row->getError() );
		}
		// pre-save checks
		if (!$row->check()){
			JError::raiseError(500, $row->getError() );
		}
		// save the changes
		if (!$row->store()){
			JError::raiseError(500, $row->getError() );
		}
		$row->checkin(); 
		//save to experience Table
		$exp			=& JTable::getInstance('experience', 'Table');
		$prev_employer 	= $post['prev_employer'];
		$designation 	= $post['designation'];
		$from 			= $post['from_date'];
		$to 			= $post['to_date'];
		$expid 			= $post['expid'];
		$job_profile 	= $post['job_profile'];
		$exp->id 			= $expid;
		$exp->user_id 		= $user->id;
		$exp->prev_employer = $prev_employer;
		$exp->designation 	= $designation;
		$exp->from_date 	= $from;
		$exp->to_date 		= $to;
		$exp->job_profile 	= $job_profile;
		// pre-save checks
		if (!$exp->check()){
			JError::raiseError(500, $exp->getError() );
		}
		// save the changes
		if (!$exp->store()){
			JError::raiseError(500, $exp->getError() );
		}
		$exp->checkin();
		
		$this->insertCustomField('jobseeker', $row->user_id, $post);
			
		/*if(!empty($_FILES['photo'])){
			$this->jbjobsUploadPhoto($_FILES['photo'], $row->user_id);
		}
		//remove the photo if chosen to remove
		if($post['removephoto']){
			$dest = JPATH_SITE.DS.'images'.DS.'jbjobs'.DS.$row->user_id.'.jpg';
			if(file_exists($dest)){
					$del = unlink($dest);
			}
		}*/
		$name 	= $post['first_name'];
		$name  .= (!empty($post['last_name'])) ? ' ' . $post['last_name'] : '';
		$query  = "UPDATE #__users SET name='$name' WHERE id='".$user->id."'";
		$db->setQuery($query);
		$db->query();
		$user->name = $name;
		
		//update the privacy post settings to the feed table.
		$query = "UPDATE #__jbjobs_feed f SET f.access=".$post['show_post']." WHERE f.actor=".$db->quote($user->id);
		$db->setQuery($query);
		$db->query();
		
		//Trigger the plugin event to fedd the employer profile update to JoomBah Feed
		JPluginHelper::importPlugin('system');
		$dispatcher =& JDispatcher::getInstance();
		$dispatcher->trigger('onJobseekerUpdateProfile', array($user->id));
		
		$msg 	= JText::_( 'JBJOBS_PROFILE_SAVED_SUCCESSFULLY' );
		$link	= JRoute::_('index.php?option=com_jbjobs&view=jobseeker&layout=dashboard&Itemid='.$Itemid, false);
		$this->setRedirect($link, $msg);
	}
	
	function setResumeFeatured(){
		$app =& JFactory::getApplication();
		$user	=& JFactory::getUser();	
		$post   = JRequest::get('post');
		$id 	= JRequest::getVar('id', 0, 'get', 'int');
		$db		=& JFactory::getDBO();
		$model = $this->getModel();
		
		$plan = $model->whichPlan($user->id);
		$credit_featuredRes = $plan->credit_featuredresume;
		$featured_expire = $plan->featuredres_expireday;
		$now  = date('Y-m-d H:i:s', time() + ($app->getCfg('offset') * 60 * 60));	
		$date_expires = date("Y-m-d H:i:s", strtotime($now."+".$featured_expire." day"));	
		
		$resume	=& JTable::getInstance('resume', 'Table');
		$resume->load($id);
		
		$transDetail = JText::_('JBJOBS_FEATURED_RESUME').' - '.$resume->name_resume.' - '.$id;
		
		$resume->featured = 1;
		$resume->featured_expire = $date_expires;
		
		// pre-save checks
		if (!$resume->check()) {
			JError::raiseError(500, $resume->getError() );
		}
		// save the changes	
		if (!$resume->store()) {
			JError::raiseError(500, $resume->getError() );
		}
		
		//update the transaction table
		$this->updateTransaction($user->id, $transDetail, $credit_featuredRes, -1);
		
		$msg = JText::_('JBJOBS_RESUME_SET_FEATURED_SUCCESS');
		$link = JRoute::_('index.php?option=com_jbjobs&view=jobseeker&layout=editresume', false);	
		$this->setRedirect($link, $msg);
	}
	
	function setJobHot(){
		$app   =& JFactory::getApplication();
		$user  =& JFactory::getUser();	
		$post  = JRequest::get('post');
		$id    = JRequest::getVar('id', 0, 'get', 'int');
		$db	   =& JFactory::getDBO();
		$model =& $this->getModel();
		
		$plan = $model->whichPlan($user->id);
		$creditperhotjob = $plan->creditperhotjob;
		$hotjobexpire = $plan->hotjobexpire;
		$now  = date('Y-m-d H:i:s', time() + ($app->getCfg('offset') * 60 * 60));	
		$date_expires = date("Y-m-d H:i:s", strtotime($now."+".$hotjobexpire." day"));	
		
		$job	=& JTable::getInstance('job', 'Table');
		$job->load($id);
		
		$transDetail = JText::_('JBJOBS_HOT_JOB').' - '.$job->job_title.' - '.JText::_('JBJOBS_JOBID').':'.$id;
		
		//$job->is_hot = 1;
		$job->hotjob_expire = $date_expires;
		
		// pre-save checks
		if(!$job->check()){
			JError::raiseError(500, $job->getError());
		}
		// save the changes	
		if(!$job->store()){
			JError::raiseError(500, $job->getError());
		}
		
		//update the transaction table
		$this->updateTransaction($user->id, $transDetail, $creditperhotjob, -1);
		
		$msg = JText::_('JBJOBS_JOB_SET_HOT_SUCCESS');
		$link = JRoute::_('index.php?option=com_jbjobs&view=employer&layout=showmyjobs', false);	
		$this->setRedirect($link, $msg);
	}
	
	/**
	 * Update the transaction of the users to the transaction table (#__jbjobs_transaction)
	 * @param int $userid
	 * @param string $transDtl
	 * @param int $credit
	 * @param int $plusMinus
	 */
	function updateTransaction($userid, $transDtl, $credit, $plusMinus){
		$app =& JFactory::getApplication();
		$now  = date('Y-m-d H:i:s', time() + ($app->getCfg('offset') * 60 * 60));	
		//Insert the transaction into the transaction table incase credit per job is greater than zero		
		if($credit > 0){
			$row_trans	=& JTable::getInstance('transaction', 'Table');
			$row_trans->date_trans  = $now;
			$row_trans->transaction = $transDtl;
			$row_trans->user_id  = $userid;
			
			if($plusMinus == 1)
				$row_trans->credit_plus = $credit; 
			elseif($plusMinus == -1)
				$row_trans->credit_minus = $credit; 
			
			// pre-save checks
			if (!$row_trans->check()) {
				JError::raiseError(500, $row_trans->getError() );
			}	
			if (!$row_trans->store()){
					JError::raiseError(500, $row_trans->getError() );
			}											
			$row_trans->checkin();
			return $row_trans;
		}
	}
	
	//3.Save Resume
	function saveResume(){
		// Check for request forgeries
		JRequest::checkToken() or jexit('Invalid Token');
		
		$user	=& JFactory::getUser();
		$model = $this->getModel();
		$Itemid = JRequest::getInt('Itemid');
		$db		=& JFactory::getDBO();
		
		if($model->isJobSeeker($user->id) == 0){
			$return	= JRoute::_('index.php?option=com_jbjobs&view=jobseeker&layout=regjobseeker');
			$this->setRedirect($return);
			return;
		}
		
		// Initialize variables
		$row	=& JTable::getInstance('resume', 'Table');
		$post   = JRequest::get('post');
		$id 	= (!empty($post['id'])) ? (int) $post['id'] : 0;	
		$type_resume = (!empty($post['type'][0])) ?  $post['type'][0] : 'c';	
		$resume      = JRequest::getVar('resume', '', 'post', 'string', JREQUEST_ALLOWRAW);	
		$is_active 	 = (!empty($post['is_active'])) ?  $post['is_active'] : 'n';
		
		//If the current resume is set active, set others as inactive
		if($is_active == 'y'){
			$query = "UPDATE #__jbjobs_resume SET is_active ='n' WHERE jseeker_id =".$db->quote($user->id);	
			$db->setQuery($query);
			if (!$db->query()){
				$this->jbJobsMsgAlert('".$db->getErrorMsg()."');
			}
		}
		//count resume to check the maximum that can be saved
		$query = "SELECT COUNT(*) FROM #__jbjobs_resume WHERE jseeker_id =".$db->quote($user->id);
		$db->setQuery($query);
		$total = $db->loadResult();
		if($total >=3 && $id == 0){
			$this->jbJobsMsgAlert(JText::sprintf('JBJOBS_MAXIMUM_RESUME', 3));
			exit();
		}
		
		if($id > 0){
			$row->load($id);
		}
		
		if(!$row->bind( $post)) {
			JError::raiseError(500, $row->getError());
		}
		$row->jseeker_id  = $user->id;
		$row->resume  	  = $resume;
		$row->type  	  = $type_resume;
		
		//UPLOAD FILE
		jimport('joomla.filesystem.file');
		$file = $_FILES['file_resume'];	
		$config =& JTable::getInstance('config','Table');
		$config->load(1);
		$type = $config->get('cvfiletype');
		//$type ='bmp,csv,doc,gif,ico,jpg,jpeg,odg,odp,ods,odt,pdf,png,ppt,swf,txt,xcf,xls,BMP,CSV,DOC,GIF,ICO,JPG,JPEG,ODG,ODP,ODS,ODT,PDF,PNG,PPT,SWF,TXT,XCF,XLS';
		$allowed = explode(',',$type);
		
		if($file['size'] > 0){
			if($file['error'] != 0){
				$this->jbJobsMsgAlert( JText::_( 'JBJOBS_UPLOAD_FILE_ERROR' ) );
				exit ();
			}
			if($file['size'] == 0){
				$file = null;
			}
			
			$format = $file['type'];
			if(!preg_match('/(.*)\.(zip|docx)/',$file['name'])){
				if(!in_array($format, $allowed)){	
					$this->jbJobsMsgAlert(JText::_('JBJOBS_YOUR_FILE_IS_IGNORED'));
					exit ();
					$file = null;
				}
			}
			$old_doc = $row->file_resume;		
			if ($file != null){
				if(!file_exists(JPATH_SITE . DS. 'images' . DS . 'jbjobs' . DS . 'pf')){
					if(mkdir(JPATH_SITE . DS . 'images' . DS . 'jbjobs' . DS . 'pf')){
						JPath::setPermissions(JPATH_SITE . DS . 'images' . DS . 'jbjobs' . DS . 'pf', '0777');
						if(file_exists(JPATH_SITE . DS . 'images' . DS . 'index.html')){
							copy(JPATH_SITE . DS . 'images' . DS . 'index.html', JPATH_SITE . DS . 'images' . DS . 'jbjobs/pf/index.html');
						}
					}
				}
				$doc = explode(".",$file['name']);					
				$new_doc = "p_".$user->id."_".strtotime("now").".".$doc[count($doc)-1];
				$dest = JPATH_SITE.DS.'images'.DS.'jbjobs'.DS.'pf'.DS.$new_doc;
				$soure = $file['tmp_name'];
				// Move uploaded file
				$uploaded = JFile::upload($soure,$dest);
				if($old_doc !="" || !empty($old_doc))
				{
					$old_doc_file = explode("/",$old_doc);				
					$delete =JPATH_SITE.DS.'images'.DS.'jbjobs'.DS.'pf'.DS.$old_doc_file[count($old_doc_file)-1];
					unlink($delete);
				}
				$row->file_resume = JURI::base().'images/jbjobs/pf/'.$new_doc;
			}
		}
		if($file['size'] > 0 && $type_resume =='f'){
			$row->type ='f';
			$row->resume ='';
		}
		elseif($file['size'] == 0 && $type_resume =='f'){
			$row->type ='f';
			$row->resume ='';
		}
		else {
			$row->type ='c';
			$old_doc = $row->file_resume;
			if($old_doc !="" || !empty($old_doc)){
				$old_doc_file = explode("/",$old_doc);				
				$delete =JPATH_SITE.DS.'images'.DS.'jbjobs'.DS.'pf'.DS.$old_doc_file[count($old_doc_file)-1];
				unlink($delete);
			}
			$row->file_resume = '';
			$row->resume = $resume;
		}
		// pre-save checks
		if (!$row->check()){
			JError::raiseError(500, $row->getError() );
		}
		// save the changes
		if (!$row->store()){
			JError::raiseError(500, $row->getError() );
		}
		$row->checkin();
		$link	= JRoute::_('index.php?option=com_jbjobs&view=jobseeker&layout=editresume&Itemid='.$Itemid, false);
		$msg = JText::_('JBJOBS_RESUME_SAVED_SUCCESS');
		$this->setRedirect($link, $msg);
	}
	
	//4.Remove Resume
	function removeResume(){
		$user	=& JFactory::getUser();	
		$post   = JRequest::get('post');
		$id 	= JRequest::getVar('id', 0, 'get', 'int');
		$db		=& JFactory::getDBO();
		
		$query = "DELETE FROM #__jbjobs_resume where id =".$db->quote($id) ;
		$db->setQuery($query);
		if (!$db->query()){
			jbJobsMsgAlert('".$db->getErrorMsg()."');
		}
		$link	= JRoute::_('index.php?option=com_jbjobs&view=jobseeker&layout=editresume', false);
		$msg = JText::_('JBJOBS_RESUME_DEL_SUCCESS');
		$this->setRedirect($link, $msg);
	}

	//5.Save Cover Letter
	function saveCoverletter(){
		// Check for request forgeries
		JRequest::checkToken() or jexit('Invalid Token');
		
		$user	=& JFactory::getUser();
		$model = $this->getModel();
		
		if($model->isJobSeeker($user->id) == 0){
			$return	= JRoute::_('index.php?option=com_jbjobs&view=jobseeker&layout=regjobseeker');
			$this->setRedirect($return);
			return;
		}
		
		// Initialize variables
		$Itemid = JRequest::getInt('Itemid');
		$db		=& JFactory::getDBO();
		$row	=& JTable::getInstance('coverletter', 'Table');
		$post   = JRequest::get('post');
		$id 	 = (!empty($post['id'])) ? (int) $post['id'] : 0;	
		$title = (!empty($post['title'])) ?  $post['title'] : '';	
		$description = JRequest::getVar('description', '', 'post', 'string', JREQUEST_ALLOWRAW);
		$is_active 	 = (!empty($post['is_active'])) ?  $post['is_active'] : 0;
		
		if($is_active){
			$query = "UPDATE #__jbjobs_coverletter SET is_active=0 WHERE jseeker_id =".$db->quote($user->id);	
			$db->setQuery( $query );
			if (!$db->query()){
				$this->jbJobsMsgAlert('".$db->getErrorMsg()."');
			}
		}
		//count coverletters 
		$query = "SELECT COUNT(*) FROM #__jbjobs_coverletter WHERE jseeker_id =".$db->quote($user->id);
		$db->setQuery($query);
		$total = $db->loadResult();
		
		if($total >= 2 && $id == 0){
			$this->jbJobsMsgAlert(JText::sprintf('JBJOBS_MAXIMUM_COVER', 2));
			exit;
		}
		
		if($id > 0){
			$row->load($id);
		}
		
		$row->jseeker_id  = $user->id;
		
		if (!$row->bind( $post )) {
			JError::raiseError(500, $row->getError() );
		}
		// pre-save checks
		if (!$row->check()){
			JError::raiseError(500, $row->getError() );
		}
		// save the changes
		if (!$row->store()){
			JError::raiseError(500, $row->getError() );
		}
		$row->checkin();
		
		$link	= JRoute::_('index.php?option=com_jbjobs&view=jobseeker&layout=editcoverletter&Itemid='.$Itemid, false);
		$msg = JText::_('JBJOBS_COVER_SAVED_SUCCESS');
		$this->setRedirect($link, $msg);
	}

	//6.Remove Cover Letter
	function removeCoverletter(){
		$user	=& JFactory::getUser();	
		$post   = JRequest::get('post');
		$id 	= JRequest::getVar('id', 0, 'get', 'int');
		$db		=& JFactory::getDBO();
		
		$query = "DELETE FROM #__jbjobs_coverletter WHERE id =".$db->quote($id) ;
		$db->setQuery( $query );
		if (!$db->query()){
			jbJobsMsgAlert('".$db->getErrorMsg()."');
		}
		$msg = JText::_('JBJOBS_COVER_DEL_SUCCESS');
		$link = JRoute::_('index.php?option=com_jbjobs&view=jobseeker&layout=editcoverletter', false);	
		$this->setRedirect($link, $msg);
	}
	
	//7.Apply and Save job by Jobseeker
	function applyJobByJS(){
		$app 	=& JFactory::getApplication();
		$user	=& JFactory::getUser();
		$model 	= $this->getModel();
		$db		=& JFactory::getDBO();
		$Itemid = JRequest::getInt('Itemid');
		
		$post    = JRequest::get('post');
		$id_job  = $post['id_job'];
		$return  = $post['return'];
		$isApply = $post['isapply'];
		
		$plan = $model->whichPlan($user->id);
		
		$job =& JTable::getInstance('job', 'Table');
		$job->load($id_job);
		
		//get the credit to debit based on type of job (featured / not)
		if($job->is_featured){
			$credit_applyjob = $plan->credit_featuredapplyjob;
			$transDetail = JText::_('JBJOBS_FEATURED_JOB_APPLY').' - '.$job->job_title.' - '.JText::_('JBJOBS_JOBID').':'.$id_job;
		}
		else {
			$credit_applyjob = $plan->credit_applyjob;
			$transDetail = JText::_('JBJOBS_APPLY_JOB').' - '.$job->job_title.' - '.JText::_('JBJOBS_JOBID').':'.$id_job;
		}
			
		if($user->id == 0){
			$return	= JRoute::_('index.php?option=com_user&view=login', false);
			$this->setRedirect($return);
			return;	
		}
		
		if($model->isJobSeeker($user->id) == 0){
			$return	= JRoute::_('index.php?option=com_jbjobs&view=jobseeker&layout=regjobseeker', false);
			$this->setRedirect($return);
			return;	
		}	
		
		$row =& JTable::getInstance('saveJob', 'Table');
		
		$chkSavApp = $model->checkSavedApplied($id_job, $user->id);
				
		if($chkSavApp['is_saved'] == 1){
			//Find the id if he has already saved but not applied to the job
			$query = "SELECT id FROM #__jbjobs_save_job WHERE id_job = ".$db->quote($id_job).				 
				 	 " AND jseeker_id =".$user->id;
			$db->setQuery($query);
			$cek_id = $db->loadResult();	
			$row->id = $cek_id;			
		}
		
		if($isApply == 'true'){
			if($chkSavApp['is_applied'] == 1){
				$this->jbJobsMsgAlert(JText::_('JBJOBS_THIS_JOB_HAS_BEEN_APPLIED'));
				exit;
			}
			$row->is_apply = 'y';
			if(!JBJOBS_FREE_MODE_JS){
				//update the transaction table
				$this->updateTransaction($user->id, $transDetail, $credit_applyjob, -1);
			}
		}
		else {
			$query = "SELECT COUNT(*) FROM #__jbjobs_save_job".
			         " WHERE is_view='y' AND id_job= ".$db->quote($id_job).
					 " AND jseeker_id =".$db->quote($user->id);
			$db->setQuery($query);
			$cek_save_view = $db->loadResult();
			
			if($cek_save_view == 1){
				$this->jbJobsMsgAlert(JText::_('JBJOBS_THIS_JOB_HAS_BEEN_SAVED'));
				exit;
			}
		}
		
		$row->id_job = $id_job;
		$row->jseeker_id = $user->id;
		$row->is_view = 'y';
		// pre-save checks
		if (!$row->check()) {
			JError::raiseError(500, $row->getError());
		}	
		// save the changes
		if (!$row->store()) {
			JError::raiseError(500, $row->getError());
		}
		$row->checkin();
		
		if($row->is_apply == 'y'){
			$siteURL = JURI::base();
			$sitename = $app->getCfg('sitename');
			$mailfrom = $app->getCfg('mailfrom');
			$fromname = $app->getCfg('fromname');
			
			$attachResume = true;
			
			if($attachResume){
				$id_resume 	 = $model->getActiveResume($user->id);
				$resume =& JTable::getInstance('resume', 'Table');
				$resume->load($id_resume);
				if($resume->type == 'f')
					$attachment = $resume->file_resume;
				else
					$attachment = JText::_('JBJOBS_NONE');
				}
			else
				$attachment = JText::_('JBJOBS_NONE');
		
			$query = "SELECT * FROM #__jbjobs_job WHERE id=".$db->quote($id_job);
			$db->setQuery($query);
			$job = $db->loadObject();
			$jobDetail = $siteURL.'index.php?option=com_jbjobs&view=guest&layout=detailjob&id='.$id_job;
			$jobApplicant = $siteURL.'index.php?option=com_jbjobs&view=employer&layout=detailjobseeker&id='.$user->id;
			
			$jobTitle = "<a href=$jobDetail>$job->job_title</a>";
			$applicantName = "<a href=$jobApplicant>$user->name</a>";
	
			$tags = array("[SITENAME]", "[JOBTITLE]", "[APPLICANTNAME]", "[ATTACHMENT]", "[SITEURL]", "[USERNAME]");
			$tagsValues = array("$sitename", "$jobTitle", "$applicantName", "$attachment", "$siteURL", "$user->username");
			
			//get the email templateS
			$template = $model->getTemplate('jobseeker-applyjob');
			
			//get subject
			$subject = $template->subject;
			$subject = str_replace($tags, $tagsValues, $subject);
			$subject = html_entity_decode($subject, ENT_QUOTES);
			
			//get message body
			$message = $template->body;
			$message = str_replace($tags, $tagsValues, $message);
			$message = html_entity_decode($message, ENT_QUOTES);
			
		 	$query = "SELECT u.email,u.id FROM #__users u 
					  INNER JOIN #__jbjobs_job j ON u.id=j.employer_id 
					  WHERE j.id=".$db->quote($id_job);
		 	$db->setQuery($query);
		 	$mail = $db->loadObject();
			
			JUtility::sendMail($mailfrom, $fromname, $mail->email, $subject, $message , 1);
			
			//Trigger the plugin event to stream the jobseeker applied for job onto JomSocial Activity stream / wall
			JPluginHelper::importPlugin('community');
			JPluginHelper::importPlugin('system', 'jbfeeds');
			$dispatcher =& JDispatcher::getInstance();
			
			$userid   = $user->id;
			$targetid = $mail->id;
			$jobtitle = $job->job_title;
			$link_job = JRoute::_('index.php?option=com_jbjobs&view=guest&layout=detailjob&id='.$id_job);
			$args 	  = array($userid, $targetid, $jobtitle, $link_job);
			
			$dispatcher->trigger('onApplyJob', $args);
			$dispatcher->trigger('onJobseekerApplyJob', array($userid, $targetid, $id_job));
		}
		if($isApply == 'true')
			$msg	= JText::_('JBJOBS_JOB_APPLIED_SUCCESSFULLY');
		else
			$msg	= JText::_('JBJOBS_JOB_SAVED_SUCCESSFULLY');
		$link	= JRoute::_('index.php?option=com_jbjobs&view=jobseeker&layout=mysavedjob&Itemid='.$Itemid, false);	
		$this->setRedirect($link, $msg);
	}
	
	//7a.Apply job by guests / anonumously
	function applyJobAnonymous(){
		// Check for request forgeries
		JRequest::checkToken() or jexit('Invalid Token');
		
		$app 	=& JFactory::getApplication();
		$user	=& JFactory::getUser();
		$model 	= $this->getModel();
		$db		=& JFactory::getDBO();
		$Itemid = JRequest::getInt('Itemid');
		
		$post    = JRequest::get('post');
		$id_job  = $post['id_job'];
		
		$config =& JTable::getInstance('config', 'Table');
		$config->load(1);
		$anonJobapply = $config->anonymous_jobapply;
		
		$plan = $model->whichPlan($user->id);
		
		$job =& JTable::getInstance('job', 'Table');
		$job->load($id_job);
		
		if(!$anonJobapply){	// go thorough this condition if anonymous job apply is not allowed.
			if($user->id == 0){
				$return	= JRoute::_('index.php?option=com_user&view=login', false);
				$this->setRedirect($return);
				return;	
			}
		}
		
		$row =& JTable::getInstance('saveJob', 'Table');
		
		//Check the id if he has already applied to the job with the same email.
		$query = "SELECT id FROM #__jbjobs_save_job WHERE id_job = ".$db->quote($id_job).				 
			 	 " AND contact_email =".$db->quote($post['contact_email']);
		$db->setQuery($query);
		$chk_id = $db->loadResult();
		if($chk_id){
			$this->jbJobsMsgAlert(JText::_('JBJOBS_YOU_HAVE_ALREADY_APPLIED_TO_THE_JOB'));	
		}
		
		//UPLOAD FILE
		jimport('joomla.filesystem.file');
		$file = $_FILES['resume_link'];	
		$type = $config->get('cvfiletype');
		//$type ='bmp,csv,doc,gif,ico,jpg,jpeg,odg,odp,ods,odt,pdf,png,ppt,swf,txt,xcf,xls,BMP,CSV,DOC,GIF,ICO,JPG,JPEG,ODG,ODP,ODS,ODT,PDF,PNG,PPT,SWF,TXT,XCF,XLS';
		$allowed = explode(',', $type);
		
		if($file['size'] > 0){
			if($file['error'] != 0){
				$this->jbJobsMsgAlert(JText::_('JBJOBS_UPLOAD_FILE_ERROR'));
				exit;
			}
			if($file['size'] == 0){
				$file = null;
			}
			
			$format = $file['type'];
			if(!preg_match('/(.*)\.(zip|docx)/', $file['name'])){
				if(!in_array($format, $allowed)){	
					$this->jbJobsMsgAlert(JText::_('JBJOBS_YOUR_FILE_IS_IGNORED'));
					exit;
					$file = null;
				}
			}
			if ($file != null){
				if(!file_exists(JPATH_SITE.DS.'images'.DS.'jbjobs'.DS.'pf')){
					if(mkdir(JPATH_SITE.DS.'images'.DS.'jbjobs'.DS.'pf')){
						JPath::setPermissions(JPATH_SITE.DS.'images'.DS.'jbjobs'.DS.'pf', '0777');
						if(file_exists(JPATH_SITE.DS.'images'.DS.'index.html')){
							copy(JPATH_SITE.DS.'images'.DS.'index.html', JPATH_SITE.DS.'images'.DS.'jbjobs/pf/index.html');
						}
					}
				}
				$doc = explode(".", $file['name']);					
				$new_doc = "p_".$user->id."_".strtotime("now").".".$doc[count($doc)-1];
				$dest = JPATH_SITE.DS.'images'.DS.'jbjobs'.DS.'pf'.DS.$new_doc;
				$soure = $file['tmp_name'];
				// Move uploaded file
				$uploaded = JFile::upload($soure, $dest);
				
				$row->resume_link = JURI::base().'images/jbjobs/pf/'.$new_doc;
			}
		}
		
		$row->id_job = $id_job;
		$row->jseeker_id = 0;
		$row->is_view = 'y';
		$row->is_apply = 'y';
		if(!$row->bind($post)){
			JError::raiseError(500, $row->getError());
		}
		// pre-save checks
		if(!$row->check()){
			JError::raiseError(500, $row->getError());
		}	
		// save the changes
		if(!$row->store()){
			JError::raiseError(500, $row->getError());
		}
		$row->checkin();
		
		//send an email to the employer
		$siteURL = JURI::base();
		$sitename = $app->getCfg('sitename');
		$mailfrom = $app->getCfg('mailfrom');
		$fromname = $app->getCfg('fromname');
		
		$jobDetail = $siteURL.'index.php?option=com_jbjobs&view=guest&layout=detailjob&id='.$id_job;
		$jobTitle = "<a href=$jobDetail>$job->job_title</a>";
		$contactName = $post['contact_name'];
		$contactEmail = $post['contact_email'];
		$contactNo = $post['contact_no'];

		$tags = array("[SITENAME]", "[JOBTITLE]", "[NAME]", "[EMAIL]", "[SITEURL]", "[CONTACTNO]");
		$tagsValues = array("$sitename", "$jobTitle", "$contactName", "$contactEmail", "$siteURL", "$contactNo");
		
		//get the email templateS
		$template = $model->getTemplate('jobseeker-anms-applyjob');
		
		//get subject
		$subject = $template->subject;
		$subject = str_replace($tags, $tagsValues, $subject);
		$subject = html_entity_decode($subject, ENT_QUOTES);
		
		//get message body
		$message = $template->body;
		$message = str_replace($tags, $tagsValues, $message);
		$message = html_entity_decode($message, ENT_QUOTES);
		
	 	$query = "SELECT u.email,u.id FROM #__users u 
				  INNER JOIN #__jbjobs_job j ON u.id=j.employer_id 
				  WHERE j.id=".$db->quote($id_job);
	 	$db->setQuery($query);
	 	$mail = $db->loadObject();
		
		JUtility::sendMail($mailfrom, $fromname, $mail->email, $subject, $message , 1);
		
		$msg	= JText::_('JBJOBS_JOB_APPLIED_SUCCESSFULLY');
		$link	= JRoute::_('index.php?option=com_jbjobs&view=guest&layout=detailjob&id='.$id_job.'&Itemid='.$Itemid, false);	
		$this->setRedirect($link, $msg);
	}
	
	//3.Save Resume
	function uploadFile(){
		// Check for request forgeries
		JRequest::checkToken() or jexit('Invalid Token');
		
		$user	=& JFactory::getUser();
		$model = $this->getModel();
		
		if($model->isJobSeeker($user->id) == 0){
			$return	= JRoute::_('index.php?option=com_jbjobs&view=jobseeker&layout=regjobseeker');
			$this->setRedirect($return);
			return;
		}
		
		// Initialize variables
		$Itemid = JRequest::getInt('Itemid');
		$db		=& JFactory::getDBO();
		$row	=& JTable::getInstance('savejob', 'Table');
		$post   = JRequest::get('post');
		
		//UPLOAD FILE
		jimport('joomla.filesystem.file');
		$file = $_FILES['resume_link'];	
		$config =& JTable::getInstance('config', 'Table');
		$config->load(1);
		$type = $config->get('cvfiletype');
		//$type ='bmp,csv,doc,gif,ico,jpg,jpeg,odg,odp,ods,odt,pdf,png,ppt,swf,txt,xcf,xls,BMP,CSV,DOC,GIF,ICO,JPG,JPEG,ODG,ODP,ODS,ODT,PDF,PNG,PPT,SWF,TXT,XCF,XLS';
		$allowed = explode(',', $type);
		
		if($file['size'] > 0){
			if($file['error'] != 0){
				$this->jbJobsMsgAlert(JText::_('JBJOBS_UPLOAD_FILE_ERROR'));
				exit;
			}
			if($file['size'] == 0){
				$file = null;
			}
			
			$format = $file['type'];
			if(!preg_match('/(.*)\.(zip|docx)/', $file['name'])){
				if(!in_array($format, $allowed)){	
					$this->jbJobsMsgAlert(JText::_('JBJOBS_YOUR_FILE_IS_IGNORED'));
					exit;
					$file = null;
				}
			}
			if ($file != null){
				if(!file_exists(JPATH_SITE.DS.'images'.DS.'jbjobs'.DS.'pf')){
					if(mkdir(JPATH_SITE.DS.'images'.DS.'jbjobs'.DS.'pf')){
						JPath::setPermissions(JPATH_SITE.DS.'images'.DS.'jbjobs'.DS.'pf', '0777');
						if(file_exists(JPATH_SITE.DS.'images'.DS.'index.html')){
							copy(JPATH_SITE.DS.'images'.DS.'index.html', JPATH_SITE.DS.'images'.DS.'jbjobs/pf/index.html');
						}
					}
				}
				$doc = explode(".", $file['name']);					
				$new_doc = "p_".$user->id."_".strtotime("now").".".$doc[count($doc)-1];
				$dest = JPATH_SITE.DS.'images'.DS.'jbjobs'.DS.'pf'.DS.$new_doc;
				$soure = $file['tmp_name'];
				// Move uploaded file
				$uploaded = JFile::upload($soure, $dest);
				
				$row->file_resume = JURI::base().'images/jbjobs/pf/'.$new_doc;
			}
		}
		// pre-save checks
		if (!$row->check()){
			JError::raiseError(500, $row->getError() );
		}
		// save the changes
		if (!$row->store()){
			JError::raiseError(500, $row->getError() );
		}
		$row->checkin();
		$link	= JRoute::_('index.php?option=com_jbjobs&view=jobseeker&layout=editresume&Itemid='.$Itemid, false);
		$msg = JText::_('JBJOBS_RESUME_SAVED_SUCCESS');
		$this->setRedirect($link, $msg);
	}
	
	//8.Delete Saved Job
	function deleteSaveJob(){
		$user	=& JFactory::getUser();
		$db =& JFactory::getDBO();
		$post = JRequest::get('post');
		$id_job = (!empty($post['id_job'])) ? $post['id_job'] : null;
		if($id_job)
		{
			$query = "UPDATE #__jbjobs_save_job SET is_view ='n' ".
					 " WHERE id_job =".$db->quote( $id_job )." and jseeker_id =".$db->quote( $user->id );
			$db->setQuery( $query );
			if (!$db->query())
			{
				$this->jbJobsMsgAlert('".$db->getErrorMsg()."');
			}
		}
		$link = JRoute::_('index.php?option=com_jbjobs&view=jobseeker&layout=mysavedjob', false);	
		$this->setRedirect($link);
	}
	
	//9.Delete All Saved Job
	function deleteAllSaveJob(){
		$user	=& JFactory::getUser();
		$db		=& JFactory::getDBO();
		$post   = JRequest::get('post');
		$id_job = $post['id_job'];
		$query = "UPDATE #__jbjobs_save_job SET is_view ='n' ".
				 " WHERE jseeker_id =".$db->quote( $user->id );
		$db->setQuery( $query );
		if (!$db->query()){
			$this->JobsMsgAlert('".$db->getErrorMsg()."');
		}
		$link = JRoute::_('index.php?option=com_jbjobs&view=jobseeker&layout=mysavedjob', false);	
		$this->setRedirect($link);
	}
	
	//saveAlert
	function saveJobalert(){
		
		// Initialize variables
		$db		=& JFactory::getDBO();
		$user 	= JFactory::getUser();
		if($user->id == 0){
			$return	= JRoute::_('index.php?option=com_user&view=login');
			$this->setRedirect($return);	
		}
		
		$id		= (!empty($post['id'])) ? (int)$post['id'] : 0;
		$row	=& JTable::getInstance('jobalert', 'Table');
		$post   = JRequest::get( 'post' );
		$id_js 	= (!empty($post['id_js'])) ? $post['id_js'] : JRequest::getVar('id_js','', 'get', 'string');
		
		$row->userid = $user->id;
		
		if(count($id_js) > 0 && !(count($id_js) == 1 && empty($id_js[0]))){
			$job_spec = implode(',', $id_js );
		}
		elseif($id_js[0] == 0){
			$job_spec = 0;
		}
		
		$row->id_job_spec = $job_spec;
		
		if (!$row->bind($post)) {
			JError::raiseError(500, $row->getError() );
		}
		// pre-save checks
		if (!$row->check()) {
			JError::raiseError(500, $row->getError() );
		}
		// if new item,  last in appropriate group
		if (!$row->id) {
			$where = "id = " . (int) $row->id;	
		}
		// save the changes
		if (!$row->store()) {
			JError::raiseError(500, $row->getError() );
		}
		$row->checkin();
		
		$msg	= JText::_('Job Alert saved' );
		$link	= JRoute::_('index.php?option=com_jbjobs&view=jobseeker&layout=jobalert', false);
		$this->setRedirect($link, $msg);
	}

/**	
==================================================================================================================	
	SECTION : Employer
	1.Save New Employer
	2.Save Employer Profile
	3.Save Job
	4.Copy Job
	5.Remove Job
	6.Save Publish Job
	7.Save Buy Credit
	8.Paypal Payment
	9.Return Paypal
	10.Upgrade Subscription
	11.Add Subscription
	12.Cancel Subscription
	13.Set Credit to Zero
	14.Paypal Subscription
	15.Return Paypal Subscription
	
==================================================================================================================
*/
	//1.Save new Employer
	function saveEmployerNew(){
		$app =& JFactory::getApplication();
	
		// Check for request forgeries
		JRequest::checkToken() or jexit('Invalid Token');
		
		$user =& JFactory::getUser();
		$post = JRequest::get('post');
		$post['name'] = (!empty($post['firstname'])) ? $post['firstname'] : null;
		$post['name'] .= (!empty($post['name']) && !empty($post['lastname'])) ? ' ' . $post['lastname'] : null;
		
		// Get required system objects
		$usern = clone(JFactory::getUser());
		$pathway =& $app->getPathway();
		$config =& JFactory::getConfig();
		$authorize =& JFactory::getACL();
		$document =& JFactory::getDocument();
		
		$lang =& JFactory::getLanguage();
	 	$lang->load('com_user', JPATH_SITE);
	
		// If user registration is not allowed, show 403 not authorized.
		$usersConfig = &JComponentHelper::getParams('com_users');
		if ($usersConfig->get('allowUserRegistration') == '0') {
			JError::raiseError( 403, JText::_('JBJOBS_ACCESS_FORBIDDEN'));
			return;
		}
		
		// Initialize new usertype setting
		$newUsertype = $usersConfig->get('new_usertype');
		if (!$newUsertype) {
			$newUsertype = 'Registered';
		}
		
		// Bind the post array to the user object
		if (!$usern->bind( $post, 'usertype')) {
			JError::raiseError( 500, $usern->getError());
		}
		
		// Set some initial user values
		$usern->set('id', 0);
		$usern->set('usertype', $newUsertype);
		$usern->set('gid', $authorize->get_group_id('', $newUsertype, 'ARO'));
		$date =& JFactory::getDate();
		$usern->set('registerDate', $date->toMySQL());
		
		// If user activation is turned on, we need to set the activation information
		$useractivation = $usersConfig->get('useractivation');
		if ($useractivation == '1'){
			jimport('joomla.user.helper');
			$usern->set('activation', JUtility::getHash( JUserHelper::genRandomPassword()) );
			$usern->set('block', '1');
		}
	
		// If there was an error with registration, set the message and display form
		if (!$usern->save()){
			$msg = JText::_( $usern->getError());
			$link = JRoute::_('index.php?option=com_jbjobs&view=employer&layout=regemployernew');	
			$this->setRedirect($link, $msg);
			return false;
		}
		
		$userid = $usern->id;
		
		// Check for request forgeries
		JRequest::checkToken() or jexit('Invalid Token');
		
		// Initialize variables
		$db		=& JFactory::getDBO();
		$row	=& JTable::getInstance('employer', 'Table');
		$post   = JRequest::get('post');
		$id 	= (!empty($post['id'])) ? (int)$post['id'] : 0;
			
		$row->user_id = $userid;
		
		if (!$row->bind($post)) {
			JError::raiseError(500, $row->getError() );
		}
		// pre-save checks
		if (!$row->check()) {
			JError::raiseError(500, $row->getError() );
		}
		// if new item,  last in appropriate group
		if (!$row->id) {
			$where = "id = " . $db->quote( (int) $row->id );		
		}
		// save the changes
		if (!$row->store()) {
			JError::raiseError(500, $row->getError() );
		}
		$row->checkin();
		
		$this->insertCustomField('employer', $row->user_id, $post);	
		
		// Send registration confirmation mail
		$password = JRequest::getString('password', '', 'post', JREQUEST_ALLOWRAW);
		$password = preg_replace('/[\x00-\x1F\x7F]/', '', $password); //Disallow control chars in the email
		$this->JBJobSendMail($usern, $password);
		
		if($useractivation){
			$msg = JText::_( 'JBJOBS_ACCOUNT_HAS_BEEN_CREATED_NEED_ACTIVATION' );
		}
		else {
			$msg = JText::_( 'JBJOBS_ACCOUNT_HAS_BEEN_CREATED_PLEASE_LOGIN' );
		}
		
		if(!JBJOBS_FREE_MODE){
			//add employer to the subscription Table
			$this->addSubscription($userid);
			$subscrid = JRequest::getVar('returnrowid', 0, 'post', 'int');//this returnid is the subscr id from plan_subscr table
			$session =& JFactory::getSession();
			$session->set('id', $subscrid, 'upgsubscr');
			
			if($post['gateway'] == '.banktransfer'){
				//send alert to admin and user
				$this->alertAdminSubscr($subscrid, $userid);
				$this->alertUserSubscr($subscrid, $userid);
			}
			
			$link = JRoute::_('index.php?option=com_jbjobs&view=membership&layout=check_out');
		}
		else {
			$link = JRoute::_('index.php?option=com_jbjobs');
		}
		$this->setRedirect($link, $msg);
	}
	
	//2.Save Employer Profile
	function saveEmployer(){
		
		// Check for request forgeries
		JRequest::checkToken() or jexit('Invalid Token');
		
		// Initialize variables
		$user	=& JFactory::getUser();
		$db		=& JFactory::getDBO();
		$row	=& JTable::getInstance('employer', 'Table');
		$Itemid = JRequest::getInt('Itemid');
		
		$post   = JRequest::get('post');
		$post['name'] = (!empty($post['firstname'])) ? $post['firstname'] : null;
		$post['name'] .= (!empty($post['name']) && !empty($post['lastname'])) ? ' ' . $post['lastname'] : null;
		
		$id = (!empty($post['id'])) ? (int)$post['id'] : 0;
		if(!empty($id) && !empty($post['name'])){
			$query = "UPDATE #__users SET name='".$post['name']."' WHERE id='".$user->id."'";
			$db->setQuery($query);
			$db->query();
		}
	
		$row->user_id = $user->id;
		
		if(!$row->bind($post)){
			JError::raiseError(500, $row->getError() );
		}
		// pre-save checks
		if(!$row->check()){
			JError::raiseError(500, $row->getError() );
		}
		// if new item,  last in appropriate group
		if(!$row->id){
			$where = "id = " . $db->quote( (int) $row->id );		
		}
		// save the changes
		if(!$row->store()){
			JError::raiseError(500, $row->getError() );
		}
		$row->checkin();
		
		$this->insertCustomField('employer', $row->user_id, $post);	
		
		/*if(!empty($_FILES['photo'])){
			$this->jbjobsUploadPhoto($_FILES['photo'], $row->user_id);
		}
		//remove the photo if chosen to remove
		if($post['removephoto']){
			$dest = JPATH_SITE.DS.'images'.DS.'jbjobs'.DS.$row->user_id.'.jpg';
			if(file_exists($dest)){
					$del = unlink($dest);
			}
		}*/
		//update the privacy post settings to the feed table.
		$query = "UPDATE #__jbjobs_feed f SET f.access=".$post['show_post']." WHERE f.actor=".$db->quote($user->id);
		$db->setQuery($query);
		$db->query();
		
		//Trigger the plugin event to fedd the employer profile update to JoomBah Feed
		JPluginHelper::importPlugin('system');
		$dispatcher =& JDispatcher::getInstance();
		$dispatcher->trigger('onEmployerUpdateProfile', array($user->id));
		
		$link	= JRoute::_('index.php?option=com_jbjobs&view=employer&layout=dashboard&Itemid='.$Itemid, false);	
		$msg = JText::_( 'JBJOBS_PROFILE_SAVED_SUCCESSFULLY' );
		$this->setRedirect($link, $msg);
	}
	
	//3.Save Job
	function saveJob(){
		// Check for request forgeries
		JRequest::checkToken() or jexit('Invalid Token');
		
		// Initialize variables
		$user 	=& JFactory::getUser();
		$Itemid =  JRequest::getInt('Itemid');
		$db		=& JFactory::getDBO();
		$row	=& JTable::getInstance('job', 'Table');
		$post   = JRequest::get('post');
		
		$post['short_desc']  = JRequest::getVar('short_desc', '', 'post', 'string', JREQUEST_ALLOWRAW);
		$post['long_desc']   = JRequest::getVar('long_desc', '', 'post', 'string', JREQUEST_ALLOWRAW);
		$post['employer_id'] = $user->id;
		
		if (!$row->bind($post)) {
			JError::raiseError(500, $row->getError() );
		}
		// pre-save checks
		if (!$row->check()) {
			JError::raiseError(500, $row->getError() );
		}
		// save the changes
		if (!$row->store()) {
			JError::raiseError(500, $row->getError() );
		}
		$this->insertCustomField('job', $row->id, $post);	
	
		$row->checkin();	
		$msg	= JText::_('JBJOBS_JOB_SAVED');
		$return	= JRoute::_('index.php?option=com_jbjobs&view=employer&layout=showmyjobs&Itemid='.$Itemid, false);
		$this->setRedirect($return, $msg);
	}
	
	//4.Copy Job
	function copyJob(){
		$model = $this->getModel();
		$user	=& JFactory::getUser();
		$id = JRequest::getVar('id', 0, 'get', 'int');
		
		if(!$user->id OR (!$model->isEmployer($user->id)) OR !$id){
			$return	= JRoute::_('index.php?option=com_jbjobs');
			$this->setRedirect($return);	
			return;
		}
		
		$db 	= & JFactory::getDBO();	
		$job	=& JTable::getInstance('job', 'Table');
		
		if ($job->load($id)){
			$job->id = 0;
			$job->job_title	= JText::_('JBJOBS_COPY_OF').' '.$job->job_title;
			$job->publish_date = null;
			$job->expire_date = null;
			$job->hotjob_expire = null;
			
			if (!$job->store()) {
				return JError::raiseWarning($job->getError());
			}
		}
		else {
			return JError::raiseWarning(500, $job->getError());
		}
		
		$msg = JText::_('JBJOBS_JOB_COPIED_SUCCESS');
		$link = JRoute::_('index.php?option=com_jbjobs&view=employer&layout=showmyjobs', false);
		$this->setRedirect($link, $msg);
	}
	
	//5.Remove Job
	function removeJob(){
		$user =& JFactory::getUser();
		$model = $this->getModel();
		$id   = JRequest::getVar('id', 0, 'get', 'string');
		
		if(!$user->id OR (!$model->isEmployer($user->id)) OR !$id){
			$return	= JRoute::_('index.php?option=com_jbjobs');
			$this->setRedirect($return);	
			return;
		}
	
		$db 	= & JFactory::getDBO();	
		
		$query = "SELECT COUNT(*) FROM #__jbjobs_job WHERE id='$id' AND employer_id='$user->id'";
		$db->setQuery($query);
		if($db->loadResult() > 0){
			$queries = array();
			$queries[] = "DELETE FROM #__jbjobs_job WHERE id='$id' AND employer_id='$user->id'";
			$queries[] = "DELETE FROM #__jbjobs_save_job WHERE id_job='".$id."'";
			foreach($queries as $query){
				$db->setQuery($query);
				$db->query();
			}
		}
		$msg 	= JText::_('JBJOBS_JOB_DELETED_SUCCESS');
		$return	= JRoute::_('index.php?option=com_jbjobs&view=employer&layout=showmyjobs', false);
		$this->setRedirect($return, $msg);	
		return;
	}
	
	//6.Save Publish Job
	function savePublishJob(){
		// Check for request forgeries
		JRequest::checkToken() or jexit('Invalid Token');
		
		// Initialize variables
		$app 	=& JFactory::getApplication();
		$Itemid =  JRequest::getInt('Itemid');
		$user 	= JFactory::getUser();
		$db		=& JFactory::getDBO();
		$model 	= $this->getModel();
		$plan 	= $model->whichPlan($user->id);
		$creditperjob = $plan->creditperjob;
		$creditperfeatured = $plan->creditperfeatured;
		
		$post   	= JRequest::get('post');
		$id_job 	= (int)$post['id'];
		$startDate 	= $post['startdate'];
		$endDate 	= $post['enddate'];
		
		$job =& JTable::getInstance('job', 'Table');
		$job->load($id_job);
		
		if($job->is_featured)
			$totalcredit = $creditperfeatured;
		else	
			$totalcredit = $creditperjob;
		
		// Update the transaction table
		$transDtl = JText::_('JBJOBS_JOB_POSTING').$job->job_title;
		$this->updateTransaction($job->employer_id, $transDtl, $totalcredit, -1);
		
		$job->publish_date = $startDate;
		$job->expire_date  = $endDate;
		
		// pre-save checks
		if (!$job->check()) {
			JError::raiseError(500, $job->getError() );
		}
		// save the changes	
		if (!$job->store()) {
			JError::raiseError(500, $job->getError() );
		}
		
		//Trigger the plugin event to stream the new job vacancy onto JomSocial Activity stream / wall
		JPluginHelper::importPlugin('community');
		JPluginHelper::importPlugin('system', 'jbfeeds');
		$dispatcher =& JDispatcher::getInstance();
		
		$userid   = $user->id;
		$jobtitle = $job->job_title;
		$link_job = JRoute::_('index.php?option=com_jbjobs&view=guest&layout=detailjob&id='.$id_job);
		$args 	  = array($userid, $jobtitle, $link_job);
		
		$dispatcher->trigger('onPublishJob', $args);
		$dispatcher->trigger('onEmployerPublishJob', array($userid, 0, $id_job, $job->short_desc));
		
		$msg  = JText::_('JBJOBS_JOB_PUBLISHED');
		$link = JRoute::_('index.php?option=com_jbjobs&view=employer&layout=showmyjobs&Itemid='.$Itemid, false);
		$this->setRedirect($link, $msg);
		
	}
	
	//7.Save Buy Credit
	function saveBuyCredit(){
		$app =& JFactory::getApplication();
		// Check for request forgeries
		JRequest::checkToken() or jexit('Invalid Token');
		
		// Initialize variables
		$Itemid =  JRequest::getInt('Itemid');

		$db		=& JFactory::getDBO();
		$row	=& JTable::getInstance('billing', 'Table');
		$post   = JRequest::get('post');
		
		$user	=& JFactory::getUser();
		$model = $this->getModel();
		$plan = $model->whichPlan($user->id);
		
		$config =& JTable::getInstance('config','Table');
		$config->load(1);
		$price_credit  = $plan->creditprice;
		$tax_percent  = $config->get('taxpercent');
		$invoiceFormatCredit = $config->invoiceFormatCredit;
	
		$post['credit'] = (int) $post['credit'];
		
		if (!$row->bind($post)) {
			JError::raiseError(500, $row->getError() );
		}
		// pre-save checks
		if (!$row->check()) {
			JError::raiseError(500, $row->getError() );
		}
		$now = date('Y-m-d H:i:s', time() + ($app->getCfg('offset') * 60 * 60 ));
		$row->user_id 	= $user->id;
		$row->date_buy  = $now;
		$row->amount 	= (int)$post['credit'] * $price_credit;
		$row->tax_percent = $tax_percent;
		
		// save the changes
		if (!$row->store()) {
			JError::raiseError(500, $row->getError() );
		}
		
		$year = date("Y");
		$time = time();
		//replace the tags
		$tags = array("[ID]", "[USERID]", "[YYYY]", "[TIME]");
		$tagsValues = array("$row->id", "$user->id", "$year", "$time");
		$invoiceNo = str_replace($tags, $tagsValues, $invoiceFormatCredit);
		$row->invoiceNo = $invoiceNo;
		
		// save the changes after updating the invoice no
		if (!$row->store()) {
			JError::raiseError(500, $row->getError() );
		}
		$row->checkin();
		
		if($row->gateway == '.banktransfer'){
	    	$this->JBJobSendMailManualTransfer($row->id);
			$link	= JRoute::_('index.php?option=com_jbjobs&view=membership&layout=manual_payment&id='.$row->id.'&Itemid='.$Itemid, false);
		}
		else {
			$link = JRoute::_('index.php?option=com_jbjobs&view=membership&layout=credit_checkout&id='.$row->id.'&Itemid='.$Itemid, false);
		}	
	
		$this->setRedirect($link, $msg);
	}
	
	//10.Upgrade Subscription
	function upgradeSubscription(){
		
		//Initialize variables
		$db =& JFactory::getDBO();
		$user	=& JFactory::getUser();
		$userid = $user->id;
		$model = $this->getModel();
		$current_plan = $model->whichPlan($userid);
		$post   = JRequest::get('post');
		$Itemid =  JRequest::getInt('Itemid');
		
		$query = "SELECT MAX(id) FROM #__jbjobs_plan_subscr WHERE user_id = $userid";
		$db->setQuery($query);
		$id_max = $db->loadResult();
		
		$query = "SELECT * FROM #__jbjobs_plan_subscr WHERE id = ".$id_max;
		$db->setQuery($query);
		$last_subscr = $db->loadObject();
		
		if($id_max && $last_subscr->approved == 0){	//if he has some plan and not approved
			$msg = JText::_('JBJOBS_PENDING_SUBSCR_CANCEL_FIRST');
			$link	= JRoute::_('index.php?option=com_jbjobs&view=membership&layout=planhistory&Itemid='.$Itemid, false);
			$this->setRedirect($link, $msg);
			return false;
		}
		
		//if($last_subscr->subscription_id == 1 && $post['subscription_id'] == 1){	//if he is free plan and choosing to buy the same
		$sub_id = $post['subscription_id'];
		$price = $post['price'.$sub_id]; //price of the chosen plan
		if($id_max)
			if($last_subscr->approved==1 && $last_subscr->price <= 0 && $price <= 0){	//if the user is in free plan and choose to buy a free plan again, he will be redirected
			$msg = JText::_('JBJOBS_FREE_MEMBER_CANNOT_BUY_FREE_PLAN');
			$link	= JRoute::_('index.php?option=com_jbjobs&view=membership&layout=planadd&Itemid='.$Itemid, false);
			$this->setRedirect($link, $msg, 'error');
			return false;
		}
	
		$this->addSubscription($userid);
		$subscrid = JRequest::getVar('returnrowid', 0, 'post', 'int');	//this returnid is the subscr id from plan_subscr table
		
		$paymode = $post['gateway'];
		$session =& JFactory::getSession();
		$session->set('id', $subscrid, 'upgsubscr');
		if($paymode == '.banktransfer'){
			//send alert to admin and user
			$this->alertAdminSubscr($subscrid, $userid);
			$this->alertUserSubscr($subscrid, $userid);
		}
		
		$link = JRoute::_('index.php?option=com_jbjobs&view=membership&layout=check_out&Itemid='.$Itemid, false);
		$this->setRedirect($link, $msg);
	}
	
	//11.Add Subscription
	function addSubscription($userid){
		$user	=& JFactory::getUser();
		if($user->guest)
			$userid = $userid;
		else
			$userid = $user->id;
		
		// Initialize variables
		$app =& JFactory::getApplication();
		$db	=& JFactory::getDBO();
		$row	=& JTable::getInstance('plansubscr', 'Table');
		$post   = JRequest::get('post');
		$config =& JTable::getInstance('config', 'Table');
		$config->load(1);	
		$taxpercent 	= $config->get('taxpercent');
		$invoiceFormatPlan = $config->invoiceFormatPlan;

		if (!$row->bind($post)) {
			JError::raiseError(500, $row->getError());
		}
		// pre-save checks
		if (!$row->check()) {
			JError::raiseError(500, $row->getError());
		}
		
		$row->user_id = $userid;
		$row->approved = 0;
		
		if($post['user_type'] == 'e')
 			$planTblName = '#__jbjobs_plan';
 		elseif($post['user_type'] == 'j')
 			$planTblName = '#__jbjobs_plan_js';
		
		//calculate the price
		$sql = "SELECT id, days, days_type, price, discount, credit, name FROM $planTblName WHERE id =". $post['subscription_id'];
	    $db->setQuery($sql);
	    $plan = $db->loadObject();
		
		if($plan->discount){
	    	$sql = 'SELECT COUNT(*) AS total FROM #__jbjobs_plan_subscr WHERE subscription_id ='. $post['subscription_id'].' AND approved=1 AND user_id='.$userid;
	    	$db->setQuery($sql);
	    	$total = $db->loadResult();
	    	if($total > 0){
	    		$plan->price = $plan->price - (($plan->price / 100) * $plan->discount);
	    	}
	    }
		// auto approve if free on expiry by system or in case of free plan
		if($plan->price <= 0){
			$date_approve = date( 'Y-m-d H:i:s', time() + ($app->getCfg('offset') * 60 * 60));
			$date_expires = date("Y-m-d H:i:s", strtotime("+$plan->days $plan->days_type") + ($app->getCfg('offset') * 60 * 60));
			$row->date_approval = $date_approve;
			$row->date_expire = $date_expires;
			$row->approved = 1;
	        $row->gateway_id = time();
			
			//check if the employer was already in free plan. This is checked so that employer gets free plan credit only once.
			$query = "SELECT COUNT(*) FROM #__jbjobs_plan_subscr WHERE user_id=$userid AND subscription_id=1";
			$db->setQuery($query);
		    $total = $db->loadResult();
			
			if($total >= 1)
				$row->credit = 0;
			else	
				$row->credit = $plan->credit;
			
			if($row->credit > 0){
				// Update the transaction table
				$transDtl = JText::_('JBJOBS_SUBSCR_BUY').' - '.$plan->name;
				$trans = $this->updateTransaction($row->user_id, $transDtl, $plan->credit, 1);
				
				$row->trans_id = $trans->id;
			}
	    }
		else {
			$row->credit = $plan->credit;
		}
		
		$row->date_buy = date('Y-m-d H:i:s', time() + ($app->getCfg('offset') * 60 * 60 ));
		$row->price	= $plan->price;
		$row->tax_percent = $taxpercent;
		
		// save the changes
		if (!$row->store()){
			JError::raiseError(500, $row->getError());
		}
		$year = date("Y");
		$time = time();
		//replace the tags
		$tags = array("[ID]", "[USERID]", "[YYYY]", "[TIME]");
		$tagsValues = array("$row->id", "$userid", "$year", "$time");
		$invoiceNo = str_replace($tags, $tagsValues, $invoiceFormatPlan);
		$row->invoiceNo = $invoiceNo;
		
		// save the changes after updating the invoice no
		if (!$row->store()) {
			JError::raiseError(500, $row->getError() );
		}
		$row->checkin();
		JRequest :: setVar('returnrowid', $row->id);
	}
	
	//12.Cancel Subscription
	function cancelSubscr(){
	
		//Initialise variables
		$db =& JFactory::getDBO();
		$user	=& JFactory::getUser();
		$userid = $user->id;
		$model = $this->getModel();
		$id = JRequest::getVar('id', 0, 'get', 'string');
		
		if(!$userid){
			$return	= JRoute::_('index.php?option=com_user&view=login');
			$this->setRedirect($return);
			return;	
		}
		
		if(!$model->isEmployer($userid) && !$model->isJobSeeker($user->id)){
			$return	= JRoute::_('index.php?option=com_jbjobs');
			$this->setRedirect($return);
			return;
		}
		//authorize cancel subscription
		$query = "SELECT * FROM #__jbjobs_plan_subscr WHERE id =".$db->quote($id);
		$db->setQuery($query);
		$subscr = $db->loadObject();
		
		if($subscr->user_id != $userid){
			$msg = JText::_('JBJOBS_NOT_AUTHORIZED_TO_CANCEL_SUBSCR');
		}
		elseif($subscr->approved == 1){
			$msg = JText::_('JBJOBS_CANNOT_CANCEL_APPROVED_SUBSCR');
		}
		else {	
			//cancel subscription
			$query = "UPDATE #__jbjobs_plan_subscr SET approved=2 WHERE id =".$db->quote($id);	//2 - cancelled
			$db->setQuery($query);
			if (!$db->query()) {
				$this->jbJobsMsgAlert('".$db->getErrorMsg()."');
			}
			$msg = JText::_('JBJOBS_SUBSCR_CANEL_SUCCESS');
		}
		
		$link = JRoute::_('index.php?option=com_jbjobs&view=membership&layout=planhistory', false);	
		$this->setRedirect($link, $msg);	
	}
	
	//13.Set Credit to Zero
	function setCreditZero($expireaftergrace){

		// Initialize variables
		$app =& JFactory::getApplication();
		$db	=& JFactory::getDBO();
		$user	=& JFactory::getUser();
		$lang =& JFactory::getLanguage();
	 	$lang->load('com_jbjobs', JPATH_SITE);
	 	
	 	$is_jobseeker = JBJobsModelJbjobs::isJobseeker($user->id);
		
	 	//get the total credit of the user
	 	$total_credit = JBJobsModelJbjobs::getTotalCredit($user->id);
		
		// Update the transaction table
		$transDtl = JText::sprintf('JBJOBS_CREDIT_EXPIRED_MANY_CREDITS', $total_credit);
		JBJobsControllerJbjobs::updateTransaction($user->id, $transDtl, $total_credit, -1);
		
		$msg = JText::_('JBJOBS_CREDIT_EXPIRED');
		if($is_jobseeker)
			$link = JRoute::_('index.php?option=com_jbjobs&view=membership&layout=planaddjs');
		else
			$link = JRoute::_('index.php?option=com_jbjobs&view=membership&layout=planadd');
		$app->redirect($link, $msg);
	}
	
/**	
==================================================================================================================	
	SECTION : Misc
	1.Insert Custom Field
	2.RSS feed
	3.Upload Photo
	4.Message Alert
==================================================================================================================
*/
	//1.Insert Custom Field
	function insertCustomField($type, $id, $post){
		$db = & JFactory::getDBO();
		
		$query = "SELECT * FROM #__jbjobs_custom_field WHERE field_for='$type' AND published='1'";
		$db->setQuery($query);
		$custom = $db->loadObjectList();
		
		if(count($custom)){
			foreach($custom as $ct){
				if(isset($post['custom_field_'.$ct->id])){
					if($type == 'job'){
						$query = "SELECT COUNT(*) FROM #__jbjobs_custom_field_value WHERE fieldid='$ct->id' AND jobid='$id'";
					}
					else {
						$query = "SELECT COUNT(*) FROM #__jbjobs_custom_field_value WHERE fieldid='$ct->id' AND userid='$id'";
					}
					$db->setQuery($query);
					$fvalue = 'value';
					$value = $post['custom_field_'.$ct->id];
					switch($ct->field_type){
						case 'textarea':
							$fvalue = 'valuetext';
							break;
						case 'checkbox':
						case 'multiple select':
							$value = (is_array($value)) ? implode(";", $value) : $value;
							break;
					}
					if($db->loadResult()){
						if($type == 'job'){
							$query = "UPDATE #__jbjobs_custom_field_value SET $fvalue='$value' WHERE fieldid='$ct->id' AND jobid='$id'";
						}
						else {
							$query = "UPDATE #__jbjobs_custom_field_value SET $fvalue='$value' WHERE fieldid='$ct->id' AND userid='$id'";
						}
					}
					else {
						if($type == 'job'){
							$query = "INSERT INTO #__jbjobs_custom_field_value (fieldid, jobid, $fvalue) VALUES ('$ct->id', '$id', '$value')";
						}
						else {
							$query = "INSERT INTO #__jbjobs_custom_field_value (fieldid, userid, $fvalue) VALUES ('$ct->id', '$id', '$value')";
						}
					}echo $query.'-';
					$db->setQuery($query);
					$db->query();
				}
			}
		}
	}

	//2.RSS feed
	function jbJobsRSS(){
		$app =& JFactory::getApplication();
	
		while(@ob_end_clean());
		ob_start();
	
		$type = JRequest::getVar('type');
		$id = (int) JRequest::getVar('id');
	
		$db =& JFactory::getDBO();
	
		$sitename = $app->getCfg('sitename');
		
		$now = date('Y-m-d');//, time() + ( $app->getCfg('offset') * 60 * 60 ) );
		$where = " is_active='y' AND expire_date >= '".$now."' AND publish_date <= '".$now."' AND expire_date <> '0000-00-00 00:00:00'";
	
		require_once(JPATH_SITE.DS.'components'.DS.'com_jbjobs'.DS.'gateways'.DS.'feedcreator.class.php');
	
		$config =& JTable::getInstance('config','Table');
		$config->load(1);
		$limit = (int) $config->get('rsslimit');
	
		$rss = new UniversalFeedCreator();
		$rss->useCached();
		
		$query = "SELECT * FROM #__jbjobs_job WHERE $where ORDER BY id DESC LIMIT $limit";
		switch($type) {
			case 'country':
				$q = "SELECT country FROM #__jbjobs_country WHERE id='$id'";
				$db->setQuery($q);
				$result = $db->loadObject();
				if(!empty($result->country)){
					$query = "SELECT * FROM #__jbjobs_job WHERE id_country='$id' and $where ORDER BY ID DESC LIMIT $limit";
				}
				$rss->title = JText::_('JBJOBS_COUNTRY') . " (".$result->country.")";
			break;
			case 'position':
				$q = "SELECT pos_type FROM #__jbjobs_pos_type WHERE id='$id'";
				$db->setQuery($q);
				$result = $db->loadObject();
				if(!empty($result->pos_type)){
					$query = "SELECT * FROM #__jbjobs_job WHERE id_pos_type='$id' and $where ORDER BY ID DESC LIMIT $limit";
				}
				$rss->title = JText::_('JBJOBS_POSITION') . " (".$result->pos_type.")";
			break;
			case 'industry':
				$q = "SELECT industry FROM #__jbjobs_industry WHERE id='$id'";
				$db->setQuery($q);
				$result = $db->loadObject();
				if(!empty($result->industry)){
					$query = "SELECT a.* FROM #__jbjobs_job AS a INNER JOIN #__jbjobs_employer AS b ON a.employer_id=b.user_id INNER JOIN #__jbjobs_industry AS c ON b.id_industry=c.id WHERE c.id='$id' and $where ORDER BY ID DESC LIMIT $limit";
				}
				$rss->title = JText::_('JBJOBS_INDUSTRY') . " (".$result->industry.")";
			break;
			case 'jobcateg':
				$q = "SELECT category FROM #__jbjobs_job_categ WHERE id='$id'";
				$db->setQuery($q);
				$result = $db->loadObject();
				if(!empty($result->category)){
					$query = "SELECT * FROM #__jbjobs_job WHERE id_job_spec IN (SELECT id FROM #__jbjobs_job_spec WHERE id_category=$id) AND $where ORDER BY id DESC LIMIT $limit";
				}
				$rss->title = JText::_('JBJOBS_CATEGORY') . " (".$result->category.")";
			break;
			case 'jobspec':
				$q = "SELECT specialization FROM #__jbjobs_job_spec WHERE id='$id'";
				$db->setQuery($q);
				$result = $db->loadObject();
				if(!empty($result->specialization)){
					$query = "SELECT * FROM #__jbjobs_job WHERE id_job_spec='$id' and $where ORDER BY id DESC LIMIT $limit";
				}
				$rss->title = JText::_('JBJOBS_SPECIALIZATION') . " (".$result->specialization.")";
			break;
			case 'company':
				$q = "SELECT comp_name FROM #__jbjobs_employer WHERE user_id='$id'";
				$db->setQuery($q);
				$result = $db->loadObject();
				if(!empty($result->comp_name)){
					$query = "SELECT a.* FROM #__jbjobs_job AS a INNER JOIN #__jbjobs_employer AS b ON a.employer_id=b.user_id WHERE b.user_id='$id' and $where ORDER BY ID DESC LIMIT $limit";
				}
				$rss->title = JText::_('JBJOBS_COMPANY_NAME') . " (".$result->comp_name.")";
			break;
			default:
				$rss->title = JText::_('JBJOBS_LATEST_JOBS');
			break;
		}
	
		$rss->description = JText::_('JBJOBS_JOB_LISTING_FROM') . " " . $sitename;
		$rss->link = JURI::base();
		$rss->syndicationURL = 'http://' . str_replace('http://', '', $_SERVER['HTTP_HOST']) . $_SERVER['REQUEST_URI'];
		
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		if(count($rows)){
			foreach($rows as $row){
				$item = new FeedItem();
				$item->title = $row->job_title;
				$link = 'http://' . str_replace('http://', '', $_SERVER['HTTP_HOST']) . JRoute::_('index.php?option=com_jbjobs&view=guest&layout=detailjob&id='.$row->id);
				$item->link = $link;
				$item->description = strip_tags($row->short_desc);
				$item->date = date("D, d M Y H:i:s O", strtotime($row->publish_date)); 
				$rss->addItem($item);
			}
		}
		$xml=$rss->createFeed("2.0");
		echo $xml;
	
		$out = ob_get_contents();
		ob_end_clean();
		echo $out;
		exit();
	}

	//3.Upload Photo
	function uploadPicture(){
		//UPLOAD FILE
		$file = $_FILES['photo'];
		$userid = JRequest::getVar('userid', '', 'post', 'int');
		$response = array();
		
		$config =& JTable::getInstance('config', 'Table');
		$config->load(1);
		//$allowed = array('image/pjpeg', 'image/jpeg', 'image/jpg', 'image/png', 'image/x-png', 'image/gif', 'image/ico', 'image/x-icon');
		$type = $config->get('imgfiletype');
		$allowed = explode(',', $type);
		$pwidth  = $config->get('imgwidth');
		$pheight = $config->get('imgheight');
		$maxsize = $config->get('imgmaxsize');
		if($file['size'] > 0 &&  ($file['size'] / 1024  < $maxsize)){
			if(!file_exists(JPATH_SITE.DS.'images'.DS.'jbjobs')){
				if(mkdir(JPATH_SITE.DS.'images'.DS.'jbjobs')){
					JPath::setPermissions(JPATH_SITE.DS.'images'.DS.'jbjobs', '0777');
					if(file_exists(JPATH_SITE.DS.'images'.DS.'index.html')){
						copy(JPATH_SITE.DS.'images'.DS.'index.html', JPATH_SITE.DS.'images'.DS.'jbjobs/index.html');
					}
				}
			}
			if($file['error'] != 0){
				echo JText::_('JBJOBS_FILE_PHOTO_ERROR');
				exit;
			}
			if($file['size'] == 0){
				$file = null;
			}
			if(!in_array($file['type'], $allowed)){
				$file = null;
				$response['result'] = 'NO';
				$response['msg'] = JText::_('JBJOBS_FILE_TYPE_NOT_ALLOWED');
				echo json_encode($response); exit;
			}
			if ($file != null){
				$dest = JPATH_SITE.DS.'images'.DS.'jbjobs'.DS.$userid.'.jpg';
				if(file_exists($dest)){
					$del = unlink($dest);
				}
				$soure = $file['tmp_name'];
				jimport('joomla.filesystem.file');
				$uploaded = JFile::upload($soure,$dest);
				$fileAtr = getimagesize($dest);
				$widthOri = $fileAtr[0];
				$heightOri = $fileAtr[1];
				$type = $fileAtr['mime'];
				$img = false;
				switch ($type){
					case 'image/jpeg':
					case 'image/jpg':
					case 'image/pjpeg':
					$img = imagecreatefromjpeg($dest);					 
					break;
					case 'image/ico':
					$img = imagecreatefromico($dest);
					break;
					case 'image/x-png':
					case 'image/png':
					$img = imagecreatefrompng($dest);
					break;
					case 'image/gif':
					$img = imagecreatefromgif($dest);
					break;
				}
				if(!$img){
					return false;
				}
				$curr = @getimagesize($dest);
				$perc_w = $pwidth / $widthOri;
				$perc_h = $pheight / $heightOri;
				if(($widthOri < $pwidth) && ($heightOri < $pheight)){
					//return;
				}
				if($perc_h > $perc_w){
					$pwidth = $pwidth;
					$pheight = round($heightOri * $perc_w);
				}
				else {
					$pheight = $pheight;
					$pwidth = round($widthOri * $perc_h);
				}
				$nwimg = imagecreatetruecolor($pwidth, $pheight);
				
				if(($fileAtr[2] == IMAGETYPE_GIF) || ($fileAtr[2] == IMAGETYPE_PNG)){
			      	$trnprt_indx = imagecolortransparent($img);
			      	// If we have a specific transparent color
				    if($trnprt_indx >= 0){
				        $trnprt_color = imagecolorsforindex($img, $trnprt_indx);	// Get the original image's transparent color's RGB values
				        $trnprt_indx  = imagecolorallocate($nwimg, $trnprt_color['red'], $trnprt_color['green'], $trnprt_color['blue']);	// Allocate the same color in the new image resource
				        imagefill($nwimg, 0, 0, $trnprt_indx);			// Completely fill the background of the new image with allocated color.
				        imagecolortransparent($nwimg, $trnprt_indx);	// Set the background color for new image to transparent
				    } 
			      	// Always make a transparent background color for PNGs that don't have one allocated already
			      	elseif($fileAtr[2] == IMAGETYPE_PNG){
				        imagealphablending($nwimg, false);	 // Turn off transparency blending (temporarily)
				        $color = imagecolorallocatealpha($nwimg, 0, 0, 0, 127);	 // Create a new transparent color for image
				        imagefill($nwimg, 0, 0, $color);	// Completely fill the background of the new image with allocated color.
				        imagesavealpha($nwimg, true);	 	// Restore transparency blending
			      	}
		    	}
				
				imagecopyresampled($nwimg, $img, 0, 0, 0, 0, $pwidth, $pheight, $widthOri, $heightOri);
				
				switch($fileAtr[2]){
			      case IMAGETYPE_GIF:
			        imagegif($nwimg, $dest);
			      break;
			      case IMAGETYPE_JPEG:
			        imagejpeg($nwimg, $dest);
			      break;
			      case IMAGETYPE_PNG:
			        imagepng($nwimg, $dest);
			      break;
			      default:
			        return false;
			    }
				
				imagedestroy($nwimg);
				imagedestroy($img);
				
				$response['result'] = 'OK';
				$response['image'] = JURI::root().'images/jbjobs/'.$userid.'.jpg?'.time();
				$response['msg'] = JText::_('JBJOBS_PICTURE_UPLOADED_SUCCESSFULLY');
				echo json_encode($response); exit;
			}
		}
		else {
			if($file['size'] / 1024  > $maxsize){
				$response['result'] = 'NO';
				$response['msg'] = JText::sprintf('JBJOBS_PICTURE_EXCEEDS_LIMIT', $maxsize);
				echo json_encode($response); exit;
			}
		}
	}
	
	function removePicture(){
		$userid = JRequest::getVar('userid', 0, 'post', 'int');
		$dest = JPATH_SITE.DS.'images'.DS.'jbjobs'.DS.$userid.'.jpg';
		
		$response = array();
		
		if(file_exists($dest)){
			$del = unlink($dest);
			$response['result'] = 'OK';
			$response['msg'] = JText::_('JBJOBS_PICTURE_REMOVED_SUCCESSFULLY');
			echo json_encode($response); exit;
		}
		else {
			$response['result'] = 'NO';
			$response['msg'] = JText::_('JBJOBS_FILE_NOT_EXISTS');
			echo json_encode($response); exit;
		}
	}
	
	//4.Message Alert
	function jbJobsMsgAlert($msg){
		if (!headers_sent()){
			while(@ob_end_clean());
			ob_start();
			echo "<script> alert('".$msg."'); window.history.go(-1); </script>\n";
			$out = ob_get_contents();
			ob_end_clean();
			echo $out;
			exit();
		}
		echo "<script> alert('".$msg."'); window.history.go(-1); </script>\n";		
		exit();
	}
	
 /**	
==================================================================================================================	
	SECTION : Email
	1.Send E-mail to Admin while Manual Transfer
	2.JoomBah Jobs SendMail
	3.Send alert to Admin on new Subscription
	4.Send alert to Subscribers on new Subscription
==================================================================================================================
*/
	//1.Send E-mail to Admin while Manual Transfer
	function JBJobSendMailManualTransfer($invoiceid){
		$app =& JFactory::getApplication();
		$model = $this->getModel();
		$user =& JFactory::getUser();
		$db =& JFactory::getDBO();
		
		$row	=& JTable::getInstance('billing', 'Table');
		$row->load($invoiceid);
		$gateway = JBjobs::getGwayName($row->gateway);
	
		if($model->isEmployer($user->id)){
			$sitename = $app->getCfg('sitename');
			$fromname = $app->getCfg('fromname');
			$adminURL = JURI::base().'administrator';
			
			$name = $user->name;
			$username = $user->username;
			$mailfrom = $user->email;
			
			$tags = array("[NAME]", "[USERNAME]", "[INVOICENO]", "[ADMINURL]", "[GATEWAY]");
			$tagsValues = array("$name", "$username", "$invoiceid", "$adminURL", "$gateway");
		
			//get the email template
			$template = $model->getTemplate('credit-purchase');
			
			//get subject
			$subject = $template->subject;
			$subject = str_replace($tags, $tagsValues, $subject);
			$subject = html_entity_decode($subject, ENT_QUOTES);
			
			//get message body
			$message = $template->body;
			$message = str_replace($tags, $tagsValues, $message);
			$message = html_entity_decode($message, ENT_QUOTES);
			
			//get all super administrator
			$query = 'SELECT name, email, sendEmail FROM #__users'.
					' WHERE LOWER(usertype) = "super administrator"';
			$db->setQuery($query);
			$rows = $db->loadObjectList();
		
			// Send notification to all administrators
			foreach ($rows as $row){
				if ($row->sendEmail){	
					JUtility::sendMail($mailfrom, $fromname, $row->email, $subject, $message, 1);
				}
			}
		}
	}
	
	//2.JoomBah Jobs SendMail
	function JBJobSendMail(&$usern, $password){
		$app =& JFactory::getApplication();
		$model = $this->getModel();
	
		$lang =& JFactory::getLanguage();
	 	$lang->load('com_user', JPATH_SITE);
	
		$db		=& JFactory::getDBO();
	
		$userid		= $usern->get('id');
		$name 		= $usern->get('name');
		$email 		= $usern->get('email');
		$username 	= $usern->get('username');
		
		$usertype = '';
		$is_employer = $model->isEmployer($userid);
		$is_jobseeker = $model->isJobseeker($userid);
		
		if($is_employer == 1)
			$usertype = JText::_('JBJOBS_EMPLOYER');
		elseif($is_jobseeker == 1)
			$usertype = JText::_('JBJOBS_JOBSEEKER');
	
		$usersConfig 	= &JComponentHelper::getParams('com_users');
		$sitename 		= $app->getCfg('sitename');
		$useractivation = $usersConfig->get('useractivation');
		$mailfrom 		= $app->getCfg('mailfrom');
		$fromname 		= $app->getCfg('fromname');
		$siteURL		= JURI::base();
		$actLink 		= $siteURL."index.php?option=com_user&task=activate&activation=".$usern->get('activation');
	
		if ($useractivation == 1){
			//get the email template
			$template = $model->getTemplate('newuser-activate');
		} 
		else {
			//get the email template
			$template = $model->getTemplate('newuser-login');
		}
		
		$tags = array("[NAME]", "[SITENAME]", "[ACTLINK]", "[SITEURL]", "[USERNAME]", "[PASSWORD]", "[USEREMAIL]", "[USERTYPE]");
		$tagsValues = array("$name", "$sitename", "$actLink", "$siteURL", "$username", "$password", "$email", "$usertype");
		
		//get subject
		$subject = $template->subject;
		$subject = str_replace($tags, $tagsValues, $subject);
		$subject = html_entity_decode($subject, ENT_QUOTES);
		
		//get message body
		$message = $template->body;
		$message = str_replace($tags, $tagsValues, $message);
		$message = html_entity_decode($message, ENT_QUOTES);
	
		//get all super administrator
		$query = 'SELECT name, email, sendEmail' .
				' FROM #__users' .
				' WHERE LOWER(usertype) = "super administrator"';
		$db->setQuery($query);
		$rows = $db->loadObjectList();
	
		// Send email to user
		if (!$mailfrom  || !$fromname) {
			$fromname = $rows[0]->name;
			$mailfrom = $rows[0]->email;
		}
	
		JUtility::sendMail($mailfrom, $fromname, $email, $subject, $message, 1);
	
		// Send notification to all administrators
	 	//get the email template
		$template = $model->getTemplate('newuser-details');
		
		//get subject
		$subject = $template->subject;
		$subject = str_replace($tags, $tagsValues, $subject);
		$subject = html_entity_decode($subject, ENT_QUOTES);
		
		//get message body
		$message = $template->body;
		$message = str_replace($tags, $tagsValues, $message);
		$message = html_entity_decode($message, ENT_QUOTES);
		
		// get super administrators id
		foreach ($rows as $row){
			if ($row->sendEmail){
				JUtility::sendMail($mailfrom, $fromname, $row->email, $subject, $message, 1);
			}
		}
	}
	
	//3.Send alert to Admin on new Subscription
	function alertAdminSubscr($subscrid, $userid){
		$app =& JFactory::getApplication();
		$db =& JFactory::getDBO();
		$row	=& JTable::getInstance('plansubscr', 'Table');
		$row->load($subscrid);
		$model = $this->getModel();
		$user =& JFactory::getUser($userid);
		
		if($row->user_type == 'e')
 			$planTblName = '#__jbjobs_plan';
 		elseif($row->user_type == 'j')
 			$planTblName = '#__jbjobs_plan_js';
 		
 		$query = "SELECT * FROM $planTblName WHERE id = ".$row->subscription_id;
		$db->setQuery($query);
		$plan = $db->loadObject();
		
		//Alert admin based on the plan settings-return if set to No
		if(!$plan->alert_admin)
			return;
	
		$name = $user->name;
		$userEmail = $user->email;
		$username = $user->username;

		$sitename = $app->getCfg('sitename');
		$fromname = $app->getCfg('fromname');
		$mailfrom = $app->getCfg('mailfrom');
	
		$subscrid = $row->id;
		$planname = $plan->name;
		$gateway = JBjobs::getGwayName($row->gateway);
		
		if($row->approved)
			$status = JText::_('JBJOBS_APPROVED');
		else
			$status = JText::_('JBJOBS_APPROVAL_PENDING');
		
		$tags = array("[NAME]", "[USERNAME]", "[PLANNAME]", "[SITENAME]", "[SUBSCRID]", "[USEREMAIL]", "[GATEWAY]", "[PLANSTATUS]");
		$tagsValues = array("$name", "$username", "$planname", "$sitename", "$subscrid", "$userEmail", "$gateway", "$status");
		
		//get the email template
		$template = $model->getTemplate('subscr-details');
		
		//get subject
		$subject = $template->subject;
		$subject = str_replace($tags, $tagsValues, $subject);
		$subject = html_entity_decode($subject, ENT_QUOTES);
		
		//get message body
		$message = $template->body;
		$message = str_replace($tags, $tagsValues, $message);
		$message = html_entity_decode($message, ENT_QUOTES);
	
		//get all super administrator
		$query = 'SELECT name, email, sendEmail FROM #__users WHERE LOWER(usertype) = "super administrator"';
		$db->setQuery($query);
		$rows = $db->loadObjectList();
	
		// Send notification to all administrators
		foreach ($rows as $row){
			if ($row->sendEmail){	
				JUtility::sendMail($mailfrom, $fromname, $row->email, $subject, $message, 1);
			}
		}
	}
	
	//4.Send alert to Subscribers on new Subscription
	function alertUserSubscr($subscrid, $userid){
		$app =& JFactory::getApplication();
		$db =& JFactory::getDBO();
		$row	=& JTable::getInstance('plansubscr', 'Table');
		$row->load($subscrid);
		$model = $this->getModel();
		$user =& JFactory::getUser($userid);
		
		if($row->user_type == 'e')
 			$planTblName = '#__jbjobs_plan';
 		elseif($row->user_type == 'j')
 			$planTblName = '#__jbjobs_plan_js';
 		
 		$query = "SELECT * FROM $planTblName WHERE id = ".$row->subscription_id;
		$db->setQuery($query);
		$plan = $db->loadObject();
	
		$name = $user->name;
		$mailto = $user->email;
		$username = $user->username;

		$sitename = $app->getCfg('sitename');
		$fromname = $app->getCfg('fromname');
		$mailfrom = $app->getCfg('mailfrom');
		$siteURL = JURI::base();
		
		//get all super administrator
		$query = 'SELECT name, email, sendEmail' .
				' FROM #__users' .
				' WHERE LOWER(usertype) = "super administrator"';
		$db->setQuery($query);
		$rows = $db->loadObjectList();
	
		// Send email to user
		if (!$mailfrom  || !$fromname) {
			$fromname = $rows[0]->name;
			$mailfrom = $rows[0]->email;
		}
	
		$subscrid = $row->id;
		$planname = $plan->name;
		
		$tags = array("[NAME]", "[PLANNAME]", "[SITENAME]", "[SITEURL]", "[ADMINEMAIL]");
		$tagsValues = array("$name", "$planname", "$sitename", "$siteURL", "$mailfrom");
		
		if($row->approved){
			//get the email template
			$template = $model->getTemplate('subscr-approved-auto');
		}
		else {
			//get the email template
			$template = $model->getTemplate('subscr-pending');
		}
		
		//get subject
		$subject = $template->subject;
		$subject = str_replace($tags, $tagsValues, $subject);
		$subject = html_entity_decode($subject, ENT_QUOTES);
		
		//get message body
		$message = $template->body;
		$message = str_replace($tags, $tagsValues, $message);
		$message = html_entity_decode($message, ENT_QUOTES);
	
		// Send email to user
		JUtility::sendMail($mailfrom, $fromname, $mailto, $subject, $message, 1);
	}
	
	function display(){
		$document = & JFactory :: getDocument();
		$viewName = JRequest :: getVar('view', 'guest');
		$layoutName = JRequest :: getVar('layout', 'showfront');
		
		$viewType = $document->getType();
		
		$view = & $this->getView($viewName, $viewType); 
		$model = & $this->getModel('jbjobs', 'JBJobsModel');
		if (!JError :: isError($model)){
			$view->setModel($model, true);
		}
		$view->setLayout($layoutName);
		$view->display();
	}
}
?>
