<?php
/**
 + Created by	:	JoomBah Team
 * Company		:	ISDS Sdn Bhd
 + Contact		:	www.joombah.com , support@joombah.com
 * Created on	:	August 2010
 * Author 		:	Faisel
 * Tested by	: 	Zaki
 + Project		: 	Job site
 * File Name	:	controllers/paypal.class.php
 * License		:	GNU General Public License version 3, or later
 ^ 
 * Description	: 	Entry point for the component (jbjobs)
 ^ 
 * History		:	NONE
 ^ 
 * @package com_jbjobs
 ^ 
 * 
 * */

defined('_JEXEC') or die( 'Restricted access' );

class googleco_class {
	var $last_error;
	var $ipn_log;
	var $ipn_log_file;
	var $ipn_response;
	var $ipn_data = array();
	var $fields = array();

	function googleco_class(){
		$this->googleco_url = 'https://www.paypal.com/cgi-bin/webscr';
		$this->last_error = '';
		$this->ipn_log_file = '.ipn_results.log';
		$this->ipn_response = '';
	}
   
	function add_field($field, $value)
	{
		$this->fields["$field"] = $value;
	}

	function submit_googleco_post()
	{
		echo '<form method="post" name="googleco_form" action="'.$this->googleco_url.'" accept-charset="utf-8" >';
		foreach ($this->fields as $name => $value)
		{
			echo '<input type="hidden" name="'.$name.'" value="'.$value.'"/>';
		}
		echo '<input type="hidden" name="_charset_"/>';
		echo JText::sprintf('JBJOBS_PAYMENT_REDIRECTION_PAGE', 'Google CO');
		echo '<br><br><input type="submit" value="'.JText::_('JBJOBS_PROCEED_FOR_PAYMENT').'">';
		echo '</form>';
	}
   
	function validateNotification($post){
		$payconfig = JBJobsControllerPayment::payConfig('.googleco');
		$merchant_id = $payconfig['gcMerchantID'];
		$merchant_key = $payconfig['gcMerchantKey'];
		$currency = $payconfig['gcCurrency'];
		$testMode = $payconfig['gctestmode'];
		
		if ($testMode){
			$server_type = "sandbox";
		}
		else {
			$server_type = "Production";
		}
		$serial_number	 = $post['serial-number'];
		
		require_once(JPATH_SITE.DS.'components'.DS.'com_jbjobs'.DS.'gateways'.DS.'google_co'.DS.'googlerequest.php');
		$googleRequest = new GoogleRequest( $merchant_id, $merchant_key, $server_type, $currency, $serial_number );
		
		$googleRequest->SendAcknowledgementRequest();

		list($res, $xml_response) = $googleRequest->SendHistoryRequest();
		
		if ($res == 200) {
			$response['valid']				 = 1;
			$response['invoice']			 = $this->XMLsubstring_tag( $xml_response, 'invoice' );
			$response['google-order-number'] = $this->XMLsubstring_tag( $xml_response, 'google-order-number' );
			$response['order-id'] 			 = $this->XMLsubstring_tag( $xml_response, 'merchant-private-data' );
			$response['serial_number']		 = $serial_number;
			$response['server_type']		 = $server_type;
		}
		elseif($res != 200) {
			$response['valid']				 = 0;
			$response['pending_reason']	= 'Acknowledgement Failed ';
			return $response;
		}

		$order_number = $response['google-order-number'];

		unset($response['google-order-number']);
		unset($response['server_type']);
		unset($response['serial_number']);

		list($res, $xml_response) = $googleRequest->SendDeliverOrder($order_number);

		if ($res != 200) {
			$response['valid']			= 0;
			$response['pending_reason']	= 'Sending Deliver Order failed';
			return $response;
		}

		list($res, $xml_response) = $googleRequest->SendChargeOrder($order_number);

		if ($res != 200) {
			$response['valid']			= 0;
			$response['pending_reason']	= 'Sending Charge Order failed';
			return $response;
		}
		
		return $response;
	}
	
	function XMLsubstring_tag( $haystack, $tag ){
		$start = '<' . $tag . '>';
		$end = '</' . $tag . '>';

		if ( strpos( $haystack, $start ) === false || strpos( $haystack, $end ) === false ) {
			return false;
		} else {
			$start_position = strpos( $haystack, $start ) + strlen( $start );
			$end_position = strpos( $haystack, $end );
			return substr( $haystack, $start_position, $end_position - $start_position );
		}
	}
}

	

?>