<?php
/**
 + Created by	:	JoomBah Team
 * Company		:	ISDS Sdn Bhd
 + Contact		:	www.joombah.com , support@joombah.com
 * Created on	:	August 2010
 * Author 		:	Faisel
 * Tested by	: 	Zaki
 + Project		: 	Job site
 * File Name	:	models/jbjobs.php
 * License		:	GNU General Public License version 3, or later
 ^ 
 * Description	: 	Entry point for the component (jbjobs)
* */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');
jimport('joomla.html.html');

$option = JRequest :: getVar('option', 'com_jbjobs');

class JBJobsModelJbjobs extends JModel{
	function __construct(){
		parent :: __construct();
		$user	=& JFactory::getUser();
	}

/**	
==================================================================================================================	
	SECTION : Guest
	1.Show Front or Register Page
	2.Search By Specialization
	3.Search By Location
	4.Search By Position
	5.Search By Industry
	6.Search By Company
	7.Latest Jobs List
	8.Detail Job
	9.Simple search
	10.Advance Search Result
	11.Detail Company
==================================================================================================================
*/
	//1.Show Front or Register Page
	function getShowFront(){
		$app =& JFactory::getApplication();
		$db 	=& JFactory::getDBO();
		$user	=& JFactory::getUser();
		if(!$user->id OR (!$this->isJobSeeker($user->id) && !$this->isEmployer($user->id))){
			return true;
		}
		else {
			$return = JRoute::_('index.php?option=com_jbjobs&task=decidedashboard');
			$app->redirect($return);
			return;
		}
	}
	
	//3.Filter jobs by criteria
	function getJobsbyCriteria(){
		
		// Initialize variables
		$app =& JFactory::getApplication();
		$user	=& JFactory::getUser();
		$db 	= & JFactory::getDBO();
		$id 	= (int)JRequest::getVar('id', 0, 'get', 'string');
		$type 	= JRequest::getVar('type', '', 'get', 'string');
		$name 	= JRequest::getVar('name', '', 'get', 'string');
		
		//for header title
		if($type == 'jobcateg'){
			$query = "SELECT category,id FROM #__jbjobs_job_categ a WHERE a.id = ".$db->quote($id);
			$db->setQuery($query);
			$header = $db->loadResult();
		}
		elseif($type == 'jobspec'){
			$query = "SELECT specialization,id FROM #__jbjobs_job_spec a WHERE a.id = ".$db->quote($id);
			$db->setQuery($query);
			$header = $db->loadResult();
		}
		elseif ($type == 'company'){
			$query = "SELECT e.comp_name,e.id id_employer FROM #__jbjobs_employer e WHERE e.show_comp_name='y' AND e.user_id=".$db->quote($id);
			$db->setQuery($query);
			$header = $db->loadResult();
			if(!$header)
				$header = JText::_('JBJOBS_NAME_CONFIDENTIAL');	
		}
		elseif ($type == 'position'){
			$query = "SELECT pos_type,id FROM #__jbjobs_pos_type WHERE id=".$db->quote($id);
			$db->setQuery($query);
			$header = $db->loadResult();	
		}
		elseif ($type == 'industry'){
			$query = "SELECT industry,id FROM #__jbjobs_industry WHERE id=".$db->quote($id);
			$db->setQuery($query);
			$header = $db->loadResult();	
		}
		elseif ($type == 'country'){
			$query = "SELECT country,id FROM #__jbjobs_country WHERE id=".$db->quote($id);
			$db->setQuery($query);
			$header = $db->loadResult();	
		}
		elseif ($type == 'state' || $type == 'city'){
			$header = $name;
		}
		
		if($type == 'jobcateg')
			$where = "WHERE a.id_job_spec IN (SELECT id FROM #__jbjobs_job_spec WHERE id_category=$id)";
		elseif($type == 'jobspec')
			$where = "WHERE a.id_job_spec =".$db->quote($id)." ";
		elseif($type == 'company')
			$where = "WHERE a.employer_id =".$db->quote($id)." ";
		elseif($type == 'position')
			$where = "WHERE a.id_pos_type =".$db->quote($id)." ";
		elseif($type == 'industry')
			$where = "WHERE c.id_industry =".$db->quote($id)." ";
		elseif($type == 'country')
			$where = "WHERE a.id_country =".$db->quote($id)." ";
		elseif($type == 'state')
			$where = "WHERE a.state LIKE ".$db->quote($name)." ";
		elseif($type == 'city')
			$where = "WHERE a.city LIKE ".$db->quote($name)." ";
			
		$now = date('Y-m-d'); // H:i:s', time() + ( $app->getCfg('offset') * 60 * 60 ) );
		$where .= "and a.is_active='y' and a.publish_date <= '".$now."' and expire_date >= '".$now."' and expire_date <> '0000-00-00 00:00:00'";
	
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= JRequest::getVar('limitstart', 0, '', 'int');
		
		$query = "SELECT COUNT(*) FROM #__jbjobs_job a".
		      	 " LEFT JOIN #__jbjobs_country b ON a.id_country = b.id".
			 	 " LEFT JOIN #__jbjobs_employer c ON a.employer_id = c.user_id".
				 " LEFT JOIN #__jbjobs_comp_type d ON c.id_comp_type = d.id ".$where.
				 " ORDER BY a.publish_date DESC";
		$db->setQuery($query);
		$total = $db->loadResult();
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination( $total, $limitstart, $limit );
	
		$query ="select a.*,country,c.id id_employer,comp_name,show_comp_name,comp_type,b.id countryid,if(now()<a.hotjob_expire, true, false) is_hot FROM #__jbjobs_job a".
		      	 " LEFT JOIN #__jbjobs_country b ON a.id_country = b.id".
			 	 " LEFT JOIN #__jbjobs_employer c ON a.employer_id = c.user_id".
				 " LEFT JOIN #__jbjobs_comp_type d ON c.id_comp_type = d.id ".$where.
				 " ORDER BY is_hot DESC, a.is_featured DESC, a.publish_date DESC, a.id DESC";
		$db->setQuery($query, $pageNav->limitstart, $pageNav->limit);
		$rows = $db->loadObjectList();	
		
		$return[0] = $rows;
		$return[1] = $header;
		$return[2] = $pageNav;
		
		return $return;
	}
	
	//7.Latest Jobs List
	function getJobList(){
			
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO();
		
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= (empty($_GET['limitstart'])) ? 0 : $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', 0, 'int');
		
		$now = date('Y-m-d');//, time() + ( $app->getCfg('offset') * 60 * 60 ) );
		$where = " WHERE a.is_active='y' and a.expire_date >= '".$now."' and a.publish_date <= '".$now."' and a.expire_date <> '0000-00-00 00:00:00'";
	
		$query = "SELECT COUNT(*) FROM #__jbjobs_job a".$where;
		$db->setQuery($query);
		$total = $db->loadResult();
	
		jimport('joomla.html.pagination');
		$pageNav = new JPagination($total, $limitstart, $limit);
	
		$query = "SELECT a.*,b.id id_spec,b.specialization,c.country,c.id AS countryid,d.id id_employer,d.comp_name,d.show_comp_name,e.id id_exp,e.exp_name,jc.category,jc.id id_jobcateg,if(now()<a.hotjob_expire, true, false) is_hot FROM #__jbjobs_job a".
				 " LEFT JOIN #__jbjobs_job_spec b ON a.id_job_spec = b.id".
				 " LEFT JOIN #__jbjobs_job_categ jc ON jc.id = b.id_category". 
				 " LEFT JOIN #__jbjobs_country c ON a.id_country = c.id".
				 " LEFT JOIN #__jbjobs_employer d ON a.employer_id = d.user_id".
				 " LEFT JOIN #__jbjobs_job_exp e ON a.id_job_exp = e.id".
				 $where .
				 " ORDER BY is_hot DESC, a.is_featured DESC, a.publish_date DESC, a.id DESC";
		$db->setQuery($query, $pageNav->limitstart, $pageNav->limit);
		$rows = $db->loadObjectList();
	
		$return[0] = $rows;
		$return[1] = $pageNav;
		return $return;
	}
	
	//7.List of Companies
	function getCompanyList(){
			
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO();
		
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= (empty($_GET['limitstart'])) ? 0 : $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', 0, 'int');
		
		$letter = JRequest::getVar('letter', '', 'get', 'char');
		$where = " WHERE e.comp_name LIKE '$letter%'";
	
		$query = "SELECT COUNT(*) FROM #__jbjobs_employer e
				  LEFT JOIN #__jbjobs_industry i ON e.id_industry = i.id
				  LEFT JOIN #__jbjobs_country c ON e.id_country = c.id
				  $where
				  ORDER BY e.id";
		$db->setQuery($query);
		$total = $db->loadResult();
	
		jimport('joomla.html.pagination');
		$pageNav = new JPagination($total, $limitstart, $limit);
	
		$query = "SELECT e.*,c.country,c.id AS countryid,i.industry FROM #__jbjobs_employer e
				  LEFT JOIN #__jbjobs_industry i ON e.id_industry = i.id
				  LEFT JOIN #__jbjobs_country c ON e.id_country = c.id
				  $where
				  ORDER BY e.id";
		$db->setQuery($query, $pageNav->limitstart, $pageNav->limit);
		$rows = $db->loadObjectList();
	
		$return[0] = $rows;
		$return[1] = $pageNav;
		return $return;
	}
	
	//8.Detail Job
	function getDetailJob(){
		$app =& JFactory::getApplication();
		$user	=& JFactory::getUser();
		$id 	= JRequest::getVar('id', 0, 'get', 'int');
		$db 	= & JFactory::getDBO();
	
		if(empty($id)){
			$return	= JRoute::_('index.php?option=com_jbjobs');
			$app->redirect($return);	
		}
	
		$query = "SELECT a.*,h.comp_name,h.id id_employer,h.show_comp_name,b.id id_deg,degree_level,pos_type,c.id as positionid,d.id id_sal,type_salary,g.country,g.id countryid,
				 f.id id_spec,f.specialization,i.industry,i.id as industryid,e.id id_exp,e.exp_name,jc.id id_jobcateg,jc.category,IF(now()<a.hotjob_expire, true, false) is_hot, 
				 (SELECT COUNT(*) FROM #__jbjobs_save_job sj WHERE sj.id_job=a.id and sj.is_apply='y') AS appcount FROM #__jbjobs_job a".
		         " LEFT JOIN #__jbjobs_degree_level b ON a.id_degree_level = b.id".
				 " LEFT JOIN #__jbjobs_pos_type c ON a.id_pos_type = c.id".
				 " LEFT JOIN #__jbjobs_type_salary d ON a.id_salary_type = d.id".
				 " LEFT JOIN #__jbjobs_job_exp e ON a.id_job_exp = e.id".
				 " LEFT JOIN #__jbjobs_job_spec f ON a.id_job_spec = f.id".
				 " LEFT JOIN #__jbjobs_job_categ jc ON jc.id = f.id_category".
				 " LEFT JOIN #__jbjobs_country g ON a.id_country = g.id". 
				 " LEFT JOIN #__jbjobs_employer h ON a.employer_id = h.user_id".
				 " LEFT JOIN #__jbjobs_industry i ON h.id_industry = i.id".
				 " WHERE a.id = ".$db->quote($id);
		$db->setQuery($query);
		$data = $db->loadObject();
		if(!count($data)){
			$return	= JRoute::_('index.php?option=com_jbjobs');
			$app->redirect($return);	
		}
		
		$query = "SELECT e.id id_comp,e.street_addr,e.city em_city,e.state em_state,c.country em_country,c.id id_country FROM #__jbjobs_job j".
				 " LEFT JOIN #__jbjobs_employer e ON j.employer_id = e.user_id".
		 		 " LEFT JOIN #__jbjobs_country c ON e.id_country = c.id". 
				 " WHERE j.id = ".$db->quote($id);
		$db->setQuery($query);
		$employer = $db->loadObject();
		
		$query = "SELECT * FROM #__jbjobs_custom_field 
		  		   WHERE published='1' AND field_for='job' ORDER BY ordering";
		$db->setQuery($query);
		$custom = $db->loadObjectList();
		  
		$query = "UPDATE #__jbjobs_job SET hits=hits+1 WHERE id=".$db->quote($id);
		$db->setQuery($query);
		$db->query();
		
		global $tree;
		$query = "SELECT * FROM #__jbjobs_fieldorder WHERE field_for=3 AND parent=0 ORDER BY ordering";
		$db->setQuery($query);
		$pars = $db->loadObjectList();
		
		// subcategories view as tree
	   	$tree = array();
	   	
	   	foreach ($pars as $v) {
	       	$ident = '';
	       	$tree[] = $v;
			$this->tree($v->id, $ident, $tree);
		}
	  
	  	$return[0] = $data;
	  	$return[1] = $custom;
	  	$return[2] = $tree;
	  	$return[3] = $employer;
	  
	  	return $return;
	}
	
	//9.Simple search
	function getSimpleSearch(){
		// Initialize variables
		$app =& JFactory::getApplication();
		$db 	= & JFactory::getDBO();		
		$post   = JRequest::get('post');
		$id 	= JRequest::getVar('id', 0, 'get', 'string');
		$keyword  	 	 = (!empty($post['keyword'])) ? $post['keyword'] : JRequest::getVar('keyword','', 'get', 'string');
		$phrase 	 	 = (!empty($post['phrase'])) ? $post['phrase'] : 'any';
		$id_job_spec 	 = (!empty($post['id_job_spec'])) ?(int) $post['id_job_spec'] : (int) JRequest::getVar('id_job_spec', 0, 'get', 'string');
		$id_job_categ 	 = JRequest::getVar('id_job_categ', 0, 'get', 'int');
		$id_job_pos_type = JRequest::getVar('id_job_pos_type', 0, 'get', 'int');
		$id_industry	 = JRequest::getVar('id_industry', 0, 'get', 'int');
		$id_degree_level = JRequest::getVar('id_degree_level', 0, 'get', 'int');
		$id_job_exp		 = JRequest::getVar('id_job_exp', 0, 'get', 'int');
		$min_salary		 = JRequest::getVar('minsalary', 0, 'get', 'int');
		$max_salary		 = JRequest::getVar('maxsalary', 0, 'get', 'int');
		$id_country  	 = (!empty($post['id_country'])) ?(int) $post['id_country'] :(int) JRequest::getVar('id_country', 0, 'get', 'string');
		$city		 	 = (!empty($post['city'])) ? $post['city'] : JRequest::getVar('city','', 'get', 'string');
		$state		 	 = (!empty($post['state'])) ? $post['state'] : JRequest::getVar('state','', 'get', 'string');
		
		$keyword = preg_replace("/\s*,\s*/", ",", $keyword); //remove the spaces before and after the commas(,)
		switch ($phrase) {
			case 'exact':
				$text		= $db->Quote( '%'.$db->getEscaped( $keyword, true ).'%', false );
				$wheres2 	= array();
				$wheres2[] 	= 'a.job_title LIKE '.$text;
				$wheres2[] 	= 'a.state LIKE '.$text;
				$wheres2[] 	= 'a.city LIKE '.$text;
				$wheres2[] 	= 'b.country LIKE '.$text;
				$wheres2[] 	= 'c.comp_name LIKE '.$text;
				$wheres2[] 	= 'cv.value LIKE '.$text;
				$wheres2[] 	= 'cv.valuetext LIKE '.$text;
				$wheres2[] 	= 'a.short_desc LIKE '.$text;
				$wheres2[] 	= 'a.long_desc LIKE '.$text;
				$queryStrings[] = '(' . implode( ') OR (', $wheres2 ) . ')';
				break;
	
			case 'all':
			case 'any':
			default:
				$words = explode(',', $keyword);
				$wheres = array();
				foreach ($words as $word) {
					$word		= $db->Quote('%'.$db->getEscaped($word, true).'%', false);
					$wheres2 	= array();
					$wheres2[] 	= 'a.job_title LIKE '.$word;
					$wheres2[] 	= 'a.state LIKE '.$word;
					$wheres2[] 	= 'a.city LIKE '.$word;
					$wheres2[] 	= 'b.country LIKE '.$word;
					$wheres2[] 	= 'c.comp_name LIKE '.$word;
					$wheres2[] 	= 'cv.value LIKE '.$word;
					$wheres2[] 	= 'cv.valuetext LIKE '.$word;
					$wheres2[] 	= 'a.short_desc LIKE '.$word;
					$wheres2[] 	= 'a.long_desc LIKE '.$word;
					$wheres[] 	= implode(' OR ', $wheres2);
				}
				$queryStrings[] = '(' . implode( ($phrase == 'all' ? ') AND (' : ') OR ('), $wheres ) . ')';
				break;
		}
		
		if($id_job_spec > 0){
			$queryStrings[] = "a.id_job_spec =".$id_job_spec;
		}
		if($id_job_categ > 0){
			$queryStrings[] = "a.id_job_spec IN (SELECT id FROM #__jbjobs_job_spec WHERE id_category=".$db->quote($id_job_categ).")";
		}
		if($id_job_pos_type > 0){
			$queryStrings[] = "a.id_pos_type =".$id_job_pos_type;
		}
		if($id_industry > 0){
			$queryStrings[] = "c.id_industry =".$id_industry;
		}
		if($id_degree_level > 0){
			$queryStrings[] = "a.id_degree_level =".$id_degree_level;
		}
		if($id_job_exp > 0){
			$queryStrings[] = "a.id_job_exp =".$id_job_exp;
		}
		if($min_salary > 0 && $max_salary > 0){
			$queryStrings[] = "a.salary BETWEEN $min_salary AND $max_salary";
		}
		if($id_country > 0){
			$queryStrings[] = "a.id_country =".$db->quote($id_country);
		}
		if($city){
			$queryStrings[] = "a.city =".$db->quote($city);
		}
		if($state){
			$queryStrings[] = "a.state =".$db->quote($state);
		}
		
		$where = implode (' AND ', $queryStrings);
		
		$now = date('Y-m-d'); // H:i:s', time() + ( $app->getCfg('offset') * 60 * 60 ) );
		$where .= " AND a.is_active='y' AND a.publish_date <= '".$now."' AND expire_date >= '".$now."' AND expire_date <> '0000-00-00 00:00:00'";
			
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= JRequest::getVar('limitstart', 0, '', 'int');
		
		$total = 0;
		$query = "SELECT DISTINCT a.*,country,c.id id_employer,c.comp_name,c.show_comp_name,comp_type,b.id countryid,if(now()<a.hotjob_expire, true, false) is_hot FROM #__jbjobs_job a".
		      	 " LEFT JOIN #__jbjobs_country b ON a.id_country = b.id".
			 	 " LEFT JOIN #__jbjobs_employer c ON a.employer_id = c.user_id".
		 		 " LEFT JOIN #__jbjobs_custom_field_value cv ON cv.jobid=a.id".
				 " LEFT JOIN #__jbjobs_comp_type d ON c.id_comp_type = d.id". 
				 " WHERE ".$where.
				 " ORDER BY is_hot DESC, a.is_featured DESC, a.publish_date DESC, a.id DESC";;
		$db->setQuery($query);
		$db->query();
		$total = $db->getNumRows();
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination( $total, $limitstart, $limit );
	
		$db->setQuery( $query, $pageNav->limitstart, $pageNav->limit );
		$rows = $db->loadObjectList();	
		
		$return[0] = $rows;
		$return[1] = $pageNav;
		
		return $return;
	}
	
	//10.Advance Search Result
	function getAdvSearchRes(){
		
		// Initialize variables
		$app =& JFactory::getApplication();
		$user	=& JFactory::getUser();
		$db 	 	 = & JFactory::getDBO();		
		$post    	 = JRequest::get('post');
		$keyword 	 = (!empty($post['keyword'])) ? $post['keyword'] : JRequest::getVar('keyword','', 'post', 'string');
		$phrase 	 = (!empty($post['phrase'])) ? $post['phrase'] : 'any';
		$city	 	 = (!empty($post['city'])) ? $post['city'] : JRequest::getVar('city','', 'post', 'string');
		$id_country  = (!empty($post['id_c'])) ? $post['id_c'] : JRequest::getVar('id_c','', 'post', 'string');
		$id_job_exp	 = (!empty($post['id_je'])) ? $post['id_je'] : JRequest::getVar('id_je','', 'post', 'string');
		$min_salary	 = (!empty($post['min_s'])) ? $post['min_s'] : JRequest::getVar('min_s','', 'post', 'string');
		$max_salary  = (!empty($post['max_s'])) ? $post['max_s'] : JRequest::getVar('max_s','', 'post', 'string');
		$id_salary_type = (!empty($post['id_st'])) ? $post['id_st'] : JRequest::getVar('id_st','', 'post', 'string');
		$id_jspec 	 = JRequest::getVar('id_spec', array(), 'post', 'array');
		$id_jcateg   = JRequest::getVar('id_categ', array(), 'post', 'array');
		$id_ind		 = JRequest::getVar('id_ind', array(), 'post', 'array');
		$id_pos_type = JRequest::getVar('id_pos_type', 0, 'post', 'int');
		
		$keyword = preg_replace("/\s*,\s*/", ",", $keyword); //remove the spaces before and after the commas(,)
		switch ($phrase) {
			case 'exact':
				$text		= $db->Quote( '%'.$db->getEscaped( $keyword, true ).'%', false);
				$wheres2 	= array();
				$wheres2[] 	= 'a.job_title LIKE '.$text;
				$wheres2[] 	= 'a.state LIKE '.$text;
				$wheres2[] 	= 'a.city LIKE '.$text;
				$wheres2[] 	= 'b.country LIKE '.$text;
				$wheres2[] 	= 'c.comp_name LIKE '.$text;
				$wheres2[] 	= 'cv.value LIKE '.$text;
				$wheres2[] 	= 'cv.valuetext LIKE '.$text;
				$wheres2[] 	= 'a.short_desc LIKE '.$text;
				$wheres2[] 	= 'a.long_desc LIKE '.$text;
				$queryStrings[] = '(' . implode( ') OR (', $wheres2 ) . ')';
				break;
	
			case 'all':
			case 'any':
			default:
				$words = explode(',', $keyword);
				$wheres = array();
				foreach ($words as $word) {
					$word		= $db->Quote('%'.$db->getEscaped($word, true).'%', false);
					$wheres2 	= array();
					$wheres2[] 	= 'a.job_title LIKE '.$word;
					$wheres2[] 	= 'a.state LIKE '.$word;
					$wheres2[] 	= 'a.city LIKE '.$word;
					$wheres2[] 	= 'b.country LIKE '.$word;
					$wheres2[] 	= 'c.comp_name LIKE '.$word;
					$wheres2[] 	= 'cv.value LIKE '.$word;
					$wheres2[] 	= 'cv.valuetext LIKE '.$word;
					$wheres2[] 	= 'a.short_desc LIKE '.$word;
					$wheres2[] 	= 'a.long_desc LIKE '.$word;
					$wheres[] 	= implode(' OR ', $wheres2);
				}
				$queryStrings[] = '(' . implode( ($phrase == 'all' ? ') AND (' : ') OR ('), $wheres ) . ')';
				break;
		}
		
		if($city){
			$queryStrings[] ="a.city LIKE '%".$city."%'";
		}	
		if(!empty($id_jspec)){
			$job_spec = implode(',', $id_jspec);
			$queryStrings[] ="a.id_job_spec IN ($job_spec)";
		}
		if(!empty($id_jcateg)){
			$job_categ = implode(',', $id_jcateg);
			$queryStrings[] = "a.id_job_spec IN (SELECT id FROM #__jbjobs_job_spec WHERE id_category IN ($job_categ))";
		}
		if(!empty($id_ind)){
			$industry = implode(',', $id_ind);
			$queryStrings[] = "c.id_industry IN ($industry)";
		}
		if(count($id_country) > 0 && !(count($id_country) ==1 && (empty($id_country[0])))){
			$country = implode(',', $id_country );
			$queryStrings[] = "a.id_country IN ( ". $db->quote( $country ) ." )";
		}
		if(count($id_job_exp) > 0 && !(count($id_job_exp) ==1 && empty($id_job_exp[0]))){
			$job_exp = implode(',', $id_job_exp );
			$queryStrings[] = "a.id_job_exp IN ( ". $db->quote( $job_exp ) ." )";
		}
		if($id_pos_type){
			$queryStrings[] = "a.id_pos_type =".$db->quote($id_pos_type);
		}
		if($min_salary > 0){
			$queryStrings[] = "salary >= ".$db->quote($min_salary);		
		}
		if($max_salary > 0){
			$queryStrings[] = "salary <= ".$db->quote($max_salary);		
		}
		if($id_salary_type > 0){
			$queryStrings[] = "id_salary_type =".$db->quote($id_salary_type);
		}
		$where =  implode (' AND ', $queryStrings);
		
		$now = date('Y-m-d'); // H:i:s', time() + ( $app->getCfg('offset') * 60 * 60 ) );
		$where .= " AND a.is_active='y' and a.publish_date <= '".$now."' and expire_date >= '".$now."' and expire_date <> '0000-00-00 00:00:00'";
		
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= (empty($_GET['limitstart'])) ? 0 : $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', 0, 'int');
	
		$query ="SELECT DISTINCT a.*,b.country,b.id AS countryid, c.comp_name,c.show_comp_name,comp_type,if(now()<a.hotjob_expire, true, false) is_hot FROM #__jbjobs_job a".
		      	 " LEFT JOIN #__jbjobs_country b ON a.id_country = b.id".
			 	 " LEFT JOIN #__jbjobs_employer c ON a.employer_id = c.user_id".
		 		 " LEFT JOIN #__jbjobs_custom_field_value cv ON cv.jobid=a.id".
				 " LEFT JOIN #__jbjobs_comp_type d ON c.id_comp_type = d.id WHERE ".$where.
				 " ORDER BY is_hot DESC, a.is_featured DESC, a.publish_date DESC, a.id DESC";
		$db->setQuery($query);
		$db->query();
		$total = $db->getNumRows();
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination($total, $limitstart, $limit);
	
		$db->setQuery($query, $pageNav->limitstart, $pageNav->limit);	
		$rows = $db->loadObjectList();
		
		$return[0] = $rows;
		$return[1] = $pageNav;
		return $return;	
	}
	
	//11.Detail Company
	function getDetailCompany(){
		$app 	=& JFactory::getApplication();
		$user	=& JFactory::getUser();
		$id 	= JRequest::getVar('id', 0, 'get', 'int');
		$db = & JFactory::getDBO();	
	
		if(empty($id)){
			$return	= JRoute::_('index.php?option=com_jbjobs');
			$app->redirect($return);
		}
	
		$query = "SELECT a.*,b.email,c.id id_country,c.country,i.id id_industry,i.industry,ct.id id_comp_type,ct.comp_type FROM #__jbjobs_employer a
				LEFT JOIN #__users b ON a.user_id = b.id
				LEFT JOIN #__jbjobs_country c ON a.id_country = c.id 
				LEFT JOIN #__jbjobs_industry i ON a.id_industry = i.id
				LEFT JOIN #__jbjobs_comp_type ct ON a.id_comp_type = ct.id
				WHERE a.user_id =".$db->quote($id);
		$db->setQuery($query);
		$data = $db->loadObjectList();
		
		if(!count($data)){
			$return	= JRoute::_('index.php?option=com_jbjobs');
			$app->redirect($return);
		}
	
	  	$query = "SELECT * FROM #__jbjobs_custom_field WHERE field_for='employer' AND published='1' ORDER BY ordering";
	  	$db->setQuery($query);
	  	$custom = $db->loadObjectList();
	  
		global $tree;
		$query = "SELECT * FROM #__jbjobs_fieldorder WHERE field_for=1 AND parent=0 ORDER BY ordering";
		$db->setQuery($query);
		$pars = $db->loadObjectList();
		
		// subcategories view as tree
		$tree = array();
		   
		foreach ($pars as $v) {
			$ident = '';
		    $tree[] = $v;
			$this->tree($v->id, $ident, $tree);
		}
		  
		$return[0] = $data;
		$return[1] = $custom;
		$return[2] = $tree;
		return $return;
	}
	
	//11.Anonymous Job apply
	function getAnmsJobapply(){
		$app =& JFactory::getApplication();
		$id 	= JRequest::getVar('id', 0, 'get', 'int');
		$db 	= & JFactory::getDBO();
	
		if(empty($id)){
			$return	= JRoute::_('index.php?option=com_jbjobs');
			$app->redirect($return);	
		}
	
		$query = "SELECT j.* FROM #__jbjobs_job j WHERE j.id =".$db->quote($id);
		$db->setQuery($query);
		$data = $db->loadObject();
		if(!count($data)){
			$return	= JRoute::_('index.php?option=com_jbjobs');
			$app->redirect($return);	
		}
		
	  $return[0] = $data;
	  return $return;
	}

	

/**	
==================================================================================================================	
	SECTION : JobSeeker
	1.Register New JobSeeker
	2.Edit JobSeeker Profile
	3.My Saved Jobs
	4.Edit Resume
	5.View Resume
	6.Edit Cover Letter
	7.View Cover Letter
	8.Resume views by Recruiters
==================================================================================================================
*/
	//1.Register New JobSeeker
	function getRegJobSeekerNew(){
		$app  =& JFactory::getApplication();
		$user =& JFactory::getUser();
		$db =& JFactory::getDBO();
	
		// if logged user try to register new then redirect to jbjobs index
		if($user->id){
			$return	= JRoute::_('index.php?option=com_jbjobs&task=decidedashboard');
			$app->redirect($return);
			return;
		}
	
		$switch = $this->whichUse($user->id);
	
		if($switch == 1){
			$app->redirect( JRoute::_('index.php?option=com_comprofiler&task=registers&type=jobseeker') );
			return;
		}
	
	  $query = "SELECT * FROM #__jbjobs_custom_field WHERE field_for='jobseeker' AND published='1' ORDER BY ordering";
	  $db->setQuery($query);
	  $custom = $db->loadObjectList();
	  
	  return $custom;
	}
	
	//2.Edit JobSeeker Profile
	function getEditJobSeeker(){
		$app  =& JFactory::getApplication();
		$user =& JFactory::getUser();
		$db	  =& JFactory::getDBO();
		
		// if logged user try to register new then redirect to jbjobs index
		if($this->isEmployer($user->id)){
			$return	= JRoute::_('index.php?option=com_jbjobs');
			$app->redirect($return);	
			return;
		}
		
		if($user->id == 0){
			$return	= JRoute::_('index.php?option=com_user&view=login');
			$app->redirect($return);
		}
		$row =& JTable::getInstance('jobSeeker','Table'); 
		if(true){
			$query = "select id from #__jbjobs_jobseeker where user_id =".$db->quote($user->id);
			$db->setQuery( $query );
			$id_jobseeker = $db->loadResult();
			$row->load($id_jobseeker);
		}
		$query = "SELECT * FROM #__jbjobs_custom_field WHERE field_for='jobseeker' AND published='1' ORDER BY ordering";
		$db->setQuery($query);
		$custom = $db->loadObjectList();
		
		$exp =& JTable::getInstance('experience', 'Table'); 
		if(true){
			$query = "select id from #__jbjobs_experience where user_id =".$db->quote($user->id);
			$db->setQuery( $query );
			$id_exp = $db->loadResult();
			$exp->load($id_exp);
		}
		
		global $tree;
		$query = "SELECT * FROM #__jbjobs_fieldorder
				  where field_for=2 AND parent=0
				  ORDER BY ordering";
		$db->setQuery($query);
		$pars = $db->loadObjectList();
		
		// subcategories view as tree
	   	$tree = array();
	   	
	   	foreach ($pars as $v) {
	       	$ident = '';
	       	$tree[] = $v;
			$this->tree($v->id, $ident, $tree);
		}
	    
		$return[0] = $row;
		$return[1] = $exp;
		$return[2] = $custom;
		$return[3] = $tree;
		return $return;
	}

	// list subcats as tree
	function tree($parent, $ident, $tree) {
	    global $tree;
	    $database = &JFactory::getDBO();
	
	   $database->setQuery("SELECT * FROM #__jbjobs_fieldorder WHERE parent =".$parent." ORDER BY ordering");
	    $rows = $database->loadObjectList();
	    if ($database->getErrorNum()) {
	        echo $database->stderr();
	        return false;
	    }
	    foreach ($rows as $v) {
	    $v->fieldtitle = $ident.".&nbsp;&nbsp;<sup>L</sup>&nbsp;".$v->fieldtitle;
	    $v->fieldtitle = str_replace('.&nbsp;&nbsp;<sup>L</sup>&nbsp;','.&nbsp;&nbsp;&nbsp;&nbsp;',$v->fieldtitle);
	    $x = strrpos($v->fieldtitle,'.&nbsp;&nbsp;&nbsp;&nbsp;');
	    $v->fieldtitle = substr_replace($v->fieldtitle, '.&nbsp;&nbsp;<sup>L</sup>&nbsp;', $x,7);
	    $tree[] = $v;
	    
	    $this->tree($v->id, $ident.".&nbsp;&nbsp;<sup>L</sup>&nbsp;", $tree);
	    }
	}
	
	//3.My Saved Jobs
	function getMySavedJob(){
		$app  =& JFactory::getApplication();
		$user	=& JFactory::getUser();
		$db		=& JFactory::getDBO();	
		$post   = JRequest::get('post');
		
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= (empty($_GET['limitstart'])) ? 0 : $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', 0, 'int');
		
		if($user->id == 0){
			$return	= JRoute::_('index.php?option=com_user&view=login');
			$app->redirect( $return );	
		}
		
		if(!$this->isJobSeeker($user->id)){
			$return	= JRoute::_('index.php?option=com_jbjobs');
			$app->redirect( $return );	
		}	
	
		$query = "SELECT COUNT(*) FROM #__jbjobs_save_job a".
				 " LEFT JOIN #__jbjobs_job b ON a .id_job = b.id".
				 " LEFT JOIN #__jbjobs_employer d ON b.employer_id = d.user_id ".
				 " LEFT JOIN #__jbjobs_country c ON b.id_country = c.id".
				 " WHERE a.jseeker_id =".$db->quote($user->id)." and is_view ='y'";	
		$db->setQuery($query);
		$total = $db->loadResult();
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination($total, $limitstart, $limit);
		
		$query = "SELECT a.*,b.id id_job,b.job_title,d.id id_employer,d.comp_name,d.show_comp_name,b.state,c.id id_country,c.country,b.is_active,b.is_featured,b.manage_applicant,b.ext_apply_url FROM #__jbjobs_save_job a".
				 " LEFT JOIN #__jbjobs_job b ON a.id_job = b.id".
				 " LEFT JOIN #__jbjobs_employer d ON b.employer_id = d.user_id ".
				 " LEFT JOIN #__jbjobs_country c ON b.id_country = c.id".
				 " WHERE a.jseeker_id =".$db->quote($user->id)." and is_view ='y'";		
		$db->setQuery($query, $pageNav->limitstart, $pageNav->limit);
		$rows = $db->loadObjectList();
		
		$return[0] = $rows;
		$return[1] = $pageNav;
		return $return;
	}
	
	//4.Edit Resume
	function getEditResume(){
		$app =& JFactory::getApplication();
		$user	=& JFactory::getUser();
		$db		=& JFactory::getDBO();
		$id 	= JRequest::getVar('id', 0, 'get', 'int');
		
		if(!$user->id){
			$return	= JRoute::_('index.php?option=com_user&view=login');
			$app->redirect( $return );	
		}
		
		if(!$this->isJobSeeker($user->id)){
			$return	= JRoute::_('index.php?option=com_jbjobs');
			$app->redirect( $return );
		}
	
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= (empty($_GET['limitstart'])) ? 0 : $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', 0, 'int');
	
		$row =& JTable::getInstance('resume','Table');
		
		if(true){
			$row->load($id);
		}
		
		//get resume of jobseeker
		$post   = JRequest::get('post');
		
		$query = "SELECT COUNT(*)".	          
			 	 " FROM #__jbjobs_resume where jseeker_id =".$db->quote($user->id);
		$db->setQuery( $query );
		$total = $db->loadResult();
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination($total, $limitstart, $limit);
		
		$query = "SELECT * ".	          
				 " FROM #__jbjobs_resume where jseeker_id  =".$db->quote( $user->id );
		$db->setQuery($query);
		$resumes = $db->loadObjectList();
		
		$return[0] = $row;
		$return[1] = $resumes;
		
		return $return;
	}
	
	//get the total available credit of the employer
	function getTotalCredit($userid){
		$db	=& JFactory::getDBO();
		$total_credit = 0;
		$query = "SELECT (SUM(credit_plus)-SUM(credit_minus)) FROM #__jbjobs_transaction WHERE user_id = ".$db->quote($userid);
		$db->setQuery($query);
		$total_credit = $db->loadResult();
		$total_credit = number_format($total_credit, 2, '.', '' ); 
		return $total_credit;
	}
	
	// check if jobseeker has applied / saved job
	function checkSavedApplied($jobid, $userid){
		$db	=& JFactory::getDBO();
		$row =& JTable::getInstance('saveJob', 'Table');
		
		$query = "SELECT COUNT(*) FROM #__jbjobs_save_job WHERE is_view ='y' AND id_job = ".$db->quote($jobid).
				 " AND jseeker_id =".$userid;
		$db->setQuery($query);
		$chk_save = $db->loadResult();		
		
		$query = "SELECT COUNT(*) FROM #__jbjobs_save_job WHERE is_apply ='y' AND id_job = ".$db->quote($jobid).				 
				 " AND jseeker_id =".$userid;
		$db->setQuery($query);
		$chk_apply = $db->loadResult();	
		
		$return['is_saved'] = $chk_save;
		$return['is_applied'] = $chk_apply;
		return $return;
	}
	
	//5.View Resume	
	function getViewResume(){
		$app =& JFactory::getApplication();
		$user	=& JFactory::getUser();
		if(!$user->id){
			$return	= JRoute::_('index.php?option=com_users&task=login');
			$app->redirect( $return );
		}
		$db		=& JFactory::getDBO();
		$id 	= JRequest::getVar('id', 0, 'get', 'int');
		$row =& JTable::getInstance('resume','Table');
		$row->load($id);
		if($row->jseeker_id != $user->id){
			if($this->isJobSeeker($user->id)){
				$return	= JRoute::_('index.php?option=com_jbjobs');
				$app->redirect( $return );	
				return;
			}
			$query = "SELECT count(*) FROM #__jbjobs_save_job s INNER JOIN #__jbjobs_job j ON s.id_job=j.id 
					  WHERE s.jseeker_id=".$db->quote( $row->jseeker_id )." AND s.is_apply='y' AND j.employer_id=".$db->quote( $user->id );
			$db->setQuery($query);
			if(!$db->loadResult()){
				$return	= JRoute::_('index.php?option=com_jbjobs');
				//$app->redirect( $return );	
				//return;
			}
			if($row->is_active == 'n'){
				$return	= JRoute::_('index.php?option=com_jbjobs');
				$app->redirect( $return );	
				return;
			}
		}
		return $row;
	}
		
	//6.Edit Cover Letter
	function getEditCoverletter(){
		$app =& JFactory::getApplication();
		$user	=& JFactory::getUser();
		$db		=& JFactory::getDBO();
		$id 	= JRequest::getVar('id', 0, 'get', 'int');
		
		if(!$user->id){
			$return	= JRoute::_('index.php?option=com_user&view=login');
			$app->redirect( $return );	
		}
		
		if(!$this->isJobSeeker($user->id)){
			$return	= JRoute::_('index.php?option=com_jbjobs');
			$app->redirect( $return );
		}
	
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= (empty($_GET['limitstart'])) ? 0 : $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', 0, 'int');
	
		$row =& JTable::getInstance('coverletter', 'Table');
		
		if(true){
			$row->load($id);
		}
		
		//get resume of jobseeker
		$post   = JRequest::get('post');
		
		$query = "SELECT COUNT(*) FROM #__jbjobs_coverletter WHERE jseeker_id =".$db->quote($user->id);
		$db->setQuery($query);
		$total = $db->loadResult();
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination($total, $limitstart, $limit);
		
		$query = "SELECT * FROM #__jbjobs_coverletter WHERE jseeker_id =".$db->quote($user->id);
		$db->setQuery($query);
		$cletters = $db->loadObjectList();
		
		$return[0] = $row;
		$return[1] = $cletters;
		
		return $return;
	}

	//7.View Cover Letter
	function getViewCoverletter(){
		$app =& JFactory::getApplication();
		$user	=& JFactory::getUser();
		if(!$user->id){
			$return	= JRoute::_('index.php?option=com_users&task=login');
			$app->redirect( $return );
		}
		$db		=& JFactory::getDBO();
		$id 	= JRequest::getVar('id', 0, 'get', 'int');
		$row =& JTable::getInstance('coverletter','Table');
		$row->load($id);
		if($row->jseeker_id != $user->id){
			if($this->isJobSeeker($user->id)){
				$return	= JRoute::_('index.php?option=com_jbjobs');
				$app->redirect( $return );	
				return;
			}
			
			if(!$row->is_active){
				$return	= JRoute::_('index.php?option=com_jbjobs');
				$app->redirect($return);	
				return;
			}
		}
		return $row;
	}

	//8.Resume views by Recruiters
	function getResumeViews(){
		$app =& JFactory::getApplication();
		
		$limit = $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= (empty($_GET['limitstart'])) ? 0 : $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', 0, 'int');
	
		$user	=& JFactory::getUser();
		if(!$user->id){
			$return	= JRoute::_('index.php?option=com_users&task=login');
			$app->redirect( $return );
		}
		$db		=& JFactory::getDBO();
		
		$query = "SELECT SUM(hits) FROM #__jbjobs_resume_view WHERE jseeker_id=$user->id";
		$db->setQuery($query);
		$totalhits = $db->loadResult();
		
		$query = "SELECT COUNT(*) FROM #__jbjobs_resume_view WHERE jseeker_id=$user->id";
		$db->setQuery($query);
		$total = $db->loadResult();
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination($total, $limitstart, $limit);
	
		$query = "SELECT r.*,e.id id_employer,e.comp_name,e.show_comp_name FROM #__jbjobs_resume_view r 
				  LEFT JOIN #__jbjobs_employer e ON e.user_id=r.employer_id
				  WHERE r.jseeker_id=$user->id";
		$db->setQuery($query, $pageNav->limitstart, $pageNav->limit);
		$rows = $db->loadObjectList();
		
		$return[0] = $rows;
		$return[1] = $totalhits;
		$return[2] = $pageNav;
		$return[3] = $total;
		return $return;
	} 

	function getJobalert(){
		$app =& JFactory::getApplication();
		$app  =& JFactory::getApplication();
		$user =& JFactory::getUser();
		$db	  =& JFactory::getDBO();
		
		// if logged user try to register new then redirect to jbjobs index
		if($this->isEmployer($user->id)){
			$return	= JRoute::_('index.php?option=com_jbjobs&task=decidedashboard');
			$app->redirect($return);	
		}
		if($user->id == 0){
			$return	= JRoute::_('index.php?option=com_user&view=login');
			$app->redirect($return);	
		}
		
		$row =& JTable::getInstance('jobalert', 'Table'); 
		if(true){
			$query = "select id from #__jbjobs_job_alert where userid =".$db->quote($user->id);
			$db->setQuery($query);
			$id_ja = $db->loadResult();
			$row->load($id_ja);
		}
		
		$spec_ids = $row->id_job_spec;
		$query = "SELECT js.* FROM #__jbjobs_job_spec js WHERE js.id IN(".$spec_ids.")";
		$db->setQuery($query);
		$specs = $db->loadObjectList();
	
		$return[0] = $row;
	 	$return[1] = $specs;
	  	return $return;
	}
	
	//jobAlert
	function getRecommendedJob(){
		$app =& JFactory::getApplication();
		$user	=& JFactory::getUser();
		$db		=& JFactory::getDBO();
		$id 	= JRequest::getVar('id', 0, 'get', 'int');
		
		if(!$id){
			$return	= JRoute::_('index.php?option=com_jbjobs&view=jobseeker&layout=jobalert');
			$msg = JText::_('JBJOBS_JOBALERT_NOT_SAVED');
			$app->redirect($return, $msg);
		}
		
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', 0, 'int');
		
		$query = "SELECT ja.* from #__jbjobs_job_alert ja WHERE ja.id=".$id;
		$db->setQuery($query);
		$alert = $db->loadObject();
		
		$keyword = $alert->keyword;
		
		// slashes cause errors, <> get stripped anyway later on. # causes problems.
		$badchars = array('#','>','<','\\'); 
		$searchword = trim(str_replace($badchars, '', $keyword));
	
		//stript the space before and after comma(,)
		$spaceStripped = preg_replace("/\s*,\s*/", ",", $searchword);
		
		$result = array();
		$result = explode(',', $spaceStripped);

		$phrase = $alert->phrase;
		switch ($phrase) {
			case 'exact':
				$text		= $db->Quote( '%'.$db->getEscaped( $result, true ).'%', false );
				$wheres2 	= array();
				$wheres2[] 	= 'a.job_title LIKE '.$text;
				$wheres2[] 	= 'a.state LIKE '.$text;
				$wheres2[] 	= 'a.city LIKE '.$text;
				$wheres2[] 	= 'b.country LIKE '.$text;
				$wheres2[] 	= 'c.comp_name LIKE '.$text;
				$wheres2[] 	= 'cv.value LIKE '.$text;
				$wheres2[] 	= 'cv.valuetext LIKE '.$text;
				$wheres2[] 	= 'a.short_desc LIKE '.$text;
				$wheres2[] 	= 'a.long_desc LIKE '.$text;
				$queryStrings[] = '(' . implode( ') OR (', $wheres2 ) . ')';
				break;
	
			case 'all':
			case 'any':
			default:
				//$words = explode( ' ', $result );
				$wheres = array();
				foreach ($result as $word) {
					$word		= $db->Quote( '%'.$db->getEscaped( $word, true ).'%', false );
					$wheres2 	= array();
					$wheres2[] 	= 'a.job_title LIKE '.$word;
					$wheres2[] 	= 'a.state LIKE '.$word;
					$wheres2[] 	= 'a.city LIKE '.$word;
					$wheres2[] 	= 'b.country LIKE '.$word;
					$wheres2[] 	= 'c.comp_name LIKE '.$word;
					$wheres2[] 	= 'cv.value LIKE '.$word;
					$wheres2[] 	= 'cv.valuetext LIKE '.$word;
					$wheres2[] 	= 'a.short_desc LIKE '.$word;
					$wheres2[] 	= 'a.long_desc LIKE '.$word;
					$wheres[] 	= implode( ' OR ', $wheres2 );
				}
				$queryStrings[] = '(' . implode( ($phrase == 'all' ? ') AND (' : ') OR ('), $wheres ) . ')';
				break;
		}
			
		$id_job_spec = $alert->id_job_spec;
		if($id_job_spec > 0){
			$queryStrings[] = "a.id_job_spec IN (".$id_job_spec.")";
		}
		
		$where =  implode (' AND ', $queryStrings);
		$now = date('Y-m-d H:i:s', time() + ($app->getCfg('offset') * 60 * 60));
		$where .= " AND a.is_active='y' AND a.expire_date > '".$now."' AND a.expire_date <> '0000-00-00 00:00:00' ";
		
		$total = 0;
		$query = "SELECT DISTINCT a.*,c.comp_name,e.exp_name,
				  (SELECT COUNT(*) FROM #__jbjobs_save_job WHERE is_apply ='y' AND id_job=a.id AND jseeker_id=$user->id) AS isApplied,
				  (SELECT COUNT(*) FROM #__jbjobs_save_job WHERE is_view ='y' AND id_job=a.id AND jseeker_id=$user->id) AS isSaved
				  FROM #__jbjobs_job a
		      	  LEFT JOIN #__jbjobs_country b ON a.id_country = b.id
			 	  LEFT JOIN #__jbjobs_employer c ON a.employer_id = c.user_id
		 		  LEFT JOIN #__jbjobs_custom_field_value cv ON cv.jobid=a.id
				  LEFT JOIN #__jbjobs_comp_type d ON c.id_comp_type = d.id
		 		  LEFT JOIN  #__jbjobs_job_exp e ON a.id_job_exp = e.id 
				  WHERE $where
				  ORDER BY a.is_featured DESC, a.publish_date DESC, a.id DESC";
		$db->setQuery($query);
		$db->query();
		$total = $db->getNumRows();
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination( $total, $limitstart, $limit );
	
		$db->setQuery( $query, $pageNav->limitstart, $pageNav->limit );
		$rows = $db->loadObjectList();	
		
		//get the jobids sent
		$query = "SELECT * from #__jbjobs_jobalert_send where alertid=$id";
		$db->setQuery($query);
		$alerts = $db->loadObjectList();
		
		$return[0] = $rows;
		$return[1] = $pageNav;
		$return[2] = $alerts;
		return $return;
	}

/**	
==================================================================================================================	
	SECTION : Employer
	1.Register New Employer
	2.Edit Employer Profile
	3.Edit Job
	4.Show My Job Postings
	5.Publish Job
	6.Job Applicants
	7.View Applicants
	8.Detail JobSeeker
	9.Find Resume
	10.My Referrals
	11.Show Credit
	12.Manual Payment
	13.Buy Credit
	14.Show Billing History
	15.Print Invoice
	16.History of plans Subscribed to
	17.Subscribe to a Plan
	18.Subscription Details
	19.Manual Subscription
	20.Subscription Checkout
==================================================================================================================
*/	
	//1.Register New Employer
	function getRegEmployerNew(){
		$app =& JFactory::getApplication();
		$user	=& JFactory::getUser();
	
		// if logged user try to register new then redirect to jbjobs index
		if($user->id){
			$return	= JRoute::_('index.php?option=com_jbjobs&task=decidedashboard');
			$app->redirect($return);
			return;
		}
	
		$switch = $this->whichUse($user->id);
	
		if($switch == 1){
			$app->redirect( JRoute::_('index.php?option=com_comprofiler&task=registers&type=employer') );
			return;
		}
	
		$db	=& JFactory::getDBO();
		$query = "SELECT * FROM #__jbjobs_custom_field WHERE field_for='employer' AND published='1' ORDER BY ordering";
		$db->setQuery($query);
		$custom = $db->loadObjectList();
		
		return $custom;
	}
	
	//2.Edit Employer Profile
	function getEditEmployer(){
		$app =& JFactory::getApplication();
		$user	=& JFactory::getUser();
		$db =& JFactory::getDBO();
		$row =& JTable::getInstance('employer','Table');
		
		if($this->isJobSeeker($user->id)){
			$return	= JRoute::_('index.php?option=com_jbjobs');
			$app->redirect( $return );	
			return;
		}
		
		if($user->id == 0){
			$return	= JRoute::_('index.php?option=com_user&view=login');
			$app->redirect( $return );	
		}
		
		if(true){
			$query = "select id from #__jbjobs_employer where user_id =".$db->quote( $user->id );	
			$db->setQuery( $query );
			$id_employer = $db->loadResult();
			$row->load($id_employer);
		}
		else{
			$name = explode(" ", $user->name);
			$row->firstname = (!empty($name[0])) ? $name[0] : '';
			$row->lastname = (!empty($name[1])) ? $name[1] : '';
		}
	
		$query = "SELECT * FROM #__jbjobs_custom_field WHERE field_for='employer' AND published='1' ORDER BY ordering";
		$db->setQuery($query);
		$custom = $db->loadObjectList();
		
		$fields = $this->getFieldsOrdering(1);
		$parents = $fields[0];
		$children = $fields[1];
	
		$return[0] = $row;
		$return[1] = $custom;
		$return[2] = $parents;
		$return[3] = $children;
		return $return;
	}
	
	//3.Edit Job
	function getFeeds(){
		require_once(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jbjobs'.DS.'helper'.DS.'feeds.php');
		$user 	=& JFactory::getUser();
		$obj = new JBFeeds();
		$feeds =  $obj->getFeedsData($user->id, 50);
		return $feeds;
	}
	
	//3.Edit Job
	function getEditJob(){
		$app =& JFactory::getApplication();
		$db		=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
		
		if(!$user->id OR !$this->isEmployer($user->id)){
			$link = JRoute::_('index.php?option=com_jbjobs');
			$app->redirect( JRoute::_($link),$message);	
		}
		
		$id = JRequest::getVar('id', 0, 'get', 'int');
		$option = JRequest::getCmd('option');
	
		($id == 0)? $isNew = true: $isNew = false;
	
		$row =& JTable::getInstance('job','Table');
		if(!$isNew){
			$row->load($id);
			if(empty($row->job_title)){
				$link = JRoute::_('index.php?option=com_jbjobs');
				$app->redirect($link, $message);	
			}
			if($row->employer_id != $user->id){
				$link = JRoute::_('index.php?option=com_jbjobs');
				$app->redirect($link, $message);	
			}
		}
		
		$query = "select id from #__jbjobs_employer where user_id =".$db->quote( $user->id );
		$db->setQuery( $query );
		$employer_id = $db->loadResult();
		
		$employer = & JTable::getInstance('employer', 'Table');
		$employer->load($employer_id);
		
		$query = "SELECT * FROM #__jbjobs_custom_field 
				  WHERE published='1' AND field_for='job'
				  ORDER BY ordering";
		/*$query = "SELECT *, CONCAT_WS('_', level2, level1) AS level FROM (
				  SELECT t1.* , t2.ordering AS level2, t1.ordering AS level1 
				  FROM #__jbjobs_custom_field AS t1 
				  LEFT JOIN #__jbjobs_custom_field as t2 on t1.parent = t2.id 
				  ) AS depth_table 
				  WHERE published='1' AND field_for='job'
				  ORDER BY level";*/
		$db->setQuery($query);
		$custom = $db->loadObjectList();
		
		$fields = $this->getFieldsOrdering(3);
		$parents = $fields[0];
		$children = $fields[1];
		
		$return[0] = $row;
		$return[1] = $employer;
		$return[2] = $custom;
		$return[3] = $parents;
		$return[4] = $children;
		
		return $return;
	}
	
	//4.Show My Job Postings
	function getShowMyJobs(){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO();
		$user 	=& JFactory::getUser();
		$post   = JRequest::get('post');
		
		if(!$user->id){
			$return	= JRoute::_('index.php?option=com_user&view=login');
			$app->redirect( $return );	
		}
		
		if(!$this->isEmployer($user->id)){
			$return	= JRoute::_('index.php?option=com_jbjobs');
			$app->redirect($return);	
		}
		
		$limit = $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= (empty($_GET['limitstart'])) ? 0 : $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', 0, 'int');
	
		$query = "SELECT COUNT(*)".	          
				 " FROM #__jbjobs_job a WHERE a.employer_id=".$db->quote($user->id);
		$db->setQuery( $query );
		$total = $db->loadResult();
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination($total, $limitstart, $limit);
	
		$query = "SELECT a.*,b.id id_spec,b.specialization  ".
				 " FROM #__jbjobs_job a".
				 " LEFT JOIN  #__jbjobs_job_spec b".
				 " ON a .id_job_spec = b.id WHERE a.employer_id=".$db->quote($user->id).
				 " ORDER BY a.id DESC"
				 ;
		
		$db->setQuery( $query, $pageNav->limitstart, $pageNav->limit );
		$rows = $db->loadObjectList();
	
		$plus = 0;
		$minus = 0;
		$total_credit = 0;
		$query = "select sum(credit_plus) from #__jbjobs_transaction where user_id = ".$db->quote($user->id);
		$db->setQuery( $query );
		$plus = $db->loadResult();
		
		$query = "select sum(credit_minus) from #__jbjobs_transaction where user_id = ".$db->quote($user->id);
		$db->setQuery( $query );
		$minus = $db->loadResult();
		
		$total_credit = $plus - $minus;
		
		$return[0] = $rows;
		$return[1] = $pageNav;
		$return[2] = $total_credit;
		
		return $return;
	}
	
	//5.Publish Job
	function getPublishJob(){
		$app =& JFactory::getApplication();
		$Itemid =  JRequest::getInt('Itemid');
		$db		=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
		
		$config =& JTable::getInstance('config','Table');
		$config->load(1);
		
		$post   = JRequest::get('post');	
		$id 	= JRequest::getVar('id', 0, 'get', 'int');
		
		if(empty($id)){
			$return	= JRoute::_('index.php?option=com_jbjobs');
			$app->redirect( $return );	
		}
		
		if($user->id == 0){
			$return	= JRoute::_('index.php?option=com_user&view=login');
			$app->redirect( $return );	
		}
	
		$is_employer = $this->isEmployer($user->id);
		if($is_employer == 0){
			$return	= JRoute::_('index.php?option=com_jbjobs&view=employer&layout=regemployer');
			$app->redirect( $return );	
		}
		
		$row =& JTable::getInstance('job','Table');
		$row->load($id);
		
		if($row->employer_id != $user->id){
			$return	= JRoute::_('index.php?option=com_jbjobs');
			$app->redirect( $return );	
		}
	
		if($config->get('freemode')) {
			// Initialize variables
			$id_job = JRequest::getVar('id', 0, 'get', 'int');
			$expires = (int) $config->get('limittimeforfreemode', 7);
	
			$job	=& JTable::getInstance('job', 'Table');
			$job->load($id_job);
			
			//check first, job already publish or not
			$now  = date('Y-m-d');// H:i:s', time() + ( $app->getCfg('offset') * 60 * 60 ) );	
			$date_expires = date("Y-m-d", strtotime("+".$expires." day"));	
		
			$job->publish_date = $now;
			$job->expire_date  = $date_expires;
			
			// pre-save checks
			if (!$job->check()) {
				JError::raiseError(500, $job->getError() );
			}
			
			// save the changes	
			if (!$job->store()) {
				JError::raiseError(500, $job->getError() );
			}
			
			//Trigger the plugin event to stream the new job vacancy onto JomSocial Activity stream / wall
			JPluginHelper::importPlugin('community');
			$dispatcher =& JDispatcher::getInstance();
			
			$userid   = $user->id;
			$jobtitle = $job->job_title;
			$link_job = JRoute::_('index.php?option=com_jbjobs&view=guest&layout=detailjob&id='.$id_job);
			$args 	  = array($userid, $jobtitle, $link_job);
			
			$dispatcher->trigger('onPublishJob', $args);
	
			$msg	= JText::_('JBJOBS_JOB_PUBLISHED');
			$link	= 'index.php?option=com_jbjobs&view=employer&layout=showmyjobs&Itemid='.$Itemid;
			$app->redirect( $link, $msg );
			exit;
		}
		return $row;
	}
	
	//6.Job Applicants
	function getJobApplicants(){
		$app =& JFactory::getApplication();
		$db		=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
	
		if(!$user->id){
			$return	= JRoute::_('index.php?option=com_user&view=login');
			$app->redirect( $return );	
		}
		
		if(!$this->isEmployer($user->id)){
			$return	= JRoute::_('index.php?option=com_jbjobs');
			$app->redirect( $return );	
		}
	
		$post   = JRequest::get('post');
		$keyword = (!empty($post['keyword'])) ? $post['keyword'] : null;
		$id_job_spec      = (!empty($post['id_job_spec'])) ? (int)$post['id_job_spec'] : 0;
		$id_major 	      = (!empty($post['id_major'])) ? (int)$post['id_major'] : 0;
		$id_job_exp  	  = (!empty($post['id_job_exp'])) ? (int)$post['id_job_exp'] : 0;
		$id_degree_level  = (!empty($post['id_degree_level'])) ? (int)$post['id_degree_level'] : 0;
		$is_applicant  	  = (!empty($post['is_applicant'])) ? (int)$post['is_applicant'] : 0;
		$id_search_job    = (!empty($post['id_search_job'])) ? (int)$post['id_search_job'] : 0;
		
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= (empty($_GET['limitstart'])) ? 0 : $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', 0, 'int');
		
		$where = " where a.job_title like '%".$keyword."%'";
		
		if($id_job_spec > 0){
			$where .= " and a.id_job_spec =".$db->quote( $id_job_spec );
		}
		
		if($id_job_exp > 0){
			$where .= " and a.id_job_exp =".$db->quote( $id_job_exp );
		}
		
		if($id_degree_level > 0){
			$where .= " and a.id_degree_level =".$db->quote( $id_degree_level );
		}
		
		$total = 0;
		
		$query = "SELECT COUNT(*) FROM #__jbjobs_job a".
				 " LEFT JOIN  #__jbjobs_country b".
				 " ON a.id_country = b.id".
				    $where.
				 " and a.employer_id = ".$db->quote( $user->id );
		$db->setQuery( $query );
		$total = $db->loadResult();
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination( $total, $limitstart, $limit );
		
		$rows = null;
	
		$query = " SELECT (SELECT COUNT(*) FROM #__jbjobs_save_job s WHERE s.id_job=a.id and s.is_apply='y') as appcount,a.*,b.id id_country,b.country ".
					 " FROM #__jbjobs_job a".
					 " LEFT JOIN #__jbjobs_country b".
					 " ON a.id_country = b.id".			 
					   $where.
					 " and a.employer_id = ".$db->quote( $user->id ).
					 " ORDER BY a.id DESC";
		
		$db->setQuery( $query, $pageNav->limitstart, $pageNav->limit );
		$rows = $db->loadObjectList();
	
		$applicants = null;
	
		if($is_applicant == 1){
			$query ="select a.*,b.*, c.name from #__jbjobs_save_job a".
						" left join #__jbjobs_jobseeker b".
						" ON a.jseeker_id = b.user_id".
						" LEFT JOIN  #__users c".
						" ON a.jseeker_id = c.id".
						" where id_job =".$db->quote( $id_search_job ).
						" and is_apply ='y'";
			if($id_major >0){
				$query .="and a.id_major = ".$db->quote( $id_major );
			}
			$db->setQuery($query);
			$applicants = $db->loadObjectList();
		}
		$return[0] = $rows;
		$return[1] = $pageNav;
		$return[2] = $applicants;
		
		return $return;
	}
	
	//7.View Applicants for a Particular Job
	function getViewApplicant(){

		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO();
		$user 	=& JFactory::getUser();
		$id 	= JRequest::getVar('id', 0, 'get', 'int');
		$post   = JRequest::get('post');
		
		if(!$user->id){
			$return	= JRoute::_('index.php?option=com_user&view=login');
			$app->redirect( $return );	
		}
		
		if(!$this->isEmployer($user->id)){
			$return	= JRoute::_('index.php?option=com_jbjobs');
			$app->redirect( $return );	
		}
		
		$limit = $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= (empty($_GET['limitstart'])) ? 0 : $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', 0, 'int');
	
		$query = "SELECT COUNT(*) FROM #__jbjobs_save_job a 
				  WHERE a.id_job=$id AND a.is_apply='y'";
		$db->setQuery($query);
		$total = $db->loadResult();
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination($total, $limitstart, $limit);
		
		$query = "SELECT b.*,a.*,d.name,r.hits,c.job_title FROM #__jbjobs_save_job a".
				" LEFT JOIN #__jbjobs_jobseeker b ON a.jseeker_id = b.user_id".
				" LEFT JOIN #__jbjobs_job c on c.id = a.id_job".
				" LEFT JOIN #__users d ON a.jseeker_id = d.id".
				" LEFT JOIN #__jbjobs_resume_view r on r.jseeker_id=a.jseeker_id AND r.employer_id=$user->id".
				" WHERE a.id_job=".$id." AND a.is_apply='y'";
		$db->setQuery($query, $pageNav->limitstart, $pageNav->limit);
		$rows = $db->loadObjectList();	
		
		//get the total available credit of the employer
		$total_credit = 0;
		$query = "SELECT (SUM(credit_plus)-SUM(credit_minus)) FROM #__jbjobs_transaction WHERE user_id = ".$db->quote($user->id);
		$db->setQuery($query);
		$total_credit = $db->loadResult();
		
		$return[0] = $rows;
		$return[1] = $pageNav;
		$return[2] = $total_credit;
		
		return $return;
	}
	
	//8.Detail JobSeeker
	function getDetailJobSeeker(){		
		$app =& JFactory::getApplication();
		$user	=& JFactory::getUser();
		$id 	= JRequest::getVar('id', 0, 'get', 'int'); 
		$preview = JRequest::getVar('preview', 0, 'get', 'int'); 
		$db 	= & JFactory::getDBO();	
		$is_jobseeker = $this->isJobSeeker($user->id);
		
		$plan = $this->whichPlan($user->id);
		$creditpercv = $plan->creditpercv;
		
		//get the total available credit of the employer
		$total_credit = 0;
		$total_credit = $this->getTotalCredit($user->id);
		
	
		if(empty($id) OR !$user->id OR (!$is_jobseeker && !$this->isEmployer($user->id))){ 
			$return	= JRoute::_('index.php?option=com_jbjobs');
			$app->redirect($return);	
		}
		
		//let the jobseeker to view his own profile
		if($id != $user->id){
			if($is_jobseeker){
				$return	= JRoute::_('index.php?option=com_jbjobs');
				$app->redirect($return);	
			}
		}
		
		if(!JBJOBS_FREE_MODE && !$preview){
			if($total_credit < $creditpercv){
				$msg 	= JText::_('JBJOBS_RESUME_VIEW_NOT_ENOUGH_CREDIT');
				$return	= JRoute::_('index.php?option=com_jbjobs&view=employer&layout=findresume');
				$app->redirect($return, $msg);
			}
		}
		
		$query = "SELECT a.*,a.user_id jseekerid, ex.*, b.email, b.name, m.id id_major,m.major,dl.id id_degree, dl.degree_level, pgdl.degree_level pg_degree_level, 
				  js.id id_spec,js.specialization, je.exp_name, pi.id id_ind1,pi.industry as primary_industry, si.industry as secondary_industry, pt.id id_pos,pt.pos_type as position_type, 
				  ts.id id_saltype,ts.type_salary as salary_type, e.comp_name agent_name, e.user_id as companyid, cn.country FROM #__jbjobs_jobseeker a".
		         " LEFT JOIN #__users b ON a.user_id = b.id".
		         " LEFT JOIN #__jbjobs_major m ON a.id_major = m.id".
		         " LEFT JOIN #__jbjobs_degree_level dl ON a.id_degree_level = dl.id".
				 " LEFT JOIN #__jbjobs_degree_level pgdl ON a.pg_id_degree_level = pgdl.id".
				 " LEFT JOIN #__jbjobs_job_spec js ON a.id_job_spec = js.id".
				 " LEFT JOIN #__jbjobs_job_exp je ON a.id_job_exp = je.id".
		         " LEFT JOIN #__jbjobs_industry pi ON a.id_industry1 = pi.id".
		         " LEFT JOIN #__jbjobs_industry si ON a.id_industry2 = si.id".
		         " LEFT JOIN #__jbjobs_pos_type pt ON a.id_pos_type = pt.id".
		         " LEFT JOIN #__jbjobs_type_salary ts ON a.id_type_salary = ts.id".
				 " LEFT JOIN #__jbjobs_employer e ON a.id_job_agency = e.user_id".
				 " LEFT JOIN #__jbjobs_country cn ON a.id_country = cn.id".
				 " LEFT JOIN #__jbjobs_experience ex ON a.user_id = ex.user_id".
				 " WHERE a.user_id =".$db->quote($id);
		$db->setQuery($query);
		$data = $db->loadObject();
	
		if(!count($data)){
			$return	= JRoute::_('index.php?option=com_jbjobs');
			$app->redirect($return );	
		}
	
		$query = "SELECT * FROM #__jbjobs_custom_field WHERE field_for='jobseeker' AND published='1' ORDER BY ordering";
		$db->setQuery($query);
		$custom = $db->loadObjectList();
		
		//update the resume view Table if the user is not jobseeker
		$debited = 0;
		if(!$is_jobseeker){
			$query = "SELECT COUNT(*) FROM #__jbjobs_resume_view WHERE jseeker_id=$id AND employer_id=$user->id";
			$db->setQuery($query);
			if($db->loadResult()){
				$query = "UPDATE #__jbjobs_resume_view SET last_viewed=NOW(), hits=hits+1 WHERE jseeker_id=$id AND employer_id=$user->id";
			}
			else {
				if(!$preview)
					$query = "INSERT INTO #__jbjobs_resume_view (last_viewed, jseeker_id, employer_id, hits) VALUES (NOW(), '$id', '$user->id', '1')";
				
				//Insert the transaction into the transaction table in case credit per job is greater than zero
				if(!JBJOBS_FREE_MODE && !$preview){
					
					// Update the transaction table
					$transDtl = JText::_('JBJOBS_RESUME_VIEW').' - '.$data->jseekerid.' - '.$data->name;
					$trans_resp = JBJobsControllerJbjobs::updateTransaction($user->id, $transDtl, $creditpercv, -1);
					if($trans_resp->id > 0)
						$debited = 1;
					
					//Trigger the plugin event to fedd the employer profile update to JoomBah Feed
					JPluginHelper::importPlugin('system');
					$dispatcher =& JDispatcher::getInstance();
					$dispatcher->trigger('onEmployerViewJobseekerProfile', array($user->id, $id));
				}
			}
			$db->setQuery($query);
			$db->query();
		}
		
		$fields = $this->getFieldsOrdering(2);
		$parents = $fields[0];
		$children = $fields[1];
		
		global $tree;
		$query = "SELECT * FROM #__jbjobs_fieldorder
				  where field_for=2 AND parent=0
				  ORDER BY ordering";
		$db->setQuery($query);
		$pars = $db->loadObjectList();
		
		// subcategories view as tree
	   	$tree = array();
	   	
	   	foreach ($pars as $v) {
	       	$ident = '';
	       	$tree[] = $v;
			$this->tree($v->id, $ident, $tree);
		}
		
		
		$return[0] = $data;
		$return[1] = $custom;
		$return[2] = $parents;
		$return[3] = $children;
		$return[4] = $debited;
		$return[5] = $tree;
		
		return $return;
	}

	//9.Find Resume
	function getFindResume(){
		$app =& JFactory::getApplication();
		$db		=& JFactory::getDBO();
		$user =& JFactory::getUser();
		
		if(!$user->id){
			$return	= JRoute::_('index.php?option=com_user&view=login');
			$app->redirect($return);	
		}
		if(!$this->isEmployer($user->id)){
			$return	= JRoute::_('index.php?option=com_jbjobs');
			$app->redirect($return);	
		}
	
		$post   		 = JRequest::get('post');
		$keyword 		 = (!empty($post['keyword'])) ? $post['keyword'] : null; 
		$phrase 		 = (!empty($post['phrase'])) ? $post['phrase'] : 'any';
		$id_job_spec     = (!empty($post['id_job_spec'])) ? (int)$post['id_job_spec'] : 0; 
		$id_major 	     = (!empty($post['id_major'])) ? (int)$post['id_major'] : 0;
		$id_job_exp  	 = (!empty($post['id_job_exp'])) ? (int)$post['id_job_exp'] : 0;
		$id_degree_level = (!empty($post['id_degree_level'])) ? (int)$post['id_degree_level'] : 0;
		$id_industry  	 = (!empty($post['id_industry'])) ? (int)$post['id_industry'] : 0;
		$id_search_job   = (!empty($post['id_search_job'])) ? (int)$post['id_search_job'] : 0;
		$id_country  	 = (!empty($post['id_country'])) ?(int) $post['id_country'] :(int) JRequest::getVar('id_country', 0, 'get', 'string');
		$state		 	 = (!empty($post['state'])) ? $post['state'] : JRequest::getVar('state','', 'get', 'string');
		$city		 	 = (!empty($post['city'])) ? $post['city'] : JRequest::getVar('city','', 'get', 'string');
		$gender			 = JRequest::getVar('personal_gender', '', 'post', 'char');
		
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= (empty($_GET['limitstart'])) ? 0 : $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', 0, 'int');
		
		$keyword = preg_replace("/\s*,\s*/", ",", $keyword); //remove the spaces before and after the commas(,)
		switch ($phrase) {
			case 'exact':
				$text		= $db->Quote( '%'.$db->getEscaped( $keyword, true ).'%', false );
				$wheres2 	= array();
				$wheres2[] 	= 'a.current_position LIKE '.$text;
				$wheres2[] 	= 'c.value LIKE '.$text;
				$wheres2[] 	= 'c.valuetext LIKE '.$text;
				$wheres2[] 	= 'a.skill_summary LIKE '.$text;
				$queryStrings[] = '(' . implode( ') OR (', $wheres2 ) . ')';
				break;
	
			case 'all':
			case 'any':
			default:
				$words = explode(',', $keyword);
				$wheres = array();
				foreach ($words as $word) {
					$word		= $db->Quote('%'.$db->getEscaped($word, true).'%', false);
					$wheres2 	= array();
					$wheres2[] 	= 'a.current_position LIKE '.$word;
					$wheres2[] 	= 'c.value LIKE '.$word;
					$wheres2[] 	= 'c.valuetext LIKE '.$word;
					$wheres2[] 	= 'a.skill_summary LIKE '.$word;
					$wheres[] 	= implode(' OR ', $wheres2);
				}
				$queryStrings[] = '(' . implode( ($phrase == 'all' ? ') AND (' : ') OR ('), $wheres ) . ')';
				break;
		}
		
		if($id_job_spec > 0){
			$queryStrings[] = "a.id_job_spec =".$id_job_spec;
		}
		if($id_major > 0){
			$queryStrings[] = "a.id_major =".$id_major ;
		}
		if($id_job_exp > 0){
			$queryStrings[] = "a.id_job_exp =".$id_job_exp ;
		}
		if($id_degree_level > 0){
			$queryStrings[] = "(a.id_degree_level =".$id_degree_level." OR a.pg_id_degree_level =".$id_degree_level.")" ;
		}
		if($id_industry > 0){
			$queryStrings[] = "(a.id_industry1 =".$id_industry." OR a.id_industry2 =".$id_industry.")" ;
		}
		if(!empty($gender)){
			$queryStrings[] = "a.personal_gender =".$db->quote($gender);
		}
		if($id_country > 0){
			$queryStrings[] = "a.id_country =".$db->quote($id_country);
		}
		if($state){
			$queryStrings[] = "a.district =".$db->quote($state);
		}
		if($city){
			$queryStrings[] = "a.city =".$db->quote($city);
		}
		
		$where = implode (' AND ', $queryStrings);
		
		$total = 0;
		$query =  " SELECT DISTINCT a.*,b.name,dl.id id_deg,dl.degree_level,
				   (SELECT r.hits FROM #__jbjobs_resume_view r WHERE r.jseeker_id=a.user_id AND r.employer_id=$user->id) AS hits, 
				   (SELECT featured FROM #__jbjobs_resume WHERE is_active='y' AND featured=1 AND featured_expire > NOW() AND jseeker_id=a.user_id) as featuredres FROM #__jbjobs_jobseeker a".
				  " LEFT JOIN #__users b ON a.user_id=b.id ".
				  " LEFT JOIN #__jbjobs_degree_level dl ON a.id_degree_level = dl.id".
				  " LEFT JOIN #__jbjobs_custom_field_value c ON c.userid=a.user_id".
				  " WHERE ".$where.
				  " ORDER BY featuredres DESC";
		$db->setQuery($query);
		$db->query();
		$total = $db->getNumRows();
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination($total, $limitstart, $limit);
		
		$db->setQuery($query, $pageNav->limitstart, $pageNav->limit);
		$rows = $db->loadObjectList();
		
		//get the total available credit of the employer
		$total_credit = 0;
		$query = "SELECT (SUM(credit_plus)-SUM(credit_minus)) FROM #__jbjobs_transaction WHERE user_id = ".$db->quote($user->id);
		$db->setQuery($query);
		$total_credit = $db->loadResult();
	
		$return[0] = $rows;
		$return[1] = $pageNav;
		$return[2] = $total_credit;
		
		return $return;
	}
	
	//10.My Referrals
	function getMyReferrals(){
	
		$app =& JFactory::getApplication();
		$user	=& JFactory::getUser();
		
		// Check for request forgeries
		//JRequest::checkToken() or jexit('Invalid Token');
	
		if(!$user->id || !$this->isEmployer($user->id)){
			$link	= 'index.php?option=com_jbjobs';
			$app->redirect( $link );
		}
	
		// Initialize variables
		$db =& JFactory::getDBO();	
		
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= (empty($_GET['limitstart'])) ? 0 : $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', 0, 'int');
		
		$total = 0;
		$query = 'SELECT count(*) FROM #__jbjobs_jobseeker WHERE id_job_agency ='.$user->id;
		$db->setQuery( $query);
		$total = $db->loadResult();
		jimport('joomla.html.pagination');
		$pageNav = new JPagination( $total, $limitstart, $limit );
		
		$query = "SELECT u.name, j.* FROM #__jbjobs_jobseeker j
				  JOIN #__users u on j.user_id = u.id
	 			  WHERE id_job_agency = ".$user->id;
				  
		$db->setQuery($query, $pageNav->limitstart, $pageNav->limit);
		$referrals = $db->loadObjectList();
		
		$return[0] = $referrals;
		$return[1] = $pageNav;
		
		return $return;
	}
	
	//11.Show Credit
	function getShowCredit(){
		$app =& JFactory::getApplication();
		$user	=& JFactory::getUser();
		$db		=& JFactory::getDBO();
		
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= (empty($_GET['limitstart'])) ? 0 : $app->getUserStateFromRequest('com_jbjobs.limitstart', 'limitstart', 0, 'int');
		
		if($user->id == 0){
			$return	= JRoute::_('index.php?option=com_user&view=login');
			$app->redirect( $return );	
		}
		/*$is_employer = $this->isEmployer($user->id);
		if($is_employer == 0){
			$return	= JRoute::_('index.php?option=com_jbjobs&view=employer&layout=regemployer');
			$app->redirect( $return );	
		}*/
		
		$query = "SELECT MAX(id) FROM #__jbjobs_transaction WHERE user_id = ".$db->quote($user->id);	
		$db->setQuery( $query );
		$id_max = $db->loadResult();
		
		$last_credit =& JTable::getInstance('transaction', 'Table');
		$last_credit->load($id_max);
		
		$plus = 0;
		$minus = 0;
		$total_credit = 0;
		$query = "SELECT SUM(credit_plus) FROM #__jbjobs_transaction WHERE user_id = ".$db->quote( $user->id );
		$db->setQuery( $query );
		$plus = $db->loadResult();
		
		$query = "SELECT SUM(credit_minus) FROM #__jbjobs_transaction WHERE user_id = ".$db->quote( $user->id );
		$db->setQuery( $query );
		$minus = $db->loadResult();
		
		$total_credit = $plus - $minus;
		$total_credit = number_format($total_credit, 2, '.', '' ); 
		
		$query = "SELECT COUNT(*)".	          
				 " FROM #__jbjobs_transaction ".
				 " WHERE user_id =".$db->quote( $user->id );	
		$db->setQuery( $query );
		$total = $db->loadResult();
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination( $total, $limitstart, $limit );
		
		$query = "SELECT *  ".
				 " FROM #__jbjobs_transaction ".
				 " WHERE user_id =".$db->quote( $user->id )." ORDER BY date_trans DESC";
		
		$db->setQuery($query, $pageNav->limitstart, $pageNav->limit);
		$rows = $db->loadObjectList();
	
		$return[0] = $rows;
		$return[1] = $pageNav;
		$return[2] = $last_credit;
		$return[3] = $total_credit;
		
		return $return;
	}

	//12.Manual Payment
	function getManualPayment(){
		
		$id 	= JRequest::getVar('id', 0, 'get', 'int');
		
		$row	=& JTable::getInstance('billing', 'Table');
		$row->load($id);
		
		$payconfig = $this->getPaymentConfig('.banktransfer');
		
		$return[0] = $row;
		$return[1] = $payconfig;
		return $return;
	}
	
	//13.Buy Credit
	function getBuyCredit(){
		$app =& JFactory::getApplication();
		$user	=& JFactory::getUser();
		$db		=& JFactory::getDBO();
		
		
		if($user->id == 0){
			$return	= JRoute::_('index.php?option=com_user&view=login');
			$app->redirect( $return );	
		}
	
		if((!$this->isJobSeeker($user->id) && !$this->isEmployer($user->id))){
			$return	= JRoute::_('index.php?option=com_jbjobs');
			$app->redirect( $return );	
		}
		
		if($this->isEmployer($user->id)){
			$row	=& JTable::getInstance('employer', 'Table');
			$query = "SELECT id FROM #__jbjobs_employer WHERE user_id =".$db->quote($user->id);
		}
		elseif($this->isJobSeeker($user->id)){
			$row	=& JTable::getInstance('jobseeker', 'Table');
			$query = "SELECT id FROM #__jbjobs_jobseeker WHERE user_id =".$db->quote($user->id);
		}
			
		$db->setQuery($query);
		$id_employer = $db->loadResult();
		$row->load($id_employer);
		
		return $row;
	}
	
	//14.Show Billing History
	function getShowBilling(){
		$app =& JFactory::getApplication();
		$user	=& JFactory::getUser();
		$db		=& JFactory::getDBO();
		
		if($user->id == 0){
			$return	= JRoute::_('index.php?option=com_user&view=login');
			$app->redirect($return);	
		}
		
		if((!$this->isJobSeeker($user->id) && !$this->isEmployer($user->id))){
			$return	= JRoute::_('index.php?option=com_jbjobs');
			$app->redirect($return);	
		}
		
		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= JRequest::getVar('limitstart',0,'','int');
		
		$query = 'SELECT COUNT(*) FROM #__jbjobs_billing where user_id = '.$db->quote($user->id). " ORDER BY date_buy DESC";	
		$db->setQuery($query);
		$total = $db->loadResult();
		
		jimport('joomla.html.pagination');
		$pageNav = new JPagination( $total, $limitstart, $limit );
		
		$query = 'SELECT * FROM #__jbjobs_billing where user_id = '.$db->quote($user->id) . " ORDER BY date_buy DESC";	
		$db->setQuery($query, $pageNav->limitstart, $pageNav->limit);
		$rows = $db->loadObjectList();
		
		$return[0] = $rows;
		$return[1] = $pageNav;
		
		return $return;
	}
	
	//15.Print Invoice
	function getPrintInvoice(){
		$app =& JFactory::getApplication();
		$user	=& JFactory::getUser();
		$id 	= JRequest::getVar('id', 0, 'get', 'string');
		$type 	= JRequest::getVar('type', '', 'get', 'string');
		$db 	= & JFactory::getDBO();
		
		$is_employer  = $this->isEmployer($user->id);
 		$is_jobseeker = $this->isJobSeeker($user->id);
 		
 		if($is_employer){
 			$profileTblName = '#__jbjobs_employer';
 		}
 		elseif($is_jobseeker){
 			$profileTblName = '#__jbjobs_jobseeker';
 		}
		
		if(!$user->id OR (!$this->isJobSeeker($user->id) && !$this->isEmployer($user->id))){
			$return	= JRoute::_('index.php?option=com_user&view=login');
			$app->redirect( $return );	
		}
		
		if($type == 'credit')
			$query = "SELECT COUNT(*) FROM #__jbjobs_billing WHERE id=".$db->quote($id). " AND user_id=".$db->quote($user->id);
		elseif($type == 'subscr')
			$query = "SELECT COUNT(*) FROM #__jbjobs_plan_subscr WHERE id=".$db->quote($id). " AND user_id=".$db->quote($user->id);
		$db->setQuery($query);
		if(!$db->loadResult()){
			?>
			<script language="javascript" type="text/javascript">
				window.close();
			</script>
			<?php
		}
		else {
			if($type == 'credit')
				$query = "SELECT b.*,b.id as invoiceid, b.address address, u.email, u.name,c.country AS bill_country,bill_addr,bill_addr_cont,bill_state,bill_city,bill_zip,bill_phone FROM #__jbjobs_billing b 
					  LEFT JOIN #__users u ON b.user_id=u.id 
					  LEFT JOIN $profileTblName e ON e.user_id=u.id 
					  LEFT JOIN #__jbjobs_country c ON e.bill_id_country=c.id
					  WHERE b.id=".$db->quote($id)." AND b.user_id=".$db->quote($user->id);
			elseif($type == 'subscr')
				$query = "SELECT p.*,p.id as invoiceid,p.price amount,pl.name as planname,u.email,u.name,c.country AS bill_country,bill_addr,bill_addr_cont,bill_state,bill_city,bill_zip,bill_phone FROM #__jbjobs_plan_subscr p 
					  LEFT JOIN #__users u ON p.user_id=u.id 
					  LEFT JOIN $profileTblName e ON e.user_id=u.id
					  LEFT JOIN #__jbjobs_country c ON e.bill_id_country=c.id
					  LEFT JOIN #__jbjobs_plan pl ON pl.id=p.subscription_id
					  WHERE p.id=".$db->quote($id)." AND p.user_id=".$db->quote($user->id);
			$db->setQuery($query);
			$row = $db->loadObject();
	
			$return[0] = $row;
			return $return;
		}
	}
	
	//16.History of plans Subscribed to
	function getPlanHistory(){
		$app =& JFactory::getApplication();
		$user = JFactory::getUser();
		$db		=& JFactory::getDBO();
		$subid 	=& JRequest::getVar('subid', 0, 'get', 'int');
		
		$is_employer  = $this->isEmployer($user->id);
 		$is_jobseeker = $this->isJobSeeker($user->id);
		
	    if(!$user->id){
			$return	= JRoute::_('index.php?option=com_user&view=login');
			$app->redirect($return);	
		}
			
		if((!$is_jobseeker && !$is_employer)){
			$return	= JRoute::_('index.php?option=com_jbjobs');
			$app->redirect($return);	
		}
 		
 		if($is_employer)
 			$planTblName = '#__jbjobs_plan';
 		elseif($is_jobseeker)
 			$planTblName = '#__jbjobs_plan_js';
		
	    $sql = "SELECT 	u.*, s.name, s.graceperiod, (TO_DAYS(u.date_expire) - TO_DAYS(NOW())) as daysleft 
    	  		FROM  #__jbjobs_plan_subscr AS u 
     			LEFT JOIN  $planTblName AS s ON s.id = u.subscription_id  
	     		WHERE  u.user_id = $user->id 
	       		AND s.published = 1 
	 			ORDER BY u.id DESC";
	    $db->setQuery($sql);
	    $rows = $db->loadObjectList();
	    
		$finish = '';
		if($subid > 0){
	        $sql = "SELECT finish_msg FROM $planTblName WHERE id = ".$subid;
	        $db->setQuery($sql);
	        $finish = $db->loadResult();
	    }
		$return[0] = $rows;
		$return[1] = $finish;
		
		return $return;
	}
	
	//17.Subscribe to a Plan
	function getPlanAdd(){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO();
		$user 	=& JFactory::getUser();
    
	  	$sql = 	"SELECT p.id AS subs FROM #__jbjobs_plan AS p 
			    LEFT JOIN #__jbjobs_plan_subscr AS u ON u.subscription_id = p.id
			    WHERE u.approved=1 
			    AND u.user_id = $user->id 
			   	GROUP BY p.id
			    ";
	    $db->setQuery($sql);
	    $plans = $db->loadResultArray();
	    
	    $sql = "SELECT p.* FROM #__jbjobs_plan AS p
			    WHERE 1 AND p.published = 1 
			    and p.invisible = 0 
			    ORDER BY p.ordering ASC";
	    $db->setQuery( $sql );
	    $rows = $db->loadObjectList();
	    
		$return[0] = $rows;
		$return[1] = $plans;
		
		return $return;
	}
	
	//17.Subscribe to a Plan for Jobseeker
	function getPlanAddJS(){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO();
		$user 	=& JFactory::getUser();
    
	  	$sql = 	"SELECT p.id AS subs FROM #__jbjobs_plan_js AS p 
			    LEFT JOIN #__jbjobs_plan_subscr AS u ON u.subscription_id = p.id
			    WHERE u.approved=1 
			    AND u.user_id = $user->id 
			   	GROUP BY p.id
			    ";
	    $db->setQuery($sql);
	    $plans = $db->loadResultArray();
	    
	    $sql = "SELECT p.* FROM #__jbjobs_plan_js AS p
			    WHERE 1 AND p.published = 1 
			    and p.invisible = 0 
			    ORDER BY p.ordering ASC";
	    $db->setQuery($sql);
	    $rows = $db->loadObjectList();
	    
		$return[0] = $rows;
		$return[1] = $plans;
		
		return $return;
	}
	
	//18.Subscription Details
	function getSubscrDetail(){
		$app =& JFactory::getApplication();
		$db		=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
		
		if(!$user->id OR !$this->isEmployer($user->id)){
			$link = JRoute::_('index.php?option=com_jbjobs');
			$app->redirect($link, $message);	
		}
		
		$id = JRequest::getVar('id', 0, 'get', 'int');
		($id == 0)? $isNew = true: $isNew = false;
	
		$query = "SELECT s.*,p.name,p.credit,p.creditperjob,p.creditperfeatured,p.creditperhotjob,p.creditprice,p.jobexpire,p.graceperiod,p.creditexpire,p.creditpercv FROM #__jbjobs_plan_subscr s
				  JOIN #__jbjobs_plan p ON p.id=s.subscription_id 
				  WHERE s.id=".$id;
		$db->setQuery($query);
		$row = $db->loadObject();
		
		$query = "select id from #__jbjobs_employer where user_id =".$db->quote($user->id);
		$db->setQuery( $query );
		$employer_id = $db->loadResult();
		
		$employer = & JTable::getInstance('employer', 'Table');
		$employer->load($employer_id);
		
	  $return[0] = $row;
	  $return[1] = $employer;
	  
	  return $return;
	}
	
	//18.Subscription Details for Jobseeker
	function getSubscrDetailJS(){
		$app =& JFactory::getApplication();
		$db		=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
		
		if(!$user->id){
			$link = JRoute::_('index.php?option=com_jbjobs');
			$app->redirect($link, $message);	
		}
		
		$id = JRequest::getVar('id', 0, 'get', 'int');
		($id == 0)? $isNew = true: $isNew = false;
	
		$query = "SELECT s.*,p.*,s.subscription_id AS planid FROM #__jbjobs_plan_subscr s
				  JOIN #__jbjobs_plan_js p ON p.id=s.subscription_id 
				  WHERE s.id=".$id;
		$db->setQuery($query);
		$row = $db->loadObject();
		
		$query = "select id from #__jbjobs_employer where user_id =".$db->quote($user->id);
		$db->setQuery( $query );
		$employer_id = $db->loadResult();
		
		$employer = & JTable::getInstance('employer', 'Table');
		$employer->load($employer_id);
		
	  $return[0] = $row;
	  $return[1] = $employer;
	  
	  return $return;
	}
	
	//19.Manual Subscription
	function getManualSubscr(){
		
		$id 	= JRequest::getVar('id', 0, 'get', 'int');
		$subscr	=& JTable::getInstance('plansubscr', 'Table');
		$subscr->load($id);	
		
		$plan	=& JTable::getInstance('plan', 'Table');
		$plan->load($subscr->subscription_id);	
		
		$payconfig = $this->getPaymentConfig('.banktransfer');
		
		$return[0] = $subscr;
		$return[1] = $plan;
		$return[2] = $payconfig;
		
		return $return;
	}
	
	//20.Subscription Checkout
	function getCheckout(){
		//get the subscription id from the session
		$session =& JFactory::getSession();
		$id = $session->get('id', 0, 'upgsubscr');
		//$session->clear('id', 'upgsubscr');
		
		//the subscr id is not set in session, get fromt the 'get' request
		if(($id == 0))
			$id = JRequest::getVar('id', 0, 'get', 'int');
		
		$subscr	=& JTable::getInstance('plansubscr', 'Table');
		$subscr->load($id);	
		
		if($subscr->user_type == 'e')
			$plan	=& JTable::getInstance('plan', 'Table');
		elseif($subscr->user_type == 'j')
			$plan	=& JTable::getInstance('planjs', 'Table');
		
		$plan->load($subscr->subscription_id);	
		
		$return[0] = $subscr;
		$return[1] = $plan;
		
		return $return;
	}
	
	//20.Subscription Checkout
	function getCreditCheckout(){
		//$session =& JFactory::getSession();
		//$id = $session->get('id', 0, 'upgsubscr');
		//$session->clear('id', 'upgsubscr');
		$id 	= JRequest::getVar('id', 0, 'get', 'int');
		$bill	=& JTable::getInstance('billing', 'Table');
		$bill->load($id);	
		
		return $bill;
	}
	
/**	
==================================================================================================================	
	SECTION : Misc
	1.Which Profile to Use?
	2.Which Plan to Use?
	3.Status of member's plan
	4.Is Employer?
	5.Is JobSeeker?
	6.Show Custom
	7.Show Custom Field Value
	8.Custom Field Value JavaScript
	9.Count Unread Messages
	10.getActiveResume
	11.getActiveCoverletter
	12.getFieldsOrdering
==================================================================================================================
*/
	//1.Which Profile to Use?
	function whichUse($userid = null){
		$config =& JTable::getInstance('config','Table');
		$config->load(1);
		$user_profile = $config->get('userprofile');
	
		switch ($user_profile){
			case 1:
				if(file_exists(JPATH_SITE.DS.'components'.DS.'com_comprofiler'.DS.'comprofiler.php')){
					return 1;
				}
				else {
					return 0;
				}
			break;
			case 2:
				if(file_exists(JPATH_SITE.DS.'components'.DS.'com_community'.DS.'community.php')){
					return 2;
				}
				else {
					return 0;
				}
			break;
			case 0:
			default:
				return 0;
			break;
		}
	}
	
	//2.Which Plan to Use?
	function whichPlan($userid = null){
		$app =& JFactory::getApplication();
		$db =& JFactory::getDBO();
		$is_expired = false;
		$is_employer  = $this->isEmployer($userid);
 		$is_jobseeker = $this->isJobSeeker($userid);
 		$planTblName = '';
 		
 		if($is_employer)
 			$planTblName = '#__jbjobs_plan';
 		elseif($is_jobseeker)
 			$planTblName = '#__jbjobs_plan_js';
		
		$query = "SELECT MAX(id) FROM #__jbjobs_plan_subscr WHERE user_id = $userid AND approved = 1";
		$db->setQuery($query);
		$id_max = $db->loadResult();
		
		if($id_max){
			//check if the plan is expired or not
			$query = 'SELECT (TO_DAYS(s.date_expire) - TO_DAYS(NOW())) daysleft FROM  #__jbjobs_plan_subscr s
					  WHERE s.id='.$id_max;
			$db->setQuery($query);
			$days_left = $db->loadResult();
			
			if($days_left < 0)
				$is_expired = true;
		}
		
		if(!$id_max || $is_expired){	//user has no active plan or it is expired. so choose the default plan (free plan)
			$query = "SELECT * FROM $planTblName WHERE id = 1";
			$db->setQuery($query);
			$default_plan = $db->loadObject();
			return $default_plan;
		}
		
		$query = "SELECT subscription_id FROM #__jbjobs_plan_subscr WHERE id = ".$id_max;
		$db->setQuery($query);
		$last_subscr = $db->loadResult();
		
		$query = "SELECT * FROM $planTblName WHERE id = ".$last_subscr;
		$db->setQuery($query);
		$last_plan = $db->loadObject();
		
		return $last_plan;
	}
	
	//3.Status of member's plan
	function planStatus($userid = null){
		$app =& JFactory::getApplication();
		$db =& JFactory::getDBO();
		
		$is_employer  = $this->isEmployer($userid);
 		$is_jobseeker = $this->isJobSeeker($userid);
 		
 		if($is_employer)
 			$planTblName = '#__jbjobs_plan';
 		elseif($is_jobseeker)
 			$planTblName = '#__jbjobs_plan_js';
		
		$query = "SELECT MAX(id) FROM #__jbjobs_plan_subscr WHERE user_id = $userid AND approved = 1";
		$db->setQuery($query);
		$id_max = $db->loadResult();
		
		if(!$id_max)	//user has no active plan. so choose the default plan (free plan)
			return 2;
		
		$query = "SELECT * FROM #__jbjobs_plan_subscr WHERE id = ".$id_max;
		$db->setQuery($query);
		$last_subscr = $db->loadObject();
		
		$query = "SELECT * FROM $planTblName WHERE id = ".$last_subscr->subscription_id;
		$db->setQuery($query);
		$last_plan = $db->loadObject();
		
		$now = date('Y-m-d H:i:s', time() + ($app->getCfg('offset') * 60 * 60));
		
		//Get the expiry date after the grace period
		$expireaftergrace = date("Y-m-d H:i:s", strtotime($last_subscr->date_expire . "+$last_plan->graceperiod day"));
		
		if($now > $last_subscr->date_expire && $now <  $expireaftergrace)
			return 0;	// The user is in grace period
			
		elseif($now >  $expireaftergrace)
			return 1;	// The user's subscr has expired
		else	
			return null;
	}
	
	//4.Is Employer?	
	function isEmployer($userid){
		$db 	=& JFactory::getDBO();
		$query 	= "SELECT COUNT(*) FROM #__jbjobs_employer where user_id =".$db->quote( $userid );
		$db->setQuery( $query );
		$total 	= $db->loadResult();
		if($total == 1)
			return 1;
		else
			return 0;
	}

	//5.Is JobSeeker?	
	function isJobSeeker($userid){
		$db 	=& JFactory::getDBO();
		$query 	= "SELECT COUNT(*) FROM #__jbjobs_jobseeker where user_id =".$db->quote( $userid );
		$db->setQuery( $query );
		$total 	= $db->loadResult();
		if($total == 1)
			return 1;
		else
			return 0;
	}
	
	//6.ShowCustom
	function showCustom($custom = null, $id = null, $type = 'profile'){
		if(!empty($custom)){
			$row = null;
			if(!empty($id)){
				$db =& JFactory::getDBO();
				if($type == 'job'){
					$query = "SELECT * FROM #__jbjobs_custom_field_value WHERE jobid='$id'";
				}
				else {
					$query = "SELECT * FROM #__jbjobs_custom_field_value WHERE userid='$id'";
				}

				$db->setQuery($query);
				$c = $db->loadObjectList();
				if(count($c)){
					foreach($c as $v){
						$row[$v->fieldid] = $v;
					}
				}
			}
			$parents = array();$children = array();
			//isolate parent and childr
			foreach($custom as $ct){
					if($ct->parent == 0)
						$parents[]=$ct;
					else
						$children[]=$ct;
				}
			
			if(count($parents)){
			?>
			<br />
			<?php foreach($parents as $pt){ ?>
				<div class="border">
				<div class="shade"><div class="arrow"></div>
					<label for="name"><?php echo JText::_($pt->field_title); ?></label></div>
					
					<table class="admintable" width="100%">
					<?php if(!empty($pt->gdesc)) : ?>
						<tr><th colspan="2" style="font-weight: normal;"><?php echo $pt->gdesc; ?></th></tr>
					<?php endif; ?>
					<?php foreach($children as $ct){?>
						<?php if($ct->parent == $pt->id){ ?>
						<tr>
							<td class="key" valign="top">
								<?php 
									$title = JText::_($ct->field_title).':: '.JText::_($ct->tips);
									$labelsuffix = '';
									if($ct->field_type == 'checkbox') $labelsuffix = '[]'; //added to validate checkbox
								?>
								<label title="<?php echo $title; ?>" class="jbtooltip" for="custom_field_<?php echo $ct->id.$labelsuffix; ?>"><?php echo JText::_($ct->field_title); ?><span class="redfont"><?php echo ($ct->required)? '*' : ''; ?></span>:</label>
							</td>
							<td>
								<?php
								$val = (!empty($row[$ct->id]->value)) ? $row[$ct->id]->value : null;
								$req = '';
								if($ct->required){
									if($ct->field_type == 'radio') $req = 'validate-radio';
									elseif($ct->field_type == 'checkbox') $req = 'validate-checkbox';
									elseif($ct->field_type == 'multiple select') $req = 'validate-dropdown';
									else $req = 'required';
								}
								switch($ct->field_type){
								case 'textbox':
									?>
									<input class="jbtooltip <?php echo $ct->class.' '.$req; ?>" type="text" name="custom_field_<?php echo $ct->id; ?>" id="custom_field_<?php echo $ct->id; ?>" size="60" value="<?php echo $val; ?>" title="<?php echo $title; ?>" />
									<?php
								break;
								case 'textarea':
									$val = (!empty($row[$ct->id]->valuetext)) ? $row[$ct->id]->valuetext : null;
									?>
									<textarea class="jbtooltip <?php echo $ct->class.' '.$req; ?>" rows="4" cols="50" name="custom_field_<?php echo $ct->id; ?>" id="custom_field_<?php echo $ct->id; ?>" title="<?php echo $title; ?>" ><?php echo $val; ?></textarea>
									<?php
								break;
								case 'radio':
									if(!empty($ct->values)){
										$values = explode(";", $ct->values);
										$put = array();
										if($ct->show_type == 'left-to-right'){
											foreach($values as $value){
												if($value){
													$put[] = JHTML::_('select.option',  $value, JText::_( $value ));
												}
											}
											echo JHTML::_('select.radiolist', $put, 'custom_field_'.$ct->id, "class='jbtooltip $ct->class $req' title='$title'", 'value', 'text', $val );?>
										<?php 
										}
										else {
											foreach($values as $value){
												if($value){
													$checked = ($val == $value) ? ' checked': '';
												?>
													<input class="jbtooltip <?php echo $ct->class.' '.$req; ?>" type="radio" name="custom_field_<?php echo $ct->id; ?>" title="<?php echo $title; ?>" value="<?php echo $value; ?>"<?php echo $checked; ?>> <?php echo $value; ?><br />
												<?php
												}
											}
										}
									}
								break;
								case 'checkbox':
									if(!empty($ct->values)){
										$values = explode(";", $ct->values);
										$put = array();
										if($ct->show_type == 'left-to-right'){
											$x = 0;
											foreach($values as $value){
												if($value){
													$checked = (in_array($value, explode(";",$val))) ? ' checked': '';
													?>
													<input id="c<?php echo $ct->id;?>b<?php echo $x; ?>" class="jbtooltip <?php echo $ct->class.' '.$req; ?>" type="checkbox" title="<?php echo $title; ?>" name="custom_field_<?php echo $ct->id; ?>[]" value="<?php echo $value; ?>"<?php echo $checked; ?>> <?php echo $value; ?>&nbsp;
													<?php
													$x++;
												}
											}
										}
										else {
											$x = 0;
											foreach($values as $value){
												if($value){
													$checked = (in_array($value, explode(";",$val))) ? ' checked': '';
													?>
													<input id="c<?php echo $ct->id;?>b<?php echo $x; ?>" class="jbtooltip <?php echo $ct->class.' '.$req; ?>" type="checkbox" title="<?php echo $title; ?>" name="custom_field_<?php echo $ct->id; ?>[]" value="<?php echo $value; ?>"<?php echo $checked; ?>> <?php echo $value; ?><br />
													<?php
													$x++;
												}
											}
										}
									}
								break;
								case 'select':
									if(!empty($ct->values)){
										$values = explode(";", $ct->values);
										$put = array();
										foreach($values as $value){
											if($value){
												$put[] = JHTML::_('select.option',  $value, JText::_( $value ), 'value', 'text');
											}
										}
										
										echo JHTML::_('select.genericlist', $put, 'custom_field_'.$ct->id, "class='jbtooltip $ct->class $req' title='$title' size='1'", 'value', 'text', $val );
									}
								break;
								case 'multiple select':
									if(!empty($ct->values)){
										$values = explode(";", $ct->values);
										$put = array();
										$val =  explode(";", $val);
										foreach($values as $value){
											if($value){
												$put[] = JHTML::_('select.option', $value, JText::_($value), 'value', 'text');
											}
										}
										$size = (count($put) < 5) ? count($put) : 5;
										echo JHTML::_('select.genericlist', $put, 'custom_field_'.$ct->id.'[]', "class='jbtooltip $ct->class $req' title='$title' size='$size' multiple", 'value', 'text', $val );
										echo '&nbsp;';
										echo JText::_('JBJOBS_HOLD_CTRL_FOR_MULTIPLE_SELECT');
									}
								break;
								case 'URL':
									?>
									<input class="jbtooltip <?php echo $ct->class.' '.$req; ?>" type="text" name="custom_field_<?php echo $ct->id; ?>" id="custom_field_<?php echo $ct->id; ?>" size="45" value="<?php echo $val; ?>" title="<?php echo $title; ?>" /> <?php echo JText::_('JBJOBS_INCLUDE_HTTP'); ?>
									<?php
								break;
								case 'Email':
									?>
									<input class="jbtooltip <?php echo $ct->class.' '.$req; ?>" type="text" name="custom_field_<?php echo $ct->id; ?>" id="custom_field_<?php echo $ct->id; ?>" size="45" value="<?php echo $val; ?>" title="<?php echo $title; ?>" />
									<?php
								break;
								case 'Date':
									?>
									<?php echo JHTML::_('calendar', $val, 'custom_field_'.$ct->id, 'custom_field_'.$ct->id, '%Y-%m-%d', array('class'=>$ct->class.' jbtooltip '.$req, 'title'=>$title)); ?>
									<?php
								break;
							}																																																																																																									
								?>
							</td>
						</tr>
						<?php } ?>
					<?php } ?>
					</table>
				</div>
				<div class="sp20">&nbsp;</div>
			<?php } ?>
			
			<?php
			}
		}
	}

	//7.showCustomFieldValue
	function showCustomFieldValue($custom=null, $id = null, $type = 'profile'){
		if(!empty($custom)){
			$row = null;
			if(!empty($id)){
				$db =& JFactory::getDBO();
				if( $type == 'profile' ){
					$query = "SELECT * FROM #__jbjobs_custom_field_value WHERE userid='$id'";
				}
				else{
					$query = "SELECT * FROM #__jbjobs_custom_field_value WHERE jobid='$id'";
				}
				$db->setQuery($query);
				$c = $db->loadObjectList();
				if(count($c)){
					foreach($c as $v){
						$row[$v->fieldid] = $v;
					}
				}
			}
			$parents = $children = array();
			//isolate parent and childr
			foreach($custom as $ct){
				if($ct->parent==0)
					$parents[]=$ct;
				else
					$children[]=$ct;
			}
			if(count($custom)){
				?>
				
				<?php foreach($parents as $pt){ ?>
				<div class="border">
				<div class="shade"><div class="arrow"></div>
					<label for="name"><?php echo JText::_( $pt->field_title ); ?></label></div>
			
					<table class="admintable">
					<?php foreach($children as $ct){ ?>
						<?php if($ct->parent == $pt->id){ ?>
							<tr>
								<td class="key" valign="top">
									<label for="name">
							<?php echo JText::_( $ct->field_title ); ?>:
							</label>				
								</td>
								<td>
							<?php
							$val = (!empty($row[$ct->id]->value)) ? $row[$ct->id]->value : null;
							switch($ct->field_type){
								case 'textbox':
								case 'select':
								case 'radio':
									echo $val;
									break;
								case 'textarea':
									$val = (!empty($row[$ct->id]->valuetext)) ? nl2br($row[$ct->id]->valuetext) : null;
									echo $val;
									break;
								case 'checkbox':
								case 'multiple select':
									$val = explode(";", $val);
									$val = implode(", ", $val);
									echo $val;
									break;
								case 'URL':
									echo '<a href='.$val.' target="_blank">'.$val.'</a>';
									break;
								case 'Email':
									echo '<a href=mailto:'.$val.' target="_blank">'.$val.'</a>';
									break;
								case 'Date':
									$config =& JTable::getInstance('config', 'Table');
									$config->load(1);
									$dformat = $config->dateformat;
									echo ($val != '') ? JHTML::_('date', $val, $dformat, false) : '';
									break;
							}
							?>
						</td>																																																						
							</tr>
						<?php } ?>
					<?php } ?>
					</table>
					</div>
					<div class="sp20">&nbsp;</div>
					<?php } ?>
			<?php } ?>
			<?php
			}
		}
		
	//showParticularCustomValue
	function showParticularCustomValue($id = null, $type = 'profile', $fieldid = null){
	
		if(!empty($id)){
			$db =& JFactory::getDBO();
			if($type == 'profile'){
				$query = "SELECT * FROM #__jbjobs_custom_field_value WHERE userid='$id' AND fieldid=".$db->Quote($fieldid);
			}
			else {
				$query = "SELECT * FROM #__jbjobs_custom_field_value WHERE jobid='$id' AND fieldid=".$db->Quote($fieldid);
			}
			$db->setQuery($query);
			$c = $db->loadObject();
			
			if(!empty($c->value)) $val = $c->value;
			elseif (!empty($c->valuetext)) $val = $c->valuetext;
			else $val = null;
			
			echo $val;
		}
	}
	
	//9.Count unread Messages
	function countUnreadMsg(){
		$db 	=& JFactory::getDBO();
		$user	=& JFactory::getUser();
		$userid = $user->id;
		$query 	= "SELECT COUNT(*) FROM #__jb_messaging where idTo =".$userid." and seen=0";
		$db->setQuery( $query );
		$total 	= $db->loadResult();
		return $total;
	}
	
	//10.getActiveResume
	function getActiveResume($jseeker_id){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO(); 
		$query = "SELECT id FROM #__jbjobs_resume WHERE is_active='y' AND jseeker_id=".$db->quote($jseeker_id);
		$db->setQuery( $query );
		$id = $db->loadResult();
		return $id;
	}
	
	//10a.getActiveResume
	function getActiveResumeFeatured($jseeker_id){
		$db	= & JFactory::getDBO(); 
		$query = "SELECT id FROM #__jbjobs_resume WHERE is_active='y' AND featured=1 AND featured_expire > NOW() AND jseeker_id=".$db->quote($jseeker_id);
		$db->setQuery($query);
		$id = $db->loadResult();
		return $id;
	}
	
	//11.getActiveCoverletter
	function getActiveCoverletter($jseeker_id){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO(); 
		$query = "SELECT id FROM #__jbjobs_coverletter WHERE is_active=1 AND jseeker_id=".$db->quote($jseeker_id);
		$db->setQuery( $query );
		$id = $db->loadResult();
		return $id;
	}

	//12.getFieldsOrdering
	function getFieldsOrdering($fieldfor) {
		$db = &$this->getDBO();
		$query =  "SELECT * FROM #__jbjobs_fieldorder
				   WHERE published = 1 AND parent=0 AND field_for=".$fieldfor.
				 " ORDER BY ordering";
		$db->setQuery($query);
		$parents = $db->loadObjectList();
		
		$query =  "SELECT * FROM #__jbjobs_fieldorder
				   WHERE published = 1 AND parent<>0 AND field_for=".$fieldfor.
				 " ORDER BY ordering";
		$db->setQuery($query);
		$children = $db->loadObjectList();
		
		$return[0] = $parents;
		$return[1] = $children;
		return $return;
	}
	
	function getPaymentConfig($fieldfor){
		$db =& JFactory::getDBO();
		$query = "SELECT * FROM #__jbjobs_payment_mode WHERE gwcode='$fieldfor'";
		$db->setQuery($query);//echo $query;
		$configs = $db->loadAssocList('fieldname');
		
		/*$configs = array();
		foreach($config as $conf)	{
			$configs[$conf->fieldname] = $conf->savedvalue;	
						
		}*/
		return $configs;
	}

		//getJobalertFrequency
		function getJobalertFrequency( $name, $value = 'w'){
			$put[] = JHTML::_('select.option',  'd', JText::_('JBJOBS_DAILY'));
			$put[] = JHTML::_('select.option',  'w', JText::_('JBJOBS_WEEKLY'));
			$put[] = JHTML::_('select.option',  'm', JText::_('JBJOBS_MONTHLY'));
			$frequency = JHTML::_('select.radiolist', $put, $name, '', 'value', 'text', $value );
			return $frequency;
		}

	function & getTemplate($tempfor){
		$db = & JFactory :: getDBO();
		
		$query = "SELECT * FROM #__jbjobs_emailtemplate WHERE templatefor = ".$db->Quote($tempfor);
		$db->setQuery($query);
		$template = $db->loadObject();
		return $template;
	}
/**
==================================================================================================================	
	SECTION : Additional Functions
	1.YesNo - boolean
	2.YesNo
	3.maleFemale
	4.getSelectCountry
	5.getSelectJobSpec
	6.getSelectPositionType
	7.getSelectExpLevel
	8.getSelectDegreeLevel
	9.getSelectTypeSalary
	10.getSelectMajor
	11.getSalutation
	12.getSelectCompType
	13.getSelectIndustry
	14.getSelectPersonalStatus
	15.getSelectJobAgency
	16.getMultipleJobSpec
	17.getMultipleCountry
	18.getMultipletExpLevel
==================================================================================================================
*/	
	//1.YesNo - boolean
	function YesNoBool( $name, $value = 1 ){
		$yesno = JHTML::_('select.booleanlist', $name, '', $value, 'JBJOBS_YES', 'JBJOBS_NO');
		return $yesno;
	}
	
	//2.YesNo
	function YesNo( $name, $value = 'y'){
		$put[] = JHTML::_('select.option',  'n', JText::_('JBJOBS_NO'));
		$put[] = JHTML::_('select.option',  'y', JText::_('JBJOBS_YES'));
		$yesno = JHTML::_('select.radiolist',  $put, $name, '', 'value', 'text', $value );
		return $yesno;
	}	
	
	//3.MaleFemale
	function maleFemale($name, $value = 'M'){
		$put[] = JHTML::_('select.option',  'M', JText::_('JBJOBS_MALE'));
		$put[] = JHTML::_('select.option',  'F', JText::_('JBJOBS_FEMALE'));
		$malefemale = JHTML::_('select.radiolist', $put, $name, '', 'value', 'text', $value);
		return $malefemale;
	}
	
	//3.postingPrivacy
	function postingPrivacy($name, $value = 0){
		$put[] = JHTML::_('select.option',  0, JText::_('JBJOBS_PUBLIC'));
		$put[] = JHTML::_('select.option',  10, JText::_('JBJOBS_SITE_MEMBERS'));
		$put[] = JHTML::_('select.option',  20, JText::_('JBJOBS_ONLY_ME'));
		$put[] = JHTML::_('select.option',  30, JText::_('JBJOBS_NOBODY'));
		$postingPrivacy = JHTML::_('select.radiolist', $put, $name, '', 'value', 'text', $value);
		return $postingPrivacy;
	}
	
	//4.getSelectCountry
	function getSelectCountry($var, $default, $disabled, $event){
		$db	= & JFactory::getDBO(); 
	
		$option = '';
		if($disabled == 1) 
			$option = 'disabled';
			
		//Load the default country from the config if the "fefault" value is empty
		if(empty($default)){
			$config =& JTable::getInstance('config', 'Table');
			$config->load(1);
			$default = $config->defaultCountry;
		}
		
		//make selection country
		$query = 'SELECT id AS value, country AS text FROM #__jbjobs_country WHERE published=1 ORDER BY country';		
		$db->setQuery($query);
		$countries = $db->loadObjectList();
		
		$types[] = JHTML::_('select.option', '', '- '.JText::_('JBJOBS_SELECT_COUNTRY').' -');
		foreach($countries as $item){
			$types[] = JHTML::_('select.option', $item->value, JText::_($item->text));
		}		
		$lists = JHTML::_('select.genericlist', $types, $var, 'class="inputbox" size="1" '.$option.' '.$event.'', 'value', 'text', $default);
		return $lists;
	}	
	
	//4.getSelectState
	function getSelectState($var, $default, $event, $countryid){
		$db	= & JFactory::getDBO(); 
	
		if($default == '') 
			$default = '0';
			
		//Load the default country from the config if the "fefault" value is empty
		if(empty($countryid)){
			$config =& JTable::getInstance('config', 'Table');
			$config->load(1);
			$countryid = $config->defaultCountry;
		}
		
		//make selection state
		$query = 'SELECT state AS value, state AS text FROM #__jbjobs_state 
				  WHERE country_id='.$db->quote($countryid).' AND published=1 ORDER BY state';		
		$db->setQuery($query);
		$states = $db->loadObjectList();
		
		$types[] = JHTML::_('select.option',  '', '- '. JText::_('JBJOBS_SELECT_STATE') .' -');
		if(!empty($states)){
			foreach($states as $item){
				$types[] = JHTML::_('select.option', $item->value, JText::_($item->text));
			}
		}
		$lists = '';
		if (isset($types[1])) if ($types[1] != '')
			$lists 	= JHTML::_('select.genericlist', $types, $var, 'class="inputbox" size="1" '.$event.'', 'value', 'text', $default );
		return $lists;
	}	
	
	//4.getSelectCity
	function getSelectCity($var, $default, $event, $statename){
		$db	= & JFactory::getDBO(); 
	
		if($default == '') 
			$default = '0'; 
		
		//make selection state
		$query = 'SELECT city AS value, city AS text FROM #__jbjobs_city 
				  WHERE state_name='.$db->quote($statename).' AND published=1 ORDER BY city';		
		$db->setQuery($query);
		$cities = $db->loadObjectList();
		
		$types[] = JHTML::_('select.option',  '', '- '. JText::_('JBJOBS_SELECT_CITY') .' -');
		foreach($cities as $item){
			$types[] = JHTML::_('select.option', $item->value, JText::_($item->text));
		}
		$lists = '';
		if (isset($types[1])) if ($types[1] != '')
			$lists 	= JHTML::_('select.genericlist', $types, $var, 'class="inputbox" size="1" '.$event.'', 'value', 'text', $default );
		return $lists;
	}	
	
	//5.getSelectJobSpec
	function getSelectJobSpec($var, $default, $disabled){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO(); 
		
		$option = '';
		if($disabled == 1) 
			$option = 'disabled';
		
		//make selection Job Specialization
		$query = 'SELECT id AS value, specialization AS text FROM #__jbjobs_job_spec WHERE published=1 ORDER BY ordering';
		$db->setQuery($query);
		$users = $db->loadObjectList();
		
		$types[] = JHTML::_('select.option', '', '- '.JText::_('JBJOBS_SELECT_SPECIALIZATION').' -');
		foreach($users as $item){
			$types[] = JHTML::_('select.option', $item->value, JText::_($item->text));
		}		
		
		$lists 	= JHTML::_('select.genericlist', $types, $var, 'class="inputbox" size="1" '.$option.'', 'value', 'text', $default);
		return $lists;
	}	
	
	//6.getSelectPositionType
	function getSelectPositionType($var, $default, $disabled){
		$db	= & JFactory::getDBO(); 
		
		$option = '';
		if($disabled == 1) 
			$option = 'disabled';
		
		//make selection position type
		$query = 'SELECT id AS value, pos_type AS text FROM #__jbjobs_pos_type WHERE published=1 ORDER BY ordering';
		$db->setQuery($query);
		$users = $db->loadObjectList();
		
		$types[] = JHTML::_('select.option',  '', '- '. JText::_('JBJOBS_POSITION_TYPE').' -');
		foreach($users as $item){
			$types[] = JHTML::_('select.option', $item->value, JText::_($item->text));
		}		
		
		$lists 	= JHTML::_('select.genericlist', $types, $var, 'class="inputbox" size="1" '.$option.'', 'value', 'text', $default);
		return $lists;
	}	
	
	//7.getSelectExpLevel
	function getSelectExpLevel($var, $default, $disabled){
		$db	= & JFactory::getDBO(); 
		
		$option = '';
		if($disabled == 1) 
			$option = 'disabled';
		
		//make selection experience level
		$query = 'SELECT id AS value, exp_name AS text FROM #__jbjobs_job_exp WHERE published=1 ORDER BY ordering';
		$db->setQuery($query);
		$users = $db->loadObjectList();
		
		$types[] = JHTML::_('select.option', '', '- '.JText::_('JBJOBS_EXPERIENCE_LEVEL').' -');
		foreach($users as $item){
			$types[] = JHTML::_('select.option', $item->value, JText::_($item->text));
		}		
		
		$lists 	= JHTML::_('select.genericlist', $types, $var, 'class="inputbox" size="1" '.$option.'', 'value', 'text', $default);
		return $lists;
	}		
	
	//8.getSelectDegreeLevel
	function getSelectDegreeLevel($var, $default, $disabled){
		$db	=& JFactory::getDBO(); 
		
		$option ='';
		if($disabled == 1) 
			$option = 'disabled';
		
		//make selection degreelevel
		$query = 'SELECT id AS value, degree_level AS text FROM #__jbjobs_degree_level WHERE published=1 ORDER BY ordering';
		$db->setQuery($query);
		$users = $db->loadObjectList();
		
		$types[] = JHTML::_('select.option', '', '- '.JText::_('JBJOBS_DEGREE_LEVEL').' -');
		foreach($users as $item){
			$types[] = JHTML::_('select.option', $item->value, JText::_($item->text));
		}		
		
		$lists 	= JHTML::_('select.genericlist', $types, $var, 'class="inputbox" size="1" '.$option.'', 'value', 'text', $default);
		return $lists;
	}	

	//9.getSelectTypeSalary
	function getSelectTypeSalary($var,$default,$disabled){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO(); 
		
		$option = '';
		if($disabled == 1) 
			$option = 'disabled';
		
		//make selection salary type
		$query = 'SELECT id AS value, type_salary AS text FROM #__jbjobs_type_salary WHERE published=1 ORDER BY ordering';
		$db->setQuery($query);
		$users = $db->loadObjectList();
		
		$types[] = JHTML::_('select.option',  '', '- '.JText::_('JBJOBS_SALARY_TYPE').' -');
		foreach($users as $item){
			$types[] = JHTML::_('select.option', $item->value, JText::_($item->text));
		}		
		
		$lists 	= JHTML::_('select.genericlist', $types, $var, 'class="inputbox" size="1" '.$option.'', 'value', 'text', $default);
		return $lists;
	}
	
	//10.getSelectMajor
	function getSelectMajor($var, $default, $disabled, $mosReq = null){
		$db	= & JFactory::getDBO(); 
		
		$option ='';
		if($disabled ==1) 
			$option = 'disabled';
		
		//make selection major
		$query = 'select id as value, major as text from #__jbjobs_major WHERE published=1 ORDER BY ordering';
		$db->setQuery( $query );
		$users = $db->loadObjectList();
		
		$types[] = JHTML::_('select.option',  '', '- '. JText::_('JBJOBS_SELECT_MAJOR') .' -');
		foreach($users as $item){
			$types[] = JHTML::_('select.option', $item->value, JText::_($item->text));
		}		
		
		$lists 	= JHTML::_('select.genericlist', $types, $var, 'class="inputbox" size="1" '.$option.$mosReq, 'value', 'text', $default);
		return $lists;
	}

	//11.getSalutation
	function getSalutation($var, $default, $disabled){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO(); 
		
		$option ='';
		if($disabled ==1) 
			$option = 'disabled';
		
		//make selection salutation
		$query = 'select id as value, salutation as text from #__jbjobs_salutation ORDER BY salutation';
		$db->setQuery( $query );
		$users = $db->loadObjectList();
		
		$types[] 		= JHTML::_('select.option',  '', '- '. JText::_('JBJOBS_SALUTATION') .' -');
		foreach( $users as $item ){
			$types[] = JHTML::_('select.option',  $item->value, JText::_( $item->text ) );
		}		
		
		$lists 	= JHTML::_('select.genericlist',   $types, $var, 'class="inputbox" size="1" '.$option.'', 'value', 'text', $default );
		return $lists;
	}

	//12.getSelectCompType
	function getSelectCompType($var, $default, $disabled){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO(); 
		
		$option ='';
		if($disabled ==1) 
			$option = 'disabled';
		
		//make selection country
		$query = 'select id as value, comp_type as text from #__jbjobs_comp_type ORDER BY comp_type';
		$db->setQuery( $query );
		$users = $db->loadObjectList();
		
		$types[] = JHTML::_('select.option',  '', '- '. JText::_('JBJOBS_SELECT_COMPANY_TYPE') .' -');
		foreach( $users as $item ){
			$types[] = JHTML::_('select.option',  $item->value, JText::_( $item->text ) );
		}		
		
		$lists 	= JHTML::_('select.genericlist',   $types, $var, 'class="inputbox" size="1" '.$option.'', 'value', 'text', $default );
		return $lists;
	}

	//13.getSelectIndustry
	function getSelectIndustry($var, $default, $disabled){
		$db	= & JFactory::getDBO(); 
		
		$option = '';
		if($disabled == 1) 
			$option = 'disabled';
		
		//make selection industry
		$query = 'SELECT id AS value, industry AS text FROM #__jbjobs_industry WHERE published=1 ORDER BY ordering';
		$db->setQuery($query);
		$users = $db->loadObjectList();
		
		$types[] = JHTML::_('select.option', '', '- '.JText::_('JBJOBS_INDUSTRY').' -');
		foreach($users as $item){
			$types[] = JHTML::_('select.option', $item->value, JText::_($item->text));
		}		
		
		$lists = JHTML::_('select.genericlist', $types, $var, 'class="inputbox" size="1" '.$option.'', 'value', 'text', $default);
		return $lists;
	}

	//14.getSelectPersonalStatus 
	function getSelectPersonalStatus($var, $title, $default, $disabled){
		
		//make selection personal status
		$types[] = JHTML::_('select.option',  '', '- '.$title.' -');
		$types[] = JHTML::_('select.option',  'Single', JText::_('JBJOBS_SINGLE'));
		$types[] = JHTML::_('select.option',  'Married', JText::_('JBJOBS_MARRIED'));
		$types[] = JHTML::_('select.option',  'Widowed', JText::_('JBJOBS_WIDOWED'));
		$types[] = JHTML::_('select.option',  'Divorced', JText::_('JBJOBS_DIVORCED'));
		$types[] = JHTML::_('select.option',  'Separated', JText::_('JBJOBS_SEPARATED'));
		$types[] = JHTML::_('select.option',  'Other', JText::_('JBJOBS_OTHER'));
		
		$lists 	= JHTML::_('select.genericlist', $types, $var, 'class="inputbox" size="1" ', 'value', 'text', $default );
		return $lists;
	}	
		
	//14.getSelectVideo 
	function getSelectVideo($var, $title, $default){
		
		//make selection personal status
		$types[] = JHTML::_('select.option',  '', '- '. JText::_(''.$title.'') .' -');
		$types[] = JHTML::_('select.option',  'youtube', JText::_('Youtube'));
		$types[] = JHTML::_('select.option',  'googlevideo', JText::_('Google Video'));
		//$types[] = JHTML::_('select.option',  'yahoovideo', JText::_('Yahoo Video'));
		//$types[] = JHTML::_('select.option',  'Metacafe', JText::_('Metacafe'));
		
		$lists 	= JHTML::_('select.genericlist', $types, $var, 'class="inputbox" size="1" ', 'value', 'text', $default );
		return $lists;
	}		
	
	//15.getSelectJobAgency 
	function getSelectJobAgency($var, $title, $default, $disabled){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO(); 
	
		$option = '';
		if($disabled == 1) 
			$option = 'disabled';
		
		if($default == '') $default = '0'; 
		//make selection job agency
		$query = 'SELECT user_id AS value, comp_name AS text FROM #__jbjobs_employer WHERE id_comp_type=2 ORDER BY comp_name';		
		$db->setQuery( $query );
		$jobagencies = $db->loadObjectList();
		
		$types[] = JHTML::_('select.option', '', '- '.$title.' -');
		$types[] = JHTML::_('select.option', '-1', JText::_('JBJOBS_NONE'));
		foreach( $jobagencies as $item ){
			$types[] = JHTML::_('select.option', $item->value, JText::_( $item->text ) );
		}		
		$tip = JText::_('JBJOBS_TT_CHOOSE_YOUR_REFERER');
		$lists 	= JHTML::_('select.genericlist', $types, $var, 'class="inputbox jbtooltip" title="'.$tip.'" size="1" '.$option.'', 'value', 'text', $default );
		return $lists;
	}	

	//16.getMultipleJobSpec
	function getMultipleJobSpec($var, $title, $default, $event){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO(); 
		
		//make selection salutation
		$query = 'SELECT id AS value, specialization AS text FROM #__jbjobs_job_spec WHERE published=1 ORDER BY ordering';
		$db->setQuery( $query );
		$users = $db->loadObjectList();
		
		$types[] = JHTML::_('select.option',  '0', '- '.$title.' -');
		foreach($users as $item){
			$types[] = JHTML::_('select.option',  $item->value, JText::_( $item->text ) );
		}		
		
		$lists 	= JHTML::_('select.genericlist', $types, $var, 'class="inputbox" size="10" multiple '.$event.'', 'value', 'text', $default );
		return $lists;
	}
	
	//17.getMultipleCountry
	function getMultipleCountry($var,$title,$default,$disabled){
		$db	= & JFactory::getDBO(); 
	
		$option = '';
		if($disabled == 1) 
			$option = 'disabled';
		
		if($default == '') $default = '0'; 
		//make selection country
		$query = 'SELECT id AS value, country AS text FROM #__jbjobs_country WHERE published=1 ORDER BY country';		
		$db->setQuery( $query );
		$countries = $db->loadObjectList();
		
		$types[] = JHTML::_('select.option',  '0', '- '.$title.' -');
		foreach($countries as $item){
			$types[] = JHTML::_('select.option', $item->value, JText::_($item->text));
		}		
		
		$lists = JHTML::_('select.genericlist', $types, $var, 'class="inputbox" size="5" multiple '.$option.'', 'value', 'text', $default);
		return $lists;
	}
	
	//18.getMultipletExpLevel
	function getMultipleExpLevel($var, $title, $default, $disabled){
		$db	= & JFactory::getDBO(); 
		
		$option = '';
		if($disabled == 1) 
			$option = 'disabled';
		
		//make selection salutation
		$query = 'SELECT id AS value, exp_name AS text FROM #__jbjobs_job_exp WHERE published=1 ORDER BY ordering';
		$db->setQuery($query);
		$exps = $db->loadObjectList();
		
		$types[] = JHTML::_('select.option',  '0', '- '.$title.' -');
		foreach($exps as $item){
			$types[] = JHTML::_('select.option', $item->value, JText::_($item->text));
		}		
		
		$lists = JHTML::_('select.genericlist', $types, $var, 'class="inputbox" size="5" multiple '.$option.'', 'value', 'text', $default);
		return $lists;
	}	
	
	//18.getMultipleIndustry
	function getMultipleIndustry($var, $title, $default, $disabled){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO(); 
		
		$option ='';
		if($disabled == 1) 
			$option = 'disabled';
		
		//make selection salutation
		$query = 'SELECT id AS value, industry AS text FROM #__jbjobs_industry WHERE published=1 ORDER BY ordering';
		$db->setQuery($query);
		$inds = $db->loadObjectList();
		
		$types[] = JHTML::_('select.option',  '0', '- '.$title.' -');
		foreach($inds as $item){
			$types[] = JHTML::_('select.option', $item->value, JText::_($item->text));
		}		
		
		$lists 	= JHTML::_('select.genericlist', $types, $var, 'class="inputbox" size="8" multiple '.$option.'', 'value', 'text', $default );
		return $lists;
	}	
	
	//13.getSelectPaymode
	function getSelectPaymode($var, $default, $disabled){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO(); 
		
		$option ='';
		if($disabled == 1) 
			$option = 'disabled';
		
		//make selection salutation
		$query = 'SELECT gwcode AS value, fieldtext AS text FROM #__jbjobs_payment_mode 
				  WHERE parent=0 AND published=1
				  ORDER BY ordering';
		$db->setQuery( $query );
		$users = $db->loadObjectList();
		
		//$types[] = ''		= JHTML::_('select.option',  '', '- '. JText::_('JBJOBS_INDUSTRY') .' -');
		foreach( $users as $item ){
			$types[] = JHTML::_('select.option',  $item->value, JText::_( $item->text ) );
		}		
		
		$lists 	= JHTML::_('select.genericlist', $types, $var, 'class="inputbox" size="1" '.$option.'', 'value', 'text', $default );
		return $lists;
	}
	
	//14.getSearchPhrase
	function getSearchPhrase($var, $default){
		
		$searchphrases 	 = array();
		$searchphrases[] = JHTML::_('select.option', 'any', JText::_('JBJOBS_ANY_WORDS'));
		$searchphrases[] = JHTML::_('select.option', 'all', JText::_('JBJOBS_ALL_WORDS'));
		$searchphrases[] = JHTML::_('select.option', 'exact', JText::_('JBJOBS_EXACT_PHRASE'));
		$lists = JHTML::_('select.radiolist',  $searchphrases, $var, '', 'value', 'text', $default);
			
		return $lists;
	}
	
	//14.getSelectManageApplicant 
	function getSelectManageApplicant($var, $default, $disabled){
		
		//make selection personal status
		$types[] = JHTML::_('select.option',  0, JText::_('JBJOBS_JOB_BOARD_ACCOUNT'));
		$types[] = JHTML::_('select.option',  1, JText::_('JBJOBS_EXTERNAL_WEBSITE'));
		
		$tip = JText::_('JBJOBS_TT_MANAGE_APPLICANTS');
		$lists 	= JHTML::_('select.genericlist', $types, $var, "class='inputbox jbtooltip' size='1' title='$tip'", 'value', 'text', $default );
		return $lists;
	}
	
	//16.getCheckJobCategSpec
	function getCheckJobCategSpec(){
		$app =& JFactory::getApplication();
		$db	= & JFactory::getDBO(); 
		$doc =& JFactory::getDocument();
		
		$query = "SELECT id, category FROM #__jbjobs_job_categ WHERE published=1 ORDER BY ordering";
		$db->setQuery($query);
		$cats = $db->loadObjectList();
		
	   	$js = 'window.addEvent("domready", function() {';
		$html = "<div class='job_search_category'>";
		foreach($cats as $cat){
			$js .= "\n\tnew CheckboxGroup('master$cat->id', '.slave$cat->id');";
			$html .= "\n\t<input type='checkbox' id='master$cat->id' name='id_categ[]' value='$cat->id'><label class='master'>$cat->category</label><br>";
			$specs = $this->spec($cat->id);
			foreach($specs as $spec){
				$html .= "\n\t<input type='checkbox' class='slave$cat->id' name='id_spec[]' value='$spec->id'><label class='slave'>$spec->specialization</label><br>";
			}
		}
		$html .="</div>";
		$js .= "});";
		
		$doc->addScriptDeclaration($js);
		return $html;
	}
	
	function spec($parentid) {
		$db = &JFactory::getDBO();
		$query = "SELECT id, specialization FROM #__jbjobs_job_spec WHERE id_category=$parentid AND published=1 ORDER BY ordering";
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		return $rows;
	}
	
	function getVideoResume($video_link, $domain){
		$width = 424;
		$height = 344;
		$uri = JFactory::getURI($video_link);
		if($domain == 'youtube'){
			$source = $uri->getVar('v');
			$youtube = "<object type=\"application/x-shockwave-flash\" style=\"width:{$width}px;height:{$height}px;\" data=\"http://www.youtube.com/v/{$source}&hl=en&fs=1\" title=\"JoomBah Jobs Video Resume\">
					<param name=\"movie\" value=\"http://www.youtube.com/v/{$source}&hl=en&fs=1\" />
					<param name=\"quality\" value=\"high\" />
					<param name=\"allowfullscreen\" value=\"true\" />
					<param name=\"allowscriptaccess\" value=\"always\" />
				</object>";
			return $youtube;
		}
		elseif($domain == 'googlevideo'){
			$source = $uri->getVar('docid');
			$google = "<object type=\"application/x-shockwave-flash\" style=\"width:{$width}px;height:{$height}px;\" data=\"http://video.google.com/googleplayer.swf?docid={$source}&hl=en&fs=true\" title=\"JoomBah Jobs Video Resume\">
					<param name=\"movie\" value=\"http://video.google.com/googleplayer.swf?docid={$source}&hl=en&fs=true\" />
					<param name=\"quality\" value=\"high\" />
					<param name=\"allowfullscreen\" value=\"true\" />
					<param name=\"allowscriptaccess\" value=\"always\" />
				</object>";
			return $google;
			
		}
		elseif($domain == 'yahoovideo'){
			$source = $uri->getVar('docid');
			$google = "<object type=\"application/x-shockwave-flash\" style=\"width:{$width}px;height:{$height}px;\" data=\"http://d.yimg.com/static.video.yahoo.com/yep/YV_YEP.swf\" title=\"JoomBah Jobs Video Resume\">
					<param name=\"movie\" value=\"http://d.yimg.com/static.video.yahoo.com/yep/YV_YEP.swf\" />
					<param name=\"quality\" value=\"high\" />
					<param name=\"allowfullscreen\" value=\"true\" />
					<param name=\"allowscriptaccess\" value=\"always\" />
					<param name=\"flashvars\" value=\"{$source}\" />
				</object>";
			return $google;
			
		}
		
	}

}	
?>
