<?php
/**
 + Created by	:	JoomBah Team
 * Company		:	ISDS Sdn Bhd
 + Contact		:	www.joombah.com , support@joombah.com
 * Created on	:	14 November 2011
 * Author 		:	JoomBah Team
 + Project		: 	Job site
 * File Name	:	plugins/search/jbjobssearch.php
 * License		:	GNU General Public License version 3, or later
 ^ 
 * Description	: 	Search Plugin for JoomBah Jobs (jbjobs)
* */
defined( '_JEXEC' ) or die ( '' );

jimport ('joomla.html.parameter');

$app = JFactory::getApplication ();
$app->registerEvent ( 'onSearch', 'plgSearchJBJobs' );
$app->registerEvent ( 'onSearchAreas', 'plgSearchJBJobsAreas' );
$app->registerEvent ( 'onContentSearch', 'plgSearchJBJobs' );
$app->registerEvent ( 'onContentSearchAreas', 'plgSearchJBJobsAreas' );

//Then define a function to return an array of search areas.
function &plgSearchJBJobsAreas() {
	static $areas = array();
	if (empty($areas)) {
		$areas['jbjobs'] = JText::_('JoomBah Jobs');
	}
	return $areas;
}

//Then the real function has to be created. The database connection should be made.
//The function will be closed with an } at the end of the file.
function plgSearchJBJobs($text, $phrase = '', $ordering = '', $areas = null) {
	$db = JFactory::getDBO ();
	$user = JFactory::getUser ();

	//If the array is not correct, return it:
	if (is_array ( $areas )) {
		if (! array_intersect ( $areas, array_keys ( plgSearchJBJobsAreas () ) )) {
			return array ();
		}
	}

	$plugin = JPluginHelper::getPlugin ( 'search', 'jbjobssearch' );
	$pluginParams = new JParameter ( $plugin->params );

	//And define the parameters. For example like this..
	$limit = $pluginParams->def ( 'search_limit', 50 );
	$contentLimit = $pluginParams->def ( 'content_limit', 40 );

	//Use the function trim to delete spaces in front of or at the back of the searching terms
	$text = trim ( $text );

	//Return Array when nothing was filled in
	if ($text == '') {
		return array ();
	}

	//After this, you have to add the database part. This will be the most difficult part, because this changes per situation.
	//In the coding examples later on you will find some of the examples used by Joomla! 1.5 core Search Plugins.
	//It will look something like this.
	$wheres = array ();
	switch ($phrase) {
			case 'exact':
				$text		= $db->Quote( '%'.$db->getEscaped( $text, true ).'%', false );
				$wheres2 	= array();
				$wheres2[] 	= 'a.job_title LIKE '.$text;
				$wheres2[] 	= 'a.state LIKE '.$text;
				$wheres2[] 	= 'a.city LIKE '.$text;
				$wheres2[] 	= 'b.country LIKE '.$text;
				$wheres2[] 	= 'c.comp_name LIKE '.$text;
				$wheres2[] 	= 'cv.value LIKE '.$text;
				$wheres2[] 	= 'cv.valuetext LIKE '.$text;
				$wheres2[] 	= 'a.short_desc LIKE '.$text;
				$wheres2[] 	= 'a.long_desc LIKE '.$text;
				$queryStrings[] = '(' . implode( ') OR (', $wheres2 ) . ')';
				break;
	
			case 'all':
			case 'any':
			default:
				$words = explode(',', $text);
				$wheres = array();
				foreach ($words as $word) {
					$word		= $db->Quote('%'.$db->getEscaped($word, true).'%', false);
					$wheres2 	= array();
					$wheres2[] 	= 'a.job_title LIKE '.$word;
					$wheres2[] 	= 'a.state LIKE '.$word;
					$wheres2[] 	= 'a.city LIKE '.$word;
					$wheres2[] 	= 'b.country LIKE '.$word;
					$wheres2[] 	= 'c.comp_name LIKE '.$word;
					$wheres2[] 	= 'cv.value LIKE '.$word;
					$wheres2[] 	= 'cv.valuetext LIKE '.$word;
					$wheres2[] 	= 'a.short_desc LIKE '.$word;
					$wheres2[] 	= 'a.long_desc LIKE '.$word;
					$wheres[] 	= implode(' OR ', $wheres2);
				}
				$queryStrings[] = '(' . implode( ($phrase == 'all' ? ') AND (' : ') OR ('), $wheres ) . ')';
				break;
		}

		$where = implode (' AND ', $queryStrings);
		
		$now = date('Y-m-d'); // H:i:s', time() + ( $app->getCfg('offset') * 60 * 60 ) );
		$where .= " AND a.is_active='y' AND a.publish_date <= '".$now."' AND expire_date >= '".$now."' AND expire_date <> '0000-00-00 00:00:00'";

	$query = "SELECT DISTINCT a.*,country,c.id id_employer,c.comp_name,c.show_comp_name,comp_type,b.id countryid,if(true, true, false) is_hot FROM #__jbjobs_job a".
	      	 " LEFT JOIN #__jbjobs_country b ON a.id_country = b.id".
		 	 " LEFT JOIN #__jbjobs_employer c ON a.employer_id = c.user_id".
	 		 " LEFT JOIN #__jbjobs_custom_field_value cv ON cv.jobid=a.id".
			 " LEFT JOIN #__jbjobs_comp_type d ON c.id_comp_type = d.id". 
			 " WHERE ".$where.
			 " ORDER BY is_hot DESC, a.is_featured DESC, a.publish_date DESC, a.id DESC";
	//Set query
	$db->setQuery ($query, 0, $limit);
	$rows = $db->loadObjectList();

	//The 'output' of the displayed link
	foreach($rows as $key => $row){
		$row->title = JString::substr ($row->job_title, '0', $contentLimit);
		$row->text = $row->short_desc;
		$row->section = 0;
		$rows [$key]->href = JURI::root().'index.php?option=com_jbjobs&view=guest&layout=detailjob&id='.$row->id.'&Itemid='.JRequest::getVar('Itemid');
	}
	//Return the search results in an array
	return $rows;
}
